/*
**	VJE-GAMMA
**			fuzoku.h
*/
struct	input_inf {
	USHORT	ptr;
	UCHAR	hinshi;
	UCHAR	flag;
};
typedef	struct input_inf	INPUT_INF;

struct	hinshi_block {
	USHORT	ptr;
	UCHAR	kubun;
	UCHAR	hinshi;
	USHORT	kata;
	UCHAR	kata_no;
};
typedef	struct hinshi_block	HNS_BLK;

/* hg 12 */
struct hinshi_group {
	USHORT	cnt;
	USHORT	hmax;
	HNS_BLK	hib[N_HIB];
};
typedef	struct hinshi_group	HNS_GRP;

/* hg2 6 fuzokugo kakunou you */
struct hinshi_group2 {
	USHORT	cnt;
	USHORT	hmax;
	HNS_BLK	hib[N_HIB];
};
typedef	struct hinshi_group2	HNS_GRP2;

/* hgf 4 gobi kakunou or saishono inf. kakunou */
struct hinshi_groupf {
	USHORT	cnt;
	USHORT	hmax;
	HNS_BLK	hib[N_HIB];
};
typedef	struct hinshi_groupf	HNS_GRPF;

/* fk */
struct hinshi_koho {
	USHORT	max_fzk;
	USHORT	cnt;
	HNS_BLK	hib[N_HIB];
};
typedef	struct hinshi_koho	HNS_KH;

/*
 *	Fuzokugo Katuyou Jouhou < Fuzokugo Table Flag >
 */
#define	F_ILEGAL_END	0x40
#define	F_SHUUJYOSHI	0x20
#define	F_NN			0x10
#define	F_JIRITU		0x04
#define	F_GENKEI		0x02
#define	F_KATUYOU		0x01

/*
 *	Katuyou Fuzokugo Naibu Hinshi Number
 */
#define	U		1
#define	SASERU		2
#define	SERU		3
#define	SOUDA		4
#define	TA		5	/* TARO _ TA TA TARA _ EX.=HASITTA */
#define	DA1		6	/* DARO _ DA DA DARA _ EX.=YONDA */
#define	DA2		7	/* DARO NARA (DATT DE DA NA = DA3) EX.=TENNKIDA YOIDAROU*/
#define	TAI		8

#define	TAGARU		9
#define	TERU		10
#define	DESU		11
#define	DERU		12	
#define	NAI		13
#define	NU		14
#define	MAI		15
#define	MASU		16

#define	MITAIDA		17
#define	YOU		18
#define	YOUDA		19
#define	RASHII		20
#define	RARERU		21
#define	RU		22
#define	RERU		23
#define	GOZAIMASU	24

#define	CHAU		25
#define	JAU		26
#define	ITADAKU		27
#define	IRASSHARU	28
#define	TUKU		29
#define	NARU		30
#define	ITASU		31
#define	YOI		32

#define	II		33
#define	IU		34
#define	OKU		35
#define	DEKIRU		36
#define	TORU		37
#define	BESHI		38
#define	MAJI		39
#define	GOTOSHI		40

#define	SU		41  /* KAKASU */
#define	SASU		42  /* TABESASU */
#define	TARU		43  /* ninngenntaru 86/10/2 K.H*/
#define	DA3		44  /* DA DATT DE NA (DA2 DE RENTAIKEI NI SETUZOKUSINAI MONO) */
#define	IRU             45

#define	SURU            48
#define	ARU             49
#define	SUGIRU          50
#define	KUDASAI         51
#define	KURERU          52
#define	SARERU          53
#define	SIMAU           54
#define	MIRU            55

#define	ORU             56
#define	KURU            57
#define	YORU            58
#define	NIKUI           59
#define	YASUI           60
#define	KAKERU			61
#define	MORAU			62
#define	MAKURU			63

#define	NASARU			64
#define	NINARU			65
#define	KUTOUTEN		66
#define	YARU			67

/*
 *	Mukatuyou Fuzokugo Naibu Hinshi Number
 */
#define	KA		1
#define	KASHIRA		2
#define	KARA		3
#define	GA		4
#define	KIRI		5
#define	KURAI		6
#define	GURAI		7
#define	KEDO		8
#define	KEREDO		9
#define	KOSO		10
#define	SA		11
#define	SAE		12
#define	SHI		13
#define	SHIKA		14
#define	SURA		15
#define	ZUTU		16
#define	ZE		17
#define	ZO		18
#define	TARI		19
#define	DAKE		20
#define	DATTE		21
#define	DARI		22
#define	TUTU		23
#define	DUTU		24
#define	TE		25
#define	TEMO		26
#define	DE		27	/* GAKKOUDE */
#define	DEMO		28
#define	TO		29
#define	TOMO		30
#define	NA		31
#define	NAA		32
#define	NAGARA		33
#define	NADO		34
#define	NARI		35
#define	NARITO		36
#define	NANKA		37
#define	NANZO		38
#define	NANTE		39
#define	NI		40
#define	NE		41
#define	NEE		42
#define	NO_		43	/* TAIGEN NI SETUZOKU */
#define	NODE		44
#define	NONI		45
#define	HA		46
#define	BA		47
#define	BAKARI		48
#define	HE		49
#define	HODO		50
#define	HOKA		51
#define	MADE		52
#define	MO		53
#define	YA		54
#define	YARA		55
#define	YO		56
#define	YORI		57
#define	WO		58
#define	UTI		59
#define	KOTO		60
#define	TAME		61
#define	TOORI		62
#define	TOKI		63
#define	TOKORO		64
#define	DOKORO		65
#define	NOMI		66
#define	HAZU		67
#define	XTUKIRI		68
#define	MAMA		69
#define	MONO		70
#define	WAKE		71
#define	TYOUON		72
#define	DE2		73	/* ASONDE */
#define	SEI		74
#define	TUITE		75
#define	TUMORI		76
#define	NO2			77	/* TAIGEN IGAI NI SETUZOKU */
#define	NN		78
/*#define	SOU		79*/
#define	KAI		80
#define	WA		81
#define	MON		82
#define	JA		83
#define	CHA 		84
#define	XTUPANASHI	85	/* KAKIPPANASI */
#define	XTUTE	86
#define	TERO	87
#define	XTUKO	88	/* DEKIKKO */
#define	DOMO	89	/* IKEDOMO */
#define	TAMAE	90	/* ASOBITAMAE */
#define	YUE		91	/* WAKASAYUE */
#define	TOKE	92	/* SUTETOKE */
#define	DOKE	93	/* ASONDOKE */
#define	TOTE	94	/* TOTEMO WO KINSHI SHITA */
#define	NITE	95	/* NI X TE O IRU / NITE X IRU */

/*
 *	Katuyou Fuzokugo
 */
#define	RSV		0

#define	U_X		0
#define	SASERU_X	0
#define	SERU_X		0
#define	SOUDA_X		0
#define	TA_X		0
#define	DA1_X		0
#define	DA2_X		0
#define	TAI_X		0	
#define	TAGARU_X	0
#define	TERU_X		0
#define	DESU_X		0
#define	DERU_X		0
#define	NAI_X		0
#define	NU_X		0
#define	MAI_X		0
#define	MASU_X		0
#define	MITAIDA_X	0
#define	YOU_X		0
#define	YOUDA_X		0
#define	RASII_X		0
#define	RARERU_X	0
#define	RU_X		0
#define	RERU_X		0
#define	GOZAI_X		0
#define	CHAU_X		0
#define	JAU_X		0
#define	ITADAKU_X	0
#define	IRASSHARU_X	0
/*#define	NASU_X		0*/
#define	NARU_X		0
#define	ITASU_X		0
#define	YOI_X		0
#define	II_X		0
#define	IU_X		0
#define	OKU_X		0
#define	DEKIRU_X	0
#define	TORU_X		0
#define	BESHI_X		0
#define	MAJI_X		0
#define	GOTOSHI_X	0
#define	SU_X		0
#define	SASU_X		0
#define	TARU_X		0
#define	DA3_X		0
#define	IRU_X		0

#define	U_O		0x80
#define	SASERU_O	0x40
#define	SERU_O		0x20
#define	SOUDA_O		0x10

#define	TA_O		0x08
#define	DA1_O		0x04
#define	DA2_O		0x02
#define	TAI_O		0x01

#define	TAGARU_O	0x80
#define	TERU_O		0x40
#define	DESU_O		0x20
#define	DERU_O		0x10

#define	NAI_O		0x08
#define	NU_O		0x04
#define	MAI_O		0x02
#define	MASU_O		0x01

#define	MITAIDA_O	0x80
#define	YOU_O		0x40
#define	YOUDA_O		0x20
#define	RASII_O		0x10

#define	RARERU_O	0x08
#define	RU_O		0x04
#define	RERU_O		0x02
#define	GOZAI_O		0x01

#define	CHAU_O		0x80
#define	JAU_O		0x40
#define	ITADAKU_O	0x20
#define	IRASSHARU_O	0x10

/*#define	NASU_O		0x08*/
#define	NARU_O		0x04
#define	ITASU_O		0x02
#define	YOI_O		0x01

#define	II_O		0x80
#define	IU_O		0x40
#define	OKU_O		0x20
#define	DEKIRU_O	0x10

#define	TORU_O		0x08
#define	BESHI_O		0x04
#define	MAJI_O		0x02
#define	GOTOSHI_O	0x01

#define	SU_O		0x80
#define	SASU_O		0x40
#define	TARU_O		0x20
#define	DA3_O		0x10
#define	IRU_O		0x08

/*
 *	Mukatuyou Fuzokugo
 */
#define	KA_X		0
#define	KASHIRA_X	0
#define	KARA_X		0
#define	GA_X		0
#define	KIRI_X		0
#define	KURAI_X		0
#define	GURAI_X		0
#define	KEDO_X		0

#define	KEREDO_X	0
#define	KOSO_X		0
#define	SA_X		0
#define	SAE_X		0
#define	SHI_X		0
#define	SHIKA_X		0
#define	SURA_X		0
#define	ZUTU_X		0

#define	ZE_X		0
#define	ZO_X		0
#define	TARI_X		0
#define	DAKE_X		0
#define	DATTE_X		0
#define	DARI_X		0
#define	TUTU_X		0
#define	DUTU_X		0

#define	TE_X		0
#define	TEMO_X		0
#define	DE_X		0
#define	DEMO_X		0
#define	TO_X		0
#define	TOMO_X		0
#define	NA_X		0
#define	NAA_X		0

#define	NAGARA_X	0
#define	NADO_X		0
#define	NARI_X		0
#define	NARITO_X	0
#define	NANKA_X		0
#define	NANZO_X		0
#define	NANTE_X		0
#define	NI_X		0

#define	NE_X		0
#define	NEE_X		0
#define	NO_X		0
#define	NODE_X		0
#define	NONI_X		0
#define	HA_X		0
#define	BA_X		0
#define	BAKARI_X	0

#define	HE_X		0
#define	HOKA_X		0
#define	HODO_X		0
#define	MADE_X		0
#define	MO_X		0
#define	YA_X		0
#define	YARA_X		0
#define	YO_X		0

#define	YORI_X		0	
#define	WO_X		0
#define	UTI_X		0
#define	KOTO_X		0
#define	TAME_X		0	
#define	TOORI_X		0
#define	TOKI_X		0
#define	TOKORO_X	0

#define	DOKORO_X	0
#define	NOMI_X		0
#define	HAZU_X		0
#define	XTUKIRI_X	0
#define	MAMA_X		0
#define	MONO_X		0
#define	WAKE_X		0
#define	TYOUON_X	0

#define	DE2_X		0
#define	SEI_X		0
#define	TUITE_X		0
#define	TUMORI_X	0
#define	NO2_X		0
#define	NN_X		0
/*#define	SOU_X		0*/
#define	KAI_X		0

#define	WA_X		0
#define	MON_X		0
#define	JA_X		0
#define	CHA_X		0
#define	XTUPANA_X	0
#define	XTUTE_X		0
#define	TERO_X		0
#define	XTUKO_X		0

#define	DOMO_X		0
#define	TAMAE_X		0
#define	YUE_X		0
#define	TOKE_X		0
#define	DOKE_X		0
#define	TOTE_X		0

#define	KA_O		0x80
#define	KASHIRA_O	0x40
#define	KARA_O		0x20
#define	GA_O		0x10
#define	KIRI_O		0x08
#define	KURAI_O		0x04
#define	GURAI_O		0x02
#define	KEDO_O		0x01

#define	KEREDO_O	0x80
#define	KOSO_O		0x40
#define	SA_O		0x20
#define	SAE_O		0x10
#define	SHI_O		0x08
#define	SHIKA_O		0x04
#define	SURA_O		0x02
#define	ZUTU_O		0x01

#define	ZE_O		0x80
#define	ZO_O		0x40
#define	TARI_O		0x20
#define	DAKE_O		0x10
#define	DATTE_O		0x08
#define	DARI_O		0x04
#define	TUTU_O		0x02
#define	DUTU_O		0x01

#define	TE_O		0x80
#define	TEMO_O		0x40
#define	DE_O		0x20
#define	DEMO_O		0x10
#define	TO_O		0x08
#define	TOMO_O		0x04
#define	NA_O		0x02
#define	NAA_O		0x01

#define	NAGARA_O	0x80
#define	NADO_O		0x40
#define	NARI_O		0x20
#define	NARITO_O	0x10
#define	NANKA_O		0x08
#define	NANZO_O		0x04
#define	NANTE_O		0x02
#define	NI_O		0x01

#define	NE_O		0x80
#define	NEE_O		0x40
#define	NO_O		0x20
#define	NODE_O		0x10
#define	NONI_O		0x08
#define	HA_O		0x04
#define	BA_O		0x02
#define	BAKARI_O	0x01

#define	HE_O		0x80
#define	HOKA_O		0x40
#define	HODO_O		0x20
#define	MADE_O		0x10
#define	MO_O		0x08
#define	YA_O		0x04
#define	YARA_O		0x02
#define	YO_O		0x01

#define	YORI_O		0x80	
#define	WO_O		0x40
#define	UTI_O		0x20
#define	KOTO_O		0x10
#define	TAME_O		0x08	
#define	TOORI_O		0x04
#define	TOKI_O		0x02
#define	TOKORO_O	0x01

#define	DOKORO_O	0x80
#define	NOMI_O		0x40
#define	HAZU_O		0x20
#define	XTUKIRI_O	0x10
#define	MAMA_O		0x08
#define	MONO_O		0x04
#define	WAKE_O		0x02
#define	TYOUON_O	0x01

#define	DE2_O		0x80
#define	SEI_O		0x40
#define	TUITE_O		0x20
#define	TUMORI_O	0x10
#define	NO2_O		0x08
#define	NN_O		0x04
/*#define	SOU_O		0x02*/
#define	KAI_O		0x01

#define	WA_O		0x80
#define	MON_O		0x40
#define	JA_O		0x20
#define	CHA_O		0x10
#define	XTUPANA_O	0x08
#define	XTUTE_O		0x04
#define	TERO_O		0x02
#define	XTUKO_O		0x01

#define	DOMO_O		0x80
#define	TAMAE_O		0x40
#define	YUE_O		0x20
#define	TOKE_O		0x10
#define	DOKE_O		0x08
#define	TOTE_O		0x04

#define	_XA		0x02
#define	_A		0x03
#define	_XI		0x04
#define	_I		0x05
#define	_XU		0x06
#define	__U		0x07	/* toshif-s: _U is already defined */
#define	_XE		0x08
#define	_E		0x09
#define	_XO		0x0a
#define	_O		0x0b
#define	_KA		0x0c
#define	_GA		0x0d
#define	_KI		0x0e
#define	_GI		0x0f
#define	_KU		0x10
#define	_GU		0x11
#define	_KE		0x12
#define	_GE		0x13
#define	_KO		0x14
#define	_GO		0x15
#define	_SA		0x16
#define	_ZA		0x17
#define	_SI		0x18
#define	_ZI		0x19
#define	_SU		0x1a
#define	_ZU		0x1b
#define	_SE		0x1c
#define	_ZE		0x1d
#define	_SO		0x1e
#define	_ZO		0x1f
#define	_TA		0x20
#define	_DA		0x21
#define	_TI		0x22
#define	_DI		0x23
#define	_XTU		0x24
#define	_TU		0x25
#define	_DU		0x26
#define	_TE		0x27
#define	_DE		0x28
#define	_TO		0x29
#define	_DO		0x2a
#define	_NA		0x2b
#define	_NI		0x2c
#define	_NU		0x2d
#define	_NE		0x2e
#define	_NO		0x2f
#define	_HA		0x30
#define	_BA		0x31
#define	_PA		0x32
#define	_HI		0x33
#define	_BI		0x34
#define	_PI		0x35
#define	_HU		0x36
#define	_BU		0x37
#define	_PU		0x38
#define	_HE		0x39
#define	_BE		0x3a
#define	_PE		0x3b
#define	_HO		0x3c
#define	_BO		0x3d
#define	_PO		0x3e
#define	_MA		0x3f
#define	_MI		0x40
#define	_MU		0x41
#define	_ME		0x42
#define	_MO		0x43
#define	_XYA		0x44
#define	_YA		0x45
#define	_XYU		0x46
#define	_YU		0x47
#define	_XYO		0x48
#define	_YO		0x49
#define	_RA		0x4a
#define	_RI		0x4b
#define	_RU		0x4c
#define	_RE		0x4d
#define	_RO		0x4e
#define	_XWA		0x4f
#define	_WA		0x50
#define	_WI		0x51
#define	_WE		0x52
#define	_WO		0x53
#define	__N		0x54
#define	_VU		0x55
#define	_TYOUON		0x56
#define	_OVERSCORE	0xfe

#define	_KUTOUTEN	0x58
#define	_HAN_SUUJI	0x59
#define	_HANKAKU	0x5a
#define	_SUUJI		0x5b
#define	_KIGO		0x5c
#define	_KAKKO_HIRAKI	0x5d
#define	_KAKKO_TOJI		0x5e

