/******************************************************************************
	Getvcode.H
******************************************************************************/
#include "typedef.h"

/*=============================================================================
	Typedef
=============================================================================*/
typedef struct	_tagKD {
	XEvent		*xeEvent;
	KeySym		ksKeysym;
	UCHAR		*ucString;
	WORD		wFunc;
	WORD		wOrgChar;
	LPARAM		lFuncOption;
	UCHAR		*ucFuncString;
} KD, *LPKD;

typedef struct	_tagCOLROW {
	int	col;
	int	row;
} COLROW, *LPCOLROW;

/*=============================================================================
	Function
=============================================================================*/
BOOL	IsKanjiKey (FXim_Client *client, LPKD lpKD);
BOOL	IsScreenMode (FXim_Client *client);
BOOL	IsKanaMode (FXim_Client *client);
BOOL	IsSkipKey (FXim_Client *client, LPKD lpKD);
USHORT	GetStageNo (FXim_Client *client, LPKD lpKD);
USHORT	GetModifNo (LPKD lpKD);
void	MapPunc (FXim_Client *client, LPKD lpKD);
void	MapKana (FXim_Client *client, LPKD lpKD);
void	MapKbd (FXim_Client *client, LPKD lpKD);
void	VirtToChar (FXim_Client *client, LPKD lpKD);
void	VirtToFunc (FXim_Client *client, LPKD lpKD);
void	KeyMap (FXim_Client *client, LPKD lpKD);
void	EnvToCore (FXim_Client *client, LPVWIN lpVWin, LPENV lpEnv);
void	SizeFixToCore (FXim_Client *client, LPVWIN lpVWin, LPENV lpEnv);
void	CoreToEnv (FXim_Client *client, LPVWIN lpVWin, LPENV lpEnv);

BOOL	FuncHandler (FXim_Client *client, LPKD lpKD);
BOOL	SaveHandler (FXim_Client *client, LPKD lpKD);
BOOL	CaseHandler (FXim_Client *client, LPKD lpKD);
BOOL	VModeHandler (FXim_Client *client, LPKD lpKD);
BOOL	IModeHandler (FXim_Client *client, LPKD lpKD);
BOOL	ExtHandler (FXim_Client *client, LPKD lpKD);
BOOL	RecHandler (FXim_Client *client, LPKD lpKD);
BOOL	DlgHandler (FXim_Client *client, LPKD lpKD);
BOOL	MenuHandler (FXim_Client *client, LPKD lpKD);
BOOL	KohoHandler (FXim_Client *client, LPKD lpKD);
BOOL	CharHandler (FXim_Client *client, LPKD lpKD);
BOOL	EditHandler (FXim_Client *client, LPKD lpKD);
BOOL	UndoHandler (FXim_Client *client, LPKD lpKD);
BOOL	EtcHandler (FXim_Client *client, LPKD lpKD);
BOOL	CandidateHandler (FXim_Client *client, LPKD lpKD);

void	VJEEditX (FXim_Client *client, USHORT count);

/*=============================================================================
	Extern
=============================================================================*/
extern	DWORD	dwLim[];

