/******************************************************************************
	Macro.H
******************************************************************************/
/*-----------------------------------------------------------------------------
	macro
-----------------------------------------------------------------------------*/
#define	recof(x)	((sizeof x)/(sizeof x[0]))
#define	add(v1,v2)	((v1) + (v2))
#define	sub(v1,v2)	((v1) - (v2))
#define	add2(v1,v2)	(v1 += (v2))
#define	sub2(v1,v2)	(v1 -= (v2))
#ifndef	max
#define	max(a,b)	(((a) > (b)) ? (a) : (b))
#endif
#ifndef	min
#define	min(a,b)	(((a) < (b)) ? (a) : (b))
#endif
#define	max2(v1,v2)	(v1 = (v1) > (v2) ? (v1) : (v2))
#define	min2(v1,v2)	(v1 = (v1) < (v2) ? (v1) : (v2))
#if !PCUNIX
#define	abs(n)		((n) < 0 ? -(n) :  (n))
#endif /* !PCUNIX */
#define	neg(n)		((n) < 0 ?  (n) : -(n))
#define	xchg(a,b,t)	((t) = (a),(a) = (b),(b) = (t))
#define	raise(a,b)	( ( (a) / (b) ) + ( (a) % (b) ? 1 : 0 ) )
#define	iff(c,t,f)	((c) ? (t) : (f))
#if !PCUNIX
#define	B16(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p)				\
			(   (a      )|(b <<  1)|(c <<  2)|(d <<  3)	\
			|   (e <<  4)|(f <<  5)|(g <<  6)|(h <<  7)	\
			|   (i <<  8)|(j <<  9)|(k << 10)|(l << 11)	\
			|   (m << 12)|(n << 13)|(o << 14)|(p << 15)	)
#define	B16CHK(no,b16)	(b16[(no) >> 4] & (1 << ((no) & 0x0f)))
#endif /* !PCUNIX */
#define	IsDBCS(c)	((0x80<=(c) && (c)<=0x9f) || (0xe0<=(c) && (c)<=0xfc))
#define	IsDBCSLeadByte(c)	IsDBCS(c)
#ifndef	LOBYTE
#define LOBYTE(w)	((BYTE)(w))
#endif
#ifndef	HIBYTE
#define HIBYTE(w)	((BYTE)(((UINT)(w) >> 8) & 0xFF))
#endif
#ifndef	LOWORD
#define LOWORD(l)	((WORD)(DWORD)(l))
#endif
#ifndef	HIWORD
#define HIWORD(l)	((WORD)((((DWORD)(l)) >> 16) & 0xFFFF))
#endif
#ifndef	MAKELONG
#define MAKELONG(l,h)	((LONG)(((WORD)(l)) | (((DWORD)((WORD)(h))) << 16)))
#endif
#define	upper(x)	((TCHAR)( ('a'<= ((int)(x)) && ((int)(x)) <='z'	) \
				? ( ((int)(x)) - 0x20			) \
				: ( ((int)(x))				) ) )

#define	isalpha(x)	(('a'<=(x) && (x)<='z') || ('A'<=(x) && (x)<='Z'))
