/******************************************************************************
	strutl.h
******************************************************************************/
/*=============================================================================
	Environment
=============================================================================*/
#define	USE_WINAPI	0

/*=============================================================================
	Profile	Compatible Functions
=============================================================================*/
int	WINAPI	GetPPString  (LPTSTR,LPTSTR,LPTSTR,LPTSTR,int,LPTSTR);
int	WINAPI	WritePPString(LPTSTR,LPTSTR,LPTSTR,LPTSTR);
void	WINAPI	FlushPP      (void);

/*=============================================================================
	Profile	Extend Functions
=============================================================================*/
#if	!USE_WINAPI
LPVOID	WINAPI	BeginFetchPP(LPTSTR  lpchSection,LPTSTR lpchFile);
LPVOID	WINAPI	FetchPPString(LPVOID,LPTSTR,int,LPTSTR,int);
#endif

/*=============================================================================
	Profile	Service Functions
=============================================================================*/
int	WINAPI	GPInt(LPTSTR,LPTSTR,LPTSTR,int);
LPTSTR	WINAPI	GPStr(LPTSTR,LPTSTR,LPTSTR,LPTSTR);
int	WINAPI	GPSel(LPTSTR,LPTSTR,LPTSTR,int,LPTSTR);
int	WINAPI	GPHex(LPTSTR,LPTSTR,LPTSTR,int);
void	WINAPI	WPInt(LPTSTR,LPTSTR,LPTSTR,int);
void	WINAPI	WPStr(LPTSTR,LPTSTR,LPTSTR,LPTSTR);
void	WINAPI	WPSel(LPTSTR,LPTSTR,LPTSTR,int,LPTSTR);
void	WINAPI	WPHex(LPTSTR,LPTSTR,LPTSTR,int);

/*=============================================================================
	lstr*	Functions
=============================================================================*/
/* #ifdef	DPMI */
#if PCUNIX || defined(DPMI)
LPTSTR	WINAPI	lstrcpy(LPTSTR dest,LPTSTR src);
LPTSTR	WINAPI	lstrcat(LPTSTR dest,LPTSTR src);
int	WINAPI	lstrcmp(LPTSTR dest,LPTSTR src);
int	WINAPI	lstrcmpi(LPTSTR dest,LPTSTR src);
int	WINAPI	lstrlen(LPTSTR src);
#endif
LPTSTR	WINAPI	lstrncpy(LPTSTR lptDes,LPTSTR lptSrc,int maxDes);
LPTSTR	WINAPI	lstrcpy2(LPTSTR lptDes,LPTSTR lptSrc);
LPTSTR	WINAPI	lmemcpy(LPSTR lptDes,LPSTR lptSrc,int maxDes);
int	WINAPI	lstrncmp(LPTSTR lptDes,LPTSTR lptSrc,int maxCmp);
int	WINAPI	lstrncmpi(LPTSTR lptDes,LPTSTR lptSrc,int maxCmp);
LPTSTR	WINAPI	lstrchr(LPTSTR lptSrc,TCHAR tch);
int	WINAPI	jstrlen(LPTSTR lptSrc);
LPTSTR	WINAPI	lstrtok(LPTSTR lptStr,TCHAR sztSep);
int	WINAPI	latoi(LPTSTR lptStr);
LPTSTR	WINAPI	litos(int v,int r);
#if !PCUNIX
LPSTR	_cdecl	lstrxcat(LPTSTR lptOut, ...);
#else /* !PCUNIX */
LPTSTR	_cdecl	lstrxcat(LPTSTR lptOut, ...);
#endif /* !PCUNIX */
LPTSTR	WINAPI	lchrcat(LPTSTR lptDes,int iChar);
int	WINAPI	lstrtyp(LPTSTR lptSrc,int iPos);
#ifdef	DPMI
typedef	int	(_cdecl *CMPFUNC)(const void *,const void *);
void *	_cdecl	lsearch(void *,const void *,int,int,CMPFUNC);
#endif
