/******************************************************************************
	TYPEDEF.H
******************************************************************************/
#ifndef	_INC_TYPEDEF_
#define	_INC_TYPEDEF_
#if PCUNIX
#include <stdio.h>
#include <unistd.h>
#include <X11/Xlib.h>
#include <X11/Xmd.h>
#endif /* !PCUNIX */
/*=============================================================================
	ܷ
=============================================================================*/
#if !PCUNIX
#ifndef	FAR
#define	FAR			_far
#endif
#ifndef	PASCAL
#define	PASCAL			_pascal
#endif
#ifndef	NEAR
#define	NEAR			_near
#endif
#ifndef	FTYPE
#define FTYPE			_fastcall
#endif
#else /* !PCUNIX */
#define	FAR
#define	PASCAL
#define	NEAR
#define FTYPE
#define _cdecl
#endif /* !PCUNIX */
#ifndef	LONG
#define	LONG			long
#endif
#ifndef	public
#define	public
#endif
#ifndef	global
#define	global
#endif
#if !PCUNIX
#ifndef	FALSE
#define	FALSE			0
#endif
#ifndef	TRUE
#define	TRUE			(-1)
#endif
#else /* !PCUNIX */
#ifndef	FALSE
#define	FALSE			False
#endif
#ifndef	TRUE
#define	TRUE			True
#endif
#endif /* !PCUNIX */
#ifndef	MAX_PATH
#define	MAX_PATH		256
#endif
#ifndef	WINAPI
#define	WINAPI			PASCAL
#endif
#ifndef	TEXT
#define	TEXT(x)			x
#endif
#ifndef	NULL
#define	NULL			((void *)0)
#endif

/*
	value	type
*/
#if !PCUNIX
typedef	int			BOOL;
typedef	unsigned char		BYTE;
#endif /* !PCUNIX */
typedef	unsigned short		WORD;
typedef	unsigned long		DWORD;
#if !PCUNIX
typedef	unsigned char		UCHAR;
typedef	unsigned short		USHORT;
typedef	unsigned long		ULONG;
#endif /* !PCUNIX */
typedef unsigned int		UINT;
/*
	FAR *
*/
typedef		void	FAR *		LPVOID;
typedef		char	FAR *		LPCHAR;
typedef unsigned char	FAR *		LPUCHAR;
typedef		short	FAR *		LPSHORT;
typedef unsigned short	FAR *		LPUSHORT;
typedef 	char	FAR *		LPSTR;
typedef		BYTE	FAR *		LPBYTE;
typedef		int	FAR *		LPINT;
typedef		WORD	FAR *		LPWORD;
typedef		long	FAR *		LPLONG;
typedef		DWORD	FAR *		LPDWORD;
/*
	NEAR *
*/
typedef	char	NEAR *		PSTR;
typedef	BYTE	NEAR *		PBYTE;
typedef	int	NEAR *		PINT;
typedef	WORD	NEAR *		PWORD;
typedef	long	NEAR *		PLONG;
typedef	DWORD	NEAR *		PDWORD;
/*
	other
*/
typedef UINT	HANDLE;
#define	HWND	WORD
typedef	unsigned char		TCHAR;
typedef	TCHAR FAR *		LPTSTR;
typedef	TCHAR FAR *		LPTCHAR;
typedef	LONG			LPARAM;
typedef	WORD			WPARAM;
#if !PCUNIX
typedef	void FAR *		LPVOID;
#endif /* !PCUNIX */
typedef	const void FAR *	LPCVOID;
#endif

