#define MAX_HINDO	0x07
#define EXPAND_INDEX_ERR	-12

#define	RSV	0x00		/* Reserve hinshi	*/
#define	H_LEN1	0x01		/* Hinshi Byte Length	*/
#define	H_LEN2	0x02
#define	H_LEN3	0x03
#define	H_LEN4	0x04
#define	H_LEN5	0x05
#define	H_LEN6	0x06
#define	H_LEN7	0x07
#define	RSVLBIT	0x08		/* Reserve low bit	*/
#define	MAINBIT	0x10		/* Main hinshi bit	*/
#define	SUBBIT	0x20		/* Sub hinshi bit	*/
#define	USRBIT	0x40		/* Usr hinshi bit	*/
#define	RSVHBIT	0x80		/* Reserve hi bit	*/

#ifdef	UCS
#define	UCS_LEN	4
#define	UDC_LEN	6
#endif

#define	GAKUSYUU		0x77
#define	USER_HINSHI		0x7f
#define	KUGIRI_GAKU		0x00

#define	HYOUKI_INF		0x48
#define	KAKARI_YOUREI_INF	0x49
#define	UKE_YOUREI_INF		0x4a
#define	KAKARI_YOUREI_IMI_INF	0x4b
#define	UKE_YOUREI_IMI_INF	0x4c
#define	KAKARI_GAKU_INF		0x4d
#define	UKE_GAKU_INF		0x4e

#define	HINSHILENG(h)	(h & H_LEN7)

#if	(WINDOWS && !DPMI)
#define	MEMCPY(d, s, c)	memcpy_l(d, s, c)
#define	MEMCMP(d, s, c)	memcmp_l(d, s, c)
#define	STRCPY(d, s)	lstrcpy(d, s)
#define	STRLEN(d)	lstrlen(d)
#else	
#define	MEMCPY(d, s, c)	memcpy_l(d, s, c)
#define	MEMCMP(d, s, c)	memcmp_l(d, s, c)
#define	STRCPY(d, s)	StrCpy(d, s)
#define	STRLEN(d)	StrBufLen(d)
#endif

#define SEND_HINSHI	1
#define SEND_HYOUKI	2
#define SEND_YOUREI	3

#define	LONGRECCOUNTMAX	16
#define	YOMI_SIZE	65

