/*
**	VJE Delta
**
**			wcnvbuf.c
**
*/
#include	"common.h"
#include	"basicedt.h"
#include	"vjestr.h"
#include	"wfncdef.h"
#include	"vjelib.h"
#include	"vfzk.h"
#include	"vfncdef.h"

#define NX	1
#define	chk_cnv_nn(c)	(0x20 <= ((c) & 0xff) && ((c) & 0xff) <= 0x40 ||\
			 0x5b <= ((c) & 0xff) && ((c) & 0xff) <= 0x5f ||\
			 0x7b <= ((c) & 0xff) && ((c) & 0xff) <= 0x7e ||\
			 0xa1 <= ((c) & 0xff) && ((c) & 0xff) <= 0xa5 )
#if	SINGLE
static	void FTYPE	cnv_pos_chk ( short );
static	void FTYPE	pos_add ( void );
static	UCHAR FTYPE	cnv_kuten( UCHAR, short,unsigned char PWIN *,UCHAR);
static  void FTYPE 	chk_cnv_code(unsigned char PWIN *);
static  short	CheckCnvMode(UCHAR );
#else
static	void	cnv_pos_chk (PBEBUF, short );
static	void	pos_add ( PBEBUF );
static	UCHAR	cnv_kuten( PBEBUF, UCHAR, short,unsigned char PWIN *,UCHAR);
static  void 	chk_cnv_code(PBEBUF, unsigned char PWIN *);
static  short	CheckCnvMode(PBEBUF pbe,UCHAR ch);
#endif

/*
 *     Convert 1.byte code to KANA (1.BYTE or 2.BYTE)
 *
 *     Calling sequence
 *
 *		 rc = cnv_code ( mode )
 *
 *        (i)    mode ......... VJEmode
 *
 */
void FTYPE	cnv_code ( pbe, bdata, mode )
PBEBUF	pbe;
PBD 	bdata;
short	mode;								/* VJEmode */
{
/*822*/	UCHAR	chk_buf[NUM_CHAR * 2 + 1];	/* cover check buffer */
/*419*/	UCHAR	before1, before2;		/* before charcter */
	UCHAR	chr;
	UCHAR	half_buf [ 5 ]; 				/* input data buffer */
	UCHAR	work_buf [ 9 ]; 				/* work_buf for convert */
	SBUFF	b_work; 				/* work_buf for convert */
	SBUFF	b_cnv;					/* convert data buffer */
	UCHAR	cnv_buf [ 9 ];					/* convert data buffer */
/*	UCHAR	cnv_atr [ 9 ];					/ * conver data attribute * / */
	USHORT	cnv_atr [ 9 ];					/* conver data attribute */
	BUFF	save_buf;	/*	UCHAR	save_buf [ NUM_CHAR * 2 + 1 ];*/	/* save area */
/*	UCHAR	save_atr [ NUM_CHAR * 2 + 1 ];	/ * atributte save area * / */
	USHORT  save_atr [ NUM_CHAR * 2 + 1 ];	/* atributte save area */
	short	i;
	short	j;
/*822*/	short	modesave;
	short	rc;
	short	len;
	short	cnv_cnt;						/* romaji convert count */
	short	sp, ep, kp;
	short	kflg;
/*	short	modex;	*/
/*0716*/
	UCHAR	before_key;

/*822*/	modesave = mode;
	if ( pbe->kihon_cnv >= pbe->kihon_pos )
		return;
/**/	if ((pbe->kihon_atr_Q[pbe->kihon_cnv + 1] & M_ROMA_CNT) == 0)
/**/		(void)chk_blk(pbe,pbe->kihon_cnv);
/**/	if (((pbe->kihon_atr_Q[pbe->kihon_pos + 1] & M_ROMA_CNT) == 0)
/**/	     && (pbe->kihon_pos < SLength(pbe->kihon_buf_Q))) {
/**/		(void)chk_blk(pbe,pbe->kihon_pos);
/**/	}
	if ( (mode & ZENKAKU_BIT) == 0 ) {
		j = KATA_BIT;
		for ( i = pbe->kihon_cnv; i < pbe->kihon_pos; i++ )
			j &= (pbe->kihon_atr_Q [ i + 1 ] & KATA_BIT);
		mode |= j;
	}
/*822*/	chk_cnv_code(pbe,chk_buf);
	mode &= ~(M_ZEN_HAN | M_ROMA_CNT);
	cnv_pos_chk ( pbe,mode );			/* Ѵ ǡ kihon_cnv ʤɤĴ */
	/* save input buffer  */
	for ( i = 0; i <= SLength(pbe->kihon_buf_Q); i++ ) {
		save_buf.str[ i ] = pbe->kihon_buf_Q.str [ i ];
		save_atr [ i ] = pbe->kihon_atr_Q [ i ];
	}
	SLength(save_buf) = SLength(pbe->kihon_buf_Q);

	/* start */
/*816*/	before1 = before2 = 0;
	chr = (UCHAR)(mode & (KANA_BIT | KATA_BIT | ZENKAKU_BIT));
	cnv_atr [ 0 ] = 0;
	for ( i = 1; i < 9; i++ )
		cnv_atr [ i ] = chr;

	ep = sp = pbe->key_cnv;
	kp = pbe->kihon_cnv;
	while ( sp < pbe->key_pos ) {
		j = ep - sp + 1;
/*716*/
		if (sp > 0)
			before_key = pbe->key_buf_Q.str [ sp ];
		else
			before_key = 0;
		for ( i = 1; i <= j; i++ )
			half_buf [ i ] = work_buf [ i ] = pbe->key_buf_Q.str [ sp + i ];
		Length(half_buf) = Length(work_buf) = (UCHAR)j;
		half_buf[1] = cnv_kuten(pbe,half_buf[1],mode,
			&pbe->kihon_buf_Q.str[get_kpos(pbe,sp - pbe->key_pos) + 1],
			before_key);
		rc = 1;
/**/		kflg = 0;
		if ( (chr = half_buf [ 1 ]) >= 0xA6 && chr <= 0xDF )
/**/			kflg = 1;
		else if ( (chr = half_buf [ 1 ]) >= 0x41 && chr <= 0x5a )	/**/
			;
		else if ( (chr = half_buf [ 1 ]) >= 0x61 && chr <= 0x7a ) /**/
			;
		else {
				if (  sp + i <= SLength(pbe->key_buf_Q) )
					half_buf [ i ] = pbe->key_buf_Q.str [ sp + i ];
				else
					half_buf [ i ] = 0;
				goto next;						/* not convert */
		}
/**/		if ( (mode & KATA_BIT) != 0 || kflg == 1)
			goto next;						/* not convert */
		for (i = 0, j = 0; i <= sp; j++)
			i += (save_atr[j + 1] & M_ROMA_CNT);
		if (modesave == CNV_HAN  && (save_atr [j] & KATA_BIT) != 0 ) {	/* 1991/5/27 Y.MOGI */
			goto next;		/* not convert */		/* 1991/5/27 Y.MOGI */
		}

		if (chk_buf[j] != 0)
			goto next;		/* not convert */
		if ( Length(work_buf) == 4 ) {		/* 4 char */
			if ( !(cnv_cnt = cnvdel_roma ( pbe,work_buf )) ) {
				for ( i = 1; i < (short)Length(work_buf); i++ ) /* 1 char shift */
					work_buf [ i ] = work_buf [ i + 1 ];
				Length(work_buf) = (UCHAR)(Length(work_buf) - 1);	/* 3 char */
#if NX
				if ( !(cnv_cnt = cnv_roma ( pbe,work_buf )) ) {
					if ( !(cnv_cnt = cnvdel_roma ( pbe,work_buf )) ) {
						for ( i = 1; i <= work_buf [ 0 ] - 1; i++ )
							work_buf [ i ] = work_buf [ i + 1 ];
						work_buf [ 0 ] = (UCHAR)(work_buf [ 0 ] - 1);	/* 2 */
						if ( !(cnv_cnt = cnv_roma ( pbe,work_buf )) ) {
							work_buf [ 1 ] = work_buf [ 2 ];
							work_buf [ 0 ] = (UCHAR)1;		/* 1 */
							if ( cnv_cnt = cnv_roma ( pbe,work_buf ) )
								cnv_atr [ 1 ] |= 1;
						}
						else
							cnv_atr [ 1 ] |= 2;
					}
					else {
						if ( mode & ZENKAKU_BIT )		   /* ѥ⡼ */
							cnv_atr [ 3 ] |= 2;
						else
							cnv_atr [ 2 ] |= 2;
						cnv_atr [ 1 ] |= 1;
					}
				}
				else
					cnv_atr [ 1 ] |= 3;
#else
				if ( cnv_cnt = cnv_roma ( pbe,work_buf ) ) {
					if ( mode & ZENKAKU_BIT )			/* ѥ⡼ */
						cnv_atr [ 3 ] |= cnv_cnt - 1;
					else
						cnv_atr [ 2 ] |= cnv_cnt - 1;
					cnv_atr [ 1 ] |= 1;
				}
#endif
			}
			else {
				if ( mode & ZENKAKU_BIT )				/* ѥ⡼ */
					cnv_atr [ 3 ] |= cnv_cnt - 1;
				else
					cnv_atr [ 2 ] |= cnv_cnt - 1;
				cnv_atr [ 1 ] |= 1;
			}
		}
		else if ( Length(work_buf) == 3 ) { /* 3 char */
			if ( !(cnv_cnt = cnv_roma ( pbe,work_buf )) ) {
				if ( cnv_cnt = cnvdel_roma ( pbe,work_buf ) ) {
					if ((work_buf[1] & 0xDF) != (UCHAR)'N' )
						cnv_atr [ 1 ] |= cnv_cnt;
					else {
						if (mode & KANA_BIT ) {
							if ( mode & ZENKAKU_BIT )
								cnv_atr [ 3 ] |= cnv_cnt - 1;
							else
								cnv_atr [ 2 ] |= cnv_cnt - 1;
						} else
							cnv_atr [ 3 ] |= cnv_cnt - 1;
						cnv_atr [ 1 ] |= 1;
					}
				}
			}
			else
				cnv_atr [ 1 ] |= cnv_cnt;
		}
#if NX
		else if ( Length(half_buf) == 2 ) { /* 2 char */
			if ( cnv_cnt = cnv_roma ( pbe,half_buf ) )
				cnv_atr [ 1 ] |= cnv_cnt;
			else {
				if ( (half_buf [ 1 ] & 0xDF) == (UCHAR)'N' &&
				   ( chk_cnv_nn(half_buf[2]) ||
				     half_buf[2] > 0x80) ) {
					cnv_cnt = 1;
					pbe->cnv_data [ 0 ] = 2;
					pbe->cnv_data [ 1 ] = 0x83;
					pbe->cnv_data [ 2 ] = 0x93;
					cnv_atr [ 1 ] |= cnv_cnt;
					Length(half_buf) = 1;
				}
			}
		}
#endif
		else {								/* 1 char */
			if ( cnv_cnt = cnv_roma ( pbe,half_buf ) )
				cnv_atr [ 1 ] |= cnv_cnt;
			else {
				if ( sp == (pbe->key_pos - 1) ) {
					if ( (half_buf [ 1 ] & 0xDF) == (UCHAR)'N' ) {
						cnv_cnt = 1;
						pbe->cnv_data [ 0 ] = 2;
						pbe->cnv_data [ 1 ] = 0x83;
						pbe->cnv_data [ 2 ] = 0x93;
						cnv_atr [ 1 ] |= cnv_cnt;
					}
				}
			}
		}
		if ( cnv_cnt ) {
			rc = 0;
/*816*/			if (Length(pbe->cnv_data) >= 2) {
/*816*/				before1 = pbe->cnv_data[Length(pbe->cnv_data)-1];
/*816*/				before2 = pbe->cnv_data[Length(pbe->cnv_data)];
/*816*/			}
			if ( (mode & KANA_BIT) != 0 ) { 			/* Katakana mode */

#if	1	/*iida */
				if ( (mode & ZENKAKU_BIT)      == 0
				&&   (pbe->wLimitMode & M_JIS) == 0 ) {
#else
				if ( (mode & ZENKAKU_BIT) == 0 ) {		/* han kaku mode */
#endif
					for ( i = 1; i <= Length(half_buf) - cnv_cnt; i++ ) {
						pbe->kihon_buf_Q.str [ ++kp ] = half_buf [ i ];
						pbe->kihon_atr_Q [	kp ] = (UCHAR)(mode | F_HANK | C_ROMA_1);
					}
#if 1	/*mk3*/
					Copylng(pbe->cnv_data, b_cnv.str, Length(pbe->cnv_data) + 1);
					SLength(b_cnv) = (short)Length(pbe->cnv_data);
					rc = zen_han ( (BUFF *)&b_cnv, (BUFF *)&b_work );/*991210 WRN*/
					for ( i = 1; i <= SLength(b_work); i++ ) {
						cnv_buf [ i ]  = b_work.str[ i ];
						cnv_atr [ i ] |= F_HANK;
					}
					Length(cnv_buf) = Length(cnv_atr) = SLength(b_work);
#else
					rc = zen_han ( pbe->cnv_data, work_buf );
					for ( i = 1; i <= (short)Length(work_buf); i++ ) {
						cnv_buf [ i ]  = work_buf [ i ];
						cnv_atr [ i ] |= F_HANK;
					}
					Length(cnv_buf) = Length(cnv_atr) = Length(work_buf);
#endif
				}
				else {						/* zen kaku mode */
					if ( cnv_cnt != (short)Length(half_buf) ) {
						for ( i = 1; i <= Length(half_buf) - cnv_cnt; i++ ) {
							Jissj ( half_buf [ i ], work_buf, 0 );
							pbe->kihon_buf_Q.str[ ++kp ] = work_buf [ 1 ];
							pbe->kihon_atr_Q [	kp ] = (UCHAR)(mode | F_ZEN_L | C_ROMA_1);
							pbe->kihon_buf_Q.str[ ++kp ] = work_buf [ 2 ];
							pbe->kihon_atr_Q [	kp ] = (UCHAR)(mode | F_ZEN_L);
						}
					}
					for ( i = 0; i <= (short)Length(pbe->cnv_data); i++ )
						cnv_buf [ i ] = pbe->cnv_data [ i ];
				}
			}
			else {							/* Hiragna mode */
				if ( cnv_cnt != (short)Length(half_buf) ) {
					for ( i = 1; i <= Length(half_buf) - cnv_cnt; i++ ) {
						Jissj ( half_buf [ i ], work_buf, 0 );
						pbe->kihon_buf_Q.str[ ++kp ] = work_buf [ 1 ];
						pbe->kihon_atr_Q [	kp ] = (UCHAR)(mode | F_ZEN_L | C_ROMA_1);
						pbe->kihon_buf_Q.str[ ++kp ] = work_buf [ 2 ];
						pbe->kihon_atr_Q [	kp ] = (UCHAR)(mode | F_ZEN_L);
					}
				}
#if 1	/*mk3*/
				Copylng(pbe->cnv_data, b_cnv.str, Length(pbe->cnv_data) + 1);
				SLength(b_cnv) = (short)Length(pbe->cnv_data);
				kata_hira ( (BUFF *)&b_cnv, (BUFF *)&b_work );/*991210 WRN*/
				Copylng( b_work.str, cnv_buf, SLength(b_work) + 1);
				Length(cnv_buf) = (UCHAR)SLength(b_work);
#else
				kata_hira ( pbe->cnv_data, cnv_buf );
#endif
			}

			if ( rc == 0 ) {
				if ( (mode & ZENKAKU_BIT) != 0 ) {
					for ( i = 1; i <= (short)Length(cnv_buf); i++ ) {
						if ( (i & 0x01) != 0 )
							cnv_atr [ i ] |= F_ZEN_L;
						else
							cnv_atr [ i ] |= F_ZEN_R;
					}
				}
			}
		}
		else
			rc = 1;
		/* check result */
		if ( rc != 0 ) {						/* Not convert */
			ep++;
			if ( ep - sp >= 4 || ep >= pbe->key_pos ) {
				if ( (ep - sp ) == 4 )
					ep = sp + 1;
{	short i;
	short	modex;
	modex = mode & ~CNV_KUTEN;
	if ( modex & CNV_TEST )
		goto NOP1;
#if	1	/*iida */
	if ( (modex == CNV_HAN || modex == CNV_HAN_EISU )
	&&   (pbe->wLimitMode & M_JIS			)
	&&   (0xa0 <= half_buf[1] && half_buf[1] <= 0xdf) )
		goto	ZEN1;
#endif
	if ( modex == CNV_HAN || modex == CNV_HAN_EISU )
		goto HAN1;
	if (!((modex & ZENKAKU_BIT) && (modex & KATA_BIT))) {
		if ((i = CheckCnvMode(pbe, half_buf[1])) == 1)
			goto HAN1;
		else if (i == 2)
			goto ZEN1;
		else
			;
	}
}
NOP1:
				if ( (mode & ZENKAKU_BIT) != 0 ) {		/* zenkaku henkan */
ZEN1:
#if 1	/*mk3*/
/*BUG*/					Length(half_buf) = 1 ;
					Copylng(half_buf, b_cnv.str, Length(half_buf) + 1);
					SLength(b_cnv) = 1;
					han_kata ( (BUFF *)&b_cnv, (BUFF *)&b_work, 1 );/*991210 WRN*/
					Copylng( b_work.str, cnv_buf, SLength(b_work) + 1);
					len = Length(cnv_buf) = (UCHAR)SLength(b_work);
#else
/*BUG*/					Length(half_buf) = 1 ;
/*BUG*/					han_kata ( half_buf, cnv_buf, 1 );
/*BUG*/					len = Length(cnv_buf);
#endif
					if ( kp >= (pbe->kihon_max - len) )
						goto err_ret;
					for ( i = 1; i <= len;	) {
						pbe->kihon_buf_Q.str[ ++kp ] = cnv_buf [ i++ ];
						pbe->kihon_atr_Q [	kp ] = (UCHAR)(mode | F_ZEN_L | C_ROMA_1);
						pbe->kihon_buf_Q.str[ ++kp ] = cnv_buf [ i++ ];
						pbe->kihon_atr_Q [	kp ] = (UCHAR)(mode | F_ZEN_L);
					}
				}
				else {	/* hankaku henkan */
HAN1:
/*BUG*/					len = Length(half_buf) = 1;
					if ( kp >= (pbe->kihon_max - len) )
						goto err_ret;
					for ( i = 1; i <= len; i++ ) {
						pbe->kihon_buf_Q.str[ ++kp ] = half_buf [ i ];
						pbe->kihon_atr_Q [	kp ] = (UCHAR)(mode | F_HANK | C_ROMA_1);
					}
				}
				if ( (len = (short)Length(half_buf)) == 4 )
					++sp;
				else
					sp += len;
				ep = sp;
			}
			if ( ep > pbe->key_pos )
				ep = ++sp;
			continue;
		}
	next:
		/* check result */
		if ( rc != 0 ) {						/* Not convert */
			ep++;
{	short i;
	short	modex;
	modex = mode & ~CNV_KUTEN;
	if ( modex & CNV_TEST )
		goto NOP2;
#if	1	/*iida */
	if ( (modex == CNV_HAN || modex == CNV_HAN_EISU )
	&&   (pbe->wLimitMode & M_JIS			)
	&&   (0xa0 <= half_buf[1] && half_buf[1] <= 0xdf) )
		goto	ZEN2;
#endif
	if ( modex == CNV_HAN || modex == CNV_HAN_EISU )
		goto HAN2;
	if (!((modex & ZENKAKU_BIT) && (modex & KATA_BIT))) {
		if ((i = CheckCnvMode(pbe, half_buf[1])) == 1)
			goto HAN2;
		else if (i == 2)
			goto ZEN2;
		else
			;
	}
}
NOP2:
			if ( (mode & ZENKAKU_BIT) != 0 ) {			/* zenkaku henkan */
ZEN2:
/*4/19*/			if (before1 == 0x83 && before2 != 0) {
					i = chkdak(before2, half_buf[1]);
					if (i != 0) {
						if (i != V_TYP)
							pbe->kihon_buf_Q.str[kp] += (UCHAR)i;
						else {
							pbe->kihon_buf_Q.str[kp] = 0x94;
							pbe->kihon_buf_Q.str[kp - 1] = 0x83;
						}
						pbe->kihon_atr_Q[kp - 1]++;
						before2 = 0;
						sp++;
						ep = sp;
						goto next1;
					}
/*4/19*/			}
				if ( ep - sp >= 2 ) {
#if 1	/*mk3*/
					Copylng(half_buf, b_cnv.str, Length(half_buf) + 1);
					SLength(b_cnv) = Length(half_buf);
					han_kata ( (BUFF *)&b_cnv, (BUFF *)&b_work, 1 );/*991210 WRN*/
					Copylng( b_work.str, cnv_buf, SLength(b_work) + 1);
					Length(cnv_buf) = (UCHAR)SLength(b_work);
#else
					han_kata ( half_buf, cnv_buf, 1 );
#endif
				} else {
					if ( pbe->KutenMode != 0 &&
					 ((bdata->wVjeModeFlag & ZENKAKU_BIT) == 0) && ((mode & KATA_BIT) == 0) )
						i = 1;				/* ,.- -> kutouten */
					else
						i = 0;
/*716*/
					if (i == 1 && (0x30 <= before_key && before_key <= 0x39))
						i = 0;
					Jissj ( half_buf [ 1 ], cnv_buf, i );
				}
				Length(cnv_buf) = 2;
/**/				before1 = cnv_buf[1];
/**/				before2 = cnv_buf[2];
				if ( (mode & KANA_BIT) == 0 ) { 		/* hiragana mode */
#if 1	/*mk3:BUGFIX:990913*/
					Copylng(cnv_buf, b_cnv.str, Length(cnv_buf) + 1);
					SLength(b_cnv) = (short)Length(cnv_buf);
					kata_hira ( (BUFF *)&b_cnv, (BUFF *)&b_work );/*991210 WRN*/
					Copylng( b_work.str, work_buf, SLength(b_work) + 1);
					Length(work_buf) = (UCHAR)SLength(b_work);
#else
					kata_hira ( cnv_buf, work_buf );	/* hiragana henkan */
#endif
					cnv_buf [ 1 ] = work_buf [ 1 ];
					cnv_buf [ 2 ] = work_buf [ 2 ];
				}
				if ( kp > (pbe->kihon_max - 2) )
					goto err_ret;
				pbe->kihon_buf_Q.str[ ++kp ] = cnv_buf [ 1 ];
				if ( (chr = half_buf [ 2 ]) == (UCHAR)'\xde' || chr == (UCHAR)'\xdf' )
					pbe->kihon_atr_Q [ kp ] = (UCHAR)(mode | F_ZEN_L | (ep - sp));
				else
					pbe->kihon_atr_Q [ kp ] = (UCHAR)(mode | F_ZEN_L | C_ROMA_1);
				pbe->kihon_buf_Q.str[ ++kp ] = cnv_buf [ 2 ];
				pbe->kihon_atr_Q [	kp ] = (UCHAR)(mode | F_ZEN_R);
			}
			else {							/* hankaku henkan */
HAN2:
				if ( (ep - sp) == 2 ) {
					if ( kp > (pbe->kihon_max - 2) )
						goto err_ret;
					if ( (chr = half_buf [ 2 ]) == (UCHAR)'\xde' || chr == (UCHAR)'\xdf' ) {
						pbe->kihon_buf_Q.str[ ++kp ] = half_buf [ 1 ];
						pbe->kihon_atr_Q [	kp ] = (UCHAR)(mode | F_HANK | 2);
						pbe->kihon_buf_Q.str[ ++kp ] = chr;
						pbe->kihon_atr_Q [	kp ] = (UCHAR)(mode | F_HANK);
					}
					else {
						pbe->kihon_buf_Q.str[ ++kp ] = half_buf [ 1 ];
						pbe->kihon_atr_Q [	kp ] = (UCHAR)(mode | F_HANK | C_ROMA_1);
						pbe->kihon_buf_Q.str[ ++kp ] = chr;
						pbe->kihon_atr_Q [	kp ] = (UCHAR)(mode | F_HANK | C_ROMA_1);
					}
				}
				else {
					if ( kp > (pbe->kihon_max - 1) )
						goto err_ret;
					pbe->kihon_buf_Q.str[ ++kp ] = half_buf [ 1 ];
					pbe->kihon_atr_Q [	kp ] = (UCHAR)(mode | F_HANK | C_ROMA_1);
				}
			}
			half_buf [ 2 ] = 0;
			sp += (short)Length(half_buf);
			ep	= sp;
		next1:
			if ( ep > pbe->key_pos )
				ep = ++sp;
		}
		if ( rc == 0 ) {							/* convert */
			for ( i = 1; i <= (short)Length(cnv_buf); i++ ) {
				if ( (kp + i) > pbe->kihon_max )
					goto err_ret;
				pbe->kihon_buf_Q.str[ kp + i ] = cnv_buf [ i ];
				pbe->kihon_atr_Q [ kp + i ] = cnv_atr [ i ];
			}
			kp += Length(cnv_buf);
			sp += Length(half_buf);
			ep	= sp;

			chr = (UCHAR)(mode & (KANA_BIT | KATA_BIT | ZENKAKU_BIT));
			cnv_atr [ 0 ] = 0;
			for ( i = 1; i < 9; i++ )
				cnv_atr [ i ] = chr;
		}
	}
	/* Restore buffer */
	if ( (kp + SLength(pbe->kihon_buf_Q) - pbe->kihon_pos) > pbe->kihon_max )
		goto err_ret;
	ep = kp;									/* save kp */
	for ( i = pbe->kihon_pos + 1; i <= SLength(pbe->kihon_buf_Q); i++ ) {
		pbe->kihon_buf_Q.str[ ++kp ] = save_buf.str[ i ];
		pbe->kihon_atr_Q [	kp ] = save_atr [ i ];
	}
	pbe->kihon_pos = ep;
	SLength(pbe->kihon_buf_Q) = Length(pbe->kihon_atr_Q) = kp;
/*941104 n -- f9 -->  */
	if ((mode & KATA_BIT) == 0) {
		cnv_nn(pbe);
	}
	return ;

err_ret:
	for ( i = 0; i <= SLength(save_buf); i++ ) {
		pbe->kihon_buf_Q.str[ i ] = save_buf.str[ i ];
		pbe->kihon_atr_Q [ i ] = save_atr [ i ];
	}
	SLength(pbe->kihon_buf_Q) = SLength(save_buf);
}

/*
 *	Check all hira kana or eisuu
 */
static void FTYPE	chk_cnv_code(pbe,cnv_code_buf)
PBEBUF	pbe;
UCHAR PWIN	*cnv_code_buf;
{
	short	ptr;
	UCHAR	code1, code2;
	USHORT	attr;
	REG1 short	i;
	REG2 short	j;

#if 1	/*mk3*/
{	USHORT	*p = (USHORT *)cnv_code_buf;
	ptr = j = 0;
	for (i = 0; i < (NUM_CHAR * 2) / 2; i++)
		p[i] = j;
}
#else
	for (i = 0; i < NUM_CHAR * 2; i++)
		cnv_code_buf[i] = 0;
	ptr = j = 0;
#endif
	for (i = pbe->kihon_cnv; i < pbe->kihon_pos; i++) {
		code1 = pbe->kihon_buf_Q.str[i + 1];
		code2 = pbe->kihon_buf_Q.str[i + 2];
		attr = pbe->kihon_atr_Q[i + 1];
		ptr++;
		if ((attr & M_ZEN_HAN) != 0) {
			i++;
#if	PENWIN
			if ((code1 != (UCHAR)0x82 || code2 < 0x60 || code2 > 0xfc) &&
#else
			if ((code1 != (UCHAR)0x82 || code2 < (UCHAR)0x9f || code2 > (UCHAR)0xfc) &&
#endif
			    (code1 != (UCHAR)0x83 || code2 < (UCHAR)0x40 || code2 > (UCHAR)0x9e)) {
				j++;
				cnv_code_buf[i] = code1;
				cnv_code_buf[i + 1] = code2;
			}
		}
		else {
			if (code1 < (UCHAR)0xa6 || code1 > (UCHAR)0xdd || code1 == (UCHAR)0xb0) {
				j++;
				cnv_code_buf[i + 1] = code1;
			}
		}
	}
	if (ptr == j) {
#if 1	/*mk3*/
{		USHORT	*p = (USHORT *)cnv_code_buf;
		for (i = j = 0; i < (NUM_CHAR * 2) / 2; i++)
			p[i] = j;
}
#else
		for (i = 0; i < NUM_CHAR * 2; i++)
			cnv_code_buf[i] = 0;
#endif
	}

}
/*
 *	Ѵ ǡ kihon_cnv/key_cnv/kihon_pos Ĵ
 */
static	void FTYPE	cnv_pos_chk ( PBEBUF pbe,short mode )
{
	UCHAR	chr;
	short	i;
	short	cnt;

	if ( (chr = pbe->key_buf_Q.str[ pbe->key_cnv ]) >= 0xA6 && chr <= 0xDF ) {
		chr = pbe->kihon_atr_Q [ pbe->kihon_pos ];
		if ( mode & ZENKAKU_BIT ) { 				/* zenkaku henkan */
			if ( chr & ZENKAKU_BIT ) {				/* zenkaku char */
				if ( chr & M_ROMA_CNT )
					++pbe->kihon_pos;
			}
			else {									/* hankaku char */
				if ( !(pbe->kihon_atr_Q [ pbe->kihon_pos + 1 ] & M_ROMA_CNT) )
					++pbe->kihon_pos;
			}
		}
		else {										/* hankaku henkan */
			if ( (chr & M_ROMA_CNT) == 2 ) {		/* char =  +  or  */
				++pbe->kihon_pos;
				if ( pbe->kihon_atr_Q [ pbe->key_pos ] & M_ROMA_CNT )
					++pbe->key_pos;
			}
		}
	}
	else {
		if ( pbe->kihon_cnv != 0 ) {
			/* F7   ѴǤҤ餬Ѵ */
			if ( !(pbe->kihon_atr_Q [ pbe->kihon_cnv + 1 ] & M_ROMA_CNT) ) {
				for ( i = pbe->kihon_cnv ; i >= 1; i-- ) {
					if ( cnt = (pbe->kihon_atr_Q [ i ] & M_ROMA_CNT) )
						break;
				}
				--pbe->kihon_cnv;
				if ( pbe->kihon_atr_Q [ pbe->kihon_cnv ] & M_ZEN_HAN )	/* ѥ⡼ */
					--pbe->kihon_cnv;
				pbe->key_cnv -= cnt ;
			}
			else
				pos_add (pbe );
		}
		else {
			if ( SLength(pbe->kihon_buf_Q) != (UCHAR)pbe->kihon_pos )
				pos_add (pbe );
		}
	}
}

static	void FTYPE	pos_add ( pbe )
PBEBUF	pbe;
{
	short	i;
	short	cnt;

	for ( i = pbe->kihon_pos + 1; i <= SLength(pbe->kihon_buf_Q); i++ ) {
		if ( pbe->kihon_atr_Q [ i ] & M_ROMA_CNT )
			break;
	}
	if ( cnt = (i - pbe->kihon_pos - 1) )
		pbe->kihon_pos += cnt;
}

static	UCHAR FTYPE	cnv_kuten( pbe, chr, mode, kihon, before)
PBEBUF	pbe;
UCHAR	chr ;
short	mode ;
UCHAR	PWIN *kihon ;
UCHAR	before;
{
	static	USHORT	cnvtbl[6] = {0x2ea1,0x5ba2,0x5da3,0x2ca4,0x2fa5,0x2db0};
	static	USHORT	cnvtbl2[12] = { (USHORT)0x2e44,(USHORT)0x5b6d,
					(USHORT)0x5d6e,(USHORT)0x2c43,
					(USHORT)0x2f5e,(USHORT)0x2d7c,
					(USHORT)0xa142,(USHORT)0xa275,
					(USHORT)0xa376,(USHORT)0xa441,
					(USHORT)0xa545,(USHORT)0xb05b};
	short	i;
	UCHAR	cnv_data ;

	cnv_data = chr ;
	if (pbe->KutenMode == 0 && (mode & CNV_KUTEN) != 0)
		return cnv_data ;
	if (!(mode & ZENKAKU_BIT)) { /*Hankaku Henkan !!! */
/*ȾѴΥ(ܥХåեΥɤ򤽤Τޤ֤) */
/*Ҥ餬ʤȾѤξ */
		if ((mode & KATA_BIT) && (mode & KANA_BIT)) { /*EISUU*/
/*ѿȾѴΥϥޡԥꥪɤ᤹ */
			for (i=0;i<6;i++) {
				if (chr == (UCHAR)(cnvtbl[i] & 0xff)) {
					cnv_data = (UCHAR)(cnvtbl[i] >> 8);
					break;
				}
			}
		} else 
		if (VjeKanji(*kihon)) {
			if (*kihon == 0x81) {
				for (i=0;i<12;i++) {
					if (*(kihon+1) == (UCHAR)(cnvtbl2[i] & 0xff)) {
						cnv_data = (UCHAR)(cnvtbl2[i] >> 8);
						break;
					}
				}
			}
		}
		else {
			for (i=0;i<12;i++) {
				if (*(kihon) == (UCHAR)(cnvtbl2[i] >> 8)) {
					cnv_data = (UCHAR)(cnvtbl2[i] >> 8);
					break;
				}
			}
		}
		return cnv_data ;
	}
	if ((mode & KATA_BIT) && (mode & KANA_BIT)) { /*EISUU*/
/*ѿѴΥ */
		if ((mode & CNV_KUTEN)) {
			if (cnv_data <= (UCHAR)0x80)
				return cnv_data ;
		}
		for (i=0;i<6;i++) {
			if (chr == (UCHAR)(cnvtbl[i] & 0xff)) {
				cnv_data = (UCHAR)(cnvtbl[i] >> 8);
				break;
			}
		}
	} else {	/*KANA*/
/*Ҥ餬ʡѴΥ */
		if ((mode & CNV_KUTEN) && !(pbe->wVjeModeFlag2 & EISUU_BIT))
			return cnv_data ;
		if (0x30 <= before && before <= 0x39)
			return cnv_data;
		for (i=0;i<6;i++) {
			if (chr == (UCHAR)(cnvtbl[i]>>8)) {
				cnv_data = (UCHAR)(cnvtbl[i] & 0xff);
				break;
			}
		}
	}
	return cnv_data ;
}

/* */
short	CheckCnvMode(PBEBUF pbe,UCHAR ch)
{
	short	i;

	ch &= 0xff;
	if ('0' <= ch && ch <= '9') {
		if ( pbe->wVjeModeLimit & C_EISU_HAN )
			return 1;	/*ȾѸ */
		else if ( pbe->wVjeModeLimit & C_EISU_ZEN )
			return 2;	/*Ѹ */
		else 
			return 3;	/*ɸ */
	}
	if ('a' <= ch && ch <= 'z') {
		if ( pbe->wVjeModeLimit & C_EISU_HAN )
			return 1;	/*ȾѸ */
		else if ( pbe->wVjeModeLimit & C_EISU_ZEN )
			return 2;	/*Ѹ */
		else 
			return 3;	/*ɸ */
	}
	if ('A' <= ch && ch <= 'Z') {
		if ( pbe->wVjeModeLimit & C_EISU_HAN )
			return 1;	/*ȾѸ */
		else if ( pbe->wVjeModeLimit & C_EISU_ZEN )
			return 2;	/*Ѹ */
		else
			return 3;	/*ɸ */
	}
/*Check KIGO */
	for (i=0;i < pbe->wKigoTBL.cnt;i++) {
		if (ch == pbe->wKigoTBL.kigo[i].moji) {
			if (pbe->wKigoTBL.kigo[i].flg == 0) {
				return 3;/*ɸ */
			}
			return (pbe->wKigoTBL.kigo[i].flg) ;
		}
	}
	return 3;/*ɸ */
}
