/*
**	VJE Delta
**			wsub.c
*/

#include	"common.h"
/*#include	"vje.h"
#include	"wvje.h"
#include	"wbebuf.h"*/
#include	"basicedt.h"
#include	"wfncdef.h"

UCHAR	OpeMsgTbl[][38] ={
	"\x8e\xab\x8f\x91\x82\xcc\x83\x6f\x81\x5b\x83\x57\x83\x87\x83\x93\x82\xaa\x88\xe1\x82\xa2\x82\xdc\x82\xb7.         " , /* 0 */
	"\x8e\xab\x8f\x91\x82\xaa\x91\xe5\x82\xab\x89\xdf\x82\xac\x82\xdc\x82\xb7.                 " , /* 1 */
	"                                    " , /* 2 */
	"\x8e\xab\x8f\x91\x82\xcc\x93\xc7\x82\xdd\x8d\x9e\x82\xdd\x82\xaa\x82\xc5\x82\xab\x82\xdc\x82\xb9\x82\xf1.         " , /* 3 */
	};

static	UCHAR	ework_buf[] = "\x83\x47\x83\x89\x81\x5b";

#define NOTROMA_STR	"\x81\x40"
#define ROMA_STR	"\x82\x71"

#define ZEN_STR		"\x91\x53"
#define HAN_STR		"\x94\xbc"

#define KUTEN_STR	"\x8b\xe6"
#define JIS_STR		"\x82\x69"
#define SJIS_STR	"\x82\x72"
#ifdef UCS
#define UNICODE_STR	"\x82\x74"
#endif
#if 1 /* 991130 */
#define EUC_STR		"\x82\x64"
#endif

#define HIRA_STR	"\x82\xa0"
#define KATA_STR	"\x83\x41"
#define EISU_STR	"\x82\x60"
#define TOUROKU_STR	"\x93\x6f"

#define EISU_DAI	"\x89\x70\x91\xe5"
#define EISU_SHO	"\x89\x70\x8f\xac"
#define EISU2		"\x89\x70\x90\x94"
#define HIRA2		"\x82\xa9\x82\xc8"
#define KATA2		"\x83\x4a\x83\x69"

/*
 *	Clear key buffer & dispaly buffer
 */
global void
clear_buf( pbe,bdata )	/* VJE ga on ni natta toki nomi */
PBEBUF	pbe;
PBD	bdata;
{
	
	clr_key_buf(pbe);
	clr_dsp_buf(bdata);
	pbe->koho_over = 0;
	pbe->edit = 0;
	clr_cnv_buf(pbe);
}

/*
 *	Clear key input buffer
 */
global void
clr_key_buf( pbe)
PBEBUF	pbe;
{
	SLength(pbe->key_buf_Q) = SLength(pbe->kihon_buf_Q) = 0;
	Length(pbe->kihon_atr_Q) = 0;
	pbe->key_pos = pbe->kihon_pos = 0;
	pbe->key_cnv = pbe->kihon_cnv = pbe->kihon_cnvted = 0;
	pbe->old_a = 0;
}

/*
 *	Clear display buffer
 */
global void
clr_dsp_buf( bdata )
PBD	bdata;
{
	bdata->cchCurPosition  = 0;
	bdata->cchCurAttr = 0;
	bdata->wDataStatus &= ~(VJE_DISPLAYDATA|VJE_MBDATA|VJE_LBDATA);
	bdata->wDataUpdate |= (VJE_DISPLAYDATA|VJE_MBDATA|VJE_LBDATA);
	bdata->cchDisplay = 0;
/*	*bdata->lpchMBTitle = 0; 91/2/26 */
/*	*bdata->lpchMBText = 0; 91/2/26 */
/*	*bdata->lpchLBTitle = 0; 91/2/26 */
	bdata->cchLBListLen = 0;
	bdata->cchCurPosition = 0;
	bdata->ichDisplayAct = 0;
}

/*
 *	Clear conversion buffer
 */
global void
clr_cnv_buf( pbe)
PBEBUF	pbe;
{
	REG1 short	i;
	
	SLength(pbe->out_buf_Q)  = 0;
	pbe->k_r.error	   = 0;
	pbe->k_r.bun_cnt	   = 0;
	pbe->k_r.max_bun	   = 0;
	pbe->k_r.total_yomi	   = 0;
	SLength(pbe->koho_buf_Q) = 0;
	pbe->kihon_cnvted       = 0;
	for ( i = 0; i < BUN_MAX; i++ ) {
		pbe->k_r.koho[i].koho_cnt = 0;
		pbe->k_r.koho[i].max_koho = 0;
	}
/*WIN95:DisplayKR */
	pbe->DisplayKR.error	   = 0;
	pbe->DisplayKR.bun_cnt	   = 0;
	pbe->DisplayKR.max_bun	   = 0;
	pbe->DisplayKR.total_yomi  = 0;
	for ( i = 0; i < BUN_MAX; i++ ) {
		pbe->DisplayKR.koho[i].koho_cnt = 0;
		pbe->DisplayKR.koho[i].max_koho = 0;
	}
}

/*
 *	Clear Result buffer
 */
global void
clr_result_buf( pbe)
PBEBUF	pbe;
{
	REG1 short	i;

	pbe->ResultKR.error	   = 0;
	pbe->ResultKR.bun_cnt	   = 0;
	pbe->ResultKR.max_bun	   = 0;
	pbe->ResultKR.total_yomi   = 0;
	for ( i = 0; i < BUN_MAX; i++ ) {
		pbe->ResultKR.koho[i].koho_cnt = 0;
		pbe->ResultKR.koho[i].max_koho = 0;
	}
}

/*
 *	Set asciiz string in display buffer with same attribute
 */
static void
set_message( str, atr, bdata )
char	*str;
short	atr;
PBD	bdata;
{
	PUCH chrptr;
	PUCH atrptr;
	REG2 short	i;
	
	i = bdata->cchMode;
	chrptr =  bdata->lpchMode + i;
	atrptr =  bdata->lpattrMode + i;
	while ( *str ) {
		*chrptr++ = *str++;
		*atrptr++ = (UCHAR) atr;
		++i;
	}
	bdata->cchMode = i;
}


/*
 *	Set character in the display buffer
 */
global void
set_chrs( chr, atr, bdata )
char	chr;
short	atr;
PBD	bdata;
{
	*(bdata->lpchDisplay + bdata->cchDisplay)   = chr;
	*(bdata->lpattrDisplay + bdata->cchDisplay) = (unsigned char)atr;
	++bdata->cchDisplay;
}

/*
 *	Set character in the system buffer
 */

global void
set_chrm( chr, atr, bdata )
char	chr;
short	atr;
PBD	bdata;
{
	*(bdata->lpchMode + bdata->cchMode)   = chr;
	*(bdata->lpattrMode + bdata->cchMode) = (UCHAR) atr;
	++bdata->cchMode;
}

/*
 *	Display vje mode
 */
global void
dspmod( pbe,bdata )
PBEBUF	pbe;
PBD	bdata;
{
	
	short atr;
	UCHAR c;
	
	bdata->cchMode = 0;
	if (bdata->wVjeModeFlag & DIRECT_MODE)
		atr = PysColor(CL_DMODE, bdata->wColorType);
	else
		atr = PysColor(CL_INPT_MODE, bdata->wColorType);
#if PCUNIX
	/*NonRoma/Roma*/
	set_message(((bdata->wVjeModeFlag & KATA_BIT) ? NOTROMA_STR : ROMA_STR), atr, bdata);
	/*Hira/Kata/Eisuu*/
	if (bdata->wVjeModeFlag & EISUU_BIT)
		set_message(EISU_STR, atr, bdata);
	else
		set_message(((bdata->wVjeModeFlag & KANA_BIT) ? KATA_STR : HIRA_STR), atr, bdata);
	/*Zenkaku/Hankaku*/
	set_message(((bdata->wVjeModeFlag & ZENKAKU_BIT) ? ZEN_STR : HAN_STR), atr, bdata);
	/*Kuten/Jis/Sjis*/
	if (pbe->codmd == 1)
		set_message(JIS_STR, atr, bdata);
	else if (pbe->codmd == 2)
		set_message(SJIS_STR, atr, bdata);
#ifdef UCS
	else if (pbe->codmd == 3)
		set_message(UNICODE_STR, atr, bdata);
#endif
#if 1 /* 991130 */
	else if (pbe->codmd == 4)
		set_message(EUC_STR, atr, bdata);
#endif
	else /* pbe->codmd == 0 ? */
		set_message(KUTEN_STR, atr, bdata);
#else
        if (pbe->kanamd & MOD_KLK_BIT) {
                c = (UCHAR)((bdata->wVjeModeFlag & KATA_BIT) ? '_' : 'R');
                set_chrm(c,PysColor(CL_ERROR, bdata->wColorType),bdata);
        } else {
                c = (UCHAR)((bdata->wVjeModeFlag & KATA_BIT) ? ' ' : 'R');
                set_chrm(c,PysColor(CL_INPT_MODE, bdata->wColorType),bdata);
        }
        if (bdata->wVjeModeFlag & EISUU_BIT) {
#if FMR
                if (bdata->wVjeModeFlag & CAPS_BIT)
                        set_message(EISU_DAI, atr, bdata);
                else
                        set_message(EISU_SHO, atr, bdata);
#else
                set_message(EISU2, atr, bdata);
#endif
        } else
                set_message(((bdata->wVjeModeFlag & KANA_BIT) ? KATA2 : HIRA2), atr, bdata);
        set_message(((bdata->wVjeModeFlag & ZENKAKU_BIT) ? ZEN_STR : HAN_STR), atr, bdata);
        if (pbe->codmd == 1)
                set_chrm('J', atr, bdata);
        else if (pbe->codmd == 2)
                set_chrm('S', atr, bdata);
#ifdef UCS
        else if (pbe->codmd == 3)
                set_chrm('U', atr, bdata);
#endif
#if 1 /* 991130 */
        else if (pbe->codmd == 4)
                set_chrm('E', atr, bdata);
#endif
	else /* pbe->codmd == 0 ? */
                set_chrm('K', atr, bdata);
	c = (UCHAR)((pbe->VJELibMode & (M_GAKU_DOUON|M_GAKU_BUNSETU)) ? '*' : ' ');
	set_chrm(c, atr, bdata);
	c = (UCHAR)((pbe->VJELibMode & M_FUKUGOU) ? 'F' : 'B');
	set_chrm(c, atr, bdata);
#endif
	bdata->wDataStatus |= VJE_MODEDATA;
	bdata->wDataUpdate |= VJE_MODEDATA;
}

/*
 *	Error message display
 */
global void
errmsg( err_no, bdata )
short	err_no;
PBD	bdata;
{
REG1 short	i;
UCHAR	*ms;
	
	ms = &OpeMsgTbl[ err_no ][0];
	i = 0;
	while ( *ms ) {
		*(bdata->lpchMBText + i) = *ms++;
		++i;
	}
/*** added by ita 93.1.27 bug ***/
	*(bdata->lpchMBText + i) = 0; 
/*******************************/
	bdata->wMBStyle = MB_OK;
	bdata->lpchMBTitle = (PUCH) ework_buf;
	bdata->wDataStatus |= VJE_MBDATA; /* 90/12/26 */
	bdata->wDataUpdate |= VJE_MBDATA; /* 90/12/26 */
}

#if 0
/*
 *	Check if dictionary already opened
 */

global short dic_first_open( pbe,bdata )
PBEBUF	pbe;
PBD	bdata;
{
#if	PENDIC
		if (pbe->dic_opened == 7)
			return(0);
#endif
		if (pbe->dic_opened == 3)
			return(0);
#if	USER_DIC
		if (!(pbe->dic_opened & 0x01) && cinits( pbe,pbe->dicname, 1, bdata ) == 1)
			return(1);
		pbe->dic_opened |= 0x01;
		if (!(pbe->dic_opened & 0x02) && cinits( pbe,pbe->udicname, 2, bdata ) == 1)
			return(1);
		pbe->dic_opened |= 0x02;
#if	PENDIC
		if (!(pbe->dic_opened & 0x04) && cinits( pbe->rdicname, 4, bdata ) == 1)
			return(1);
		pbe->dic_opened |= 0x04;
#endif
#else
		if (!(pbe->dic_opened & 0x01) && cinits( pbe,pbe->dicname, 0, bdata ) == 1)
			return(1);
		pbe->dic_opened |= 0x01;
#endif
		return(0);
}
#endif

#if	PENDIC
void	Cpyname(UCHAR PWIN *dname,UCHAR PWIN *fname )
{
	for ( ;*dname != EOS; )
		*fname++ = *dname++ ;
	*fname = EOS ;
}
void	Makename(UCHAR PWIN *dicname,UCHAR PWIN *fname,UCHAR PWIN *mkname )
{
	UCHAR	PWIN *pt ;

	Cpyname (dicname,mkname);
	for (pt = mkname;*mkname != EOS; mkname++) {
		if (*mkname == ':')
			pt = mkname + 1 ;
		else if (*mkname == '\\')
			pt = mkname + 1 ;
		else
			;
	}
	Cpyname(fname,pt);
}
#endif


#if 0
/*
 *	Cinits
 *    Exit 0: End Normally
 *         1: Error
 */
global short
cinits( pbe,name, hajime, bdata )
PBEBUF	pbe;
char	name[];
short	hajime;
PBD	bdata;
{
	REG1 short	ret;


	if (*name == 0)
		return(0);
#if	USER_DIC
	
	if ( hajime & 0x02 )
		pbe->hVjeLib = ret = open_udic( name );
	else
#endif
		pbe->MainFD = ret = open_dic( name );
	if ( ret >= 0)
		return ( 0 );
	errmsg( ret+4, bdata );
	return ( 1 );
}
#endif

static	UCHAR	ColorTbl[2][12] = {
B_BLACK|F_WHITE, B_BLACK|F_YELLOW ,B_CYAN|F_BLACK, B_BLACK|F_CYAN, B_WHITE|F_BLACK,  
B_BLACK|F_CYAN, B_YELLOW|F_BLACK, B_BLACK|F_CYAN, B_CYAN|F_BLACK, B_BLACK|F_RED,
B_YELLOW|F_BLACK, B_YELLOW|F_BLACK,
F_WHITE, F_YELLOW, F_CYAN|F_REVERSE, F_CYAN, F_YELLOW|F_UNDERLINE, 
F_CYAN|F_UNDERLINE, F_YELLOW|F_REVERSE/*91/1/29*/, F_CYAN, F_CYAN|F_REVERSE, F_RED,
F_YELLOW|F_REVERSE, F_YELLOW|F_REVERSE }; 

global short PysColor(color, type)   
short	color;	/*WIN32:Warning */
short	type;	/*WIN32:Warning */
/*int	color; */
/*int	type; */
{                                    
	if (type == CL_SPECIAL)
		return(color);
	else
		return(ColorTbl[type][color]);      
}                                    
                                     
/*
 *	Get bunsetu jisho yomi code length
 *	return : bunsetu jisho yomi code length
 */
 global SHORT	get_chr_cnt(char PWIN *buf,SHORT p1,SHORT p2)
{
	REG3 int	len;
	REG1 UCHAR	c;

	len = 0;
	for (; p1 < p2; p1++) {
		c = buf[p1];
		if (!(c < 0x80 || 0xa0  < c && c < 0xe0))
			++p1;
		++len;
	}
	return (len);
}

