/* @(#)wvje.h    1.0  11/30/1989 by VACS Corp. */

/*
 *	VJE-Delta Version 2.5 for Windows95
 * 			written by Ken Hagiwara 
 *			substatially modified by  Ken Hagiwara
 *
 *
 *  VJE-Delta (VACS Japanese Entry System)
 *
 * Revision History:
 *
 * Ken Hagiwara, 30-Nov-89
 *      - Initial Revision
 */

/*
**
**			wvje.h
**
*/

#define	CNV_HIRA	ZENKAKU_BIT			/* Hiragana convert */
#define	CNV_KATA	(ZENKAKU_BIT | KANA_BIT)	/* Katakana convert */
#define	CNV_ZEN		(ZENKAKU_BIT | KANA_BIT | KATA_BIT)	/* Zenkau Eisuu     */
#define	CNV_HAN		KANA_BIT			/* Hanksku convert  */
#define CNV_HAN_EISU	(KANA_BIT | KATA_BIT)
#define	CNV_SET_POS	50				/* Set kihon & key pos */
#define	CNV_SET_CNV	51				/* Set kihon & key cnv */
#define	CNV_NN		52				/* Conver N to 'NN' */
#define	CNV_DEL		53				/* Delete key & kihon*/
#define	CNV_KUTEN	0x8000				/* Convert KUTEN */
#define	CNV_TEST	0x4000				/* Convert KUTEN */

#define	NORMAL_TYP	0
#define	DAKU_TYP		1
#define	HANDAKU_TYP	2
#define	V_TYP		3

#if 1/*KOHOSORT*/
#define	KOHO_SORT_NORMAL	(0)
#define KOHO_SORT_TOP		(1)
#define KOHO_SORT_END		(2)
#define KOHO_SORT_BUSYU		(3)
#define KOHO_SORT_KAKUSU	(4)
#endif

/* extents Attribute bit (UCHAR ---> USHORT)*/
#define C_EISU_HAN		0x0100		/**/
#define C_EISU_ZEN		0x0200		/**/
#define C_EISU_ZEN_HAN		(C_EISU_HAN | C_EISU_ZEN)
#define C_KATA_HAN		0x0400		/**/
#define C_KATA_ZEN		0x0800		/**/
#define C_KATA_ZEN_HAN		(C_KATA_HAN | C_KATA_ZEN)
#define C_KIGO_HAN		0x1000		/**/
#define C_KIGO_ZEN		0x2000		/**/
#define C_KIGO_ZEN_HAN		(C_KIGO_HAN | C_KIGO_ZEN)
#define C_AUTO_HOSEI		0x8000		/* */

#define	MOJI			0		/* Input carcter V_FUNC */
#define	V_FUNC			para[0]	/* vertual function */
#define	CAR			para[1]	/* input carcter */
#define	ATTRI			para[2]	/* input carcter attribute */

#define	KUTEN_MAX		94	/* Max kuten number */
#if DEBUG
#define	DSPSIZE			127	/* Koho dsplay max size */
#else
#define	DSPSIZE			80	/* Koho dsplay max size */
#endif

#define	C_INIT		0
#define	NORM_SCRN	1
#define	SCRN_NORM	3
#define	C_ROMA		7
#define	C_HIRA_MD	8
#define	C_KATA_MD	9
#define	C_ZEN_MD	10
#define	C_HAN_MD	11
#define	C_RET		12
#define	C_SP_RET	13
#define	C_SP_RET2	14
#define	C_CANALL	15
#define	C_NOP		16
#define	S_KAKU		19
#define	S_KAKU2		20
#define	S_CODE		23
#define	S_KIGO		25
#define	T_CAN		27
#define	T_HIRA_CNV	28
#define	T_KATA_CNV	29
#define	T_ZEN_CNV	30
#define	T_HAN_CNV	31
#define	T_ADD		32
#define	T_EDIT		33
#define	T_EDIT2		34
#define	T_LLIM		35
#define	TS_CNV		36
#define	TS_CNVH		37
#define	C_EISU_MD	40
#define	C_UNDO		41
#define	C_DMODE		42
#define	C_INP		43
#define	C_KLK_MD	44
#define	C_MODE		45
#define	C_OPEN		46
#define	C_UOPEN		47
#define C_ROM_OPEN	48
#define C_ROM_CLOSE 49
#define C_CAPS_MD	50
#define C_NCAP_MD	51
#define C_TOUROKU	52
#define C_SAKUJYO	53
#define C_CLOSE 	54
#define C_UCLOSE	55
#define C_MB		56
#define C_LB		57
#define C_GMODE 	58

#define S_1KAKU		59
#define C_ATOK_MODE	60
#define T_KATA_WX	61
#define TS_FUKU_CNV	62
#define C_OPT_OPEN	63
#define C_OPT_CLOSE	64
#define TS_CNV_OPT	65
#define T_HAN_EISU_CNV	66
#define C_KATA_LIM	67
#define C_EISU_LIM	68
#define C_KIGO_LIM	69

#define C_LIM_OPEN	70
#define C_LIM_CLOSE 	71

#if 0
#define C_GETTANGO	72	/* for B-TRON */
#endif
