/*
 * أɣʹϢ֥롼
 *
 */
#if !DIGITAL/*DIGITAL-UX*/
#include <X11/Xlibint.h>
#endif
#include <sys/types.h>
#include "xim.h"

typedef struct  _FXim_ClientRec {
	FXim_Client		client;
	Xim_PreeditPropRec 	preedit;
	Xim_StatusPropRec 	status;
	Xim_KohoPropRec 	koho;
	FXimFont   		preedit_font;
	FXimFont   		koho_font;
	FXimFont   		status_font;
	CARD16			output_buff[FXIM_LINEBUFF_LENGTH];
#if 0
	CARD16			input_buff[ FXIM_LINEBUFF_LENGTH];
#endif
} FXim_ClientRec;
/*
 * ȥ󥹥ݡΥơ֥
 * إץȥΤߥݡȤƤޤ
 */
static Xv_TransRec	transRec[] = {
    {"X", InitialXProto, ExitXProto, GetXProtoName},
    {(char *)NULL, (Bool (*)())NULL,
			(void (*)())NULL, (Bool (*)())NULL}
};
/*
 * ϥƥȤΥơ֥
 */
static FXim_ClientRec	*fxim_table = (FXim_ClientRec *)0;
static int		 fxim_table_max_no;
static int		 fxim_table_used_max_no;
static int		 fxim_table_used_no;

Bool
InitialTransport()
{
    register int i;
    Bool	 ret = False;

    for (i = 0; transRec[i].transport_name; i++) {
	if (transRec[i].config_flag = (*transRec[i].config)(&transRec[i]))
	    ret = True;
    }
    return ret;
}

void
ExitTransport()
{
    register int i;

    for (i = 0; transRec[i].transport_name; i++)
	(*transRec[i].exit)(&transRec[i]);
    return;
}

Bool
GetTransportName(array, name)
    char	*array;
    char	*name;
{
    register int i;

    for (i = 0; transRec[i].transport_name; i++) {
	if (!strcmp(transRec[i].transport_name, name)) {
	    if (transRec[i].config_flag)
		return (*transRec[i].get_name)(&transRec[i], array);
	    else
		return False;
	}
    }
    return False;
}

Static Bool
_XimServerCheck(display, event, arg)
    Display	*display;
    XEvent	*event;
    XPointer	 arg;
{
    switch(event->type) {
    case Expose :
    case SelectionRequest:
    case KeyPress :
    case KeyRelease :
	return True;
    case DestroyNotify :
	if (event->xkey.window == root_client->window)
	    return True;
	break;
    }
    return False;
}

void
XimTransportCheck()
{
    register int  i;

    for (i = 0; transRec[i].transport_name; i++) {
	if (transRec[i].method.event_proc) {
	    (*transRec[i].method.event_proc)(&transRec[i]);
	}
    }
    return;
}

Static void
FreeRecvQueue(top)
    register Xv_Recv	top;
{
    register Xv_Recv	next;

    if (!top)
	return;
    for (; top; top = next) {
	next = top->next;
	XvFree(top);
    }
    return;
}

Bool
InitialClientTable(table_no)
    int  table_no;
{
    int  size;

    if (fxim_table)
	return True;

    fxim_table_max_no = table_no;

    size = sizeof(FXim_ClientRec) * fxim_table_max_no;
    if (!(fxim_table = (FXim_ClientRec *)malloc(size))) {
	ErrorMessage(70, size);
	return False;
    }

    bzero(fxim_table, size);
    fxim_table_used_max_no = 0;
    fxim_table_used_no	   = 0;
    return True;
}

void
ExitClientTable()
{
    if (!fxim_table)
	return;

    free(fxim_table);
    fxim_table		   = (FXim_ClientRec *)0;
    fxim_table_max_no	   = 0;
    fxim_table_used_max_no = 0;
    fxim_table_used_no	   = 0;
    return;
}

FXim_Client *
NewClient(window)
	Window	window;
{
	FXim_ClientRec	*cr = fxim_table;
	register int	i;

	if (fxim_table_used_no >= fxim_table_max_no) {
		return (FXim_Client *)0;
	}

	for (i = 0; i < fxim_table_max_no; i++, cr++) {
		if (cr->client.used) {
			continue;
		}
		bzero (cr, sizeof(FXim_ClientRec));
		cr->client.used		= True;
		cr->client.icid		= i + 1;
		cr->client.window	= window;
		cr->client.preedit	= &cr->preedit;
		cr->client.status	= &cr->status;
		cr->client.koho		= &cr->koho;
		cr->client.preedit_font	= &cr->preedit_font;
		cr->client.koho_font	= &cr->koho_font;
		cr->client.status_font	= &cr->status_font;
		cr->client.output_buff	= cr->output_buff;
#if 0
		cr->client.input_buff	= cr->input_buff;
#endif
		cr->client.filter_event_mask          = DEFAULT_FILTER_MASK;
		cr->client.cv_filter_event_mask       = DEFAULT_FILTER_MASK;
		cr->client.intercept_event_mask       = DEFAULT_INTERCEPT_MASK;
		cr->client.cv_intercept_event_mask    = DEFAULT_INTERCEPT_MASK;
		cr->client.select_event_mask          = DEFAULT_SELECT_MASK;
		cr->client.cv_select_event_mask       = DEFAULT_SELECT_MASK;
		cr->client.forward_event_mask         = DEFAULT_FORWARD_MASK;
		cr->client.cv_forward_event_mask      = DEFAULT_FORWARD_MASK;
#if 0
		cr->client.synchoronous_event_mask    = DEFAULT_FORWARD_MASK;
		cr->client.cv_synchoronous_event_mask = DEFAULT_FORWARD_MASK;
#else
		cr->client.synchoronous_event_mask    = DEFAULT_SYNCRONOUS_MASK;
		cr->client.cv_synchoronous_event_mask = DEFAULT_SYNCRONOUS_MASK;
#endif
#if 1 /* 20000301:OPEN-VJE */
		cr->client.vjeState			= VJE_CLOSE;
#endif
		cr->client.AtwFocus			= False;

		cr->client.vkp.save_lpchLBTitle[0]	= (UCHAR )0;
		cr->client.vkp.save_lpchLBList[0]	= (UCHAR )0;
		cr->client.vkp.save_cLBItemNum		= 0;
		cr->client.vkp.DrawFlag			= VKP_DRAW_NONE;
		cr->client.vkp.Visible			= 0;

		cr->client.status->FontName		= (char *)0;
		cr->client.preedit->FontName		= (char *)0;
		cr->client.koho->FontName		= (char *)0;

		cr->client.SkipFlag			= SKIP_NONE;
		cr->client.SkipOption			= 0;

		if (i >= fxim_table_used_max_no) {
			fxim_table_used_max_no = i + 1;
		}
		fxim_table_used_no++;

		return (&cr->client);
	}
	return (FXim_Client *)0;
}

void 
DeleteClient(xim_client)
    FXim_Client		*xim_client;
{
    	register int	 i;

#if 0/*991109*/
	if (xim_client->v_data) {
		CloseVJE (xim_client);
	}
#endif

    	if (xim_client == current_client) {
		current_client = root_client;
		current_preedit_font = root_client->preedit_font;
    	}

    	for (i = 0; i < fxim_table_used_max_no; i++) {
		if (!fxim_table[i].client.used)
			    continue;

		if (&fxim_table[i].client == xim_client) {
		    FreeRecvQueue(fxim_table[i].client.pending);
#if 1/*991109*/
		    if (xim_client->v_data) {
	 		CloseVJE (xim_client);
		    }
#endif
		    fxim_table[i].client.used = False;
		    if (xim_client->preedit->FontName) {
			free(xim_client->preedit->FontName);
		    }
		    if (xim_client->status->FontName) {
			free(xim_client->status->FontName);
		    }
		    if (i == fxim_table_used_max_no)
			fxim_table_used_max_no--;
		    fxim_table_used_no--;
		    return;
		}
    	}
    	return;
}

void
DeleteClientByIMRec(xim_imrec)
    FXim_IMRec		*xim_imrec;
{
    register int	 i;
    FXim_Client		*xim_client;

    for (i = 0; i < fxim_table_used_max_no; i++) {
	if (!fxim_table[i].client.used)
	    continue;

	if (fxim_table[i].client.parent_imrec == xim_imrec) {
	    FreeRecvQueue(fxim_table[i].client.pending);
#if 1/*991109*/
	    xim_client = &fxim_table[i].client;
	    if (xim_client->v_data) {
	 		CloseVJE (xim_client);
	    }
#endif
	    fxim_table[i].client.used = False;

	    if (&fxim_table[i].client == current_client) {
		current_client = root_client;
		current_preedit_font = root_client->preedit_font;
	    }

	    if (fxim_table[i].client.preedit->FontName)
		free(fxim_table[i].client.preedit->FontName);
	    if (fxim_table[i].client.status->FontName)
		free(fxim_table[i].client.status->FontName);

	    if (i == fxim_table_used_max_no)
		fxim_table_used_max_no--;
	    fxim_table_used_no--;
	}
    }
    return;
}

void VjeClientClose()
{
	int	i;
	for (i=1;i<fxim_table_max_no;i++) {
		if (fxim_table[i].client.window != (Window)0)
			DeleteClient((FXim_Client *)&fxim_table[i].client);
	}
}

FXim_Client *
FindClientByIMIDandICID(imid, icid)
    XIMID	 imid;
    XICID	 icid;
{
    register int i;

    for (i = 0; i < fxim_table_used_max_no; i++) {
	if (!fxim_table[i].client.used) 
	    continue;
	if ((fxim_table[i].client.imid == imid)
	 && (fxim_table[i].client.icid == icid)) {
	    	return &fxim_table[i].client;
	}
    }
    return (FXim_Client *)0;	/* error return */
}

FXim_Client *
FindClient(window)
    Window	 window;
{
    register int i;

    for (i = 0; i < fxim_table_used_max_no; i++) {
	if (!fxim_table[i].client.used)
	    continue;

	if (fxim_table[i].client.window == window)
	    return &fxim_table[i].client;
    }
    return (FXim_Client *)0;	/* error return */
}

FXim_Client *
FindClientByFocusWindow(window)
    Window	 window;
{
    register int i;

    for (i = 0; i < fxim_table_used_max_no; i++) {
	if (!fxim_table[i].client.used)
	    continue;

	if (fxim_table[i].client.focus_window == window)
	    return &fxim_table[i].client;
    }
    return (FXim_Client *)0;	/* error return */
}

FXim_Client *
FindClientByPreeditOrStatusWindow(window)
    Window	 window;
{
    register int i;

    for (i = 0; i < fxim_table_used_max_no; i++) {
	if (!fxim_table[i].client.used)
	    continue;
	if ((fxim_table[i].client.preedit_window == window)
	 || (fxim_table[i].client.status_window == window)
         || (fxim_table[i].client.koho_window == window))
	    return &fxim_table[i].client;
    }
    return (FXim_Client *)0;	/* error return */
}


FXim_Client *
GetClient(icid)
    XICID		icid;
{
    register int	i;
    int			j = 0;

    if (icid) {
	for (i = 1; i < fxim_table_used_max_no; i++) {
	    if (!fxim_table[i].client.used)
		continue;

	    if (fxim_table[i].client.icid == icid ) {
		j = i + 1;
		break;
	    }
	}
    } else
	j = 1;

    if (j) {
	for (i = j; i < fxim_table_used_max_no; i++) {
	    if (!fxim_table[i].client.used)
		continue;

	    if (fxim_table[i].client.window)
		return &fxim_table[i].client;
	}
    }
    return (FXim_Client *)0;	/* error return */
}

Bool
SetCurrentClient(window)
    Window	 window;
{
    FXim_Client	*xim_client;

    xim_client = FindClientByFocusWindow(window);
    if (!xim_client) {
	xim_client = FindClient(window);
	if (!xim_client) {
	    current_client = root_client;
	    current_preedit_font = current_client->preedit_font;
	    return False;
	}
    }
    current_client = xim_client;
    current_preedit_font = current_client->preedit_font;
    return True;
}

void
DestroyCurrentClient(event)
    XEvent        *event;
{
    if (current_client->prot_type == FPRT_XIM) {
	current_client->focus_window = 0;
	XimDestroyClient(current_client, 1);
    }
}

/*
 * IM functins
 */
static FXim_IMRec	*fxim_im = (FXim_IMRec *)0;
static int		 fxim_im_max_no;
static int		 fxim_im_used_max_no;
static int		 fxim_im_used_no;

Bool
InitialIMRecTable(table_no)
    int  table_no;
{
    int  size;

    if (fxim_im)
	return True;

    fxim_im_max_no = table_no;

    size = sizeof(FXim_IMRec) * fxim_im_max_no;
    if (!(fxim_im = (FXim_IMRec *)malloc(size))) {
	ErrorMessage(70, size);
	return False;
    }

    bzero(fxim_im, size);
    fxim_im_used_max_no = 0;
    fxim_im_used_no	= 0;
    return True;
}

void
ExitIMRecTable()
{
    if (!fxim_im)
	return;

    free(fxim_im);
    fxim_im		= (FXim_IMRec *)0;
    fxim_im_max_no	= 0;
    fxim_im_used_max_no = 0;
    fxim_im_used_no	= 0;
    return;
}

FXim_IMRec *
NewIMRec(xim_connect)
    FXim_Connect	*xim_connect;
{
    FXim_IMRec		*im_rec = fxim_im;
    register int	 i;

    if (fxim_im_used_no >= fxim_im_max_no)
	return (FXim_IMRec *)0;

    for (i = 0; i < fxim_im_max_no; i++, im_rec++) {
	if (!im_rec->used) {
	    bzero(im_rec, sizeof(FXim_IMRec));
	    im_rec->used	   = True;
/*
 * 991008 WinManagerΥˤKterm򣴤ĵư
 * ܤ Ktermưʤ
 *
 * IMIDΥΤȯ롣餯KtermXФ
 * ХȻפ뤬IMID 򣱣ѹ롣
 */
	    im_rec->imid	   = i + 1 + 10;
	    im_rec->parent_connect = xim_connect;

	    if (i >= fxim_im_used_max_no)
		fxim_im_used_max_no = i + 1;
	    fxim_im_used_no++;
	    return im_rec;
	}
    }
    return (FXim_IMRec *)0;
}

void
DeleteIMRec(id)
    XIMID	 id;
{
    register int i;

    for (i = 0; i < fxim_im_used_max_no; i++) {
	if (!fxim_im[i].used)
	    continue;

	if (fxim_im[i].imid == id) {
	    DeleteClientByIMRec(&fxim_im[i]);
	    fxim_im[i].used = False;

	    if (i == fxim_im_used_max_no)
		fxim_im_used_max_no--;
	    fxim_im_used_no--;
	    return;
	}
    }
    return;
}

void
DeleteIMRecByConnect(xim_connect)
    FXim_Connect	*xim_connect;
{
    register int	 i;

    for (i = 0; i < fxim_im_used_max_no; i++) {
	if (!fxim_im[i].used)
	    continue;

	if (fxim_im[i].parent_connect == xim_connect) {
	    DeleteClientByIMRec(&fxim_im[i]);
	    fxim_im[i].used = False;

	    if (i == fxim_im_used_max_no)
		fxim_im_used_max_no--;
	    fxim_im_used_no--;
	}
    }
    return;
}

FXim_IMRec *
FindIMRecByIMID(id)
    XIMID	 id;
{
    register int i;

    for (i = 0; i < fxim_im_used_max_no; i++) {
	if (!fxim_im[i].imid)
	    continue;

	if (fxim_im[i].imid == id)
	    return &fxim_im[i];
    }
    return (FXim_IMRec *)0;	/* error return */
}

/*
 * CONNECT functions
 */
static FXim_Connect	*fxim_connect = (FXim_Connect *)0;
static int		 fxim_connect_max_no;
static int		 fxim_connect_used_max_no;
static int		 fxim_connect_used_no;

Bool
InitialConnectTable(table_no)
    int  table_no;
{
    int  size;

    if (fxim_connect)
	return True;

    fxim_connect_max_no = table_no;

    size = sizeof(FXim_Connect) * fxim_connect_max_no;
    if (!(fxim_connect = (FXim_Connect *)malloc(size))) {
	ErrorMessage(70, size);
	return False;
    }

    bzero(fxim_connect, size);
    fxim_connect_used_max_no = 0;
    fxim_connect_used_no     = 0;
    return True;
}

void
ExitConnectTable()
{
    if (!fxim_connect)
	return;

    free(fxim_connect);
    fxim_connect	     = (FXim_Connect *)0;
    fxim_connect_max_no	     = 0;
    fxim_connect_used_max_no = 0;
    fxim_connect_used_no     = 0;
    return;
}

FXim_Connect *
NewConnect()
{
    FXim_Connect	*connect_rec = fxim_connect;
    register int	 i;

    if (fxim_connect_used_no >= fxim_connect_max_no - 4)/*990402:Xfig*/
	return (FXim_Connect *)0;

    for (i = 0; i < fxim_connect_max_no; i++, connect_rec++) {
	if (!connect_rec->used) {
	    bzero(connect_rec, sizeof(FXim_Connect));
	    connect_rec->used	   = True;
	    connect_rec->connectID = i + 1;

	    if (i >= fxim_connect_used_max_no)
		fxim_connect_used_max_no = i + 1;
	    fxim_connect_used_no++;
	    return connect_rec;
	}
    }
    return (FXim_Connect *)0;
}

void
DeleteConnect(connect)
    FXim_Connect	*connect;
{
    register int  	 i;

    for (i = 0; i < fxim_connect_used_max_no; i++) {
	if (!fxim_connect[i].used)
	    continue;

	if (&fxim_connect[i] == connect) {
	    DeleteIMRecByConnect(connect);

	    if (connect->auth_names)
		free(connect->auth_names);
	    FreeRecvQueue(fxim_connect[i].recv);
	    fxim_connect[i].used = False;

	    if (i == fxim_connect_used_max_no)
		fxim_connect_used_max_no--;
	    fxim_connect_used_no--;
	    return;
	}
    }
    return;
}

FXim_Connect *
FindConnectByCTID(id)
    FXCNID	 id;
{
    register int i;

    for (i = 0; i < fxim_connect_used_max_no; i++) {
	if (!fxim_connect[i].used)
	    continue;

	if (fxim_connect[i].connectID == id)
	    return &fxim_connect[i];
    }
    return (FXim_Connect *)0;	/* error return */
}

FXim_Connect *
FindConnectByFd(fd)
    int		 fd;
{
    register int i;

    for (i = 0; i < fxim_connect_used_max_no; i++) {
	if (!fxim_connect[i].used)
	    continue;

	if (fxim_connect[i].fd == fd)
	    return &fxim_connect[i];
    }
    return (FXim_Connect *)0;	/* error return */
}

FXim_Connect *
FindConnectByFDSET(mask)
    fd_set	 *mask;
{
    register int  i;

    for (i = 0; i < fxim_connect_used_max_no; i++) {
	if (!fxim_connect[i].used)
	    continue;

	if (FD_ISSET(fxim_connect[i].fd, mask))
	    return &fxim_connect[i];
    }
    return (FXim_Connect *)0;	/* error return */
}

FXim_Connect *
FindConnectByClientWindow(window)
    Window	 window;
{
    register int i;

    for (i = 0; i<fxim_connect_used_max_no; i++) {
	if (!fxim_connect[i].used)
	    continue;

	if (fxim_connect[i].client_window == window)
	    return &fxim_connect[i];
    }
    return (FXim_Connect *)0;	/* error return */
}

FXim_Connect *
FindConnectByServerWindow(window)
    Window	 window;
{
    register int i;

    for (i = 0; i < fxim_connect_used_max_no; i++) {
	if (!fxim_connect[i].used)
	    continue;

	if (fxim_connect[i].server_window == window)
	    return &fxim_connect[i];
    }
    return (FXim_Connect *)0;	/* error return */
}

Static CARD16
_XimCard16(val)
    CARD16	 val;
{
    return val;
}

Static CARD16
_XimSwapCard16(val)
    CARD16	 val;
{
    return (val << 8) & 0xff00 |
           (val >> 8) & 0xff;
}

Static CARD32
_XimCard32(val)
    CARD32	val;
{
    return val;
}

Static CARD32
_XimSwapCard32(val)
    CARD32	val;
{
    return (val << 24) & 0xff000000 |
	   (val <<  8) & 0xff0000   |
	   (val >>  8) & 0xff00     |
	   (val >> 24) & 0xff;
}

void
XimSetEndian()
{
    CARD8		endian = current_connect->byte_order;
    static CARD16	tesr_card = 1;

    if ((endian == BIGENDIANS    && *((CARD8 *)&tesr_card) == 0)
     || (endian == LITTLEENDIAN && *((CARD8 *)&tesr_card) != 0)) {
	current_connect->Card16 = _XimCard16;
	current_connect->Card32  = _XimCard32;
    } else {
	current_connect->Card16 = _XimSwapCard16;
	current_connect->Card32  = _XimSwapCard32;
    }
    return;
}
