/*
 *	VJE-GAMMA Version 2.0 	
 * 			written by Ken Hagiwara 
 *			substatially modified by  Ken Hagiwara
 *
 *
 * Basic-Edit include file 
 * for the VJE-GAMMA japanese frontend processer 
 *
 * Revision History:
 *
 * Ken Hagiwara, 30-Nov-89
 *      - Initial Revision
 */
#include "vje.h"
#include "wvje.h"
#include "wbebuf.h"

struct bdata {
	USHORT	wDataStatus;
	USHORT	wDataUpdate;
/* Character packet */
	USHORT	wCharCode;
	USHORT	wVkey;
/* Result buffer */
	USHORT	cchResult;
	PSZ	lpchResult;
/* Mode buffer */
	USHORT	cchMode;
	PSZ	lpchMode;
	PSZ	lpattrMode;
/* Message box */
	PSZ	lpchMBText;
	PSZ	lpchMBTitle;
	USHORT	wMBStyle;
/* Display buffer */
	USHORT	cchDisplay;
	PSZ	lpchDisplay;
	PSZ	lpattrDisplay;
	USHORT	cchCurPosition;
	USHORT	cchCurAttr;
	USHORT	ichDisplayAct;
/* List box */
	PSZ	lpchLBTitle;
	USHORT	cchLBListLen;
	PSZ	lpchLBList;
	USHORT	cLBItemPageFirst;
	USHORT	cLBItemTotal;	
	USHORT	cLBItemNum;
	USHORT	cLBItemNumMax;
	USHORT	cLBItemLenMax;
	USHORT	cLBItemHead;
/* Vje-Edit data */
	USHORT	wVjeModeFlag;
	USHORT	wMainStage;
/* for sonota */
	PSZ 	lpchRomFlName;	   /* 1993/4/27 Y.Mogi ROMAJI*/
	PSZ 	lpchRomTbName;	   /* 1993/4/27 Y.Mogi ROMAJI*/
	PSZ	lpchDicName;
/*95	USHORT	wHenModFlag; */
/*95	USHORT	wHenModFlagV; */
	long	wHenModFlag;
	long	wHenModFlagV;
	long	wHenModFlagLim;		/*  */
#if	PENWIN
	USHORT	wPenModeFlag ;
#endif
/* Tango Touroku */
	PSZ	lpchYomi;
	PSZ 	lpchHyouki;
	USHORT	wHinshi;
#ifdef	GETTANGO
	USHORT	wHinshiType;
	USHORT	wTangoSts;
#endif
	USHORT	wCodeMax;
	USHORT	wKeyType;
	USHORT	wColorType;
	USHORT	wDispListBox;
#if	PENWIN
	PSZ	kihon_atr;
	int far	*New_buninf;
#endif
/*Delta*/
	USHORT  wOptDicNo;	/*OptionDicNo(0..9) F_DIC_OPEN no param <IN>*/
	USHORT  wOptDicMode;	/*OptionDicNo(0..9) F_DIC_OPEN no param <IN>*/
	USHORT  wErrorCode;	/*Open Error Code                 <OUT>*/
/*WIN95: */
/*	BUNINF	far *buninf;	*/	/*genzai no K_R info	  <OUT>*/
/*	BUNINF	far *buninf_kaku;*/	/*kakutei ji no K_R info  <OUT>*/
/*	PSZ	kihon_buf;	*/	/*KihonBuffer info	  <OUT>*/
/*	PSZ	key_buf;	*/	/*Key_buf_Q		  <OUT>*/
	BUFF	PWIN *lpchDisplayYomi ;
	BUNINF	PWIN *lpchDisplayBuninf ;
	BUFF	PWIN *lpchResultYomi ;
	BUNINF	PWIN *lpchResultBuninf ;
	USHORT	wTikuFlag ;	/*ɤߥե饰 1:OK,2:One More Call*/
#if 1/*KOHOSORT*/
	USHORT  koho_mode;/*0:NORMAL,1:SORT_TOP,2:SORT_END*/
#endif
	};
typedef	struct bdata BDATA;

#if OS2|MSDOS|WINDOWS
typedef BDATA far *PBD;
#else
typedef BDATA *PBD;
#endif

#if SINGLE
#if WINDOWS && !DPMI
#if WIN32
	short FAR PASCAL BasicEdit(BDATA far *);
#else
short  PWIN pascal BasicEdit(BDATA far *);
#endif
#else
short  BasicEdit(BDATA far *);
#endif
#else
#if WINDOWS && !DPMI	/*WIN95 */
 short FAR PASCAL BasicEditOpen(HBASEDT PWIN *);
 short FAR PASCAL BasicEditClose(HBASEDT );
 short FAR PASCAL BasicEdit(HBASEDT ,PBD);
#else
 short  BasicEditOpen(struct  _BEBUF * *lphBasEdt);
 short  BasicEditClose(struct  _BEBUF *hBasEdt);
 short  BasicEdit(struct  _BEBUF *hBasEdit,struct  bdata PWIN *bdata);
#endif
#endif

#define FIX_MODE	0x01	/* fix input like atok */ /* 92/7/31 */
#define	SCREEN_MODE	0x02	/* VJE active */
#define	DIRECT_MODE	0x04	/* Direct Mode */
#define	ZENKAKU_BIT	0x08	/* Zenkaku / hankaku input mode */
#define	KATA_BIT	0x10	/* Kana / Romaji Input mode */
#define	KANA_BIT	0x20	/* Katakana / Hiragana input mode */
#define	EISUU_BIT	0x40	/* Eisuu Input mode */
#define	CAPS_BIT	0x80	/* Eisuu Caps Input mode */
#define EISU_ZEN_BIT	0x100	/* Eisuu Zenkaku */
#define KANA_ZEN_BIT	0x200   /* KANA Zenkaku */

#define	INP_MASK	(ZENKAKU_BIT|KANA_BIT)

#define	INACTIVE_MODE	0

#define	VJEMODE()	(bdata->wVjeModeFlag & SCREEN_MODE)
#define	SetVJEMODE(m)	(bdata->wVjeModeFlag = bdata->wVjeModeFlag & ~SCREEN_MODE | (m))

/*#define	INITIAL_VJE_MODE KATA_BIT|KANA_BIT 93/12/16 */
#define	INITIAL_VJE_MODE ZENKAKU_BIT

/*
 *	Main stage (kdata->MainStage)
 */
#define PRC_EMP 	0x0080		/* Buffer Empty */
#define PRC_INPUT	0x0040      /* Input State  */
#define PRC_CNV 	0x0020      /* Tango Sentaku */
#define PRC_DON 	0x0010      /* Tango Sentaku with Douongo */
#define PRC_RCNV	0x0008		/* Saihenkan */
#define PRC_CODE	0x0004	    /* Code henkan */
#define PRC_DEL		0x0002	    /* Tango Sakujyo */
#define PRC_RSV1	0x0001	    /* Rserved */

/*
 *	Henkan Mode Flag (kdata->HenModFlag)
 */
#define MOD_KUTEN_YES		0x00008000	/*Kuten mode yes*/
#define MOD_KUTEN_NO		0x00004000	/*Kuten mode no*/
#define MOD_TANKAN_YES		0x00002000	/*TANKAN GAKU*/
#define MOD_TANKAN_NO		0x00001000	/*TANKAN*/
#define MOD_KUTEN_CNV_YES	0x00000400	/**/
#define MOD_KUTEN_CNV_NO	0x00000200	/**/
#define MOD_CALC_ON		0x00000100	/* Calc on */
#define MOD_CALC_OFF		0x00000080	/* Calc off */
#define MOD_EUC			0x00000800	/*990826*/
#define MOD_SJIS		0x00000040	/* kuten code henkan */
#define MOD_KUTEN		0x00000020	/* kuten code henkan */
#define MOD_JIS			0x00000010	/* jis code henkan */
#define	MOD_UNICODE		0x00000008	/* unicode henkan */
#define MOD_REN			0x00000004	/* renbunsetu henkan */
#define MOD_SAKI		0x00000002	/* sakiyomi henkan */
#define MOD_BETA		0x00000001	/* betagaki henkan */

/*
 *	VJE-Lib Henkan Mode Flag (bdata->HenModFlagV)
 */
#define MOD_HOSEI_ON		0x00100000	/* Hosei Ari*/
#define MOD_HOSEI_OFF		0x00080000	/* Hosei Kinsi(Def)*/
#define MOD_YURAGI_ON		0x00040000	/* YURAGI Ari*/
#define MOD_YURAGI_OFF		0x00020000	/* YURAGI Kinsi(Def)*/
#define	MOD_EISU_OFF		0x00010000	/* Kougo Ari*/
#define	MOD_EISU_ON		0x00008000	/* Kougo Kinsi */
#define	MOD_KOUGO_ON		0x00004000	/* Kougo Ari*/
#define	MOD_KOUGO_OFF		0x00002000	/* Kougo Kinsi */
#define	MOD_KOUBUN_ON		0x00001000	/* Koubun Kaiseki suru */
#define	MOD_KOUBUN_OFF		0x00000800	/* Koubun Kaiseki sinai */
#define MOD_FUKUGOU		0x00000400	/* Fukugougo henkan */
#define MOD_BUNSETU		0x00000200	/* Bunsetu henkan */
#define MOD_GAKU_DOUON		0x00000100	/* douongo gakushuu */
#define MOD_GAKU_BUNSETU	0x00000080	/* bunsetu-kan & douongo gakushuu */
#define MOD_GAKU_OFF		0x00000040	/* gakushuu off */
#define MOD_OKURI_HONSOKU	0x00000020	/* okuri honsoku */
#define MOD_OKURI_OKURU		0x00000010	/* okuri okuru */
#define MOD_OKURI_HABUKU	0x00000008	/* okuri habuku */
#define MOD_OKURI_ZENBU		0x00000004	/* reserve */
#define MOD_KATAKANA_ON		0x00000002	/* katakana touorku on */
#define MOD_KATAKANA_OFF	0x00000001	/* katakana touorku off */
#if	PENWIN
	#define PEN_INP_NORM		0x0001		/* NORMAL */
	#define PEN_INP_PEN		0x0002		/* for PEN */
	#define PEN_CNV_YES		0x0004		/* majiri CNV */
	#define PEN_CNV_NO		0x0008		/* no majiri CNV*/
	#define PEN_GAKU_ON		0x0010
	#define PEN_GAKU_OFF		0x0020
#endif

/*
 *	wHenModFlagLim (¥⡼)
 */
#define	MOD_LIM_OFF		0x00000001	/*¤ʤ(Def)*/
#define	MOD_LIM_1		0x00000002	/*:1ǯ*/
#define	MOD_LIM_2		0x00000004	/*:2ǯ*/
#define	MOD_LIM_3		0x00000008	/*:3ǯ*/
#define	MOD_LIM_4		0x00000010	/*:4ǯ*/
#define	MOD_LIM_5		0x00000020	/*:5ǯ*/
#define	MOD_LIM_6		0x00000040	/*:6ǯ*/
#define	MOD_LIM_JYOU		0x00000080	/*:*/
#define	MOD_LIM_NOYOMI		0x00000100	/*:(ɤߤϥåʤ)*/
#define	MOD_LIM_KOYU_YES	0x00000200	/*ͭ̾¤*/
#define	MOD_LIM_KOYU_NO		0x00000400	/*ͭ̾¤ʤ*/
#define	MOD_LIM_MARK_YES	0x00000800	/*ñޡɽ*/
#define	MOD_LIM_MARK_NO		0x00001000	/*ñɽʤ*/
#define	MOD_LIM_JIS_YES		0x00002000	/*ʣɣ¤Ԥ     */
#define	MOD_LIM_JIS_NO		0x00004000	/*ʣɣ¤Ԥʤ */

/*
 *	wDicMode (⡼)
 */
#define MOD_DIC_FOR_GAKU	0x01	/*μ񤬳ؽǤ */
#define MOD_GAKU_DON		0x02	/*μñؽ */
#define MOD_GAKU_BUN		0x04	/*μñؽ */
#define MOD_GAKU_NO 		0x08	/*μñϳؽʤ */
#define MOD_GAKU_MYSELF		0x10	/*μ˳ؽ */
#define	MOD_PARA_ACCESS		0x20	/*μ󼭽Ǥ */

/*
 *	KanaLock status (kanamd)
 */
#define	MOD_KLK_BIT	(0x0001)		/*kanalock off*/
#define	MOD_KANA_BIT	(0x0002)		/*kanalock on*/
/*
 *	Virtual function number
 */
#ifdef	GETTANGO
#define N_VFNO		121	/*Number of virtual func MAX = 49 > 64 */
#else
#define N_VFNO		120	/*Number of virtual func MAX = 49 > 64 */
#endif

#define	F_INIT		1	/* menu mode */
#define	F_SCRN		2	/* Kanji */
#define	F_CNV		3	/* Henkan */
#define	F_HIRA_CNV	4
#define	F_KATA_CNV	5
#define	F_ZEN_CNV	6
#define	F_HAN_CNV	7
#define	F_NO_CNV	8	/* Kakkutei */
#define	F_CODE		9
#define	F_SPACE		10
#define	F_KANA_LOCK	11
#define	F_CNV_NBLK	12	/* Down Arrow */
#define	F_RIGHT		13	/* Right Arrow */
#define	F_LEFT		14	/* Left Arrow */
#define	F_BS 		15
#define	F_DEL		16
#define	F_ROM		17
#define	F_HIRA		18
#define	F_KATA		19
#define	F_ZEN		20
#define	F_HAN		21
#define	F_OPEN		22
#define	F_UOPEN		23
#define	F_CODE_CNT	24
#define	F_LLIM		25
#define	F_RLIM		26
#define	F_CANCEL	27
#define	F_NO_CNV2	28	/* Shift Kakutei */
#define	F_CTRL		29
#define	F_CHR		30
#define	F_CLOSE		31
#define	F_KNJ		32
#define	F_UCLOSE	33
#define	F_CANALL	34	/* Shift ESC */
#define	F_EISUU		35
#define	F_UNDO		36	/* Kakutei */
#define	F_DMODE		37	/* Ctrl Kakutei */
#define	F_UNDO2		38	/* Kakutei(no BakSpace) Delta*/
#define	F_GET_MODE	39
#define	F_CAPS_ON	40
#define	F_CAPS_OFF	41
#define	F_TOUROKU	42
#define	F_SAKUJYO	43
#define	F_MODE		44
#define	F_REV_SPACE	45
#define	F_MB_SEL	46
#define	F_LB_SEL	47
#define F_ROM_OPEN	48		/* 1993/4/14 Y.Mogi */
#define F_ROM_CLOSE	49		/* 1993/4/14 Y.Mogi */
#define F_CNV_BBLK	50	/* Up Arrow */
#define F_CNV_BKOHO	51	/* Left Arrow */
#define F_CNV_NKOHO	52	/* Right Arrow */
#define F_CNV_BUNL	53	/* Shift Right Arrow */
#define F_CNV_BUNS	54	/* Shift Left Arrow */
#define F_CNV_BCNV	55	/* Shift Henkan */
/*Delta*/
#define F_ATOK_KAKU	56	/* ATOK Bubun Kakutei*/
#define F_ATOK_1KAKU    57	/* ATOK 1moji Kakutei*/
#define F_ATOK_TOPKAKU  58	/* ATOK sentou 1 on Kakutei*/
#define F_ATOK_ENDKAKU  59	/* ATOK saisyu 1 on Kakutei*/
#define F_ATOK_MODE     60	/* ATOK mode (F10)*/
#define F_ATOK_EISUU    61	/* ATOK eiji (shift+NFER)*/
#define F_ATOK_KANA     62	/* ATOK kana (ctrl +NFER)*/
#define F_ATOK_ZEN_FIX  63	/**/
#define F_ATOK_HAN_FIX  64	/**/
#define F_WX_KANA  	65	/**/
#define F_FUKUGOU  	66	/**/
#define F_CNV1		67	/*henkan(loop)*/
#define F_CNV_ATK	68	/*henkan(ATOK)*/
#define F_CNV_NCNV	69	/*ji kouho*/
#define F_CNV_NCNV1	70	/*ji kouho(loop)*/
#define F_CNV_NCNV_ATK	71	/*ji kouho(ATOK)*/
#define F_CNV_BCNV1	72      /*zen kouho(loop)*/
#define F_CNV_BCNV_ATK	73      /*zen kouho(ATOK)*/
#define F_CNV_NBLK1	74      /*Down Arrow(loop)*/
#define F_CNV_NBLK_ATK	75      /*Down Arrow(ATOK)*/
#define F_CNV_BBLK1	76      /*Up Arrow(loop)*/
#define F_CNV_BBLK_ATK	77      /*Up Arrow(ATOK)*/
#define F_CNV_OPT1	78	/*OptionDic1 henkan*/
#define F_CNV_OPT2	79	/*         2       */
#define F_CNV_OPT3	80	/*         3       */
#define F_CNV_OPT4	81	/*         4       */
#define F_CNV_OPT5	82	/*         5       */

#define F_CNV_OPT6	83	/*         6       */
#define F_CNV_OPT7	84	/*         7       */
#define F_CNV_OPT8	85	/*         8       */
#define F_CNV_OPT9	86	/*         9       */
#define F_CNV_OPT10	87	/*         10       */

#define F_DIC_OPEN	88	/*OptionDic Open*/
#define F_DIC_CLOSE	89	/*OptionDic Close*/

#define F_HIRA_KATA	90	/*F_HIRA F_KATA no Toggle*/
#define F_ATOK_BS	91	/**/
#define F_FKEY		92	/*ret ret nop*/

#define F_KLK_ON	93	/**/
#define F_KLK_OFF	94	/**/

#define F_ATOK_CNV      95	/* ATOK mode (XFER)*/
#define F_KOHOMAX	96	/* WIN95:KOHO MAX */
#define F_HAN_EISU_CNV	97	/* WIN95:EISU HAN */

#define F_KATA_HAN	98	/* KATAKANA HAN */
#define F_KATA_ZEN	99	/* KATAKANA ZEN */
#define F_KATA_AUTO	100	/* KATAKANA Default(ɸ)*/
#define F_EISU_HAN	101	/* EISU HAN */
#define F_EISU_ZEN	102	/* EISU ZEN */
#define F_EISU_AUTO	103	/* EISU by F_ZEN or F_HAN(ɸ)*/
#define F_KIGO_HAN	104	/* KIGO HAN */
#define F_KIGO_ZEN	105	/* KIGO ZEN */
#define F_KIGO_AUTO	106	/* KIGO by F_ZEN or F_HAN(ɸ)*/
#define F_KOHO_DEL	107	/* ܸ 9/25*/
#define F_WX_EISU	108	/* WXѿѴ 9/25*/
#define F_ESC2		109	/* ٤ɤߤ᤹ 9/25*/
#define F_RLIM2		110	/* ʸư 2 9/25*/
#define F_CHR_BS	111	/* 1ʸִ(ϥ⡼ɻͭ) 10/5*/
#define F_LIM_OPEN	112	/* ¥ǡץ */
#define F_LIM_CLOSE	113	/* ¥ǡ */
#define F_TIKU		114	/* ɤ */
#if 1/*KOHOSORT*/
#define F_LB_SEL2	115
#define	F_KOHO_NORMAL	116
#define	F_KOHO_SORT_TOP	117
#define	F_KOHO_SORT_END	118
#define	F_KOHO_SORT_BUSYU	119
#define	F_KOHO_SORT_KAKUSU	120
#endif
#ifdef	GETTANGO
#define	F_GET_TANGO	121	/* ñ */
#endif

#if	PENWIN
	#define	F_SAIHENKAN	88
	#define	F_PEN		89
	#define	F_GET_PEN	90
#endif
#if	PENDIC
	#define	F_ROPEN		91
	#define	F_RCLOSE	92
#endif

#define F_EXTEND	127		/* Number of virtual func MAX = 90 */

/* vjeinout.h (94/2/22) */
/*#define F_SAIHEN		240	*/
/*#define F_TANGO		241	*/
/*#define F_HELP		242	*/
/*#define F_NOP			250	*/
/*#define F_NORMAL		252	*/
/*#define F_MORE		253	*/
/*#define F_OTHER		254	*/
/*#define F_ETC			255	*/
/*#define F_ERROR		-1	*/

/* backgraund color */
#define	B_BLACK		0x00
#define	B_BLUE		0x10
#define	B_GREEN		0x20
#define	B_CYAN		0x30
#define	B_RED		0x40
#define B_MAZENTA	0x50
#define	B_YELLOW	0x60
#define	B_WHITE		0x70
#define	B_LTGRAY	0x80

/* color */
#define	F_BLACK		0x00
#define	F_BLUE		0x01
#define	F_GREEN		0x02
#define	F_CYAN		0x03
#define	F_RED		0x04
#define F_MAZENTA	0x05
#define	F_YELLOW	0x06
#define	F_WHITE		0x07
#define	F_REVERSE	0x08
#define	F_UNDERLINE	0x10
#define	F_LTGRAY	0x20

/*
 *	Virtual attribute to physical attribute
 */
#define	CL_NORMAL    0   /* ̾￧                   */
#define	CL_INPUT     1   /* ʸ               */
#define CL_HENKAN_1  2   /* ʸᡡ   */
#define CL_HENKAN_2  3   /* Ѵʸ */
#define	CL_EDIT	     4   /* Խ               */
#define	CL_HENKAN_3  5   /* Ѵʸ       */
#define	CL_CSR	     6   /* 뿧             */
#define	CL_INPT_MODE 7   /* ϥ⡼ɽ         */
#define CL_DMODE     8   /* DIRECT MODE HYOUJI   */
#define	CL_ERROR     9   /* 顼ɽ               */
#define CL_MARK	    10   /* Mark(ǻ) */
#define	CL_CSR2	    11   /* ʸȤƣӣФղä°*/
#define	CL_EXTEND   12	 /* Start of Extend Color    */

#define	VJE_RESULT	0x80
#define	VJE_MODEDATA	0x40
#define	VJE_MBDATA	0x20
#define	VJE_DISPLAYDATA	0x10
#define	VJE_LBDATA	0x08

#define RC_ERROR 	-1
#define RC_EATEN  	0
#define RC_IGNORED  	1
#define RC_EXIT 	2
#if WINDOWS
#undef	MB_OK
#endif
#define	MB_OK	0
#define	KEY_KANALOCK		0	/* Keyboard KanaLock  */
#define	KEY_EISUU		1
#define	KEY_STANDARD		2
#define	KEY_KANALOCK2		3	/* Keyboard KanaLock ʤ */

#define	CL_CGA			0
#define	CL_LOGIC		1
#define	CL_SPECIAL		2

#ifdef	GETTANGO
/* Hinsi Type */
#define	HTYPE_USER		0x0001
#define	HTYPE_AUTO		0x0002
#define	HTYPE_SYSTEM		0x0004
#define	HTYPE_DETAIL		0x0100
#endif

/*
 *	Call tiku(); parm1
 */
#define	FARST_RDIC		0x0080

