/*
**   VJE GAMMA
**			common.h
**
*/

#if MAC				/* ٤ɤ߹褦 */
#pragma once
#endif

#if WIN32
#include	<windows.h>
#define PUCH	PUCHAR
#define LockData	LocalLock
#define UnlockData	LocalUnlock
#define LocalInit	HeapCreate
#define iskanji	VjeKanji
#endif

#if DPMI
#define iskanji	VjeKanji
#endif

#ifndef	EOF
#define	EOF			(-1)
#endif

#if WINDOWS

#if WIN32
#define	FP_OFF
#endif

#if DPMI
#define	NULL			0
#endif

#else	/*WINDOWS*/

#define	FP_OFF

#ifndef	NULL

#if	MSDOS
#define	NULL			((UCHAR PWIN *)0)
#else
#define	NULL			0

#endif	/*MSDOS*/

#endif	/*NULL*/

#endif	/*WINDOWS*/

#define	YES			1
#define	NO			0
#define	ON			YES
#define	OFF			NO
#define	OK			0
#define	ERR			(-1)
#define	PLUS			1
#define	ZERO			0
#define	MINUS		(-1)

#define	EOS			'\0'
#define	TAB			'\t'
#define	CR			'\r'
#define	LF			'\n'
#define	BS			'\b'
#define	DEL			0x7f
#define	ESC			0x1b
#define	BLANK		' '
#define	BELL		0x07
#define	DAKUTEN		0xde
#define	HANDAKUTEN	0xdf
#define	HATSUON		0xdd

#define	MASK			0xff
#define	toggle(flag)	((flag) = !(flag))
#define	swap(a, b)	{(a) ^= (b); (b) ^= (a); (a) ^= (a);}
#define	TAB_STEP	8
#define	TAB_STOP(n)	(TAB_STEP - (n) % TAB_STEP)
#define	INC(c, base)	((c) = (++(c) % (base)))
#define	DEC(c, base)	((c) = ((--(c) + (base)) % (base)))

/*
 *	Macros for length prefixed string
 */
#define	SP(p) 		((*(p) & 0xff) + (*((p) + 1) & 0xff) * 256)

#ifdef	UCS
#define	VjeUniCode(c)	(0x813F == (c) || (c) == 0x813E)
#define	VjeUdcCode(c)	(0x813A <= (c) && (c) <= 0x813D)
#endif

#define	VjeKanji(c)	(0x80 <= ((c) & 0xff) && ((c) & 0xff) <= 0x9f ||\
			 0xe0 <= ((c) & 0xff) && ((c) & 0xff) <= 0xfc)
#define	max(a,b)	(((a) > (b)) ? (a) : (b))
#define	min(a,b)	(((a) < (b)) ? (a) : (b))

#if !MAC		/* ɸǤ뤿 */
#define	abs(a)		(((a) < 0) ? -(a) : (a))
#endif

#ifndef	iscsymf		/*WIN32 */
#define	iscsymf(c)	(isalpha(c) || ((c) == '_'))
#endif

#ifndef	iscsym		/*WIN32 */
#define	iscsym(c)	(isalnum(c) || ((c) == '_'))
#endif

#if 1	/* V300 */
typedef	struct	Large_Buffer {
	short		len;
	unsigned char	str[500*2+3];	/* for TEST SIZE */
/*	unsigned char	str[NUM_CHAR*2+3];	/* str[0] Reserved */
} BUFF, WBUFF;
typedef	struct	Key_Buffer {	/* for key_buf_Q */
	short		len;
	unsigned char	str[500*3+3];	/* for TEST SIZE */
/*	unsigned char	str[NUM_CHAR*3+3];	/* str[0] Reserved */
} KBUFF;
typedef	struct	Small_Buffer {	/* for stack area Work Buffer */
	short		len;
	unsigned char	str[16+1];		/* str[0] Reserved */
} SBUFF;
typedef	struct	Pwork_Buffer {	/* for stack area Work Buffer */
	short		len;
	unsigned char	str[2];
} PBUFF;

#if MAC			/* ɸǤ뤿 */
#undef	Length
#endif
#define	SLength(s)	(s.len)			/* for struct BUFF */
#define	SAddchar(s, c)	(s.str[++SLength(s)] = (c))
#define	PLength(s)	(s->len)		/* for BUFF* */
#define	PAddchar(s, c)	(s->str[++PLength(s)] = (c))
#define	CLength(s)	(s[0])			/* for single Char array */
#define	CAddchar(s, c)	((s)[++Slength(s)] = (c))
#define	Length(s)	(s[0])
#define	Addchar(s, c)	((s)[++Length(s)] = (c))
#define	Addchar2(s, c)	((s)[++(s)[0]] = (c))

#else	/* V300 */

typedef	unsigned char	BUFF;
#if GYAKUBIKI
typedef	unsigned short	WBUFF;
#else /* GYAKUBIKI */
typedef	unsigned char	WBUFF;
#endif /* GYAKUBIKI */

#if !MAC		/* ɸǤ뤿 */
#define	Length(s)	(s[0])
#endif
#define	Addchar(s, c)	((s)[++Length(s)] = (c))
#define	Addchar2(s, c)	((s)[++(s)[0]] = (c))

#endif	/* V300 */

typedef	short	FLAG;
typedef	unsigned char	UCHAR;
typedef	short	SHORT;
typedef	unsigned short	USHORT;
#if ( MSDOS | OS2 )	/* 16bit */
typedef	long		XINT32;
typedef	unsigned long	XUINT32;
typedef	long		XLONG;
typedef	unsigned long	ULONG;
#else
#if ( WIN32 | unix | PCUNIX | MAC )	/* 32bit */
typedef	int		XINT32;
typedef	unsigned int	XUINT32;
typedef	int		XLONG;
typedef	unsigned int	ULONG;
#endif
#endif

#if MAC			/* cut 'far' for MAC */
#define	far
#endif

#if unix
typedef UCHAR	*PSZ;
typedef char	*PCH;
typedef UCHAR	*PUCH;
typedef UCHAR	*POS2;
#define PWIN
#define PWINW
#define PWIND
#define PWINS1
#define PWINS2
#define FTYPE
#else /* unix */

#if MAC
typedef UCHAR	*PSZ;
typedef char	*PCH;
typedef UCHAR	*PUCH;
typedef UCHAR	*POS2;
#define PWIN
#define PWINW
#define PWIND
#define PWINS1
#define PWINS2
#define FTYPE
#define BOOL	Boolean
#else	/* MAC */

#if OS2
typedef UCHAR far	*PSZ;
typedef char far	*PCH;
typedef UCHAR far	*PUCH;
typedef UCHAR far	*POS2;
#define PWIN
#define PWINW
#define PWIND
#define PWINS1
#define PWINS2
#define FTYPE
#else	/* OS2 */

#if WIN32
typedef UCHAR	far	*POS2;
#define PWIN	far
#define PWINW	
#define PWIND	
#define PWINS1	
#define PWINS2  
#define FTYPE	
#else	/*WIN32 */

#if MSDOS
typedef UCHAR far	*PSZ;
typedef char far	*PCH;
typedef UCHAR far	*PUCH;
	#if WINDOWS
typedef UCHAR	far	*POS2;
#define PWIN	far
extern	_segment	segw;
#define PWINW	_based(segw)
#define PWIND	far /*_based(segudic) // dicinf */
#define PWINS1	far /*_based(segudic) // dir */
#define PWINS2  far /*_based(segudic) // dir_ptr */
		#if DPMI
#define FTYPE
		#else
#define FTYPE	_fastcall near
	#endif
	#else	/*WINDOWS */
typedef UCHAR		*POS2;
#define PWIN
#define PWINW
#define PWIND
#define PWINS1
#define PWINS2
#define FTYPE
	#endif	/* WINDOWS */
#endif	/* MSDOS */
#endif	/* WIN32 */
#endif /* OS2 */
#endif	/* MAC */
#endif /* unix */


#define	public
#define	global

#if	MSDOS

#if	OS2

#define REG1
#define REG2
#define	REG3
#define	REG4
#define	REG5
#define	REG6
#define	REG7
#define	REG8

#else		/* OS2 else */

#define	REG1			register
#define	REG2			register
#define	REG3
#define	REG4
#define	REG5
#define	REG6
#define	REG7
#define	REG8

#endif		/* if OS2 END */

#else		/* MSDOS else */

#ifdef	BSD4_2

#define	REG1
#define	REG2
#define	REG3
#define	REG4
#define	REG5
#define	REG6
#define	REG7
#define	REG8

#else		/* BSD4_2 else */

#define	REG1			register
#define	REG2			register
#define	REG3			register
#define	REG4			register
#define	REG5			register
#define	REG6			register
#define	REG7			register
#define	REG8			register

#endif		/* ifdef BSC4_2 END */

#endif		/* if MSDOS END */
