/******************************************************************************
	Fileio.H
******************************************************************************/
#include	<unistd.h>
#include	<pwd.h>
#include	<sys/types.h>
#include	<sys/stat.h>
#include	<fcntl.h>
#include	<dirent.h>

/*=============================================================================
	define
=============================================================================*/
#define	InLog(s)				((void *)0)
#define	OutLog(s)				((void *)0)
#define	SetEndOfFile(s)				((void *)0)
#define INVALID_HANDLE_VALUE			((HANDLE)(-1))
#define FILE_ATTRIBUTE_DIRECTORY		(0x00000010)
#define FILE_ATTRIBUTE_NORMAL			(0x00000080)

/*=============================================================================
	typdef
=============================================================================*/
typedef DIR *LPDIR;
typedef struct dirent DIRENT, *LPDIRENT;

/*-----------------------------------------------------------------------------
	dic header structure	(from vjelib.h)
-----------------------------------------------------------------------------*/
typedef	struct _tagHEADER	{
	unsigned char	id_string[16];		/* ʸ */
	unsigned char	title[64];		/* Υȥ */
	unsigned char	version[16];		/* ΥС */
	unsigned char	copyright[48];		/* ԡ饤 */
	unsigned char	user_inf[16];		/* 桼 */
	unsigned char	make_date[16];		/*  */
	unsigned char	form_date[16];		/*  */
	unsigned char	edit_date[16];		/* ѹ */
	unsigned long	yomi_no;		/* ɤ */
	unsigned long	tango_no;		/* Ͽñ */
	unsigned long	sys_tango_no;		/* ƥϿñ */
	unsigned long	usr_tango_no;		/* 桼Ͽñ */
	unsigned short	free_link;		/* ǽζBLKؤLink */
	unsigned short	block_no;		/* ѤƤ֥åο */
	unsigned short	block_size;		/* ǡ֥å礭 */
	unsigned short	data_pos;		/* ǡƬ */
	unsigned short	index_size;		/* ǥå礭 */
	unsigned short	index_pos;		/* ǥåƬ */
	unsigned short	filler1[2];
	unsigned short	code_type	: 4;	/* ɼ */
	unsigned short	sort_type	: 4;	/*  */
	unsigned short	field_byte	: 8;	/* եΰByte*/
	unsigned short	record_byte	: 8;	/* 쥳ΰByte */
	unsigned short	filler2		: 8;
	unsigned short	yourei_no;		/* f4-f5 */
	unsigned short	gak_yourei_no;		/* f6-f7 */
	unsigned short	usr_add_disable	: 1;	/* 桼ñϿػf */
	unsigned short	sys_add_disable	: 1;	/* ƥñϿػf */
	unsigned short	usr_del_disable	: 1;	/* 桼ñػf */
	unsigned short	sys_del_disable	: 1;	/* ƥñػf */
	unsigned short	rec_gak_disable	: 1;	/* 쥳ñؽػf */
	unsigned short	bun_gak_disable	: 1;	/* 쥳ɴñؽػf */
	unsigned short	ruigigo_flag	: 1;	/* ե饰 */
	unsigned short	filler5		: 9;
	unsigned long	max_index;		/* fa-fd */
	unsigned short	check_sum;		/* å */
}	HEADER,FAR *LPHEADER;

