/******************************************************************************
	Getvcode.C
******************************************************************************/
#define		XK_KATAKANA
#include	<X11/keysym.h>
#include	"typedef.h"
#include	"xim.h"
#include	"xui.h"
#include	"macro.h"
#include	"fileio.h"
#include	"env.h"
#include	"getstr.h"
#include	"strutl.h"
#include	"getvcode.h"

/*Accessary*/
short		AccMode = 0;/*Only One Accessary.*/
char		AccApl[512];

/*=============================================================================
	Define
=============================================================================*/
#define	KC_YEN_PC98	21
#define	KC_YEN_AT	133
#define	CH_CYOUON	0xb0
#define	MOD_OKURI_BITS	(MOD_OKURI_ZENBU|MOD_OKURI_HONSOKU\
			|MOD_OKURI_OKURU|MOD_OKURI_HABUKU )
#define	MOD_CODE_BITS	(MOD_SJIS|MOD_KUTEN|MOD_JIS|MOD_UNICODE|MOD_EUC)

/*=============================================================================
	Global	Data
=============================================================================*/
#if 1 /* 20000301:OPEN-VJE */
DWORD	dwLim[] = {
#else
static	DWORD	dwLim[] = {
#endif
	MOD_LIM_OFF,	MOD_LIM_1,	MOD_LIM_2,
	MOD_LIM_3,	MOD_LIM_4,	MOD_LIM_5,
	MOD_LIM_6,	MOD_LIM_JYOU,	MOD_LIM_NOYOMI,
};

/*-----------------------------------------------------------------------------
  ϻˤȾʸ򥨥ߥ졼Ȥ뤿Υơ֥
  ܸʣ˥ܡɤǥΡޥλΥơ֥
-----------------------------------------------------------------------------*/
UCHAR	KanaNormalTable_A01[] = {
/*         !     "     #     $     %     &     '     1*/
  0x00, 0x00 ,0x00 ,0x00 ,0x00 ,0x00, 0x00 ,0x00,  /*1*/
/*   (     )     *     +     ,     -     .     /     2*/
  0x00, 0x00 ,0x00 ,0x00 ,0xc8 ,0xce ,0xd9 ,0xd2,  /*2*/
/*   0     1     2     3     4     5     6     7     3*/
  0xdc, 0xc7 ,0xcc ,0xb1 ,0xb3 ,0xb4 ,0xb5 ,0xd4,  /*3*/
/*   8     9     :     ;     <     =     >     ?     4*/
  0xd5, 0xd6 ,0xb9 ,0xda ,0x00 ,0x00 ,0x00 ,0x00,  /*4*/
/*   @     A     B     C     D     E     F     G     5*/
  0xde, 0xc1 ,0xba ,0xbf ,0xbc ,0xb2 ,0xca ,0xb7,  /*5*/
/*   H     I     J     K     L     M     N     O     6*/
  0xb8, 0xc6 ,0xcf ,0xc9 ,0xd8 ,0xd3 ,0xd0 ,0xd7,  /*6*/
/*   P     Q     R     S     T     U     V     W     7*/
  0xbe, 0xc0 ,0xbd ,0xc4 ,0xb6 ,0xc5 ,0xcb ,0xc3,  /*7*/
/*   X     Y     Z     [     \     ]     ^     0x5f  8*/
  0xbb, 0xdd ,0xc2 ,0xdf ,0xdb ,0xd1 ,0xcd ,0x00,  /*8*/
/*   `     a     b     c     d     e     f     g     9*/
  0x00, 0xc1 ,0xba ,0xbf ,0xbc ,0xb2 ,0xca ,0xb7,  /*9*/
/*   h     i     j     k     l     m     n     o     0*/
  0xb8, 0xc6 ,0xcf ,0xc9 ,0xd8 ,0xd3 ,0xd0 ,0xd7,  /*0*/
/*   p     q     r     s     t     u     v     w     1*/
  0xbe, 0xc0 ,0xbd ,0xc4 ,0xb6 ,0xc5 ,0xcb ,0xc3,  /*1*/
/*   x     y     z     {     |     }     ~           2*/
  0xbb, 0xdd ,0xc2 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00   /*2*/
};

/*-----------------------------------------------------------------------------
  ϻˤȾʸ򥨥ߥ졼Ȥ뤿Υơ֥
  ܸʣ˥ܡɤǥեȤλΥơ֥
-----------------------------------------------------------------------------*/
UCHAR	KanaShiftTable_A01[] = {
/*         !     "     #     $     %     &     '     1*/
  0x00, 0xc7, 0xcc ,0xa7 ,0xa9 ,0xaa ,0xab ,0xac , /*1*/
/*   (     )     *     +     ,     -     .     /     2*/
  0xad, 0xae, 0xb9 ,0xda, 0x00 ,0x00 ,0x00 ,0x00 , /*2*/
/*   0     1     2     3     4     5     6     7     3*/
  0x00, 0x00, 0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00 , /*3*/
/*   8     9     :     ;     <     =     >     ?     4*/
  0x00, 0x00, 0x00, 0x00 ,0xa4 ,0xce ,0xa1 ,0xa5 , /*4*/
/*   @     A     B     C     D     E     F     G     5*/
  0x00, 0xc1, 0xba ,0xbf ,0xbc ,0xa8 ,0xca ,0xb7 , /*5*/
/*   H     I     J     K     L     M     N     O     6*/
  0xb8, 0xc6, 0xcf ,0xc9 ,0xd8 ,0xd3 ,0xd0 ,0xd7 , /*6*/
/*   P     Q     R     S     T     U     V     W     7*/
  0xbe, 0xc0, 0xbd ,0xc4 ,0xb6 ,0xc5 ,0xcb ,0xc3 , /*7*/
/*   X     Y     Z     [     \     ]     ^     _     8*/
  0xbb, 0xdd, 0xaf ,0x00 ,0x00 ,0x00 ,0x00 ,0x7c , /*8*/
/*   `     a     b     c     d     e     f     g     9*/
  0xde, 0xc1, 0xba ,0xbf ,0xbc ,0xa8 ,0xca ,0xb7 , /*9*/
/*   h     i     j     k     l     m     n     o     0*/
  0xb8, 0xc6, 0xcf ,0xc9 ,0xd8 ,0xd3 ,0xd0 ,0xd7 , /*0*/
/*   p     q     r     s     t     u     v     w     1*/
  0xbe, 0xc0, 0xbd ,0xc4 ,0xb6 ,0xc5 ,0xcb ,0xc3 , /*1*/
/*   x     y     z     {     |     }     ~           2*/
  0xbb, 0xdd, 0xaf ,0xa2 ,0xb0 ,0xa3 ,0xa6 ,0x00   /*2*/
};

/*-----------------------------------------------------------------------------
  ϻˤȾʸ򥨥ߥ졼Ȥ뤿Υơ֥
  УãܡɤǥΡޥλΥơ֥
-----------------------------------------------------------------------------*/
UCHAR	KanaNormalTable_PC98[] = {
/*         !     "     #     $     %     &     '     1*/
  0x00, 0x00 ,0x00 ,0x00 ,0x00 ,0x00, 0x00 ,0x00,  /*1*/
/*   (     )     *     +     ,     -     .     /     2*/
  0x00, 0x00 ,0x00 ,0x00 ,0xc8 ,0xce ,0xd9 ,0xd2,  /*2*/
/*   0     1     2     3     4     5     6     7     3*/
  0xdc, 0xc7 ,0xcc ,0xb1 ,0xb3 ,0xb4 ,0xb5 ,0xd4,  /*3*/
/*   8     9     :     ;     <     =     >     ?     4*/
  0xd5, 0xd6 ,0xb9 ,0xda ,0x00 ,0x00 ,0x00 ,0x00,  /*4*/
/*   @     A     B     C     D     E     F     G     5*/
  0xde, 0xc1 ,0xba ,0xbf ,0xbc ,0xb2 ,0xca ,0xb7,  /*5*/
/*   H     I     J     K     L     M     N     O     6*/
  0xb8, 0xc6 ,0xcf ,0xc9 ,0xd8 ,0xd3 ,0xd0 ,0xd7,  /*6*/
/*   P     Q     R     S     T     U     V     W     7*/
  0xbe, 0xc0 ,0xbd ,0xc4 ,0xb6 ,0xc5 ,0xcb ,0xc3,  /*7*/
/*   X     Y     Z     [     \     ]     ^     0x5f  8*/
  0xbb, 0xdd ,0xc2 ,0xdf ,0xdb ,0xd1 ,0xcd ,0x00,  /*8*/
/*   `     a     b     c     d     e     f     g     9*/
  0x00, 0xc1 ,0xba ,0xbf ,0xbc ,0xb2 ,0xca ,0xb7,  /*9*/
/*   h     i     j     k     l     m     n     o     0*/
  0xb8, 0xc6 ,0xcf ,0xc9 ,0xd8 ,0xd3 ,0xd0 ,0xd7,  /*0*/
/*   p     q     r     s     t     u     v     w     1*/
  0xbe, 0xc0 ,0xbd ,0xc4 ,0xb6 ,0xc5 ,0xcb ,0xc3,  /*1*/
/*   x     y     z     {     |     }     ~           2*/
  0xbb, 0xdd ,0xc2 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00   /*2*/
};

/*-----------------------------------------------------------------------------
  ϻˤȾʸ򥨥ߥ졼Ȥ뤿Υơ֥
  УãܡɤǥեȤλΥơ֥
-----------------------------------------------------------------------------*/
UCHAR	KanaShiftTable_PC98[] = {
/*         !     "     #     $     %     &     '     1*/
  0x00, 0xc7, 0xcc ,0xa7 ,0xa9 ,0xaa ,0xab ,0xac , /*1*/
/*   (     )     *     +     ,     -     .     /     2*/
  0xad, 0xae, 0xb9 ,0xda, 0x00 ,0x00 ,0x00 ,0x00 , /*2*/
/*   0     1     2     3     4     5     6     7     3*/
  0xa6, 0x00, 0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00 , /*3*/
/*   8     9     :     ;     <     =     >     ?     4*/
  0x00, 0x00, 0x00, 0x00 ,0xa4 ,0xce ,0xa1 ,0xa5 , /*4*/
/*   @     A     B     C     D     E     F     G     5*/
  0x00, 0xc1, 0xba ,0xbf ,0xbc ,0xa8 ,0xca ,0xb7 , /*5*/
/*   H     I     J     K     L     M     N     O     6*/
  0xb8, 0xc6, 0xcf ,0xc9 ,0xd8 ,0xd3 ,0xd0 ,0xd7 , /*6*/
/*   P     Q     R     S     T     U     V     W     7*/
  0xbe, 0xc0, 0xbd ,0xc4 ,0xb6 ,0xc5 ,0xcb ,0xc3 , /*7*/
/*   X     Y     Z     [     \     ]     ^     _     8*/
  0xbb, 0xdd, 0xaf ,0x00 ,0x00 ,0x00 ,0x00 ,0x7c , /*8*/
/*   `     a     b     c     d     e     f     g     9*/
  0xa6, 0xc1, 0xba ,0xbf ,0xbc ,0xa8 ,0xca ,0xb7 , /*9*/
/*   h     i     j     k     l     m     n     o     0*/
  0xb8, 0xc6, 0xcf ,0xc9 ,0xd8 ,0xd3 ,0xd0 ,0xd7 , /*0*/
/*   p     q     r     s     t     u     v     w     1*/
  0xbe, 0xc0, 0xbd ,0xc4 ,0xb6 ,0xc5 ,0xcb ,0xc3 , /*1*/
/*   x     y     z     {     |     }     ~           2*/
  0xbb, 0xdd, 0xaf ,0xa2 ,0xb0 ,0xa3 ,0xde ,0x00   /*2*/
};

/*-----------------------------------------------------------------------------
  ϻˤȾʸ򥨥ߥ졼Ȥ뤿Υơ֥
  գӡʣ˥ܡɤǥΡޥλΥơ֥
-----------------------------------------------------------------------------*/
UCHAR	KanaNormalTable_101[] = {
/*         !     "     #     $     %     &     '     1*/
  0x00, 0x00 ,0x00 ,0x00 ,0x00 ,0x00, 0x00 ,0xb9,  /*1*/
/*   (     )     *     +     ,     -     .     /     2*/
  0x00, 0x00 ,0x00 ,0x00 ,0xc8 ,0xce ,0xd9 ,0xd2,  /*2*/
/*   0     1     2     3     4     5     6     7     3*/
  0xdc, 0xc7 ,0xcc ,0xb1 ,0xb3 ,0xb4 ,0xb5 ,0xd4,  /*3*/
/*   8     9     :     ;     <     =     >     ?     4*/
  0xd5, 0xd6 ,0x00 ,0xda ,0x00 ,0xcd ,0x00 ,0x00,  /*4*/
/*   @     A     B     C     D     E     F     G     5*/
  0x00, 0xc1 ,0xba ,0xbf ,0xbc ,0xb2 ,0xca ,0xb7,  /*5*/
/*   H     I     J     K     L     M     N     O     6*/
  0xb8, 0xc6 ,0xcf ,0xc9 ,0xd8 ,0xd3 ,0xd0 ,0xd7,  /*6*/
/*   P     Q     R     S     T     U     V     W     7*/
  0xbe, 0xc0 ,0xbd ,0xc4 ,0xb6 ,0xc5 ,0xcb ,0xc3,  /*7*/
/*   X     Y     Z     [     \     ]     ^     _     8*/
  0xbb, 0xdd ,0xc2 ,0xde ,0xd1 ,0xdf ,0x00 ,0x00,  /*8*/
/*   `     a     b     c     d     e     f     g     9*/
  0xdb, 0xc1 ,0xba ,0xbf ,0xbc ,0xb2 ,0xca ,0xb7,  /*9*/
/*   h     i     j     k     l     m     n     o     0*/
  0xb8, 0xc6 ,0xcf ,0xc9 ,0xd8 ,0xd3 ,0xd0 ,0xd7,  /*0*/
/*   p     q     r     s     t     u     v     w     1*/
  0xbe, 0xc0 ,0xbd ,0xc4 ,0xb6 ,0xc5 ,0xcb ,0xc3,  /*1*/
/*   x     y     z     {     |     }     ~           2*/
  0xbb, 0xdd ,0xc2 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00   /*2*/
};

/*-----------------------------------------------------------------------------
  ϻˤȾʸ򥨥ߥ졼Ȥ뤿Υơ֥
  գӡʣ˥ܡɤǥեȤλΥơ֥
-----------------------------------------------------------------------------*/
UCHAR	KanaShiftTable_101[] = {
/*         !     "     #     $     %     &     '     1*/
  0x00, 0xc7, 0xb9 ,0xa7 ,0xa9 ,0xaa ,0xac ,0x00 , /*1*/
/*   (     )     *     +     ,     -     .     /     2*/
  0xae, 0xa6, 0xad ,0xcd, 0x00 ,0x00 ,0x00 ,0x00 , /*2*/
/*   0     1     2     3     4     5     6     7     3*/
  0x00, 0x00, 0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00 , /*3*/
/*   8     9     :     ;     <     =     >     ?     4*/
  0x00, 0x00, 0xda, 0x00 ,0xa4 ,0x00 ,0xa1 ,0xa5 , /*4*/
/*   @     A     B     C     D     E     F     G     5*/
  0xcc, 0xc1, 0xba ,0xbf ,0xbc ,0xa8 ,0xca ,0xb7 , /*5*/
/*   H     I     J     K     L     M     N     O     6*/
  0xb8, 0xc6, 0xcf ,0xc9 ,0xd8 ,0xd3 ,0xd0 ,0xd7 , /*6*/
/*   P     Q     R     S     T     U     V     W     7*/
  0xbe, 0xc0, 0xbd ,0xc4 ,0xb6 ,0xc5 ,0xcb ,0xc3 , /*7*/
/*   X     Y     Z     [     \     ]     ^     _     8*/
  0xbb, 0xdd, 0xaf ,0x00 ,0x00 ,0x00 ,0xab ,0xb0 , /*8*/
/*   `     a     b     c     d     e     f     g     9*/
  0x00, 0xc1, 0xba ,0xbf ,0xbc ,0xa8 ,0xca ,0xb7 , /*9*/
/*   h     i     j     k     l     m     n     o     0*/
  0xb8, 0xc6, 0xcf ,0xc9 ,0xd8 ,0xd3 ,0xd0 ,0xd7 , /*0*/
/*   p     q     r     s     t     u     v     w     1*/
  0x70, 0xc0, 0xbd ,0xc4 ,0xb6 ,0xc5 ,0xcb ,0xc3 , /*1*/
/*   x     y     z     {     |     }     ~           2*/
  0xbb, 0xdd, 0xaf ,0xa2 ,0xd1 ,0xa3 ,0xdb ,0x00   /*2*/
};

/*=============================================================================
	GetBDATA
=============================================================================*/
PBD	GetBDATA
(
	FXim_Client	*client
)
{
	return ((PBD )&client->bdata);
}

/*=============================================================================
	GetBEBUF
=============================================================================*/
HBASEDT	GetBEBUF
(
	FXim_Client	*client
)
{
	return ((HBASEDT )client->v_data);
}

/*=============================================================================
	GetBEBUF_P
=============================================================================*/
HBASEDT	*GetBEBUF_P
(
	FXim_Client	*client
)
{
	return ((HBASEDT *)&client->v_data);
}

/*=============================================================================
	IsKanjiKey
=============================================================================*/
BOOL	IsKanjiKey
(
	FXim_Client	*client,
	LPKD		lpKD
)
{
	PBD	bdata;
	bdata	= (PBD )GetBDATA (client);
	VirtToFunc (client, lpKD);
	if (bdata->wVkey == F_SCRN
	 || bdata->wVkey == F_EX_KANJI_ON
	 || bdata->wVkey == F_EX_KANJI_OFF
	 || bdata->wVkey == F_EX_KANJI_OFF2) {/*990402*/
		return (TRUE);
	}
	return (FALSE);
}

/*=============================================================================
	IsScreenMode
=============================================================================*/
BOOL	IsScreenMode
(
	FXim_Client	*client
)
{
	PBD	bdata;
	bdata	= (PBD )GetBDATA (client);
	return (
		(bdata->wVjeModeFlag & SCREEN_MODE)
		? TRUE
		: FALSE
	);
}

/*=============================================================================
	IsKanaMode
=============================================================================*/
BOOL	IsKanaMode
(
	FXim_Client	*client
)
{
	PBD	bdata;
	bdata	= (PBD )GetBDATA (client);
	return (
		(!(bdata->wVjeModeFlag & EISUU_BIT) &&
		  (bdata->wVjeModeFlag & KATA_BIT ))
		? TRUE
		: FALSE
	);
}

/*=============================================================================
	IsSkipKey
=============================================================================*/
BOOL	IsSkipKey
(
	FXim_Client	*client,
	LPKD		lpKD
)
{
	PBD	bdata;
	USHORT	uFunc, uCode;
	int	col, row, len;

	bdata	= (PBD )GetBDATA (client);
	uFunc	= lpKD->wFunc;
	uCode	= lpKD->wOrgChar;

	switch (client->SkipFlag) {
	case	SKIP_NONE:
		switch (uFunc) {
		case	F_EX_NEXT_SKIP:
			client->SkipFlag	= SKIP_NEXT;
			client->SkipOption	= 0;
			SendKeyEvent (lpKD->xeEvent);
			return (TRUE);

		case	F_CHR:
			if (XK_1 > uCode || uCode > XK_9) {
				return (FALSE);
			}
			if (GetStageNo (client, lpKD) != STAGE_DON2) {
				return (FALSE);
			}
			GetVKpCanRMtx (client, &col, &row, &len);
			if (col < 2) {
				return (FALSE);
			}
			client->SkipFlag	= SKIP_CAN;
			client->SkipOption	= min (
							(uCode - XK_0),
							row
						);
			return (TRUE);
		}
		break;

	case	SKIP_NEXT:
		client->SkipFlag	= SKIP_NONE;
		client->SkipOption	= 0;
		SendKeyEvent (lpKD->xeEvent);
		return (TRUE);

	case	SKIP_CAN:
		switch (uFunc) {
		case	F_CHR:
			if (XK_1 <= uCode && uCode <= XK_9) {
				client->SkipFlag	= SKIP_CAN;
				client->SkipOption	= min (
								(uCode - XK_0),
								row
							);
				return (TRUE);
			}
			break;
		}
		lpKD->lFuncOption	= client->SkipOption;

		client->SkipFlag	= SKIP_NONE;
		client->SkipOption	= 0;
		return (FALSE);
	}

	client->SkipFlag	= SKIP_NONE;
	client->SkipOption	= 0;

	return (FALSE);
}

/*=============================================================================
	GetStageNo
=============================================================================*/
USHORT	GetStageNo
(
	FXim_Client	*client,
	LPKD		lpKD
)
{
	PBD		bdata;
	LPENV		lpEnv;
	USHORT		stage;
	USHORT		no;

	bdata		= (PBD   )GetBDATA (client);
	lpEnv		= (LPENV )GetEnv (0);
	stage		= bdata->wMainStage;

	if (!IsScreenMode (client) || stage & PRC_EMP) {
		no	= STAGE_EMP;
	} else if (stage & (PRC_INPUT|PRC_RCNV)) {
		no	= STAGE_INP;
	} else if (stage & PRC_CNV) {
		no	= STAGE_CNV;
	} else if (stage & (PRC_DON|PRC_CODE)) {
		if (lpEnv->can.wMatrix == NO) {
			no	= STAGE_DON1;
		} else {
			no	= STAGE_DON2;
		}
	} else {
		no	= STAGE_EMP;
	}

	return (no);
}

/*=============================================================================
	GetModifNo
=============================================================================*/
USHORT	GetModifNo
(
	LPKD		lpKD
)
{
	XEvent		*event;
	UINT		state;
	USHORT		no;

	event		= lpKD->xeEvent;
	state		= event->xkey.state;

	if (state & ControlMask) {
		if (state & Mod1Mask) {
			if (state & ShiftMask) {
				no	= FCASE_CTRL_ALT_SHIFT;
			} else {
				no	= FCASE_CTRL_ALT;
			}
		} else if (state & ShiftMask) {
			no	= FCASE_CTRL_SHIFT;
		} else {
			no	= FCASE_CTRL;
		}
	} else if (state & Mod1Mask) {
		if (state & ShiftMask) {
			no	= FCASE_ALT_SHIFT;
		} else {
			no	= FCASE_ALT;
		}
	} else if (state & ShiftMask) {
		no	= FCASE_SHIFT;
	} else {
		no	= FCASE_NORMAL;
	}

	return (no);
}

/*=============================================================================
	InitKD
=============================================================================*/
void	InitKD
(
	LPKD	lpKD
)
{
	lpKD->xeEvent		= (XEvent *)0;
	lpKD->ksKeysym		= (KeySym  )0;
	lpKD->ucString		= (UCHAR  *)0;
	lpKD->wFunc		= (WORD    )0;
	lpKD->wOrgChar		= (WORD	   )0;
	lpKD->lFuncOption	= (LPARAM  )0;
	lpKD->ucFuncString	= (UCHAR  *)0;
}

/*=============================================================================
	MapPunc
=============================================================================*/
void	MapPunc
(
	FXim_Client	*client,
	LPKD		lpKD
)
{
	PBD		bdata;
	LPVWIN		lpVWin;
	LPVKBD		lpVKbd;
	KeySym		keysym;
	USHORT		mode;
	USHORT		code;

	bdata		= (PBD    )GetBDATA (client);
	lpVWin		= (LPVWIN )GetVWin  ();
	lpVKbd		= (LPVKBD )GetVKbd  (lpVWin);
	keysym		= lpKD->ksKeysym;
	mode		= bdata->wVjeModeFlag;
	code		= bdata->wCharCode;

	switch ((UCHAR )code) {
	case XK_comma: /* "," */
		if (mode & EISUU_BIT) {
			;
		} else if (keysym == XK_KP_Separator) {
			;
		} else if (lpVKbd->wComma == YES) {
			code	= YES_COMMA;
		} else if (lpVKbd->wComma == AUTO) {
			code	= AUTO_COMMA;
		}
		break;
	case XK_period: /* "." */
		if (mode & EISUU_BIT) {
			;
		} else if (keysym == XK_KP_Decimal) {
			;
		} else if (lpVKbd->wPeriod == YES) {
			code	= YES_PERIOD;
		} else if (lpVKbd->wPeriod == AUTO) {
			code	= AUTO_PERIOD;
		}
		break;
	case XK_slash: /* "/" */
		if (mode & EISUU_BIT) {
			;
		} else if (keysym == XK_KP_Divide) {
			;
		} else if (lpVKbd->wSlash == YES) {
			code	= YES_SLASH;
		} else if (lpVKbd->wSlash == AUTO) {
			code	= AUTO_SLASH;
		}
		break;
	case XK_minus: /* "-" */
		if (mode & EISUU_BIT) {
			;
		} else if (keysym == XK_KP_Subtract) {
			;
		} else if (lpVKbd->wHyphen == YES) {
			code	= YES_HYPHEN;
		} else if (lpVKbd->wHyphen == AUTO) {
			code	= AUTO_HYPHEN;
		}
		break;
	case XK_bracketleft: /* "[" */
		if (mode & EISUU_BIT) {
			;
		} else if (lpVKbd->wBracket == YES) {
			code	= YES_BRACKETLEFT;
		}
		break;
	case XK_bracketright: /* "]" */
		if (mode & EISUU_BIT) {
			;
		} else if (lpVKbd->wBracket == YES) {
			code	= YES_BRACKETRIGHT;
		}
		break;
	case XK_kana_comma & 0x00ff:
		if (lpVKbd->wTen == YES) {
			code	= YES_TEN;
		}
		break;
	case XK_kana_fullstop & 0x00ff:
		if (lpVKbd->wMaru == YES) {
			code	= YES_MARU;
		}
		break;
	}

	bdata->wCharCode	= code;

	return;
}

/*=============================================================================
	MapKbd
=============================================================================*/
void	MapKbd
(
	FXim_Client	*client,
	LPKD		lpKD
)
{
#if DEF_ENV_EUC
	TCHAR		sjis[MAX_SHORT_STR+1];
#endif
	PBD		bdata;
	LPENV		lpEnv;
	XEvent		*event;
	KeySym		keysym;
	USHORT		code;
	LPTSTR		lptTemp;
	USHORT		i, j;

	bdata		= (PBD   )GetBDATA (client);
	lpEnv		= (LPENV )GetEnv (0);
	event		= lpKD->xeEvent;
	keysym		= lpKD->ksKeysym;
	code		= bdata->wCharCode;
	i		= ConvVK (keysym);
	j		= GetModifNo (lpKD);

#if DEF_BACKSLASH_AND_YEN
	if (i == XK_backslash) {
		if (lpEnv->kbd.wKbdType == KBD_PC98) {
			if (event->xkey.keycode == KC_YEN_PC98) {
				i	= XK_yen;
			}
		} else {
			if (event->xkey.keycode == KC_YEN_AT) {
				i	= XK_yen;
			}
		}
	}
#endif
	if (i < MAX_VK) {
		if (!IsKanaMode (client)) {
			lptTemp	= lpEnv->kbd.sztATable[i][j];
		} else {
			lptTemp	= lpEnv->kbd.sztKTable[i][j];
		}
		if (lstrlen (lptTemp)) {
#if DEF_ENV_EUC
			EucToShiftjis (sjis, lptTemp);
			code	= *sjis;
#else
			code	= *lptTemp;
#endif
		}
	}

	bdata->wCharCode	= code;

	return;
}

/*=============================================================================
	MapKana
=============================================================================*/
void	MapKana
(
	FXim_Client	*client,
	LPKD		lpKD
)
{
	PBD		bdata;
	LPENV		lpEnv;
	XEvent		*event;
	KeySym		keysym;
	UINT		state;
	USHORT		code;
	UCHAR  		*bTbl;
	UCHAR  		*sTbl;

	bdata		= (PBD   )GetBDATA (client);
	lpEnv		= (LPENV )GetEnv (0);
	event		= lpKD->xeEvent;
	keysym		= lpKD->ksKeysym;
	code		= bdata->wCharCode;
	state		= event->xkey.state;

	if (keysym >= XK_space
	 && keysym <= XK_asciitilde) {
		if (lpEnv->kbd.wKbdType == KBD_A01) {
			bTbl	= KanaNormalTable_A01;
			sTbl	= KanaShiftTable_A01;
		} else if (lpEnv->kbd.wKbdType == KBD_PC98) {
			bTbl	= KanaNormalTable_PC98;
			sTbl	= KanaShiftTable_PC98;
		} else {
			bTbl	= KanaNormalTable_101;
			sTbl	= KanaShiftTable_101;
		}
		if (state & ShiftMask) {
			if (sTbl[code - 0x20]) {
				code	= sTbl[code - 0x20];
			}
		} else {
			if(bTbl[code - 0x20]) {
				code	= bTbl[code - 0x20];
			}
		}
#if DEF_BACKSLASH_AND_YEN
		if (keysym == XK_backslash) {
			if (lpEnv->kbd.wKbdType == KBD_PC98) {
				if (event->xkey.keycode == KC_YEN_PC98) {
					code	= CH_CYOUON;
				}
			} else {
				if (event->xkey.keycode == KC_YEN_AT) {
					code	= CH_CYOUON;
				}
			}
		}
#endif
	}

	bdata->wCharCode	= code;

	return;
}

/*=============================================================================
	VirtToChar
=============================================================================*/
void	VirtToChar
(
	FXim_Client	*client,
	LPKD		lpKD
)
{
	PBD		bdata;
	KeySym		keysym;
	UCHAR		*string;

	bdata		= (PBD )GetBDATA (client);
	keysym		= lpKD->ksKeysym;
	string		= lpKD->ucString;

	if (keysym >= XK_overline
	 && keysym <= XK_semivoicedsound) { /* kana ? */
		bdata->wCharCode	= keysym & 0xff;
	} else {
		bdata->wCharCode	= *string;
	}

	if (IsKanaMode (client)) {
		MapKana (client, lpKD);
	}
	MapKbd  (client, lpKD);
	MapPunc (client, lpKD);

	return;
}

/*=============================================================================
	VirtToFunc
=============================================================================*/
void	VirtToFunc
(
	FXim_Client	*client,
	LPKD		lpKD
)
{
	PBD		bdata;
	LPENV		lpEnv;
	KeySym		keysym;
	USHORT		i, j, k;

	bdata		= (PBD   )GetBDATA (client);
	lpEnv		= (LPENV )GetEnv (0);
	keysym		= lpKD->ksKeysym;

	i		= ConvVK (keysym);
	j		= GetModifNo (lpKD);
	k		= GetStageNo (client, lpKD);

	if (i < MAX_VK) {
		bdata->wVkey	= lpEnv->kbd.wVirtTable[i][j][k];
	} else {
		bdata->wVkey	= F_FKEY;
	}

	return;
}

/*=============================================================================
	KeyMap
=============================================================================*/
void	KeyMap
(
	FXim_Client	*client,
	LPKD		lpKD
)
{
	PBD		bdata;

	bdata		= (PBD )GetBDATA (client);

	bdata->wVkey	= (USHORT )0;
	bdata->wCharCode= (USHORT )0;

	VirtToFunc (client, lpKD);
	if (bdata->wVkey == F_FKEY) {
		VirtToChar (client, lpKD);
		if (!(bdata->wCharCode)) {
			;
		} else if (bdata->wCharCode < XK_space) {
			bdata->wVkey	= F_CTRL;
		} else if (bdata->wCharCode == 0x7f) { /* Delete */
			bdata->wVkey	= F_DEL;
		} else {
			bdata->wVkey	= F_CHR;
		}
	}
	
	lpKD->wFunc	= bdata->wVkey;
	lpKD->wOrgChar	= bdata->wCharCode;

#if 0 /* debug */
printf ("Func,Char:[0x%04x,0x%04x]\n", bdata->wVkey, bdata->wCharCode);
fflush (stdout);
#endif
	return;
}

/*=============================================================================
	GetSaveFuncID
=============================================================================*/
WORD	GetSaveFuncID
(
	FXim_Client	*client,
	WORD		wFunc
)
{
	WORD	rc	= FC_0;

	switch	(wFunc) {
	case	F_ROM:			case	F_EX_ROM_ON:
	case	F_EX_ROM_OFF:
		rc	= FC_1;
		break;
	case	F_EX_CHAR_TOG:		case	F_HIRA:
	case	F_KATA:			case	F_EISUU:
		rc	= FC_2;
		break;
	case	F_ZEN:			case	F_HAN:
	case	F_EX_SIZE_ZEN:		case	F_EX_SIZE_HAN:
		rc	= FC_3;
		break;
	case	F_EX_OKURI_TOG:		case	F_EX_OKURI_HONSOKU:
	case	F_EX_OKURI_OKURU:	case	F_EX_OKURI_HABUKU:
	case	F_EX_OKURI_ZENBU:
		rc	= FC_4;
		break;
	case	F_EX_CODE_TOG:		case	F_EX_CODE_JIS:
	case	F_EX_CODE_SJIS:		case	F_EX_CODE_KUTEN:
	case	F_EX_CODE_UNICODE:	case	F_EX_CODE_EUC:
		rc	= FC_5;
		break;
	case	F_EX_CNVMODE_TOG:	case	F_EX_CNVMODE_REN:
	case	F_EX_CNVMODE_BETA:	case	F_EX_CNVMODE_SAKI:
		rc	= FC_6;
		break;
	case	F_EX_BUNPOU_TOG:	case	F_EX_BUNPOU_BUN:
	case	F_EX_BUNPOU_FUKU:
		rc	= FC_7;
		break;
	case	F_EX_KOUGO_TOG:		case	F_EX_KOUGO_ON:
	case	F_EX_KOUGO_OFF:
		rc	= FC_8;
		break;
	case	F_EX_KUTOCNV_TOG:	case	F_EX_KUTOCNV_ON:
	case	F_EX_KUTOCNV_OFF:
		rc	= FC_9;
		break;
	case	F_EX_CALC_TOG:		case	F_EX_CALC_ON:
	case	F_EX_CALC_OFF:
		rc	= FC_10;
		break;
	case	F_EX_HOSEI_TOG:		case	F_EX_HOSEI_ON:
	case	F_EX_HOSEI_OFF:
		rc	= FC_11;
		break;
	case	F_EX_YURAGI_TOG:	case	F_EX_YURAGI_ON:
	case	F_EX_YURAGI_OFF:
		rc	= FC_12;
		break;
	case	F_EX_KANAREG_TOG:	case	F_EX_KANAREG_ON:
	case	F_EX_KANAREG_OFF:
		rc	= FC_13;
		break;
	case	F_EX_EISUREG_TOG:	case	F_EX_EISUREG_ON:
	case	F_EX_EISUREG_OFF:
		rc	= FC_14;
		break;
	case	F_EX_JISONLY_TOG:	case	F_EX_JISONLY_ON:
	case	F_EX_JISONLY_OFF:
		rc	= FC_15;
		break;
	case	F_EX_COMMA_TOG:		case	F_EX_COMMA_ON:
	case	F_EX_COMMA_OFF:		case	F_EX_COMMA_AUTO:
		rc	= FC_16;
		break;
	case	F_EX_PERIOD_TOG:	case	F_EX_PERIOD_ON:
	case	F_EX_PERIOD_OFF:	case	F_EX_PERIOD_AUTO:
		rc	= FC_17;
		break;
	case	F_EX_SLASH_TOG:		case	F_EX_SLASH_ON:
	case	F_EX_SLASH_OFF:		case	F_EX_SLASH_AUTO:
		rc	= FC_18;
		break;
	case	F_EX_HYPHEN_TOG:	case	F_EX_HYPHEN_ON:
	case	F_EX_HYPHEN_OFF:	case	F_EX_HYPHEN_AUTO:
		rc	= FC_19;
		break;
	case	F_EX_BRACKET_TOG:	case	F_EX_BRACKET_ON:
	case	F_EX_BRACKET_OFF:
		rc	= FC_20;
		break;
	case	F_EX_TEN_TOG:		case	F_EX_TEN_ON:
	case	F_EX_TEN_OFF:
		rc	= FC_21;
		break;
	case	F_EX_MARU_TOG:		case	F_EX_MARU_ON:
	case	F_EX_MARU_OFF:
		rc	= FC_22;
		break;
	default:
		rc	= FC_0;
		break;
	}

	return	(rc);
}

/*=============================================================================
	EnvToCore
=============================================================================*/
void	EnvToCore
(
	FXim_Client	*client,
	LPVWIN		lpVWin,
	LPENV		lpEnv
)
{
	LPENVMOD	mod;
	LPENVDCI	dci;
	LPENVFIX	fix;
	LPENVCMP	cmp;
	KD		kd;
	LPTSTR		lptTmp;
	PBD		bdata;
	int		i;
	WORD		wFlag;
	WORD		wFunc;
	WORD		wID;

	/*---------------------------------------------------------------------
		initialize
	---------------------------------------------------------------------*/
	bdata	= (PBD )GetBDATA (client);

	mod	= &lpEnv->mod;
	dci	= &lpEnv->dci;
	fix	= &lpEnv->fix;
	cmp	= &lpEnv->cmp;

	wFlag	= LOWORD (lpVWin->Param);
	wFunc	= HIWORD (lpVWin->Param);
	wID	= GetSaveFuncID (client, wFunc);

	if (!(wFlag & (ENV_ALL|ENV_MODE))) {
		return;
	}

	InitKD (&kd);
	if ( IsScreenMode (client) && !(bdata->wMainStage & PRC_EMP) ) {
		kd.wFunc = F_CANALL;
		FuncHandler (client, &kd);
	}

	/*---------------------------------------------------------------------
		set wKeyType
	---------------------------------------------------------------------*/
#if 0 /* Delete:KanaCtrl */
	bdata->wKeyType = (mod->wKanaCtrl == YES)
			 ? (KEY_KANALOCK	 )
			 : (KEY_KANALOCK2	 );
#else /* Delete:KanaCtrl */
	bdata->wKeyType	= KEY_STANDARD;
#endif /* Delete:KanaCtrl */

	/*---------------------------------------------------------------------
		set any settings
	---------------------------------------------------------------------*/
	if (wFlag & ENV_MODE && wID != FC_1 )	kd.wFunc = F_EX_NOP;
	else if	(mod->wRoman==YES	    )	kd.wFunc = F_EX_ROM_ON;
	else			        	kd.wFunc = F_EX_ROM_OFF;
	FuncHandler(client,&kd);
	if (wFlag & ENV_MODE && wID != FC_2 )	kd.wFunc = F_EX_NOP;
	else if	(mod->wMojiType==HIRA	    )	kd.wFunc = F_HIRA;
	else if	(mod->wMojiType==KATA	    )	kd.wFunc = F_KATA;
	else					kd.wFunc = F_EISUU;
	FuncHandler(client,&kd);
	if (wFlag & ENV_MODE && wID != FC_3 )	kd.wFunc = F_EX_NOP;
	else if	(mod->wMojiSize==ZEN	    )	kd.wFunc = F_EX_SIZE_ZEN;
	else					kd.wFunc = F_EX_SIZE_HAN;
	FuncHandler(client,&kd);
	if (wFlag & ENV_MODE && wID != FC_4 )	kd.wFunc = F_EX_NOP;
	else if	(mod->wOkuriKana==HON	    )	kd.wFunc = F_EX_OKURI_HONSOKU;
	else if	(mod->wOkuriKana==OKURI	    )	kd.wFunc = F_EX_OKURI_OKURU;
	else if	(mod->wOkuriKana==NON	    )	kd.wFunc = F_EX_OKURI_HABUKU;
	else					kd.wFunc = F_EX_OKURI_ZENBU;
	FuncHandler(client,&kd);
	if (wFlag & ENV_MODE && wID != FC_5 )	kd.wFunc = F_EX_NOP;
	else if	(mod->wCode==SJIS	    )	kd.wFunc = F_EX_CODE_SJIS;
	else if	(mod->wCode==JIS	    )	kd.wFunc = F_EX_CODE_JIS;
#if	XKP_SUPPORT
	else if	(mod->wCode==UCS4	    )	kd.wFunc = F_EX_CODE_UNICODE;
#endif
	else if	(mod->wCode==EUC	    )	kd.wFunc = F_EX_CODE_EUC;
	else					kd.wFunc = F_EX_CODE_KUTEN;
	FuncHandler(client,&kd);
	if (wFlag & ENV_MODE && wID != FC_6 )	kd.wFunc = F_EX_NOP;
	else if	(mod->wHenkan==SAKI	    )	kd.wFunc = F_EX_CNVMODE_SAKI;
	else if	(mod->wHenkan==REN	    )	kd.wFunc = F_EX_CNVMODE_REN;
	else					kd.wFunc = F_EX_CNVMODE_BETA;
	FuncHandler(client,&kd);
	if (wFlag & ENV_MODE && wID != FC_7 )	kd.wFunc = F_EX_NOP;
	else if	(mod->wBunpou==BUN	    )	kd.wFunc = F_EX_BUNPOU_BUN;
	else					kd.wFunc = F_EX_BUNPOU_FUKU;
	FuncHandler(client,&kd);
	if (wFlag & ENV_MODE && wID != FC_8 )	kd.wFunc = F_EX_NOP;
	else if	(mod->wKougoConv==YES	    )	kd.wFunc = F_EX_KOUGO_ON;
	else					kd.wFunc = F_EX_KOUGO_OFF;
	FuncHandler(client,&kd);
	if (wFlag & ENV_MODE && wID != FC_9 )	kd.wFunc = F_EX_NOP;
	else if	(mod->wKutouConv==YES	    )	kd.wFunc = F_EX_KUTOCNV_ON;
	else					kd.wFunc = F_EX_KUTOCNV_OFF;
	FuncHandler(client,&kd);
	if (wFlag & ENV_MODE && wID != FC_10)	kd.wFunc = F_EX_NOP;
	else if	(mod->wCalc==YES	    )	kd.wFunc = F_EX_CALC_ON;
	else					kd.wFunc = F_EX_CALC_OFF;
	FuncHandler(client,&kd);
	if (wFlag & ENV_MODE && wID != FC_11)	kd.wFunc = F_EX_NOP;
	else if	(mod->wHosei==YES	    )	kd.wFunc = F_EX_HOSEI_ON;
	else			        	kd.wFunc = F_EX_HOSEI_OFF;
	FuncHandler(client,&kd);
	if (wFlag & ENV_MODE && wID != FC_12)	kd.wFunc = F_EX_NOP;
	else if	(mod->wYuragi==YES	    )	kd.wFunc = F_EX_YURAGI_ON;
	else					kd.wFunc = F_EX_YURAGI_OFF;
	FuncHandler(client,&kd);
#if 0 /* Delete:KutenMode */
	if	(mod->wKutenMode==YES	    )	kd.wFunc = F_EX_KUTENMODE_ON;
	else					kd.wFunc = F_EX_KUTENMODE_OFF;
	FuncHandler(client,&kd);
#endif /* Delete:KutenMode */
	if (wFlag & ENV_MODE && wID != FC_13)	kd.wFunc = F_EX_NOP;
	if	(dci->wKanaGaku == YES	    )	kd.wFunc = F_EX_KANAREG_ON;
	else					kd.wFunc = F_EX_KANAREG_OFF;
	FuncHandler(client,&kd);
	if (wFlag & ENV_MODE && wID != FC_14)	kd.wFunc = F_EX_NOP;
	if	(dci->wEisuGaku == YES	    )	kd.wFunc = F_EX_EISUREG_ON;
	else					kd.wFunc = F_EX_EISUREG_OFF;
	FuncHandler(client,&kd);
	if (wFlag & ENV_MODE && wID != FC_15)	;
	else {
		kd.wFunc	= F_EX_LIM_MODE;
		kd.lFuncOption	= (   (dwLim[cmp->wRank]   )	)
				| (   (cmp->wKoyu    == YES)
				  ?   (MOD_LIM_KOYU_YES    )
				  :   (MOD_LIM_KOYU_NO     )	)
				| (   (cmp->wMark    == YES)
				  ?   (MOD_LIM_MARK_YES    )
				  :   (MOD_LIM_MARK_NO     )	)
				| (   (mod->wJisOnly == YES)
				  ?   (MOD_LIM_JIS_YES     )
				  :   (MOD_LIM_JIS_NO      )	)
				;
		FuncHandler(client,&kd);
	}
	if (wFlag & ENV_MODE && wID != FC_15)
		;
	else
		SizeFixToCore (client, lpVWin, lpEnv);

	kd.wFunc	= F_EX_DON_START;
	kd.lFuncOption	= (LPARAM) lpEnv->can.wStart;
	FuncHandler(client,&kd);

	return;
}

#if PCUNIX
/*=============================================================================
	SizeFixToCore
=============================================================================*/
void	SizeFixToCore
(
	FXim_Client	*client,
	LPVWIN		lpVWin,
	LPENV		lpEnv
)
{
static	TCHAR		sztKigo[KIGOS][4] = {
			TEXT("()"),	TEXT("{}"),	TEXT("[]"),
			TEXT(""),	TEXT("<>"),	TEXT(".,"),
			TEXT(""),	TEXT("!"),	TEXT("\""),
			TEXT("#"),	TEXT("$"),	TEXT("%"),
			TEXT("&"),	TEXT("'"),	TEXT("*"),
			TEXT("+"),	TEXT("-"),	TEXT("/"),
			TEXT(":"),	TEXT(";"),	TEXT("="),
			TEXT("?"),	TEXT("@"),	TEXT("\\"),
			TEXT("^"),	TEXT("_"),	TEXT("`"),
			TEXT("|"),	TEXT("~"),	TEXT(""),
			TEXT(" "),
			};
	KD		kd;
	LPENVFIX	fix;
	LPTSTR		lptTmp;
	int		i;

	fix		= &lpEnv->fix;

	if	(fix->wEisuFix  == ZEN	    )	kd.wFunc = F_EISU_ZEN;
	else if	(fix->wEisuFix  == HAN	    )	kd.wFunc = F_EISU_HAN;
	else					kd.wFunc = F_EISU_AUTO;
	FuncHandler(client,&kd);

	if	(fix->wKanaFix  == ZEN	    )	kd.wFunc = F_KATA_ZEN;
	else if	(fix->wKanaFix  == HAN	    )	kd.wFunc = F_KATA_HAN;
	else					kd.wFunc = F_KATA_AUTO;
	FuncHandler(client,&kd);

	for	( i = 0 ; i < KIGOS ; i++ ) {
		if	(fix->wKigoFix[i] == ZEN )
			kd.wFunc = F_KIGO_ZEN;
		else if	(fix->wKigoFix[i] == HAN )
			kd.wFunc = F_KIGO_HAN;
		else
			kd.wFunc = F_KIGO_AUTO;
		for (lptTmp = sztKigo[i]; *lptTmp ; lptTmp++) {
			kd.wOrgChar = (WORD) *lptTmp;
			FuncHandler(client,&kd);
		}
	}

	return;
}
#endif

/*=============================================================================
	CoreToEnv
=============================================================================*/
void	CoreToEnv
(
	FXim_Client	*client,
	LPVWIN		lpVWin,
	LPENV		lpEnv
)
{
	LPENVMOD	mod;
	LPENVDCI	dci;
	LPENVCMP	cmp;
	PBD		bdata;
	long		lVje;
	long		lHen;
	long		lHenV;
	long		lHenL;
	long		lKey;
	int		i;
	WORD		wFlag;
	WORD		wFunc;
	WORD		wID;

	/*---------------------------------------------------------------------
		initialize
	---------------------------------------------------------------------*/
	bdata	= (PBD )GetBDATA (client);

	mod	= &lpEnv->mod;
	dci	= &lpEnv->dci;
	cmp	= &lpEnv->cmp;

	lVje	= bdata->wVjeModeFlag;
	lHen	= bdata->wHenModFlag;
	lHenV	= bdata->wHenModFlagV;
	lHenL	= bdata->wHenModFlagLim;
	lKey	= bdata->wKeyType;

	wFlag	= LOWORD (lpVWin->Param);
	wFunc	= HIWORD (lpVWin->Param);
	wID	= GetSaveFuncID (client, wFunc);

	if (!(wFlag & (ENV_ALL|ENV_MODE))) {
		return;
	}

	/*---------------------------------------------------------------------
		set any settings
	---------------------------------------------------------------------*/
	if	(wFlag & ENV_MODE && wID != FC_1 )	;
	else if	(lVje  & KATA_BIT)			mod->wRoman     = NO;
	else						mod->wRoman     = YES;
	if	(wFlag & ENV_MODE && wID != FC_2 )	;
	else if	(lVje  & EISUU_BIT		 )	mod->wMojiType  = EISU;
	else if	(lVje  & KANA_BIT		 )	mod->wMojiType  = KATA;
	else						mod->wMojiType  = HIRA;
	if	(wFlag & ENV_MODE && wID != FC_3 )	;
	else if	(lVje  & ZENKAKU_BIT)			mod->wMojiSize  = ZEN;
	else						mod->wMojiSize  = HAN;
	if	(wFlag & ENV_MODE && wID != FC_4 )	;
	else if	(lHenV & MOD_OKURI_HONSOKU	 )	mod->wOkuriKana = HON;
	else if	(lHenV & MOD_OKURI_OKURU	 )	mod->wOkuriKana = OKURI;
	else if (lHenV & MOD_OKURI_HABUKU	 )	mod->wOkuriKana = NON;
	else						mod->wOkuriKana = ALL;
	if	(wFlag & ENV_MODE && wID != FC_5 )	;
	else if	(lHen  & MOD_SJIS		 )	mod->wCode      = SJIS;
	else if	(lHen  & MOD_JIS		 )	mod->wCode      = JIS;
#if	XKP_SUPPORT
	else if	(lHen  & MOD_UNICODE		 )	mod->wCode      = UCS4;
#endif
	else if	(lHen  & MOD_EUC		 )	mod->wCode      = EUC;
	else						mod->wCode      = KUTEN;
	if	(wFlag & ENV_MODE && wID != FC_6 )	;
	else if	(lHen  & MOD_SAKI		 )	mod->wHenkan    = SAKI;
	else if (lHen  & MOD_BETA		 )	mod->wHenkan    = BETA;
	else						mod->wHenkan    = REN;
	if	(wFlag & ENV_MODE && wID != FC_7 )	;
	else if	(lHenV & MOD_BUNSETU		 )	mod->wBunpou    = BUN;
	else						mod->wBunpou    = FUKU;
	if	(wFlag & ENV_MODE && wID != FC_8 )	;
	else if	(lHenV & MOD_KOUGO_ON		 )	mod->wKougoConv = YES;
	else						mod->wKougoConv = NO;
	if	(wFlag & ENV_MODE && wID != FC_9 )	;
	else if	(lHen  & MOD_KUTEN_CNV_YES	 )	mod->wKutouConv = YES;
	else						mod->wKutouConv = NO;
	if	(wFlag & ENV_MODE && wID != FC_10)	;
	else if	(lHen  & MOD_CALC_ON		 )	mod->wCalc      = YES;
	else						mod->wCalc      = NO;
	if	(wFlag & ENV_MODE && wID != FC_11)	;
	else if	(lHenV & MOD_HOSEI_ON		 )	mod->wHosei     = YES;
	else						mod->wHosei     = NO;
	if	(wFlag & ENV_MODE && wID != FC_12)	;
	else if	(lHenV & MOD_YURAGI_ON		 )	mod->wYuragi    = YES;
	else						mod->wYuragi    = NO;
#if 0 /* Delete:KutenMode */
	if	(lHen  & MOD_KUTEN_YES		 )	mod->wKutenMode = YES;
	else						mod->wKutenMode = NO;
#endif /* Delete:KutenMode */
	if	(wFlag & ENV_MODE && wID != FC_13)	;
	else if	(lHenV & MOD_KATAKANA_ON	 )	dci->wKanaGaku  = YES;
	else						dci->wKanaGaku  = NO;
	if	(wFlag & ENV_MODE && wID != FC_14)	;
	else if	(lHenV & MOD_EISU_ON		 )	dci->wEisuGaku  = YES;
	else						dci->wEisuGaku  = NO;
	if	(wFlag & ENV_MODE && wID != FC_15)	;
	else if	(lHenL & MOD_LIM_KOYU_YES	 )	cmp->wKoyu      = YES;
	else						cmp->wKoyu      = NO;
	if	(wFlag & ENV_MODE && wID != FC_15)	;
	else if	(lHenL & MOD_LIM_MARK_YES	 )	cmp->wMark      = YES;
	else						cmp->wMark      = NO;
	if	(wFlag & ENV_MODE && wID != FC_15)	;
	else if	(lHenL & MOD_LIM_JIS_YES	 )	mod->wJisOnly   = YES;
	else						mod->wJisOnly   = NO;
	if	(wFlag & ENV_MODE && wID != FC_15)	;
	else {
		for	( i = 0 ; i < recof(dwLim) ; i++ ) {
			if	( lHenL & dwLim[i] ) {
				cmp->wRank	= i;
				break;
			}
		}
	}
#if 0 /* Delete:KanaCtrl */
	if	(lKey == KEY_KANALOCK		 )	mod->wKanaCtrl  = YES;
	else if	(lKey == KEY_KANALOCK2		 )	mod->wKanaCtrl  = NO;
	else						mod->wKanaCtrl  = YES;
#endif /* Delete:KanaCtrl */

	return;
}

/*=============================================================================
	FuncHandler
=============================================================================*/
BOOL	FuncHandler
(
	FXim_Client	*client,
	LPKD		lpKD
)
{
	BOOL		ret	= FALSE;
	PBD		bdata;
	LPENV		lpEnv;

	bdata	= (PBD   )GetBDATA (client);
	lpEnv	= (LPENV )GetEnv (0);

#if PCUNIX
	switch	(lpKD->wFunc) {
	case	F_EX_CNV_BLIN:
	case	F_EX_CNV_BLIN_ATK:
	case	F_EX_CNV_NLIN:
	case	F_EX_CNV_NLIN_ATK:
	case	F_EX_CNV_BCOL:
	case	F_EX_CNV_BCOL_ATK:
	case	F_EX_CNV_NCOL:
	case	F_EX_CNV_NCOL_ATK:
	case	F_CHR:
		if (GetStageNo (client, lpKD) == STAGE_DON2) {
			ret = CandidateHandler (client, lpKD);
			if (ret) {
				return (ret);
			}
		}
		break;

	default:
		break;
	}
#endif /* PCUNIX */

	switch	(lpKD->wFunc) {
	case	F_EX_SAVE_MODE:
	case	F_EX_REST_MODE:
		ret = SaveHandler (client, lpKD);
		break;

	case	F_EX_SHIFT_DOWN:
	case	F_EX_SHIFT_UP:
	case	F_EX_LSKEY:
		ret = CaseHandler (client, lpKD);
		break;

	case	F_KLK_ON:
	case	F_KLK_OFF:
		ret = EditHandler (client, lpKD);
		break;

#if 0 /* Delete:KanaCtrl */
	case	F_EX_KANALOCK_TOG:
		EmulateKeydown (client, XK_Kana_Lock, 1);
		break;
#endif /* Delete:KanaCtrl */

	case	F_EX_KANJI_ON:		case	F_EX_KANJI_OFF:
#if PCUNIX /* 990402 */
	case    F_EX_KANJI_OFF2:
#endif /* PCUNIX */
	case	F_SCRN:
	case	F_HIRA:			case	F_KATA:
	case	F_EISUU:		case	F_HIRA_KATA:
	case	F_EX_CHAR_TOG:
	case	F_EX_SIZE_ZEN:		case	F_EX_SIZE_HAN:
	case	F_ZEN:			case	F_HAN:
	case	F_EX_ROM_ON:		case	F_EX_ROM_OFF:
	case	F_ROM:
	case	F_EX_ROMSAVE:
	case	F_EX_DMODE_ON:		case	F_EX_DMODE_OFF:
	case	F_DMODE:
	case	F_EX_CNVMODE_REN:	case	F_EX_CNVMODE_BETA:
	case	F_EX_CNVMODE_SAKI:	case	F_EX_CNVMODE_TOG:
	case	F_EX_KUTOCNV_ON:	case	F_EX_KUTOCNV_OFF:
	case	F_EX_KUTOCNV_TOG:
	case	F_EX_KOUGO_ON:		case	F_EX_KOUGO_OFF:
	case	F_EX_KOUGO_TOG:
	case	F_EX_OKURI_HONSOKU:	case	F_EX_OKURI_OKURU:
	case	F_EX_OKURI_HABUKU:	case	F_EX_OKURI_ZENBU:
	case	F_EX_OKURI_TOG:
	case	F_EX_KANAREG_ON:	case	F_EX_KANAREG_OFF:
	case	F_EX_KANAREG_TOG:
	case	F_EX_EISUREG_ON:	case	F_EX_EISUREG_OFF:
	case	F_EX_EISUREG_TOG:
	case	F_EX_CODE_JIS:		case	F_EX_CODE_SJIS:
	case	F_EX_CODE_KUTEN:	case	F_EX_CODE_UNICODE:
	case	F_EX_CODE_EUC:
	case	F_EX_CODE_TOG:
	case	F_EX_BUNPOU_BUN:	case	F_EX_BUNPOU_FUKU:
	case	F_EX_BUNPOU_TOG:
	case	F_EX_YURAGI_ON:		case	F_EX_YURAGI_OFF:
	case	F_EX_YURAGI_TOG:
	case	F_EX_HOSEI_ON:		case	F_EX_HOSEI_OFF:
	case	F_EX_HOSEI_TOG:
	case	F_EX_CALC_ON:		case	F_EX_CALC_OFF:
	case	F_EX_CALC_TOG:
	case	F_EX_SMODE_FUKU:	case	F_EX_SMODE_BETA:
	case	F_EX_SMODE_REN:
	case	F_EX_LIM_MODE:
	case	F_EX_KUTENMODE_ON:	case	F_EX_KUTENMODE_OFF:
	case	F_EX_KUTENMODE_TOG:
	case	F_EX_INPUT_TOG:		case	F_EX_KANA_TOG:
	case	F_EX_EISU_TOG:
	case	F_EX_JISONLY_ON:	case	F_EX_JISONLY_OFF:
	case	F_EX_JISONLY_TOG:
	case	F_EX_KANACTRL_ON:	case	F_EX_KANACTRL_OFF:
	case	F_EX_KANACTRL_TOG:
		ret = VModeHandler (client, lpKD);
		break;

#if !PCUNIX
	case	F_EX_SPOT_ON:		case	F_EX_SPOT_OFF:
	case	F_EX_SPOT_TOG:
#endif /* !PCUNIX */
	case	F_EX_COMMA_ON:
	case	F_EX_COMMA_OFF:		case	F_EX_COMMA_AUTO:
	case	F_EX_COMMA_TOG:		case	F_EX_PERIOD_ON:
	case	F_EX_PERIOD_OFF:	case	F_EX_PERIOD_AUTO:
	case	F_EX_PERIOD_TOG:	case	F_EX_SLASH_ON:
	case	F_EX_SLASH_OFF:		case	F_EX_SLASH_AUTO:
	case	F_EX_SLASH_TOG:		case	F_EX_HYPHEN_ON:
	case	F_EX_HYPHEN_OFF:	case	F_EX_HYPHEN_AUTO:
	case	F_EX_HYPHEN_TOG:	case	F_EX_BRACKET_ON:
	case	F_EX_BRACKET_OFF:	case	F_EX_BRACKET_TOG:
	case	F_EX_TEN_ON:		case	F_EX_TEN_OFF:
	case	F_EX_TEN_TOG:		case	F_EX_MARU_ON:
	case	F_EX_MARU_OFF:		case	F_EX_MARU_TOG:
		ret = IModeHandler (client, lpKD);
		break;

	case	F_KOHOMAX:
	case	F_EX_WX_BS:
	case	F_EX_COMPLETE:
	case	F_EX_JUMP_CURSOR:
	case	F_EX_JUMP_KOHO:
#if !PCUNIX
	case	F_EX_CNV_BLIN:		case	F_EX_CNV_NLIN:
	case	F_EX_CNV_BLIN_ATK:	case	F_EX_CNV_NLIN_ATK:
#endif /* !PCUNIX */
	case	F_EX_DON_START:
#if PCUNIX
	case	F_EX_KINPUT2_BS:
	case	F_EX_CNV_BBLK:
	case	F_EX_CNV_NBLK:
	case	F_EX_SENDACCDATA:
#endif /* PCUNIX */
		ret = ExtHandler (client, lpKD);
		break;

	case	F_EX_RECONV:
		ret = RecHandler (client, lpKD);
		break;

	case	F_EX_HELP:
	case	F_EX_UTY:
	case	F_EX_VERSION:
	case	F_EX_ACC1:		case	F_EX_ACC2:
	case	F_EX_ACC3:		case	F_EX_ACC4:
	case	F_EX_ACC5:		case	F_EX_ACC6:
	case	F_EX_ACC7:		case	F_EX_ACC8:
	case	F_EX_ACC9:		case	F_EX_ACC10:
	case	F_EX_REGWORD:		case	F_EX_DELWORD:
	case	F_EX_ENV:
		ret = DlgHandler (client, lpKD);
		break;

#if PCUNIX
	case F_EX_BTN_MONO_SMALL:
	case F_EX_BTN_MONO_BIG:
	case F_EX_BTN_COLOR_SMALL:
	case F_EX_BTN_COLOR_BIG:
	case F_EX_ENV_LOAD:
	case F_EX_ENV_SAVE:
	case F_EX_BTN_OFF_NORMAL:
	case F_EX_BTN_OFF_MINIMIZE:
	case F_EX_BTN_OFF_HIDE:
		ret = MenuHandler (client, lpKD);
		break;

	case F_EX_KOHO_SORT_TOP:
	case F_EX_KOHO_SORT_END:
		ret = KohoHandler (client, lpKD);
		break;
#endif /* PCUNIX */

	case	F_CHR:
	case	F_CHR_BS:
		ret = CharHandler (client, lpKD);
		break;

	case	F_UNDO:
		ret = UndoHandler (client, lpKD);
		break;

	case	F_EX_REDISP:
		ret = EtcHandler (client, lpKD);
		break;

	case	F_EX_NOP:
		break;

	default:
		ret = EditHandler (client, lpKD);
		break;
	}
	return ret;
}

/*=============================================================================
	SaveHandler
=============================================================================*/
BOOL	SaveHandler
(
	FXim_Client	*client,
	LPKD		lpKD
)
{
static	WORD	wSaveVjeModeFlag  [8];
static	long	lSaveHenModFlag   [8];
static	long	lSaveHenModFlagV  [8];
static	long	lSaveHenModFlagLim[8];
static	int	sp	= 0;
	BOOL	ret	= FALSE;
	PBD	bdata;

	bdata	= (PBD )GetBDATA (client);

	if	( lpKD->wFunc == F_EX_SAVE_MODE && sp < 8 ) {
		wSaveVjeModeFlag  [sp]	= bdata->wVjeModeFlag;
		lSaveHenModFlag   [sp]	= bdata->wHenModFlag;
		lSaveHenModFlagV  [sp]	= bdata->wHenModFlagV;
		lSaveHenModFlagLim[sp]	= bdata->wHenModFlagLim;
		sp++;
	}
	else if	( lpKD->wFunc == F_EX_REST_MODE && sp > 0 ) {
		sp--;
		bdata->wVjeModeFlag	= wSaveVjeModeFlag  [sp];
		bdata->wHenModFlag	= lSaveHenModFlag   [sp];
		bdata->wHenModFlagV	= lSaveHenModFlagV  [sp];
		bdata->wHenModFlagLim	= lSaveHenModFlagLim[sp];
		bdata->wVkey		= F_MODE;
		VJEEditX (client, 1);
		ret			= TRUE;
	}
	return	ret;
}

/*=============================================================================
	CaseHandler
=============================================================================*/
BOOL	CaseHandler
(
	FXim_Client	*client,
	LPKD		lpKD
)
{
	BOOL	ret = FALSE;

	return	ret;
}

/*=============================================================================
	VModeHandler
=============================================================================*/
BOOL	VModeHandler
(
	FXim_Client	*client,
	LPKD		lpKD
)
{
	LPENV		lpEnv;
	LPVWIN		lpVWin;
	HBASEDT		bebuf;
	PBD		bdata;
	WORD		wVje;
	WORD		wKeyType;
	WORD		vk;
	long		lHen;
	long		lHenV;
	long		lHenLim;
	WORD		vkQ[8];
	int		vkQCount;
	int		i;

	lpEnv		= (LPENV   )GetEnv (0);
	lpVWin		= (LPVWIN   )GetVWin ();
	bdata		= (PBD     )GetBDATA (client);
	bebuf		= (HBASEDT )GetBEBUF (client);
	vk		= lpKD->wFunc;
	vkQCount	= 0;
	wVje		= bdata->wVjeModeFlag;
	wKeyType	= bdata->wKeyType;
	lHen		= bdata->wHenModFlag;
	lHenV		= bdata->wHenModFlagV;
	lHenLim		= bdata->wHenModFlagLim;
retry:
	switch	( vk ) {
	case	F_EX_KANJI_ON:
		if	(wVje & SCREEN_MODE) {
			vk	= 0;
		}
		else	{
			vk	= F_SCRN;
		}
		break;
	case	F_EX_KANJI_OFF:
#if PCUNIX /* 990402 */
	case    F_EX_KANJI_OFF2:
#endif /* PCUNIX */
		if	(wVje & SCREEN_MODE) {
			vk	= F_SCRN;
		}
		else	{
			vk	= 0;
		}
		break;
	case	F_SCRN:
		break;
	case	F_HIRA:
	case	F_KATA:
	case	F_EISUU:
	case	F_HIRA_KATA:
		break;
	case	F_EX_CHAR_TOG:
#if 0 /* Delete:KanaCtrl */
		if	( wKeyType == KEY_KANALOCK2 ) {
			if	( wVje & KATA_BIT ) {
				if	( wVje & EISUU_BIT ) {
					vk	= F_EISUU;
				}
				else	{
					vk	= F_HIRA_KATA;
				}
			}
			else	{
				if	(IsKanaLock ()) {
					vk	= F_HIRA_KATA;
				}
				else	{
					if	( wVje & EISUU_BIT ) {
						vk	= F_HIRA;
					}
					else if	( wVje & KANA_BIT  ) {
						vk	= F_EISUU;
					}
					else {
						vk	= F_KATA;
					}
				}
			}
		}
		else {
#endif /* Delete:KanaCtrl */
			if	( wVje & EISUU_BIT ) {
				vk	= F_HIRA;
			}
			else if	( wVje & KANA_BIT  ) {
				vk	= F_EISUU;
			}
			else {
				vk	= F_KATA;
			}
#if 0 /* Delete:KanaCtrl */
		}
#endif /* Delete:KanaCtrl */
		break;
	case	F_EX_INPUT_TOG:
#if 0 /* Delete:KanaCtrl */
		if	( wKeyType == KEY_KANALOCK2 ) {
			if	( wVje & EISUU_BIT ) {
				goto	L_EX_EISU_TOG;
			}
		}
		else	{
#endif /* Delete:KanaCtrl */
			if	( wVje & EISUU_BIT ) {
				if	(  (wVje & ZENKAKU_BIT) ) {
					goto	L_EX_EISU_TOG;
				}
			}
			else if ( wVje & KANA_BIT ) {
				if	( !(wVje & ZENKAKU_BIT) ) {
					goto	L_EX_EISU_TOG;
				}
			}
#if 0 /* Delete:KanaCtrl */
		}
#endif /* Delete:KanaCtrl */
		/* nobreak */
	case	F_EX_KANA_TOG:
		if	( wVje & EISUU_BIT ) {
			vk		= F_HIRA;
			vkQ[vkQCount++]	= F_EX_SIZE_ZEN;
		}
		else	{
			if	( wVje & ZENKAKU_BIT ) {
				vk		= F_ZEN;
			}
			else	{
				vk		= F_HIRA_KATA;
				vkQ[vkQCount++]	= F_ZEN;
			}
		}
		break;
	case	F_EX_EISU_TOG:
		L_EX_EISU_TOG:
		if	( wVje & EISUU_BIT ) {
			vk		= F_ZEN;
		}
		else	{
			vk		= F_EISUU;
			vkQ[vkQCount++]	= F_EX_SIZE_ZEN;
		}
		break;
	case	F_EX_SIZE_ZEN:
		if	( wVje & ZENKAKU_BIT ) {
			vk	= 0;
		}
		else	{
			vk	= F_ZEN;
		}
		break;
	case	F_EX_SIZE_HAN:
		if	( wVje & ZENKAKU_BIT ) {
			vk	= F_ZEN;
		}
		else	{
			vk	= 0;
		}
		break;
	case	F_ZEN:
	case	F_HAN:
		break;
	case	F_EX_ROM_ON:
		vk	= F_ROM;
		if	( !(wVje & KATA_BIT) ) {
			vk	= 0;
		}
		break;
	case	F_EX_ROM_OFF:
		vk	= F_ROM;
		if	(  (wVje & KATA_BIT) ) {
			vk	= 0;
		}
		break;
	case	F_ROM:
		break;
	case	F_EX_ROMSAVE:
		vk	= F_ROM;
		break;
	case	F_EX_DMODE_ON:
		vk	= F_DMODE;
		if	(  (wVje & DIRECT_MODE) ) {
			vk	= 0;
		}
		break;
	case	F_EX_DMODE_OFF:
		vk	= F_DMODE;
		if	( !(wVje & DIRECT_MODE) ) {
			vk	= 0;
		}
		break;
	case	F_DMODE:
		break;
	case	F_EX_CNVMODE_REN:
		lHen	&= ~(MOD_SAKI|MOD_REN|MOD_BETA);
		lHen	|=  (         MOD_REN         );
		vk	= F_MODE;
		break;
	case	F_EX_CNVMODE_BETA:
		lHen	&= ~(MOD_SAKI|MOD_REN|MOD_BETA);
		lHen	|=  (                 MOD_BETA);
		vk	=  F_MODE;
		break;
	case	F_EX_CNVMODE_SAKI:
		lHen	&= ~(MOD_SAKI|MOD_REN|MOD_BETA);
		lHen	|=  (MOD_SAKI                 );
		vk	= F_MODE;
		break;
	case	F_EX_CNVMODE_TOG:
		if	( lHen & MOD_SAKI ) {
			vk	= F_EX_CNVMODE_REN;
		}
		else if	( lHen & MOD_REN  ) {
			vk	= F_EX_CNVMODE_BETA;
		}
		else {
			vk	= F_EX_CNVMODE_SAKI;
		}
		break;
	case	F_EX_KUTOCNV_ON:
		lHen	&= ~(MOD_KUTEN_CNV_YES|MOD_KUTEN_CNV_NO);
		lHen	|=  (MOD_KUTEN_CNV_YES                 );
		vk	= F_MODE;
		break;
	case	F_EX_KUTOCNV_OFF:
		lHen	&= ~(MOD_KUTEN_CNV_YES|MOD_KUTEN_CNV_NO);
		lHen	|=  (                  MOD_KUTEN_CNV_NO);
		vk	= F_MODE;
		break;
	case	F_EX_KUTOCNV_TOG:
		if	( lHen & MOD_KUTEN_CNV_YES ) {
			vk	= F_EX_KUTOCNV_OFF;
		}
		else	{
			vk	= F_EX_KUTOCNV_ON;
		}
		break;
	case	F_EX_KOUGO_ON:
		lHenV	&= ~(MOD_KOUGO_ON|MOD_KOUGO_OFF);
		lHenV	|=  (MOD_KOUGO_ON              );
		vk	= F_MODE;
		break;
	case	F_EX_KOUGO_OFF:
		lHenV	&= ~(MOD_KOUGO_ON|MOD_KOUGO_OFF);
		lHenV	|=  (             MOD_KOUGO_OFF);
		vk	= F_MODE;
		break;
	case	F_EX_KOUGO_TOG:
		if	( lHenV & MOD_KOUGO_ON ) {
			vk	= F_EX_KOUGO_OFF;
		}
		else	{
			vk	= F_EX_KOUGO_ON;
		}
		break;
	case	F_EX_OKURI_HONSOKU:
		lHenV	&= ~(MOD_OKURI_BITS   );
		lHenV	|=  (MOD_OKURI_HONSOKU);
		vk	= F_MODE;
		break;
	case	F_EX_OKURI_OKURU:
		lHenV	&= ~(MOD_OKURI_BITS   );
		lHenV	|=  (MOD_OKURI_OKURU  );
		vk	= F_MODE;
		break;
	case	F_EX_OKURI_HABUKU:
		lHenV	&= ~(MOD_OKURI_BITS   );
		lHenV	|=  (MOD_OKURI_HABUKU );
		vk	= F_MODE;
		break;
	case	F_EX_OKURI_ZENBU:
		lHenV	&= ~(MOD_OKURI_BITS   );
		lHenV	|=  (MOD_OKURI_ZENBU  );
		vk	= F_MODE;
		break;
	case	F_EX_OKURI_TOG:
		if	( lHenV & MOD_OKURI_ZENBU   ) {
			vk	= F_EX_OKURI_HONSOKU;
		}
		else if	( lHenV & MOD_OKURI_HONSOKU ) {
			vk	= F_EX_OKURI_OKURU;
		}
		else if	( lHenV & MOD_OKURI_OKURU   ) {
			vk	= F_EX_OKURI_HABUKU;
		}
		else	{
			vk	= F_EX_OKURI_ZENBU;
		}
		break;
	case	F_EX_KANAREG_ON:
		lHenV	&= ~(MOD_KATAKANA_ON|MOD_KATAKANA_OFF);
		lHenV	|=  (MOD_KATAKANA_ON                 );
		vk	= F_MODE;
		break;
	case	F_EX_KANAREG_OFF:
		lHenV	&= ~(MOD_KATAKANA_ON|MOD_KATAKANA_OFF);
		lHenV	|=  (                MOD_KATAKANA_OFF);
		vk	= F_MODE;
		break;
	case	F_EX_KANAREG_TOG:
		if	( lHenV & MOD_KATAKANA_ON ) {
			vk	= F_EX_KANAREG_OFF;
		}
		else	{
			vk	= F_EX_KANAREG_ON;
		}
		break;
	case	F_EX_EISUREG_ON:
		lHenV	&= ~(MOD_EISU_ON|MOD_EISU_OFF);
		lHenV	|=  (MOD_EISU_ON             );
		vk	= F_MODE;
		break;
	case	F_EX_EISUREG_OFF:
		lHenV	&= ~(MOD_EISU_ON|MOD_EISU_OFF);
		lHenV	|=  (            MOD_EISU_OFF);
		vk	= F_MODE;
		break;
	case	F_EX_EISUREG_TOG:
		if	( lHenV & MOD_EISU_ON ) {
			vk	= F_EX_EISUREG_OFF;
		}
		else	{
			vk	= F_EX_EISUREG_ON;
		}
		break;
	case	F_EX_CODE_UNICODE:
#if	XKP_SUPPORT
		lHen		= (lHen & ~MOD_CODE_BITS)|MOD_UNICODE;
		vk		=  F_MODE;
#if	0
		bdata->wCodeMax= 0xffff;
#else
		bdata->wCodeMax= 0;
#endif
		break;
#endif
	case	F_EX_CODE_EUC:
		lHen		= (lHen & ~MOD_CODE_BITS)|MOD_EUC;
		vk		= F_MODE;
		bdata->wCodeMax= 0x7a7e;
		break;
	case	F_EX_CODE_JIS:
		lHen		= (lHen & ~MOD_CODE_BITS)|MOD_JIS;
		vk		= F_MODE;
		bdata->wCodeMax= 0x987e;
		break;
	case	F_EX_CODE_SJIS:
		lHen		= (lHen & ~MOD_CODE_BITS)|MOD_SJIS;
		vk		= F_MODE;
		bdata->wCodeMax= 0x987e;
		break;
	case	F_EX_CODE_KUTEN:
		lHen		= (lHen & ~MOD_CODE_BITS)|MOD_KUTEN;
		vk		= F_MODE;
		bdata->wCodeMax= 0x987e;
		break;
	case	F_EX_CODE_TOG:
		if	( lHen & MOD_SJIS    ) {
			vk	= F_EX_CODE_KUTEN;
		}
		else if	( lHen & MOD_KUTEN   ) {
#if 0
			vk	= F_EX_CODE_UNICODE;
		}
		else if	( lHen & MOD_UNICODE ) {
#endif
			vk	= F_EX_CODE_EUC;
		}
		else if	( lHen & MOD_EUC ) {
			vk	= F_EX_CODE_JIS;
		}
		else	{
			vk	= F_EX_CODE_SJIS;
		}
		break;
	case	F_EX_BUNPOU_BUN:
		lHenV	&= ~(MOD_BUNSETU|MOD_FUKUGOU);
		lHenV	|=  (MOD_BUNSETU            );
		vk	= F_MODE;
		break;
	case	F_EX_BUNPOU_FUKU:
		lHenV	&= ~(MOD_BUNSETU|MOD_FUKUGOU);
		lHenV	|=  (            MOD_FUKUGOU);
		vk	= F_MODE;
		break;
	case	F_EX_BUNPOU_TOG:
		if	( lHenV & MOD_BUNSETU ) {
			vk	= F_EX_BUNPOU_FUKU;
		}
		else	{
			vk	= F_EX_BUNPOU_BUN;
		}
		break;
	case	F_EX_YURAGI_ON:
		lHenV	&= ~(MOD_YURAGI_ON|MOD_YURAGI_OFF);
		lHenV	|=  (MOD_YURAGI_ON               );
		vk	= F_MODE;
		break;
	case	F_EX_YURAGI_OFF:
		lHenV	&= ~(MOD_YURAGI_ON|MOD_YURAGI_OFF);
		lHenV	|=  (              MOD_YURAGI_OFF);
		vk	= F_MODE;
		break;
	case	F_EX_YURAGI_TOG:
		if	( lHenV & MOD_YURAGI_ON ) {
			vk	= F_EX_YURAGI_OFF;
		}
		else	{
			vk	= F_EX_YURAGI_ON;
		}
		break;
	case	F_EX_HOSEI_ON:
		lHenV	&= ~(MOD_HOSEI_ON|MOD_HOSEI_OFF);
		lHenV	|=  (MOD_HOSEI_ON              );
		vk	= F_MODE;
		break;
	case	F_EX_HOSEI_OFF:
		lHenV	&= ~(MOD_HOSEI_ON|MOD_HOSEI_OFF);
		lHenV	|=  (             MOD_HOSEI_OFF);
		vk	= F_MODE;
		break;
	case	F_EX_HOSEI_TOG:
		if	( lHenV & MOD_HOSEI_ON ) {
			vk	= F_EX_HOSEI_OFF;
		}
		else	{
			vk	= F_EX_HOSEI_ON;
		}
		break;
	case	F_EX_CALC_ON:
		lHen	&= ~(MOD_CALC_ON|MOD_CALC_OFF);
		lHen	|=  (MOD_CALC_ON             );
		vk	= F_MODE;
		break;
	case	F_EX_CALC_OFF:
		lHen	&= ~(MOD_CALC_ON|MOD_CALC_OFF);
		lHen	|=  (            MOD_CALC_OFF);
		vk	= F_MODE;
		break;
	case	F_EX_CALC_TOG:
		if	( lHen & MOD_CALC_ON ) {
			vk	= F_EX_CALC_OFF;
		}
		else	{
			vk	= F_EX_CALC_ON;
		}
		break;
	case	F_EX_SMODE_FUKU:
		lHenV	&= ~(MOD_BUNSETU|MOD_FUKUGOU  );
		lHenV	|=  (            MOD_FUKUGOU  );
		lHen	&= ~(MOD_SAKI|MOD_REN|MOD_BETA);
		lHen	|=  (MOD_SAKI                 );
		vk	= F_MODE;
		break;
	case	F_EX_SMODE_BETA:
		lHenV	&= ~(MOD_BUNSETU|MOD_FUKUGOU  );
		lHenV	|=  (MOD_BUNSETU              );
		lHen	&= ~(MOD_SAKI|MOD_REN|MOD_BETA);
		lHen	|=  (                 MOD_BETA);
		vk	= F_MODE;
		break;
	case	F_EX_SMODE_REN:
		lHenV	&= ~(MOD_BUNSETU|MOD_FUKUGOU  );
		lHenV	|=  (MOD_BUNSETU              );
		lHen	&= ~(MOD_SAKI|MOD_REN|MOD_BETA);
		lHen	|=  (MOD_SAKI                 );
		vk	= F_MODE;
		break;
	case	F_EX_LIM_MODE:
		lHenLim	= lpKD->lFuncOption;
		vk	= F_MODE;
		break;
	case	F_EX_KUTENMODE_ON:
		lHen	&= ~(MOD_KUTEN_YES|MOD_KUTEN_NO);
		lHen	|=  (MOD_KUTEN_YES             );
		vk	= F_MODE;
		break;
	case	F_EX_KUTENMODE_OFF:
		lHen	&= ~(MOD_KUTEN_YES|MOD_KUTEN_NO);
		lHen	|=  (              MOD_KUTEN_NO);
		vk	= F_MODE;
		break;
	case	F_EX_KUTENMODE_TOG:
		if	( lHen & MOD_KUTEN_YES ) {
			vk	= F_EX_KUTENMODE_OFF;
		}
		else	{
			vk	= F_EX_KUTENMODE_ON;
		}
		break;
	case	F_EX_JISONLY_ON:
		lHenLim	&= ~(MOD_LIM_JIS_YES|MOD_LIM_JIS_NO);
		lHenLim	|=  (MOD_LIM_JIS_YES		   );
		vk	= F_MODE;
		break;
	case	F_EX_JISONLY_OFF:
		lHenLim	&= ~(MOD_LIM_JIS_YES|MOD_LIM_JIS_NO);
		lHenLim	|=  (                MOD_LIM_JIS_NO);
		vk	= F_MODE;
		break;
	case	F_EX_JISONLY_TOG:
		if	( lHenLim & MOD_LIM_JIS_YES ) {
			vk	= F_EX_JISONLY_OFF;
		}
		else	{
			vk	= F_EX_JISONLY_ON;
		}
		break;
#if 0 /* Delete:KanaCtrl */
	case	F_EX_KANACTRL_ON:
		bdata->wKeyType		= KEY_KANALOCK;
		vk			= (IsKanaLock ())
					? (F_KLK_ON	)
					: (F_KLK_OFF	);
		break;
	case	F_EX_KANACTRL_OFF:
		bdata->wKeyType		= KEY_KANALOCK2;
		vk			= (IsKanaLock ())
					? (F_KLK_ON	)
					: (F_KLK_OFF	);
		break;
	case	F_EX_KANACTRL_TOG:
		if	( bdata->wKeyType == KEY_KANALOCK  ) {
			vk	= F_EX_KANACTRL_OFF;
		}
		else if	( bdata->wKeyType == KEY_KANALOCK2 ) {
			vk	= F_EX_KANACTRL_ON;
		}
		else	{
			vk	= 0;
		}
		break;
#endif /* Delete:KanaCtrl */
	default:
		vk	= 0;
		break;
	}
	if	( vk >= F_EXTEND ) {
		goto retry;
	}
	else if ( vk == F_MODE ) {
		bdata->wVjeModeFlag	= wVje;
		bdata->wHenModFlag	= lHen;
		bdata->wHenModFlagV	= lHenV;
		bdata->wHenModFlagLim	= lHenLim;
		bdata->wVkey		= vk;
		VJEEditX (client, 1);
	}
	else if	( vk ) {
		bdata->wVkey	= vk;
		VJEEditX (client, 1);
	}
	if	( vkQCount ) {
		vk	= vkQ[0];
		for	( i = 1 ; i < vkQCount ; i++ ) {
			vkQ[i-1]	= vkQ[i];
		}
		vkQCount--;
		goto	retry;
	}

#if PCUNIX
	if	( lpKD->wFunc == F_EX_JISONLY_ON
	||	  lpKD->wFunc == F_EX_JISONLY_OFF
	||	  lpKD->wFunc == F_EX_JISONLY_TOG ) {
			SizeFixToCore (client, lpVWin, lpEnv);
	}
#endif
	if	( lpKD->wFunc == F_EX_ROMSAVE ) {
		CoreToEnv (client, lpVWin, lpEnv);
		SaveRomaEnv (lpEnv);
	}
	return	vk ? TRUE : FALSE;
}

/*=============================================================================
	IModeHandler
=============================================================================*/
BOOL	IModeHandler
(
	FXim_Client	*client,
	LPKD		lpKD
)
{
	LPVWIN		lpVWin;
	LPVKBD		lpVKbd;

	lpVWin		= (LPVWIN )GetVWin ();
	lpVKbd		= (LPVKBD )GetVKbd (lpVWin);

	switch	( lpKD->wFunc ) {
#if !PCUNIX
	case	F_EX_SPOT_ON:
	case	F_EX_SPOT_OFF:
	case	F_EX_SPOT_TOG:
		if	( lpKD->wFunc == F_EX_SPOT_ON	) {
			lpEnv->cmp.wSpot	= YES;
		}
		else if	( lpKD->wFunc == F_EX_SPOT_OFF	) {
			lpEnv->cmp.wSpot	= NO;
		}
		else if	( lpEnv->cmp.wSpot == NO	) {
			lpEnv->cmp.wSpot	= YES;
		}
		else	{
			lpEnv->cmp.wSpot	= NO;
		}
		break;
#endif /* !PCUNIX */
	case	F_EX_COMMA_ON:
		lpVKbd->wComma		= YES;
		break;
	case	F_EX_COMMA_OFF:
		lpVKbd->wComma		= NO;
		break;
	case	F_EX_COMMA_AUTO:
		lpVKbd->wComma		= AUTO;
		break;
	case	F_EX_COMMA_TOG:
		lpVKbd->wComma		= (lpVKbd->wComma+1) % 3;
		break;
	case	F_EX_PERIOD_ON:
		lpVKbd->wPeriod		= YES;
		break;
	case	F_EX_PERIOD_OFF:
		lpVKbd->wPeriod		= NO;
		break;
	case	F_EX_PERIOD_AUTO:
		lpVKbd->wPeriod		= AUTO;
		break;
	case	F_EX_PERIOD_TOG:
		lpVKbd->wPeriod		= (lpVKbd->wPeriod+1) % 3;
		break;
	case	F_EX_SLASH_ON:
		lpVKbd->wSlash		= YES;
		break;
	case	F_EX_SLASH_OFF:
		lpVKbd->wSlash		= NO;
		break;
	case	F_EX_SLASH_AUTO:
		lpVKbd->wSlash		= AUTO;
		break;
	case	F_EX_SLASH_TOG:
		lpVKbd->wSlash		= (lpVKbd->wSlash+1) % 3;
		break;
	case	F_EX_HYPHEN_ON:
		lpVKbd->wHyphen		= YES;
		break;
	case	F_EX_HYPHEN_OFF:
		lpVKbd->wHyphen		= NO;
		break;
	case	F_EX_HYPHEN_AUTO:
		lpVKbd->wHyphen		= AUTO;
		break;
	case	F_EX_HYPHEN_TOG:
		lpVKbd->wHyphen		= (lpVKbd->wHyphen+1) % 3;
		break;
	case	F_EX_BRACKET_ON:
		lpVKbd->wBracket	= YES;
		break;
	case	F_EX_BRACKET_OFF:
		lpVKbd->wBracket	= NO;
		break;
	case	F_EX_BRACKET_TOG:
		lpVKbd->wBracket	= (lpVKbd->wBracket+1) % 2;
		break;
	case	F_EX_TEN_ON:
		lpVKbd->wTen		= YES;
		break;
	case	F_EX_TEN_OFF:
		lpVKbd->wTen		= NO;
		break;
	case	F_EX_TEN_TOG:
		lpVKbd->wTen		= (lpVKbd->wTen+1) % 2;
		break;
	case	F_EX_MARU_ON:
		lpVKbd->wMaru		= YES;
		break;
	case	F_EX_MARU_OFF:
		lpVKbd->wMaru		= NO;
		break;
	case	F_EX_MARU_TOG:
		lpVKbd->wMaru		= (lpVKbd->wMaru+1) % 2;
		break;
	}

	return	TRUE;
}

/*=============================================================================
	ExtHandler
=============================================================================*/
BOOL	ExtHandler
(
	FXim_Client	*client,
	LPKD		lpKD
)
{
	BOOL		ret	= FALSE;
	PBD		bdata;
	TCHAR		sztWork[MAX_COMP_SIZE + 1];
	int		lenWork;
	int		iCur,iMax,iNew,iOfs,iRep,iEoc;
	WORD		vk;
	COLROW		cr;
	int		i;

	bdata	= (PBD )GetBDATA (client);

	switch	( lpKD->wFunc ) {
	case	F_KOHOMAX:
		cr.col	= LOWORD(lpKD->lFuncOption);
		cr.row	= HIWORD(lpKD->lFuncOption);
		if	( cr.col > 0 && cr.row > 0 ) {
			bdata->cLBItemNumMax	= cr.col
						* cr.row;
			bdata->wVkey		= lpKD->wFunc;
			VJEEditX (client, 1);
			ret	= TRUE;
		}
		break;
#if PCUNIX
	case	F_EX_KINPUT2_BS:
		if	( bdata->wMainStage & (PRC_CODE) ) {
			bdata->wVkey	= F_CANCEL;
			VJEEditX (client, 1);
		} else if	( bdata->wMainStage & (PRC_DON) ) {
			bdata->wVkey	= F_RIGHT;
			VJEEditX (client, 1);
			bdata->wVkey	= F_LEFT;
			VJEEditX (client, 1);
		} else if	( bdata->wMainStage & (PRC_CNV|PRC_RCNV) ) {
			bdata->wVkey	= F_ATOK_BS;
			VJEEditX (client, 1);
		} else {
			bdata->wVkey	= F_BS;
			VJEEditX (client, 1);
		}
		ret	= TRUE;
		break;
#endif /* PCUNIX */
	case	F_EX_WX_BS:
		if	( bdata->wMainStage & (PRC_CNV|PRC_DON) ) {
			bdata->wVkey	= F_RIGHT;
			VJEEditX (client, 1);
			bdata->wVkey	= F_BS;
			VJEEditX (client, 1);
			bdata->wVkey	= F_LEFT;
			VJEEditX (client, 1);
		}
		else {
			bdata->wVkey	= F_BS;
			VJEEditX (client, 1);
		}
		ret	= TRUE;
		break;
	case	F_EX_COMPLETE:
		bdata->wVkey	= F_NO_CNV2;
		VJEEditX (client, 1);
		if	( !(bdata->wMainStage & PRC_EMP) ) {
			lenWork		= bdata->cchResult;
			lstrncpy(sztWork,bdata->lpchResult,lenWork);
			bdata->wVkey	= F_CANALL;
			VJEEditX (client, 1);
			lstrncpy(bdata->lpchResult,sztWork,lenWork);
			bdata->cchResult= lenWork;
		}
		ret	= TRUE;
		break;
	case	F_EX_JUMP_CURSOR:
		iNew	= (int) lpKD->lFuncOption;
		i	= MAX_COMP_SIZE;
		iCur	= bdata->cchCurPosition;
		iEoc	= GetEndofCursor(bdata);
		if	( iEoc < iNew ) {
			bdata->wVkey = F_RIGHT;
			while	( iEoc < iNew && i-- ) {
				VJEEditX (client, 1);
				iEoc	= GetEndofCursor(bdata);
				ret	= TRUE;
			}
		}
		else if	( iCur > iNew ) {
			bdata->wVkey	= F_LEFT;
			while	( iCur > iNew && i-- ) {
				VJEEditX (client, 1);
				iCur	= bdata->cchCurPosition;
				ret	= TRUE;
			}
		}
		break;
	case	F_EX_JUMP_KOHO:
		break;
#if !PCUNIX
	case	F_EX_CNV_BLIN:
		bdata->wVkey	= F_CNV_BCNV;
		i		= lpKD->lFuncOption;
		goto	lin_common;
	case	F_EX_CNV_NLIN:
		bdata->wVkey	= F_CNV_NCNV;
		i		= lpKD->lFuncOption;
		goto	lin_common;
	case	F_EX_CNV_BLIN_ATK:
		bdata->wVkey	= F_CNV_BCNV_ATK;
		i		= lpKD->lFuncOption;
		goto	lin_common;
	case	F_EX_CNV_NLIN_ATK:
		bdata->wVkey	= F_CNV_NCNV_ATK;
		i		= lpKD->lFuncOption;
		goto	lin_common;
#endif /* !PCUNIX */
#if PCUNIX
	case	F_EX_CNV_BBLK:
		bdata->wVkey	= F_CNV_BBLK;
		i		= lpKD->lFuncOption;
		goto	lin_common;
	case	F_EX_CNV_NBLK:
		bdata->wVkey	= F_CNV_NBLK;
		i		= lpKD->lFuncOption;
		goto	lin_common;
#endif /* PCUNIX */
	lin_common:
#if 1
		VJEEditX (client, i);
#else
		while	( i-- ) {
			VJEEditX (client, 1);
		}
#endif
		ret	= TRUE;
		break;
	case	F_EX_DON_START:
		bdata->wDispListBox	= (WORD) lpKD->lFuncOption;
		break;
#if PCUNIX
	case	F_EX_SENDACCDATA:
		SendAccData (client);
		ret	= TRUE;
		break;
#endif /* PCUNIX */
	}
	return	ret;
}

/*=============================================================================
	RecHandler
=============================================================================*/
BOOL	RecHandler
(
	FXim_Client	*client,
	LPKD		lpKD
)
{
	BOOL		ret	= FALSE;
	PBD		bdata;
	LPTSTR		lptStr;
	TCHAR		c;
	WORD		w;

	bdata	= (PBD )GetBDATA (client);
	lptStr	= lpKD->ucFuncString;

	if	( lptStr && (bdata->wMainStage & PRC_EMP) ) {
		bdata->wVkey	= F_EX_SAVE_MODE;
		FuncHandler (client,lpKD);
		bdata->wVkey	= F_EX_KUTOCNV_OFF;
		FuncHandler (client,lpKD);
		bdata->wVkey	= F_EX_CNVMODE_REN;
		FuncHandler (client,lpKD);
		ret	= TRUE;
		while	( *lptStr ) {
			c	= *lptStr++;
			w	= (WORD) c;
#ifndef	UNICODE
			if	( IsDBCS(c) || c == AUTO_KIGO_1ST ) {
				w	= (WORD) (c << 8          )
					| (WORD) (*lptStr++       );
			}
#endif
			if	( !w ) {
				bdata->wVkey	= F_FKEY;
			}
			else if	( w < 0x20 ) {
				bdata->wVkey	= F_CTRL;
			}
			else	{
				bdata->wVkey	= F_CHR;
			}
			bdata->wCharCode	= w;
			VJEEditX (client, 1);
			if	( bdata->cchResult ) {	/* ʤ */
				ret	= FALSE;
				break;
			}
		}
		if	( !ret ) {
			bdata->wVkey		= F_CANALL;
			VJEEditX (client, 1);
			bdata->cchResult	= 0;
			bdata->lpchResult[0]	= (TCHAR) 0;
		}
		bdata->wVkey	= F_EX_REST_MODE;
		FuncHandler (client,lpKD);
	}

	return	ret;
}

/*=============================================================================
	DlgHandler
=============================================================================*/
BOOL	DlgHandler
(
	FXim_Client	*client,
	LPKD		lpKD
)
{
	BOOL	ret = FALSE;
	TCHAR	sztFile[MAX_PATH + MAX_LONG_STR * 2 + 1];
	LPENV	lpEnv;
	SHORT	i;

	lpEnv		= (LPENV )GetEnv (0);
	sztFile[0]	= (TCHAR )0;

	switch	(lpKD->wFunc) {
	case	F_EX_ACC1:		case	F_EX_ACC2:
	case	F_EX_ACC3:		case	F_EX_ACC4:
	case	F_EX_ACC5:		case	F_EX_ACC6:
	case	F_EX_ACC7:		case	F_EX_ACC8:
	case	F_EX_ACC9:		case	F_EX_ACC10:
#if 1/*Accessary*/
		if (AccMode != 0)
			break;
		AppWindowName(current_client);
#endif
		i = lpKD->wFunc - F_EX_ACC1;
		if (0 <= i && i < lpEnv->aci.wAccCount) {
			lstrcpy (sztFile, lpEnv->acc[i].sztAccFile);
			lstrcat (sztFile, " \"");
			lstrcat (sztFile, AccApl);
			lstrcat (sztFile, "\"");
		}
		break;
	case	F_EX_HELP:
	case	F_EX_UTY:
	case	F_EX_VERSION:
	case	F_EX_REGWORD:		case	F_EX_DELWORD:
	case	F_EX_ENV:
		i = VCmdFuncToIndex (lpKD->wFunc);
		if (0 <= i) {
			lstrcpy (sztFile, (LPTSTR )GetVCmdFile (i));
		}
		break;
	}

	if (sztFile[0]) {
		Exec (sztFile);
		ret	= TRUE;
	}

	return	ret;
}

#if PCUNIX
/*=============================================================================
	MenuHandler
=============================================================================*/
BOOL	MenuHandler
(
	FXim_Client	*client,
	LPKD		lpKD
)
{
	BOOL		ret = FALSE;
	LPVWIN		lpVWin;

	lpVWin	= (LPVWIN   )GetVWin ();

	switch	(lpKD->wFunc) {
	case F_EX_BTN_OFF_NORMAL:
		ChangeStatusWindowVisible (
			client, STS_BTN_OFF_NML
		);
		ret = TRUE;
		break;

	case F_EX_BTN_OFF_MINIMIZE:
		ChangeStatusWindowVisible (
			client, STS_BTN_OFF_MIN
		);
		ret = TRUE;
		break;

	case F_EX_BTN_OFF_HIDE:
		ChangeStatusWindowVisible (
			client, STS_BTN_OFF_HID
		);
		ret = TRUE;
		break;

	case F_EX_BTN_MONO_SMALL:
		ChangeStatusWindowButton (
			client, STS_BTN_SIZE_SMALL, IDP_BTN12B
		);
		ret = TRUE;
		break;

	case F_EX_BTN_MONO_BIG:
		ChangeStatusWindowButton (
			client, STS_BTN_SIZE_BIG,   IDP_BTN20B
		);
		ret = TRUE;
		break;

	case F_EX_BTN_COLOR_SMALL:
		ChangeStatusWindowButton (
			client, STS_BTN_SIZE_SMALL, IDP_BTN12C
		);
		ret = TRUE;
		break;

	case F_EX_BTN_COLOR_BIG:
		ChangeStatusWindowButton (
			client, STS_BTN_SIZE_BIG,   IDP_BTN20C
		);
		ret = TRUE;
		break;

	case F_EX_ENV_LOAD:
		lpVWin->Param	= lpKD->lFuncOption;
		ret = LoadVjeEnv (client, lpVWin);
		break;

	case F_EX_ENV_SAVE:
		lpVWin->Param	= lpKD->lFuncOption;
		ret = SaveVjeEnv (client, lpVWin);
		break;
	}

	return	ret;
}

/*=============================================================================
	KohoHandler
=============================================================================*/
BOOL	KohoHandler
(
	FXim_Client	*client,
	LPKD		lpKD
)
{
	BOOL		ret = FALSE;
	PBD		bdata;

	bdata	= (PBD )GetBDATA (client);

	switch	(lpKD->wFunc) {
	case F_EX_KOHO_SORT_TOP:
		if (bdata->koho_mode != KOHO_SORT_TOP) {
			bdata->wVkey	= F_KOHO_SORT_TOP;
		} else {
			bdata->wVkey	= F_KOHO_NORMAL;
		}
		VJEEditX (client, 1);
		ret = TRUE;
		break;

	case F_EX_KOHO_SORT_END:
		if (bdata->koho_mode != KOHO_SORT_END) {
			bdata->wVkey	= F_KOHO_SORT_END;
		} else {
			bdata->wVkey	= F_KOHO_NORMAL;
		}
		VJEEditX (client, 1);
		ret = TRUE;
		break;
	}
	return	ret;
}
#endif /* PCUNIX */

/*=============================================================================
	CharHandler
=============================================================================*/
BOOL	CharHandler
(
	FXim_Client	*client,
	LPKD		lpKD
)
{
	PBD		bdata;
	TCHAR		sztWork[MAX_COMP_SIZE + 1];
	WORD		lenWork;
	LPTSTR		lptStr;
	TCHAR		c;
	WORD		w;
	int		i;

	bdata	= (PBD )GetBDATA (client);

	if	( lpKD->wOrgChar ) {
		if	( bdata->wVjeModeFlag & SCREEN_MODE ) {
			bdata->wVkey	= lpKD->wFunc;
			bdata->wCharCode= lpKD->wOrgChar;
			VJEEditX (client, 1);
		}
		else {
			lenWork = sizeof(bdata->wVkey);
			bzero (bdata->lpchResult,lenWork + 1);
			lmemcpy (
				bdata->lpchResult,
				(TCHAR *)&bdata->wVkey,
				lenWork
			);
			bdata->cchResult = lenWork;
			bdata->lpchResultYomi->len/*[0]*/	= 0;
			bdata->lpchResultBuninf->max_bun= 0;
		}
	}
	else	{
		lptStr	= lpKD->ucFuncString;
		if	( lptStr && (bdata->wVjeModeFlag & SCREEN_MODE) ) {
			lenWork	= 0;
			for (i = 0 ; (c = *(lptStr + i)) ; i++ ) {
				w	= (WORD) c;
#ifndef	UNICODE
				if ( IsDBCS(c) || c == AUTO_KIGO_1ST ) {
					w	= (WORD) (c << 8	   )
					 	| (WORD) (*(lptStr + (++i)));
				}
#endif
				bdata->wCharCode	= w;
				VJEEditX (client, 1);
				lmemcpy (
					&sztWork[lenWork],
					bdata->lpchResult,
					bdata->cchResult
				);
				lenWork	+= bdata->cchResult;
			}
			lmemcpy(bdata->lpchResult,sztWork,lenWork);
			bdata->cchResult	= lenWork;
		}
		else {
			lstrcpy (bdata->lpchResult,lptStr);
			bdata->cchResult = lstrlen(bdata->lpchResult);
			bdata->lpchResultYomi->len/*[0]*/	= 0;
			bdata->lpchResultBuninf->max_bun= 0;
		}
	}

	return	TRUE;
}

/*=============================================================================
	EditHandler
=============================================================================*/
BOOL	EditHandler
(
	FXim_Client	*client,
	LPKD		lpKD
)
{
	BOOL	ret	= FALSE;
	PBD	bdata;

	bdata	= (PBD )GetBDATA (client);

	if	( 0 < lpKD->wFunc && lpKD->wFunc < F_EXTEND ) {
		bdata->wVkey	= lpKD->wFunc;
		bdata->wCharCode= lpKD->wOrgChar;
		VJEEditX (client, 1);
		ret	= TRUE;
	}
	return	ret;
}

/*=============================================================================
	UndoHandler
=============================================================================*/
BOOL	UndoHandler
(
	FXim_Client	*client,
	LPKD		lpKD
)
{
	BOOL	ret = FALSE;
	return	ret;
}

/*=============================================================================
	EtcHandler
=============================================================================*/
BOOL	EtcHandler
(
	FXim_Client	*client,
	LPKD		lpKD
)
{
	BOOL	ret = FALSE;
	return	ret;
}

#if PCUNIX
/*=============================================================================
	CandidateHandler
=============================================================================*/
BOOL	CandidateHandler
(
	FXim_Client	*client,
	LPKD		lpKD
)
{
	BOOL		ret	= FALSE;
	PBD		bdata;
	LPVKP		lpVKp;
	USHORT		uFunc, uCode, lFuncOption;
	int		c_x, c_y, n_x, n_y;
	int		cur, min, max, max1, max2;
	int		col, row, len;
	int		i, num;

	bdata		= (PBD      )GetBDATA (client);
	lpVKp		= (LPVKP    )GetVKp (client);
	uFunc		= lpKD->wFunc;
	uCode		= lpKD->wOrgChar;
	lFuncOption	= lpKD->lFuncOption;

	GetVKpCanRMtx (client, &col, &row, &len);

	switch	(uFunc) {
	case	F_CHR:
		if (lFuncOption > 0) {
			if (!(XK_a <= uCode && uCode <= XK_z
			 ||   XK_A <= uCode && uCode <= XK_Z)) {
				break;
			}
			n_y	= lFuncOption;
			if (XK_a <= uCode && uCode <= XK_z) {
				n_x	= uCode - XK_a + 1;
			} else {
				n_x	= uCode - XK_A + 1;
			}
			n_x	= min (
					n_x,
					GetVKpCanRCol (client, n_y)
				);
			if (lpVKp->Dir == YOKO) {
				i	= (n_y - 1) * col
					+ n_x;
			} else {
				i	= (n_x - 1) * row
					+ n_y;
			}
			bdata->wVkey		= F_LB_SEL2;
			bdata->wCharCode	= i
						+ bdata->cLBItemPageFirst
						- 1;
			VJEEditX (client, 1);
			ret	= TRUE;
		}
		break;

	case	F_EX_CNV_NLIN:
	case	F_EX_CNV_NLIN_ATK:
		if (lpVKp->Dir == YOKO) {
			i		= col;
		} else {
			i		= 1;
		}
		goto	lin_common;

	case	F_EX_CNV_NCOL:
	case	F_EX_CNV_NCOL_ATK:
		if (lpVKp->Dir == YOKO) {
			i		= 1;
		} else {
			i		= row;
		}
		goto	lin_common;

	case	F_EX_CNV_BLIN:
	case	F_EX_CNV_BLIN_ATK:
		if (lpVKp->Dir == YOKO) {
			i		= -col;
		} else {
			i		= -1;
		}
		goto	lin_common;

	case	F_EX_CNV_BCOL:
	case	F_EX_CNV_BCOL_ATK:
		if (lpVKp->Dir == YOKO) {
			i		= -1;
		} else {
			i		= -row;
		}
		goto	lin_common;

	lin_common:
		if (bdata->wMainStage & PRC_CODE) {
			if (i > 0) {
				bdata->wVkey		= F_CNV_NCNV;
			} else {
				bdata->wVkey		= F_CNV_BCNV;
				i			*= -1;
			}
			VJEEditX (client, i);
		} else {
			max1	= bdata->cLBItemTotal;
			max2	= bdata->cLBItemPageFirst
				+ bdata->cLBItemNumMax
				- 1;
			min	= bdata->cLBItemPageFirst;
			max	= min (max1, max2);
			cur	= bdata->cLBItemPageFirst
				+ bdata->cLBItemNum
				- 1
				+ i;
			switch	(uFunc) {
			case	F_EX_CNV_NLIN_ATK:
			case	F_EX_CNV_NCOL_ATK:
			case	F_EX_CNV_BLIN_ATK:
			case	F_EX_CNV_BCOL_ATK:
				if (cur < 1) {
					cur	= max1;
				} else if (cur > max1) {
					cur	= 1;
				}
				break;
			}
			if (cur < 1) {
				bdata->wVkey		= F_CNV_BBLK;
				VJEEditX (client, 1);
			} else if (cur < min) {
				bdata->wVkey		= F_CNV_BBLK;
				VJEEditX (client, 1);
				bdata->wVkey		= F_LB_SEL2;
				bdata->wCharCode	= cur;
				VJEEditX (client, 1);
			} else if (cur <= max) {
				bdata->wVkey		= F_LB_SEL2;
				bdata->wCharCode	= cur;
				VJEEditX (client, 1);
			} else if (max < max1) {
				bdata->wVkey		= F_CNV_NBLK;
				VJEEditX (client, 1);
				bdata->wVkey		= F_LB_SEL2;
				bdata->wCharCode	= cur;
				VJEEditX (client, 1);
			} else {
				bdata->wVkey		= F_CNV_NBLK;
				VJEEditX (client, 1);
			}
		}
		ret	= TRUE;
		break;

	}
	return (ret);
}
#endif /* PCUNIX */

/*=============================================================================
	GetEndofCursor
=============================================================================*/
int	GetEndofCursor
(
	PBD	bdata
)
{
	int	i;
	BYTE	a;

	i	= bdata->cchCurPosition;
	a	= bdata->lpattrDisplay[i];
	while	(i < bdata->cchDisplay && bdata->lpattrDisplay[i] == a) i++;
	return	i;
}

/*=============================================================================
	VJEEditX
=============================================================================*/
void	VJEEditX
(
	FXim_Client	*client,
	USHORT		count
)
{
	PBD		bdata;
	HBASEDT		bebuf;
	USHORT		i;

	bdata	= (PBD     )GetBDATA (client);
	bebuf	= (HBASEDT )GetBEBUF (client);

/*990219*/
	client->oldMainStage	= bdata->wMainStage;
/*990219*/
	for (i=0; i < count; i++) {
		BasicEdit (bebuf, bdata);
	}

	bdata->lpchDisplay[bdata->cchDisplay]	= 0;
	bdata->lpattrDisplay[bdata->cchDisplay]	= 0;
	i	= ShiftjisToUshortEuc (
			client->output_buff,
			bdata->lpchDisplay
		);
	client->reverse_colums	= 0;
	client->last_colums	= i;
	if (bdata->wDataUpdate & VJE_DISPLAYDATA) {
		client->input_flag	= FINF_MODY;
	}
	PreeditDisplayAttribute (client);

	return;
}

