/*
**	VJE-GAMMA
**			fuzoku.h
*/

#if MAC				/* ٤ɤ߹褦 */
#pragma once
#endif
#define MAX_JODOUSHI	48
#define MAX_JOSHI	96

#define	L_HIB		sizeof(HNS_BLK)	/* Length of a hib */	
#define	N_HIB		12		/* Number of Hinshi Infomation Block */

#define	BUN_MAE_O	0x01
#define	BUN_INC_O	0x02
#define	BUN_1ST_KCB	0x80
struct	input_inf {
	USHORT	ptr;
	UCHAR	hinshi;
	UCHAR	hinshi2;
	UCHAR	flag;
};
typedef	struct input_inf	INPUT_INF;

struct	hinshi_block {
	USHORT	ptr;
	UCHAR	kubun;
	UCHAR	hinshi;
	UCHAR	kubun2;
	UCHAR	hinshi2;
	UCHAR	daihyou_kaku;
	UCHAR	kata_no;
	USHORT	kata;
};
typedef	struct hinshi_block	HNS_BLK;
/* ̳Ǽ */
/* hg 12 */
struct hinshi_group {
	USHORT	cnt;
	USHORT	hmax;
	HNS_BLK	hib[N_HIB];
};
typedef	struct hinshi_group	HNS_GRP;

/* hg2 6 fuzokugo kakunou you */
struct hinshi_group2 {
	USHORT	cnt;
	USHORT	hmax;
	HNS_BLK	hib[N_HIB];
};
typedef	struct hinshi_group2	HNS_GRP2;
/* hgf 4 gobi kakunou or saishono inf. kakunou */
struct hinshi_groupf {
	USHORT	cnt;
	USHORT	hmax;
	HNS_BLK	hib[N_HIB];
};
typedef	struct hinshi_groupf	HNS_GRPF;
/* fk */
struct hinshi_koho {
	USHORT	max_fzk;
	USHORT	cnt;
	HNS_BLK	hib[N_HIB];
};
typedef	struct hinshi_koho	HNS_KH;

/*
 *	Fuzokugo Kata Jouhou < kata_tb Flag >
 */
#define	KATA_TAIGEN		0x4000
#define	KATA_MEIREI		0x2000
#define	KATA_KATEI		0x1000
#define	KATA_RENTAI		0x0800
#define	KATA_SHUUSHI	0x0400
#define	KATA_RENYOU		0x0200
#define	KATA_HENKEI2		0x0002 /* hatu onbin (v+n ky+xyuu/u kd+ni)
/*
 *	Fuzokugo Katuyou Jouhou < Fuzokugo Table Flag >
 */
#define	F_ILEGAL_END	0x40
#define	F_SHUUJYOSHI	0x20
#define	F_NN			0x10
#define	F_KOUGO_FZK		0x08	/* KOUGOTAI FUZOKUGO */
#define	F_JIRITU		0x04 /* JIRITUGO     */
#define	F_GENKEI		0x02 /* KATUYOU GOBI SHORI GA HITUYOU */
#define	F_KATUYOU		0x01 /* KATUYOU KEI */

/*
 *	Katuyou Fuzokugo Naibu Hinshi Number
 * JD: JHODOUSHI   JDK: KOUGO JHODOUSHI   JDB: BUNGO JHODOUSHI
 * HD: HOJHO DOUSHI   HK: HOJHO KEIYOUSHI
 */

#define	U		1	/* ư */
#define	SASERU	2	/* ư */
#define	SERU	3	/* ư */
#define	SOUDA	4	/* ư */
#define	TA		5	/* ư  _    _ EX.=ä */
#define	DA1		6	/* ư  _    _ EX.=ɤ */
#define	DA2		7	/* ư  ʤ (    = DA3) EX.=ŷ 褤 */
#define	TAI		8	/* ư */

#define	TAGARU	9	/* ư */
#define	TERU	10	/* ʣư te+iru */
#define	DESU	11	/* ư */
#define	DERU	12	/* ʣư de+iru */
#define	NAI		13	/* ư */
#define	NU		14	/* ư */
#define	MAI		15	/* ư */
#define	MASU	16	/* ư */

#define	MITAIDA	17	/* ư */
#define	YOU2	18	/* ư UKE-YOU */
#define	YOUDA	19	/* ư */
#define	RASHII	20	/* ư */
#define	RARERU	21	/* ư */
#define	RU		22	/* ư mire+ru */
#define	RERU	23	/* ư */
#define	GOZAIMASU	24	/* ư  */

#define	CHAU	25	/* ʣư te+simau */
#define	JAU		26	/* ʣư de+simau */
#define	ITADAKU	27	/* ư  */
#define	IRASSHARU	28	/* ư  */
#define	MIRU	29	/* ư  ߤX */
#define	NARU	30	/* ư  */
#define	ITASU	31	/* ư  */
#define	YOI		32	/*    */

#define	II		33	/*    */
#define	IU		34	/* ư  */
/* ֤ʤפϿǤʤΤǼΩȤ 49ְʹߤذư */
#define SARERU  35      /* ư  */
#define	DEKIRU	36	/* ư  */
#define	TORU	37	/* ư  fuyou ? -> nitotte */
#define	BESHI	38	/* ưʸ  */
#define	MAJI	39	/* ưʸ  */
#define	GOTOSHI	40	/* ưʸ  */

#define	SU		41  /* ư KAKASU */
#define	SASU	42  /* ư TABESASU */
#define	DESI	43	/* ư */
#define	DA3		44  /* ư     (DA2 Ϣη³ʤ) */
#define	IRU		45	/* ư  */
#define	URU		46	/* ư  */
#define DORU    47      /* ư  */
#define	SURU	48	/* ư  */
/*======= 嵭Ͻư or Ѹ ================================= */

#define	ARU		49	/* ư  */
#define	SUGIRU	50	/* ư  */
#define	KUDASAI	51	/* ư  */
#define	KURERU	52	/* ư  */
#define	SIMAU	54	/* ư  */
#define OKU             55      /* ư  */
#define	ORU		56	/* ư  */

#define	KURU	57	/* ư  */
#define	KIRU	58	/* ư  */
#define	NIKUI	59	/*    */
#define	YASUI	60	/*    */
#define	KAKERU	61	/* ư  */
#define	MORAU	62	/* ư  */
#define	MAKURU	63	/* ư */

#define	NASARU	64	/* ư  */
#define	YOU3	65	/* ư  -> ʲ KAKE-YOU */
#define	YARU	67	/* ư  */
#define	DAKKE	68	/* ʣư dat+ta+ka 93/4/27 */
#define	TOIU	69	/* ʣư to+iu 94/3/25 */

/*
 *	Mukatuyou Fuzokugo Naibu Hinshi Number
 */
#define	KA		1 /*     /    /FUKU/     */
#define	KASHIRA	2 /*     /    /    /SHUU */
#define	KARA	3 /* KAKU/SETU/    /SHUU */ /* taigen */
#define	GA		4 /* KAKU/SETU/    /     */
#define	KIRI	5 /*     /    /FUKU/     */
#define	KURAI	6 /*     /    /FUKU/     */
#define	KARA2	7 /* KAKU/SETU/    /SHUU */ /* yougen */
#define	HA2		8 /*     /    /FUKU/     */ /* yougen */
#define	KEREDO	9 /*     /SETU/    /SHUU */
#define	KOSO	10 /*     /    /FUKU/     */
#define	SA		11 /*     /    /    /SHUU */
#define	SAE		12 /*     /    /FUKU/     */
#define	SHI		13 /*     /SETU/    /     */
#define	SHIKA	14 /*     /    /FUKU/     */
#define	SURA	15 /*     /    /FUKU/     */
#define	TO2		16 /*     /SETU/    /     */
#define	ZE		17 /*     /    /    /SHUU */
#define	ZO		18 /*     /    /    /SHUU */
#define	TARI	19 /*     /SETU/    /     */
#define	DAKE	20 /*     /    /FUKU/     */
#define	DATTE	21 /*     /    /FUKU/     */
#define	DARI	22 /*     /SETU/    /     */
#define	TUTU	23 /*     /SETU/    /     */
#define	TO1		24 /*KAKU /    /    /     */
#define	TE		25 /*     /SETU/    /SHUU */
/*#define       RSV26   26 / *     /SETU/    /     * / */
#define	DE		27 /* KAKU/    /    /     */	/* GAKKOUDE */
#define	DEMO	28 /*     /    /FUKU/     */
#define	TO		29 /* KAKU/    /    /     */
#define	TOMO	30 /*     /SETU/    /SHUU */
#define	NA		31 /*     /    /    /SHUU */
/*#define       RSV32           32 / *     /    /    /SHUU * / */
#define	NAGARA	33 /*     /SETU/    /     */
#define	NADO	34 /*     /    /FUKU/     */
#define	NARI	35 /*     /SETU/FUKU/     */
#define	NARITO	36 /*     /    /    /     */
#define	NANKA	37 /*     /    /FUKU?     */
#define	NANZO	38 /*     /    /FUKU?     */
#define	NANTE	39 /*     /    /FUKU?     */
#define	NI		40 /* KAKU/    /    /     */ /* θ³ */
#define	NE		41 /*     /    /    /SHUU */
#define	NEE		42 /*     /    /    /     */
#define	NO_		43 /* KAKU/    /    /     */	/* TAIGEN NI SETUZOKU */
#define	NODE	44 /*     /SETU/    /     */
#define	NONI	45 /*     /SETU/    /     */
#define	HA		46 /*     /    /FUKU/     */
#define	BA		47 /*     /SETU/    /     */
#define	BAKARI	48 /*     /    /FUKU/     */
#define	HE		49 /* KAKU/    /    /     */
#define	HOKA	50 /*     /    /FUKU/     */
#define	HODO	51 /*     /    /FUKU/     */
#define	MADE	52 /*     /    /FUKU/     */
#define	MO		53 /*     /SETU/FUKU/     */
#define	YA		54 /* KAKU/SETU/FUKU/SHUU */
#define	YARA	55 /*     /    /FUKU/     */
#define	YO		56 /*     /    /    /SHUU */
#define	YORI	57 /* KAKU/    /    /     */
#define	WO		58 /* KAKU/    /    /     */
#define	NI1		59 /* KAKU/    /    /     */ /* Ѹ³ */
#define	KOTO	60 /* KMEI/    /    /     */
#define	TAME	61 /* KMEI/    /    /     */
#define	TOORI	62 /* KMEI/    /    /     */
#define	TOKI	63 /* KMEI/    /    /     */
#define	TOKORO	64 /*     /SETU/    /     */
#define	DOKORO	65 /*     /SETU?    /     */
#define	NOMI	66 /*     /    /FUKU/     */
#define	HAZU	67 /* KMEI/    /    /     */
#define	XTUKIRI	68 /*     /    /FUKU?     */
#define	MAMA	69 /* KMEI/    /    /     */
#define	MO2		70 /*     /    /FUKU/     */ /* yougen */
#define	WAKE	71 /* KMEI/    /    /     */
#define	KA2		72 /*     /    /FUKU/     */
#define	DE2		73 /*     /SETU/    /     */	/* ASONDE */
/*#define       RSV74           74 / * KMEI/    /    /     * / */
#define	NITUITE	75 /*     /    /    /     */
#define	TUMORI	76 /* KMEI/    /    /     */
#define	NO2		77 /* KAKU/    /    /     */	/* TAIGEN IGAI NI SETUZOKU */
#define	NN		78 /* KAKU/    /    /     */
#define	NO3		79 /*     /    /    /SHUU */
#define	KAI		80 /*     /    /    /SHUU */
#define	WA		81 /*     /    /    /SHUU */
#define	MON		82 /*     /    /    /     */
#define	JA		83 /*     /    /    /     */
#define	CHA 	84 /*     /    /    /     */
#define	XTUPANASHI	85 /*     /    /    /     */	/* KAKIPPANASI */
#define	XTUTE	86 /* KAKU/    /    /SHUU */
/*#define       RSV87   87 / *     /    /    /     * / */
#define	XTUKO	88 /*     /    /    /     */	/* DEKIKKO */
#define	DOMO	89 /*     /SETU/    /     */	/* IKEDOMO */
#define	TAMAE	90 /*     /    /    /     */	/* ASOBITAMAE */
#define	YUE		91 /* KMEI/    /    /     */	/* WAKASAYUE */
/*#define	RSV92	92 / *     /    /    /     * / */
/*#define	RSV93	93 / *     /    /    /     * / */
#define	TOTE	94 /*     /SETU/FUKU/     */	/* TOTEMO WO KINSHI SHITA */
#define	NITE	95 /* KAKU/    /    /     */	/* NITE NI O TE O IRU / NITE X IRU */
#define	NANO	96 /*     /    /    /     */	/* 93/6/9 */
/******** ikaha vjetb4.c ni entry ga nai ****************/
#define RSV97   97 /*     /    /    /     */    /* 93/6/9 */
#define	DEHANAINISEYO	98 /*     /    /    /     */	/* 93/6/10 */
#define	NO1		99 /*     /    /    /     */	/* 93/6/10 */
#define	NADOSI	100 /*     /    /    /     */	/* 94/6/8 */
#define	XTUTE2	101 /* KAKU/    /    /SHUU */	/* 93/6/10 */
#define	MONO	102 /* KMEI/    /    /     */
#define	DANO	103 /*     /    /FUKU/     */
#define	F_NULL	104 /*     /    /    /     */
#define	NIYORU	105	/*     /    /FUKU/     */
#define	DAKEATTE	106	/*     /    /FUKU/     */
#define	YOU		107	/*KMEI /    /    /     */ /*  KAKI-YOU */
#define	KAGA	108 /*     /    /FUKU/     */
#define	NINARU	109	/* ʣư ni+naru */


/*
 *	Katuyou Fuzokugo
 */
#define	RSV		0

#define	U_X		0
#define	SASERU_X	0
#define	SERU_X		0
#define	SOUDA_X		0
#define	TA_X		0
#define	DA1_X		0
#define	DA2_X		0
#define	TAI_X		0	
#define	TAGARU_X	0
#define	TERU_X		0
#define	DESU_X		0
#define	DERU_X		0
#define	NAI_X		0
#define	NU_X		0
#define	MAI_X		0
#define	MASU_X		0
#define	MITAIDA_X	0
#define	YOU_X		0
#define	YOUDA_X		0
#define	RASII_X		0
#define	RARERU_X	0
#define	RU_X		0
#define	RERU_X		0
#define	GOZAI_X		0
#define	CHAU_X		0
#define	JAU_X		0
#define	ITADAKU_X	0
#define	IRASSHARU_X	0
#define	MIRU_X		0
#define	NARU_X		0
#define	ITASU_X		0
#define	YOI_X		0
#define	II_X		0
#define	IU_X		0
#define SARERU_X        0
#define	DEKIRU_X	0
#define	TORU_X		0
#define	BESHI_X		0
#define	MAJI_X		0
#define	GOTOSHI_X	0
#define	SU_X		0
#define	SASU_X		0
#define	DESI_X		0
#define	DA3_X		0
#define	IRU_X		0
#define	URU_X		0
#define	SURU_X		0

#define	U_O		0x80
#define	SASERU_O	0x40
#define	SERU_O		0x20
#define	SOUDA_O		0x10

#define	TA_O		0x08
#define	DA1_O		0x04
#define	DA2_O		0x02
#define	TAI_O		0x01

#define	TAGARU_O	0x80
#define	TERU_O		0x40
#define	DESU_O		0x20
#define	DERU_O		0x10

#define	NAI_O		0x08
#define	NU_O		0x04
#define	MAI_O		0x02
#define	MASU_O		0x01

#define	MITAIDA_O	0x80
#define	YOU_O		0x40
#define	YOUDA_O		0x20
#define	RASII_O		0x10

#define	RARERU_O	0x08
#define	RU_O		0x04
#define	RERU_O		0x02
#define	GOZAI_O		0x01

#define	CHAU_O		0x80
#define	JAU_O		0x40
#define	ITADAKU_O	0x20
#define	IRASSHARU_O	0x10

#define	MIRU_O		0x08
#define	NARU_O		0x04
#define	ITASU_O		0x02
#define	YOI_O		0x01

#define	II_O		0x80
#define	IU_O		0x40
#define SARERU_O                0x20
#define	DEKIRU_O	0x10

#define	TORU_O		0x08
#define	BESHI_O		0x04
#define	MAJI_O		0x02
#define	GOTOSHI_O	0x01

#define	SU_O		0x80
#define	SASU_O		0x40
#define	DESI_O		0x20
#define	DA3_O		0x10
#define	IRU_O		0x08
#define	URU_O		0x04
#define	SURU_O		0x01

/*
 *	Mukatuyou Fuzokugo
 */
#define	KA_X		0
#define	KASHIRA_X	0
#define	KARA_X		0
#define	GA_X		0
#define	KIRI_X		0
#define	KURAI_X		0
#define	KARA2_X		0
#define	HA2_X		0

#define	KEREDO_X	0
#define	KOSO_X		0
#define	SA_X		0
#define	SAE_X		0
#define	SHI_X		0
#define	SHIKA_X		0
#define	SURA_X		0
#define	TO2_X		0

#define	ZE_X		0
#define	ZO_X		0
#define	TARI_X		0
#define	DAKE_X		0
#define	DATTE_X		0
#define	DARI_X		0
#define	TUTU_X		0
/*#define	DUTU_X		0*/

#define	TE_X		0
#define	TEMO_X		0
#define	DE_X		0
#define	DEMO_X		0
#define	TO_X		0
#define	TOMO_X		0
#define	NA_X		0
#define	NAA_X		0

#define	NAGARA_X	0
#define	NADO_X		0
#define	NARI_X		0
#define	NARITO_X	0
#define	NANKA_X		0
#define	NANZO_X		0
#define	NANTE_X		0
#define	NI_X		0

#define	NE_X		0
#define	NEE_X		0
#define	NO_X		0
#define	NODE_X		0
#define	NONI_X		0
#define	HA_X		0
#define	BA_X		0
#define	BAKARI_X	0

#define	HE_X		0
#define	HOKA_X		0
#define	HODO_X		0
#define	MADE_X		0
#define	MO_X		0
#define	YA_X		0
#define	YARA_X		0
#define	YO_X		0

#define	YORI_X		0	
#define	WO_X		0
#define	NI1_X		0
#define	KOTO_X		0
#define	TAME_X		0	
#define	TOORI_X		0
#define	TOKI_X		0
#define	TOKORO_X	0

#define	DOKORO_X	0
#define	NOMI_X		0
#define	HAZU_X		0
#define	XTUKIRI_X	0
#define	MAMA_X		0
#define	MO2_X		0
#define	WAKE_X		0
#define	KA2_X		0

#define	DE2_X		0
#define	SEI_X		0
#define	TUITE_X		0
#define	TUMORI_X	0
#define	NO2_X		0
#define	NN_X		0
#define	KAI_X		0

#define	WA_X		0
#define	MON_X		0
#define	JA_X		0
#define	CHA_X		0
#define	XTUPANA_X	0
#define	XTUTE_X		0
#define	TERO_X		0
#define	XTUKO_X		0

#define	DOMO_X		0
#define	TAMAE_X		0
#define	YUE_X		0
#define	TOKE_X		0
#define	DOKE_X		0
#define	TOTE_X		0
#define	NITE_X		0
#define	NANO_X		0

#define	KA_O		0x80
#define	KASHIRA_O	0x40
#define	KARA_O		0x20
#define	GA_O		0x10
#define	KIRI_O		0x08
#define	KURAI_O		0x04
#define	KARA2_O		0x02
#define	HA2_O		0x01

#define	KEREDO_O	0x80
#define	KOSO_O		0x40
#define	SA_O		0x20
#define	SAE_O		0x10
#define	SHI_O		0x08
#define	SHIKA_O		0x04
#define	SURA_O		0x02
#define	TO2_O		0x01

#define	ZE_O		0x80
#define	ZO_O		0x40
#define	TARI_O		0x20
#define	DAKE_O		0x10
#define	DATTE_O		0x08
#define	DARI_O		0x04
#define	TUTU_O		0x02
/*#define	DUTU_O		0x01*/

#define	TE_O		0x80
#define	TEMO_O		0x40
#define	DE_O		0x20
#define	DEMO_O		0x10
#define	TO_O		0x08
#define	TOMO_O		0x04
#define	NA_O		0x02
#define	NAA_O		0x01

#define	NAGARA_O	0x80
#define	NADO_O		0x40
#define	NARI_O		0x20
#define	NARITO_O	0x10
#define	NANKA_O		0x08
#define	NANZO_O		0x04
#define	NANTE_O		0x02
#define	NI_O		0x01

#define	NE_O		0x80
#define	NEE_O		0x40
#define	NO_O		0x20
#define	NODE_O		0x10
#define	NONI_O		0x08
#define	HA_O		0x04
#define	BA_O		0x02
#define	BAKARI_O	0x01

#define	HE_O		0x80
#define	HOKA_O		0x40
#define	HODO_O		0x20
#define	MADE_O		0x10
#define	MO_O		0x08
#define	YA_O		0x04
#define	YARA_O		0x02
#define	YO_O		0x01

#define	YORI_O		0x80	
#define	WO_O		0x40
#define	NI1_O		0x20
#define	KOTO_O		0x10
#define	TAME_O		0x08	
#define	TOORI_O		0x04
#define	TOKI_O		0x02
#define	TOKORO_O	0x01

#define	DOKORO_O	0x80
#define	NOMI_O		0x40
#define	HAZU_O		0x20
#define	XTUKIRI_O	0x10
#define	MAMA_O		0x08
#define	MO2_O		0x04
#define	WAKE_O		0x02
#define	KA2_O		0x01

#define	DE2_O		0x80
#define	SEI_O		0x40
#define	TUITE_O		0x20
#define	TUMORI_O	0x10
#define	NO2_O		0x08
#define	NN_O		0x04
#define	KAI_O		0x01

#define	WA_O		0x80
#define	MON_O		0x40
#define	JA_O		0x20
#define	CHA_O		0x10
#define	XTUPANA_O	0x08
#define	XTUTE_O		0x04
#define	TERO_O		0x02
#define	XTUKO_O		0x01

#define	DOMO_O		0x80
#define	TAMAE_O		0x40
#define	YUE_O		0x20
#define	TOKE_O		0x10
#define	DOKE_O		0x08
#define	TOTE_O		0x04
#define	NITE_O		0x02
#define	NANO_O		0x01

#define	_XA		0x02
#define	_A		0x03
#define	_XI		0x04
#define	_I		0x05
#define	_XU		0x06
#define	__U		0x07	/* toshif-s: _U is already defined */
#define	_XE		0x08
#define	_E		0x09
#define	_XO		0x0a
#define	_O		0x0b
#define	_KA		0x0c
#define	_GA		0x0d
#define	_KI		0x0e
#define	_GI		0x0f
#define	_KU		0x10
#define	_GU		0x11
#define	_KE		0x12
#define	_GE		0x13
#define	_KO		0x14
#define	_GO		0x15
#define	_SA		0x16
#define	_ZA		0x17
#define	_SI		0x18
#define	_ZI		0x19
#define	_SU		0x1a
#define	_ZU		0x1b
#define	_SE		0x1c
#define	_ZE		0x1d
#define	_SO		0x1e
#define	_ZO		0x1f
#define	_TA		0x20
#define	_DA		0x21
#define	_TI		0x22
#define	_DI		0x23
#define	_XTU		0x24
#define	_TU		0x25
#define	_DU		0x26
#define	_TE		0x27
#define	_DE		0x28
#define	_TO		0x29
#define	_DO		0x2a
#define	_NA		0x2b
#define	_NI		0x2c
#define	_NU		0x2d
#define	_NE		0x2e
#define	_NO		0x2f
#define	_HA		0x30
#define	_BA		0x31
#define	_PA		0x32
#define	_HI		0x33
#define	_BI		0x34
#define	_PI		0x35
#define	_HU		0x36
#define	_BU		0x37
#define	_PU		0x38
#define	_HE		0x39
#define	_BE		0x3a
#define	_PE		0x3b
#define	_HO		0x3c
#define	_BO		0x3d
#define	_PO		0x3e
#define	_MA		0x3f
#define	_MI		0x40
#define	_MU		0x41
#define	_ME		0x42
#define	_MO		0x43
#define	_XYA		0x44
#define	_YA		0x45
#define	_XYU		0x46
#define	_YU		0x47
#define	_XYO		0x48
#define	_YO		0x49
#define	_RA		0x4a
#define	_RI		0x4b
#define	_RU		0x4c
#define	_RE		0x4d
#define	_RO		0x4e
#define	_XWA		0x4f
#define	_WA		0x50
#define	_WI		0x51
#define	_WE		0x52
#define	_WO		0x53
#define	__N		0x54
#define	_VU		0x55
#define	_TYOUON		0x56
#if VJE95
#define	_NAKAGURO	0x57 /*  */
#define	_KANA_KAKKO_HIRAKI	0x58 /*  */
#define	_KANA_KAKKO_TOJI	0x59 /*  */
#define	_KUTEN		0x5a /*  . */
#define	_TOUTEN		0x5b /*  , */
#define	_HANKAKU	0x5c
#define	_KIGO		0x5d /*    */
#define	_HANDAKUTEN	0x60 /*    */
#define _ZENKAKU	0x61
/*KAKKO */
#define _KAKKO1_HIRAKI	0xa8	/*(*/
#define _KAKKO1_TOJI	0xa9	/*)*/
#define _KAKKO2_HIRAKI	0xdb	/*[*/
#define _KAKKO2_TOJI	0xdd	/*]*/
#define _KAKKO3_HIRAKI	0xfb	/*{*/
#define _KAKKO3_TOJI	0xfd	/*}*/
#else
#define	_KUTEN		0x57 /*  . ! ? */
#define	_TOUTEN		0x58 /*  , */
#define	_NAKAGURO	0x59
#define	_HANKAKU	0x5a
#define	_HAN_KAKKO_HIRAKI	0x5b
#define	_HAN_KAKKO_TOJI		0x5c
#define	_KIGO		0x5d
#define	_KAKKO_HIRAKI	0x5e
#define	_KAKKO_TOJI		0x5f
#define _ZENKAKU	0x60
#endif
#define _ERR_YOMI	0xff
