/******************************************************************************
	Vjeenv.H
******************************************************************************/
/*=============================================================================
	define
=============================================================================*/
#define		XKP_SUPPORT		0
#define		USE_APPBAR		0
#define		VERSION			25

#if PCUNIX
#define		MAX_AWT_BUFF		2048
#define		DEF_ENV_EUC		1
#define		DEF_BACKSLASH_AND_YEN	1

#define		KANJI_KEY_MAX		32
#define		AlterMask		(1<<3)

#define		HTTOPLEFT		0
#define		HTTOPRIGHT		1
#define		HTBOTTOMLEFT		2
#define		HTBOTTOMRIGHT		3

#define		FCASE_NORMAL		0	/* Nrm                  */
#define		FCASE_SHIFT		1	/* Sft (@)              */
#define		FCASE_CTRL		2	/* Ctl (^)              */
#define		FCASE_ALT		3	/* Alt (*)              */
#define		FCASE_CTRL_SHIFT	4	/* Ctl+Sft (^@)         */
#define		FCASE_CTRL_ALT		5	/* Ctl+Alt (^*)         */
#define		FCASE_ALT_SHIFT		6	/* Alt+Sft (*@)         */
#define		FCASE_CTRL_ALT_SHIFT	7	/* Ctl+Alt+Sft (^*@)    */

#define		STAGE_EMP		0	/* EMP			*/
#define		STAGE_INP		1	/* INP			*/
#define		STAGE_CNV		2	/* CNV			*/
#define		STAGE_DON1		3	/* DON1			*/
#define		STAGE_DON2		4	/* DON2			*/
#endif /* PCUNIX */

#if !PCUNIX
/*-----------------------------------------------------------------------------
	ѥ
-----------------------------------------------------------------------------*/
#define  	WSTATIC			auto
#ifdef		DEBUG
//#define   	DEBUG_ENV			/* For Debug		     */
//#define   	DEBUG_API			/* For Debug		     */
//#define   	DEBUG_KEY			/* For Debug		     */
//#define   	DEBUG_UI			/* For Debug		     */
//#define   	DEBUG_VJE			/* For Debug		     */
//#define   	DEBUG_APIUI			/* For Debug		     */
//#define	DEBUG_KANA			/* For Debug		     */
//#define   	DEBUG_LOG			/* For Debug		     */
#endif
#endif /* !PCUNIX */

/*-----------------------------------------------------------------------------
	DBCS_SIZE
-----------------------------------------------------------------------------*/
#ifdef	UNICODE
#define	DBCS_SIZE			1
#else
#define	DBCS_SIZE			2
#endif

/*-----------------------------------------------------------------------------
	Ƽ
-----------------------------------------------------------------------------*/
#if PCUNIX
#define		MIN_CAND_COL		 1
#define		MAX_CAND_COL		26
#define		MIN_CAND_ROW		 1
#define		MAX_CAND_ROW		 9
#define		MAX_CAND_NUM		256
#define		MAX_COMP_SIZE		(NUM_CHAR * DBCS_SIZE)
#define		MAX_CAND_SIZE		(L_TANGO  * DBCS_SIZE)
#define		MAX_MODE_SIZE		(10 * DBCS_SIZE)
#define		MAX_MSG_SIZE		(40 * DBCS_SIZE)
#define		MAX_TITLE_SIZE		(40 * DBCS_SIZE)
#define		MAX_YOMI_SIZE		(L_YOMI * DBCS_SIZE)
#define		MAX_HYOKI_SIZE		(L_YOMI * DBCS_SIZE)
#define		MAX_LONG_STR		64
#define		MAX_SHORT_STR		18
#define		MAX_VK			(256*3)	/* Num of XK_xx		*/
						/* 0x0000 - 0x00FF,
						   0xFF00 - 0xFFFF,
						   0xFE00 - 0xFEFF	*/
#define		MAX_FCASE		8	/* Nrm Sft Ctl Alt	*/
						/* Ctl+Sft Ctl+Alt	*/
						/* Alt+Sft Ctl+Alt+Sft	*/
#define		MAX_STAGE		5	/* EMP INP CNV DON1 DON2*/
#define		MAX_CCASE		2	/* Nrm Sft		*/
#define		MIN_DRAG		4
#define		MAX_BTNTOP		128
#define		MAX_ACC			10
#define		MAX_DIC			10
#define		MAX_SET			256
#define		MAX_BTNSIZE		48
#define		MAX_UICOMPC		32
#define		MAX_KEYTOP		256
#define		MAX_ROMA_SIZE		8191
#define		MAX_MODESTR		10
#if	WITHFONT
#define		MAX_FONTARRAY		16
#endif
#else /* PCUNIX */
#define		MAX_CLAUSE_NUM		80
#define		MAX_CAND_COL		16
#define		MAX_CAND_ROW		16
#define		MAX_CAND_NUM		256
#define		MAX_COMP_SIZE		(81 * DBCS_SIZE)
#define		MAX_CAND_SIZE		(32 * DBCS_SIZE)
#define		MAX_MODE_SIZE		(10 * DBCS_SIZE)
#define		MAX_MSG_SIZE		(40 * DBCS_SIZE)
#define		MAX_TITLE_SIZE		(40 * DBCS_SIZE)
#define		MAX_YOMI_SIZE		(32 * DBCS_SIZE)
#define		MAX_HYOKI_SIZE		(32 * DBCS_SIZE)
#define		MAX_LONG_STR		64
#define		MAX_SHORT_STR		6
#define		MAX_VK			256	/* Num of VK_xx 	*/
#define		MAX_FCASE		4	/* Nrm Sft Ctl Ctl+Sft	*/
#define		MAX_STAGE		5
#define		MAX_CCASE		2	/* Normal Sft		*/
#define		MIN_DRAG		4
#define		MAX_BTNTOP		128
#define		MAX_ACC			10
#define		MAX_DIC			10
#define		MAX_SET			256
#define		MAX_BTNSIZE		48
#define		MAX_UICOMPC		32
#define		MAX_KEYTOP		256
#define		MAX_ROMA_SIZE		8191
#define		MAX_MODESTR		10
#if	WITHFONT
#define		MAX_FONTARRAY		16
#endif
#endif /* PCUNIX */

/*-----------------------------------------------------------------------------
	å
-----------------------------------------------------------------------------*/
#define		DLL_STACK_SIZE			(4096 * 3)
#define		IME_STACK_SIZE			(4096 * 2)
#define		API_IMEINQUIRE			IME_STACK_SIZE
#define		API_IMECONVERSIONLIST		IME_STACK_SIZE
#define		API_IMEDESTROY			IME_STACK_SIZE
#define		API_IMEESCAPE			0
#define		API_IMESETACTIVECONTEXT		IME_STACK_SIZE
#define		API_IMEPROCESSKEY		IME_STACK_SIZE
#define		API_IMETOASCIIEX		IME_STACK_SIZE
#define		API_NOTIFYIME			IME_STACK_SIZE
#define		API_IMESELECT			IME_STACK_SIZE
#define		API_IMESETCOMPOSITIONSTRING	IME_STACK_SIZE
#define		API_IMEREGISTERWORD		IME_STACK_SIZE
#define		API_IMEUNREGISTERWORD		IME_STACK_SIZE
#define		API_IMEGETREGISTERWORDSTYLE	IME_STACK_SIZE
#define		API_IMEENUMREGISTERWORD		IME_STACK_SIZE
#define		API_IMECONFIGURE		IME_STACK_SIZE
#define		UIW_UI				IME_STACK_SIZE
#define		UIW_UIBTN			IME_STACK_SIZE
#define		UIW_UIBTNC			IME_STACK_SIZE
#define		UIW_UICAND			IME_STACK_SIZE
#define		UIW_UICANDC			IME_STACK_SIZE
#define		UIW_UICOMP			IME_STACK_SIZE
#define		UIW_UICOMPC			IME_STACK_SIZE
#define		UIW_UICOMPW			IME_STACK_SIZE
#define		UIW_UIFRAME			IME_STACK_SIZE
#define		UIW_UIKBD			IME_STACK_SIZE
#define		UIW_UIPOPUP			IME_STACK_SIZE
#define		UIW_UIREG			IME_STACK_SIZE
#define		UIW_UISIZE			IME_STACK_SIZE
#define		UIW_UIVER			IME_STACK_SIZE

/*-----------------------------------------------------------------------------
	ѡģɣ
-----------------------------------------------------------------------------*/
#define		PARTS_UNKNOWN		0
#define		PARTS_BTN		1
#define		PARTS_KBD		2
#define		PARTS_FUNC		3
#define		PARTS_COMPW		4
#define		MAX_PARTS		5
#define		MAX_WIN			MAX_PARTS
#define		PARTS_ONOFF		5

/*-----------------------------------------------------------------------------
	ܡɣɣ
-----------------------------------------------------------------------------*/
#define		KBD_UNKNOWN		0x0000
#define		KBD_101			0x0001
#define		KBD_AX			0x0002
#define		KBD_002			0x0003
#define		KBD_A01			0x0004
#define		KBD_PC98		0x0005
#define		KBD_FNCAT		0x0006		/* AT Function	     */
#define		KBD_FNC98		0x0007		/* 98 Function       */
#define		KBD_PAD1H		0x0008		/* Ҥ餬	     */
#define		KBD_PAD1K		0x0009		/* 	     */
#define		KBD_PAD1A		0x000a		/* ѿ		     */

/*=============================================================================
	꥽ɣ
=============================================================================*/
/*-----------------------------------------------------------------------------
	ICON/BITMAP	IDI_xx/IDP_xx	(No 1xxx)
-----------------------------------------------------------------------------*/
#define		IDI_VJED95IS		1000
#define		IDI_VJED95IM		1001
#define		IDI_HIRA		1002
#define		IDI_KATA		1003
#define		IDI_EISU		1004
#define		IDP_BTN12B		1005
#define		IDP_BTN20B		1006
#define		IDP_BTN12C		1007
#define		IDP_BTN20C		1008
#define		IDP_PAD1H		1009
#define		IDP_PAD1K		1010
#define		IDP_PAD1A		1011
#define		IDP_CAND		1012

/*-----------------------------------------------------------------------------
	Menu	IDM_xx	(No 3xxx - 5xxx)
-----------------------------------------------------------------------------*/
#define		IDM_MINIMIZE		3001
#define		IDM_SHOWNORMAL		3002
#define		IDM_SEL_BTN		3010
#define		IDM_SEL_COMPW		3011
#define		IDM_SEL_KBD		3012
#define		IDM_SEL_FUNC		3013
#define		IDM_OFF_SHOW		3017
#define		IDM_OFF_SHRINK		3018
#define		IDM_OFF_HIDE		3019
#define		IDM_DOCKABLE		3020

#define		IDM_REGWORD		3025
#define		IDM_DELWORD		3026

#define		IDM_ACC_1		3030
#define		IDM_ACC_2		3031
#define		IDM_ACC_3		3032
#define		IDM_ACC_4		3033
#define		IDM_ACC_5		3034
#define		IDM_ACC_6		3035
#define		IDM_ACC_7		3036
#define		IDM_ACC_8		3037
#define		IDM_ACC_9		3038
#define		IDM_ACC_10		3039
#define		IDM_ACC_SEP		3040

#define		IDM_OTHER_ENV		3050
#define		IDM_OTHER_DIC		3051
#define		IDM_OTHER_SAVE		3052
#define		IDM_VERSION		3053

#define		IDM_KBD			3100
#define		IDM_KBD_TYP_HARD	3110
#define		IDM_KBD_TYP_PAD1H	3111
#define		IDM_KBD_TYP_PAD1K	3112
#define		IDM_KBD_TYP_PAD1A	3113
#define		IDM_KBD_CHAR		3114
#define		IDM_KBD_FUNC		3115
#define		IDM_KBD_PROP		3116

#define		IDM_FUNC		3120
#define		IDM_FUNC_PROP		3121

#define		IDM_BTN			3130
#define		IDM_BTN_12B		3131
#define		IDM_BTN_20B		3132
#define		IDM_BTN_12C		3133
#define		IDM_BTN_20C		3134
#define		IDM_BTN_PROP		3135

#define		IDM_COMPW		3140
#define		IDM_COMPW_PROP		3141

#define		IDM_TRAY		3150

/*-----------------------------------------------------------------------------
	Dialog	IDD_xx	(No 6xxx - 8xxx)
-----------------------------------------------------------------------------*/
#define		IDD_ERROR		6000
#define		IDD_REGWORD		6010
#define		IDD_DELWORD		6011
#define		IDD_YOMI		6012
#define		IDD_HYOKI		6013
#define		IDD_HIN_EDIT		6014
#define		IDD_HIN_LIST		6015
#define		IDD_VERSION		6020
#define		IDD_DESC		6021
#define		IDD_USER1		6022
#define		IDD_USER2		6023
#define		IDD_MODULEDATA		6024
