#if MAC					/* ٤ɤ߹褦 */
#pragma once
#endif
#include "vyr.h"

#if WINDOWS
#if DPMI
#include "typedef.h"
#else
#include "windows.h"
#endif
#endif
#if MAC
#include "unix.h"
#include "stdlib.h"
#endif

#if DPMI || unix
typedef struct tagOFDOSSTRUCT
{
    char stat;
    char szPathName[128];
} OFDOSSTRUCT;
#endif
#ifdef	ADELTA
struct	yourei_field {
	UCHAR	yourei;		/* Yourei code			*/
	UCHAR	kaku;		/* Kaku jyouhou code		*/
	USHORT	id;		/* ID || Imi code		*/
	USHORT	num;		/* Current Yourei field No.	*/
};
typedef	struct	yourei_field	YOUREI_FIELD;

struct	hyouki_field {
	UCHAR	inf1;		/* HyoukiInf patern1		*/
	UCHAR	inf2;		/* HyoukiInf patern2		*/
	UCHAR	inf3;		/* HyoukiInf patern3		*/
	UCHAR	inf4;		/* HyoukiInf patern4		*/
	USHORT	num;		/* Current Yourei field No.	*/
};
typedef	struct	hyouki_field	HYOUKI_FIELD;

struct	hin_field {
	UCHAR	hinsilen;	/* Hinshi Length			*/
	UCHAR	hinsi;		/* Hinshi 1st byte			*/
	UCHAR	hinsisub;	/* Hinshi 2nd byte			*/
	UCHAR	gaku;		/* 0 : no gakushuu			*/
				/* 1 : gakushuu kugiri			*/
				/* 2 : gakushuu douon'			*/
				/* 3 : gakushuu (kugiri+douon')		*/
	UCHAR	user;		/* 0 : system tango			*/
				/* 1 : usr tango			*/
	USHORT	hyoukitotal;	/* KyoyouHyouki field count		*/
	USHORT	youreitotal;	/* Yourei field count			*/
	USHORT	atr_len;	/* One-field Length			*/
	HYOUKI_FIELD	kyoyou;	/* */
	YOUREI_FIELD	yourei;	/* */
};
typedef	struct	hin_field	HIN_FIELD;

typedef	struct {

	SHORT	LongRecCount;
	UCHAR	PWIN	*LongRec;
#if WIN32
	HANDLE	LongHandle;
#else
	SHORT	LongHandle;
#endif
	USHORT	LongStartIdx;

	USHORT	HyoukiPtr;
	UCHAR	HinsiType;
	USHORT	YoureiNo;
	USHORT	kaku;
	SHORT	flg;
}	DELTA_INF;
#endif

#if MAC					/* ٤ɤ߹褦 */
#pragma once
#endif

#if unix
#include	<sys/types.h>
#define	MAX_HANDLE	/*256*/(1024 + 4)/*991104*/

#define	LowMalloc(size)		((UCHAR PWIN *)malloc(size))
#define	LowFree(ptr)		(free(ptr))
#define	LowOpen(name, mode)	((int)open((char *) (name), (int) (mode)))
#define	LowClose(fd)		(close((int)(fd)))
#define	LowLseek(fd, pos, mode)	(lseek((int)(fd), (pos), (mode)))
#define	LowRead(fd, buf, size)	((XLONG) read((int)(fd), (buf), (size)))
#define	LowWrite(fd, buf, size)	((XLONG) write((int)(fd), (buf), (size)))
#else	/* unix */
#if OS2

#define	MAX_HANDLE	256
extern	int	open ( char *, int );
extern	int	close ( int );
extern	long	lseek ( int, long, int );
extern	int	read ( int, char *, unsigned int );
extern	int	write ( int, char *, unsigned int );

#define LowOpen(name, mode)	(open( (char far *)(name), (int)(mode) ) )
#define LowClose(fd)		(close((fd)))
#define	LowLseek(fd, pos, mode)	(lseek((fd), (pos), (mode)))
#define	LowRead(fd, buf, size)	((short) read((fd), (char far *)(buf), (size)))
#define	LowWrite(fd, buf, size)	((short) write((fd), (char far *)(buf), (size)))
#else	/* OS2 */
#if (WINDOWS && !DPMI)
#if	PENDIC
	char PWIN *RLowMalloc(int,short) ;
	void RLowFree(char PWIN *,short) ;
#endif
/*WIN95:256 Context /1 process */
#define	MAX_HANDLE	256
char PWIN *LowMalloc(int,HVJELIB,short);
void LowFree(char PWIN *);
#define	LowOpen(name, mode)	((HFILE)_lopen((char far *) (name), (UINT) (mode)))
#define	LowClose(fd)		(_lclose((HFILE)(fd)))
#define	LowLseek(fd, pos, mode)	(_llseek((HFILE)(fd), (pos), (mode)))
#if WIN32
#define	LowRead(fd, buf, size)	((XLONG)_lread((HFILE)(fd), (char far *)(buf), (XLONG)(size)))
#define	LowWrite(fd, buf, size)	((XLONG)_lwrite((HFILE)(fd), (char far *)(buf), (XLONG)(size)))
#else
#define	LowRead(fd, buf, size)	((int) _lread((HFILE)(fd), (char far *)(buf), (UINT)(size)))
#define	LowWrite(fd, buf, size)	((int) _lwrite((HFILE)(fd), (char far *)(buf), (UINT)(size)))
#endif
#else /* WINDOWS */

#if MAC

#define	MAX_HANDLE	256
void *LowMalloc(size_t);
void LowFree(void *);
short	LowOpen(UCHAR *, USHORT);
short	LowClose(short);
short	LowLseek(short, long, short);
short	LowRead(short, UCHAR *, long);
long	LowWrite(short, UCHAR *, long);
short	LowFlush(short);

#else /* MAC */
#if	PENDIC
	#define	RLowMalloc(size)	(malloc(size))
	#define	RLowFree(ptr)		(free(ptr))
#endif
#define	MAX_HANDLE	1
#if DPMI
#include	<share.h>

LPVOID	LowMalloc(UINT, HVJELIB, int);
void	LowFree(LPVOID);
#define	LowOpen(name, mode)	((int)open((char *) (name), (int)((mode)|O_BINARY|SH_DENYNO)))
#else
#define	LowMalloc(size)		(malloc(size))
#define	LowFree(ptr)		(free(ptr))
#define	LowOpen(name, mode)	((int)open((char *) (name), (int) ((mode)|O_BINARY)))
#endif
#define	LowClose(fd)		(close((int)(fd)))
#define	LowLseek(fd, pos, mode)	(lseek((int)(fd), (pos), (mode)))
#define	LowRead(fd, buf, size)	((short) read((int)(fd), (buf), (size)))
#define	LowWrite(fd, buf, size)	((short) write((int)(fd), (buf), (size)))
#endif	/* MAC */
#endif	/* WINDOWS */
#endif	/* OS2 */
#endif	/* unix */
/*===============================================================
	ꥢ(LowMalloc(size,hd,ID_NO) for Windows )ˤĤ
	ID_NO (06)ϼΰ٤˻ѤƤ롣7 ʹߤ̾Υ
	Ȥǽ

	ID_NO	Ū
	------------------------------
	0 : 	w ΰ
	1 : 	 1 (SDIC[0])
	2 :	 2 (SDIC[1])
	3 :	 3 (SDIC[2])
	4 :	 4 (SDIC[3])
	5 :	 5 (SDIC[4])
	6 :	 6 (SDIC[5])
	7 :	 7 (SDIC[6])
	8 :	 8 (SDIC[7])
	9 :	 9 (SDIC[8])
	10:	 10 (SDIC[9])
	------------------------------
	11:	޻ޥΰ 1 (̾Υ)
	12:	޻ޥΰ 2 (̾Υ)
	13:	koho3
	14:	OpenKanjiTable
	15:	OpenKanjiTable
	16:     clear
=================================================================*/
#define MALLOC_7	(11)	/*޻ޥ1 */
#define MALLOC_8	(12)	/*޻ޥ2 */
#define MALLOC_9	(13)	/*koho3*/
#define MALLOC_A	(14)	/*OpenKanjiTable*/
#define MALLOC_B	(15)	/*OpenKanjiTable*/
#define MALLOC_C	(16)	/*clear*/
#define MALLOC_MAX	(MALLOC_C + 1)

#define	MAX_SDIC	11	/*WIN95 */
#define	END_MARK	255			/* End of link */
#define	END_CARD	0			/* End of link */

#define	DOUONGO_MAX		768
#ifdef WIN32 /*+mk */
#define	KCB_MAX		END_MARK-1		/* Max kcb */
#else
#define	KCB_MAX		128			/* Max kcb */
#endif

#if unix
#define	KCARD_MAX		/*1024*/2048		/* Number of cards */
#define SCARD_MAX		240			/* Number of special card */
#define CARD_JI_LEN	12	/* kcard jiritugo hyouki nagasa */
#else /* unix */
#if WINDOWS
#ifdef WIN32 /*+mk */
#define	KCARD_MAX		768*10			/* Number of cards */
#define SCARD_MAX		160*10			/* Number of special card */
#define CARD_JI_LEN	6	/* kcard jiritugo hyouki nagasa */
#else
#define	KCARD_MAX		768			/* Number of cards */
#define SCARD_MAX		160			/* Number of special card */
#define CARD_JI_LEN	6	/* kcard jiritugo hyouki nagasa */
#endif
#else /* WINDOWS */
#define	KCARD_MAX		768			/* Number of cards */
#define SCARD_MAX		80			/* Number of special card */
#define CARD_JI_LEN	12	/* kcard jiritugo hyouki nagasa */
#endif /* WINDOWS */
#endif /* unix */

#define LONG_DOUONGO_MAX SCARD_MAX 

#define	BUNL_MAX		32			/* Max length of a bunsetu */
#define	BUNL_MAX3		96 /*64 97/3/28 K.H.*/			/* Max length of 3 bunsetu */

#define	HEADER_LENGTH	256			/* Kokugo dir total size */
#if 1	/* V300 */
#define	INDEX_MAX_SIZE	(1024 * 48 - 256)	/* dictionary index max size V300*/
#define	LONGREC_MAX_BLOCK	4
#else
#define	INDEX_MAX_SIZE	(1024 * 24 - 256)	/* dictionary index max size */
#define	LONGREC_MAX_BLOCK	4
#endif
#define		MAX_DIC_YOMI	256
#if MOJI1_INDEX
#define	MOJI_DIR		MAX_DIC_YOMI * 2
#else
#define	MOJI_DIR		0
#endif
#define	HINSI_MAX		128				/* Number of max hinsi */
#define	GHINSI_MAX		23+2				/* Number of max gobi hinsi */
#define	IHINSI_MAX		17				/* Number of max internal hinsi */
#define	L_KOHO		sizeof(KH_LINK)	/* Length of a koho 20 */
#define	L_KCB		sizeof(KCB)		/* Length of a kcb 15 */
#define	L_CARD		sizeof(KCARD)		/* Length of a card 16 */
#define	L_SCARD		sizeof(SCARD)		/* Length of a scard 76 */
#define	L_OKF  		sizeof(OKF)	/* Length of a ok flag block 4 */
#define	N_KOHO		4		/* Number of Fuzokugo koho Block */
#define	DIRTB_SIZE	(32 * 3 + 1)	/* Directory table size */
#if WIN32
#define MAX_PATHV	6
#else
#define MAX_PATH	6
#endif
#define MAX_PNT_PATH	16
#define MAX_PNT_PATH12	16
#define N_KANSUU_TYPE	9 /*7-5-7-9 */
#define K_ZEN		0
#define K_STANDARD	1
#define K_OLD		2
#define K_ONLY_KANJI	3
#define K_HAN		4
#define K_COMMA_ZEN	5
#define K_COMMA_HAN	6
#define K_GIRISYA	7
#define K_MARU_SUUJI	8
#define MAX_EINF	4


#define	UDIC_CHG_HINDO	0x04
#define	UDIC_ADD	0x00
#define	UDIC_ADD_LAST	0x08


#define	GetActKoho(n)	(&w->koho1[(n)])
/*
 *	Yourei Field
 */
#if WINDOWS
#ifdef WIN32	/*+mk */
#define	YCARD_MAX		1024*4			/* Number of cards */
#else
#define	YCARD_MAX		1024+768			/* Number of cards */
#endif
#else
#define	YCARD_MAX		1024+512			/* Number of cards */
#endif
#define	L_YCARD		sizeof(YCARD)		/* Length of a scard 76 */

struct ycard {
	struct ycard PWINW	*nextcard;
	UCHAR	type;
	UCHAR	kaku;
	short	yno;
};
typedef	struct ycard	YCARD;

/*
 *	Koho card (CARD)
 */
struct fzk {
	UCHAR	len;
	UCHAR	daihyou;	/* VOICE & DAIHYOU KAKUJHOSHI */
};
typedef	struct fzk	FZK;

struct kcard {
	struct kcard PWINW	*nextcard;
	YCARD PWINW	*yfield;
	short	flg;
#if VJE95
	short	flg2;
#endif
	UCHAR	kcbno;
	UCHAR	hykno;
	UCHAR	hinsi;
	UCHAR	hinsi2;
	UCHAR	hindo;
	short/*UCHAR*/	nji;
	FZK		fzk[4];
	UCHAR	ji[CARD_JI_LEN];
};
typedef	struct kcard	KCARD;

/*
 *	Special Card (SCARD)
 */
struct scard {
	struct scard PWINW	*nextcard;
	YCARD PWINW	*yfield;
	short	flg;
#if VJE95
	short	flg2;
#endif
	UCHAR	kcbno;
	UCHAR	hykno;
	UCHAR	hinsi;
	UCHAR	hinsi2;
	UCHAR	hindo;
	short/*UCHAR*/	nji;
	FZK		fzk[4];
	UCHAR	ji[L_TANGO * 2];
};
typedef	struct scard	SCARD;

#if WINDOWS
struct mem_block {
	HANDLE	hMem;
	UCHAR PWIN *lp;
};
typedef struct mem_block MEM_BLK;
#endif

struct header_type {
	UCHAR			id_string[16];		/* ʸ */
	UCHAR			title[64];		/* Υȥ */
	UCHAR			version[16];		/* ΥС */
/*	UCHAR			copyright[64];		/ * ԡ饤 * / */
	unsigned char	copyright[48];	/* ԡ饤 */
	unsigned char	user_inf[16];	/* 桼 */
	UCHAR			make_date[16];		/*  */
	UCHAR			form_date[16];		/*  */
	UCHAR			edit_date[16];		/* ѹ */
	unsigned long	yomi_no;			/* ɤ */
	unsigned long	tango_no;			/* Ͽñ */
	unsigned long	sys_tango_no;		/* ƥϿñ */
	unsigned long	usr_tango_no;		/* 桼Ͽñ */
	USHORT			free_link;		/* ǽζ֥åؤΥ󥯾 */
	USHORT			block_no;			/* ѤƤ֥åο */
	USHORT			block_size;		/* ĤΥǡ֥å礭 */
	USHORT			data_pos;			/* ǡƬ */
	USHORT			index_size;		/* ǥå礭 */
	USHORT			index_pos;		/* ǥåƬ */
#if VJE95 /*+951025 */
	unsigned short	sys_yourei_limit;  /* ec-ed ƥֹκ */
	USHORT			filler1;
#else
	USHORT			filler1[2];
/*	unsigned short	dapa_pos_high;  / * ǡƬ־̥ * / */
/*	unsigned short	index_pos_high;	/ * ǥåƬ־̥ * / */
#endif
#if WIN32
	unsigned short code_type	: 4;/* ɼ */
	unsigned short sort_type	: 4;/*  */
	unsigned short field_byte	: 8;/* եΰХȿ */
	unsigned short record_byte	: 8;/* 쥳ΰΥХȿ */
	unsigned short filler2		: 8;
#else
	unsigned code_type		: 4;		/* ɼ */
	unsigned sort_type		: 4;		/*  */
	unsigned field_byte		: 8;		/* եΰΥХȿ */
	unsigned record_byte	: 8;		/* 쥳ΰΥХȿ */
	unsigned filler2		: 8;
#endif
	unsigned short	yourei_no;		/* f4-f5 */
	unsigned short	gak_yourei_no;	/* f6-f7 */
#if WIN32
	unsigned short usr_add_disable	: 1;/* 桼ñϿػߥե饰 */
	unsigned short sys_add_disable	: 1;/* ƥñϿػߥե饰 */
	unsigned short usr_del_disable	: 1;/* 桼ñػߥե饰 */
	unsigned short sys_del_disable	: 1;/* ƥñػߥե饰 */
	unsigned short rec_gak_disable	: 1;/* 쥳ñؽػߥե饰 */
	unsigned short bun_gak_disable	: 1;/* 쥳ɴñؽػߥե饰 */
	unsigned short ruigigo_flag	: 1;/* ե饰 */
	unsigned short filler5		: 9;
#else
	unsigned usr_add_disable	: 1;/* 桼ñϿػߥե饰 */
	unsigned sys_add_disable	: 1;/* ƥñϿػߥե饰 */
	unsigned usr_del_disable	: 1;/* 桼ñػߥե饰 */
	unsigned sys_del_disable	: 1;/* ƥñػߥե饰 */
	unsigned rec_gak_disable	: 1;/* 쥳ñؽػߥե饰 */
	unsigned bun_gak_disable	: 1;/* 쥳ɴñؽػߥե饰 */
	unsigned ruigigo_flag		: 1;/* ե饰 */
	unsigned filler5		: 9;
#endif
	unsigned long	max_index;			/* fa-fd */
	USHORT			check_sum;		/* å */
};

typedef	struct header_type	HEADER;

#if	USER_DIC
#if NEW_CASH
#if MAC
typedef unsigned char **HANDLE ;
typedef short WORD ;
#endif

struct cash {
short		DicRecord[MAX_DIC_YOMI]; /* MSB = 1:vusr.dic 0:vmain.dic */
short		DicOffset[MAX_DIC_YOMI]; /* MSB = Permanent record Bit 1 = LRU bit */
HANDLE	RecordBuf[MAX_DIC_YOMI];
};
typedef struct cash CASH;
#endif

/*
 *	Dictionary information
 */
struct dic_inf {
	UCHAR	srch_max ; /*WIN95:DIC srch_max */
	UCHAR	jimax; /*WIN95:DIC jiritugo yomi max */
	short	flg;	/*WIN95:DIC Access Mode */
#if MAC
	short	fd;
#else
	int	fd;
#endif
	short	same_user_dic;
	USHORT	dir_ptr_len;
	USHORT	dir_ptr_max;
	USHORT	PWINS1 *dir_ptr;

	USHORT	dir_len;
	UCHAR	PWINS2 *dir;
#if MOJI1_INDEX
	USHORT	PWINS1 *moji_ptr;
#endif
#if NEW_CASH
	CASH	cash;
	UCHAR PWIN	*CashPtr;
#if MAC					/* MacǤ,cashͭɤΥե饰Ȥƻ */
	UCHAR	hCash;
#else
	HANDLE	hCash;
#endif
#endif /* NEW_CASH */
#if DIC_BUFF
	UCHAR	PWINS2 *dic2; /* dictionary buffer 1024 * n */
	UCHAR	CurentCode[2];
	short	low_dic_rec;
	short	high_dic_rec;
#endif
	HEADER	head;
	UCHAR	dicname[128];
#if unix
	ino_t	inode;
#endif /* unix */
#if DLL_SRCH	/* add under 5 line by masa 30/Aug/93 */
	USHORT	current_read_ptr[3];	/* Current read pointer */
	USHORT	start_read_ptr[3];	/* Start read pointer */
	USHORT	end_read_ptr[3];	/* End read pointer */
	short	block_head;			/* offset of block head */
	UCHAR	save_yomi_end[65] ;
#endif
	short	StartLogicalRec;
	short	RecCount;
	short	dic_rec;
	UCHAR	dic1[TDIC_SIZE * 4 + 1]; /*84/10/15 BUGFIX*/
};
typedef	struct dic_inf	DIC_INF;
#endif

struct fnd_pos {
	USHORT	rec;
	USHORT	pos;
	UCHAR	match;
	UCHAR	ji;
	UCHAR	eiji;
};
typedef	struct fnd_pos	FND_POS;

struct	dirtb {
	USHORT	cnt;
	FND_POS	fnd[DIRTB_SIZE];
};
typedef	struct dirtb	DIRTB;

#if	USER_DIC
struct tango_cnt {
	short	yomi_no;
	short	tango_no;
	short	sys_tango_no;
	short	usr_tango_no;
};
typedef	struct tango_cnt	TANGO_CNT;
#endif
typedef	UCHAR	KCB_No;

struct	kcb_link_type {
	KCB_No	next;
	KCB_No	crnt;
	KCB_No	prev;
};
typedef	struct kcb_link_type	KCB_LINK;

struct	card_link_type {
	KCARD PWINW 	*next;
	KCARD PWINW 	*crnt;
	KCARD PWINW 	*prev;
	short		cnt;
};
typedef	struct card_link_type	CARD_LINK;

struct	ycard_link_type {
	YCARD PWINW 	*next;
	YCARD PWINW 	*crnt;
	YCARD PWINW 	*prev;
	short		cnt;
};
typedef	struct ycard_link_type	YCARD_LINK;

struct path_inf12 {
	KCARD	PWINW *card1;
	KCARD	PWINW *card2;
	short	kaku;
};
typedef	struct path_inf12	PATH_INF12;
struct	path12 {
	UCHAR	cnt;
	PATH_INF12	path[MAX_PNT_PATH12];
};
typedef	struct path12	PATH12;

struct path_inf {
	KCARD	PWINW *card1;
	KCARD	PWINW *card2;
	KCARD	PWINW *card3;
	short	kaku12;
	short	kaku23;
	short	yourei_no12;
	short	yourei_no23;
};
typedef	struct path_inf	PATH_INF;

struct	path {
	UCHAR	cnt;
	UCHAR	flg; /* 95/11/15 */
	PATH_INF	path[MAX_PNT_PATH];
};
typedef	struct path	PATH;

struct	pathwork {
#if WIN32
	PATH	p[MAX_PATHV];
#else
	PATH	p[MAX_PATH];
#endif
};
typedef	struct pathwork	PATHWORK;


/*
 *	(Koho)
 */
/* flg */
#define	BAD_YOMI_1JI		0x01 /* 1/2ʸȤ */
#define	BAD_YOMI_2JI		0x02 /*  */
#define	BAD_YOMI_3JI		0x04 /*  */
#define	BAD_YOMI_2ND		0x08 /* 2ʸܤƬʸѹ */
#define	BAD_YOMI_EI			0x10 /* ɤߤalphabetˤ */
#define KOHO_DEL_MLT_CARD	0x80

#define	BAD_YOMI_MASK		(BAD_YOMI_1JI|BAD_YOMI_2JI|BAD_YOMI_3JI)

struct	koho_lnk {
	USHORT	koho_max;			/* Koho max */
	USHORT	koho_cnt;			/* Koho counter */
	UCHAR	hindo_max;			/* hindo max */
	short/*UCHAR*/	bunpnt;			/* Bunsetu start point (jisho yomi code) */
	short/*UCHAR*/	yomipnt;		/* Bunsetu start point (yomi code) */
	short/*UCHAR*/	bunlen1;		/* Bunsetu length 1 */
	UCHAR	hinsi;			/* Yuusen hinshi number */
	KCB_LINK	kcbs;
	CARD_LINK	cards;
	UCHAR	blk;			/* Block counter */
	UCHAR	iblk;			/* Block counter initial value */
	UCHAR	flg;
	UCHAR	dic_no;
	PATH12	path;
	UCHAR	kakari_saki;
	UCHAR	pnt;
	short	uke_kaku;
	short	kaku;
	short	yourei_no;
};
typedef	struct koho_lnk	KH_LINK;

struct	koho_lnk2 {
	short/*UCHAR*/	bunpnt;			/* Bunsetu start point (jisho yomi code) */
	short/*UCHAR*/	yomipnt;		/* Bunsetu start point (yomi code) */
	short/*UCHAR*/	bunlen1;		/* Bunsetu length 1 */
};
typedef	struct koho_lnk2	KH_LINK2;

/*
 *	(KCB)
 */
struct	koho_cb {
	short	flg;
	UCHAR	dic_no;
	UCHAR	ji_yomi;
	UCHAR	ji_yomi_org;
	UCHAR	hira_yomi; /* rcä -> rch+ ji=1->3 hira_yomi=4 */
	UCHAR	eiji_yomi; /* rcä -> rch+ ji=1->3 eiji_yomi=2 */
	UCHAR	bad_len;
	UCHAR	bad_chr;
	UCHAR	max_len;
	KCB_LINK	kcbs;
	CARD_LINK	cards;
	CARD_LINK	honsoku;
};
typedef	struct koho_cb	KCB;

struct eva_inf {
	UCHAR	from;
	UCHAR	jimax;
};
typedef	struct eva_inf	EVA_INF;

struct	eva_blk {
	short	flg;
	UCHAR   maxpnt;
	UCHAR   bad_chr1;
	UCHAR   bad_chr2;
	UCHAR   bad_len2;
	UCHAR   bad_chr3;
	UCHAR   bad_len3;
	EVA_INF	e_inf[MAX_EINF];
	KCB_LINK	kcbs;
};
typedef	struct eva_blk	EVA_BLK;

#define	L_EVA	sizeof(EVA_BLK)
#define	L_EVA_INF	sizeof(EVA_INF)

struct	new	{
	unsigned long	yomi_no;
	unsigned long	tango_no;
	unsigned long	sys_tango;
	unsigned long	user_tango;
};
typedef	struct new	NEW;

struct	b	{
	UCHAR	nbun;
	UCHAR	bun1;
	UCHAR	bun2;
	UCHAR	bun3;
	UCHAR	jimax;
	UCHAR	hin1;
	UCHAR	hin2e;
	UCHAR	hin2s;
	UCHAR	hin3;
	UCHAR	pntmae;
	UCHAR	pnt12;
	UCHAR	pnt23;
	UCHAR	rank2;
	short	yourei_no;
};
typedef	struct b	B;

struct	blen	{
UCHAR	cnt;
UCHAR	highest_path_no;
UCHAR	flg;
#if WIN32
B		b[MAX_PATHV];
#else
B		b[MAX_PATH];
#endif
};
typedef	struct blen	BLEN;
/*
 *	BLEN Flag < flg >
 */
#define	B_MATUBI		0x01		/* MATUBI BUNSETU */


struct okf {
	UCHAR	f[L_YOMI][GHINSI_MAX];
};
typedef	struct okf	OKF;

struct	jitbl {
	UCHAR	ji1_cnj;
	UCHAR	ji2_cnj;
	UCHAR	gobi_flg;
	UCHAR	int_hin;
	UCHAR	gobi_no;
	UCHAR	gobi_grp;
	UCHAR	hin_len;
	UCHAR	imi;
};
typedef	struct jitbl	JITBL;

struct	hin_b2d {
	UCHAR	hin1;
	UCHAR	hin2;
};
typedef	struct hin_b2d	HIN_B2D;



struct	vjework {
HVJELIB	hd;
/*
 *	VJE mode
 */
short	conv_mode;
short	wCnvMode;
#if VJE95
short	wCnvMode2;
short	wRank;
#endif
/*
 *	VJE state control
 */
UCHAR	stg;
UCHAR	jimax;
/*UCHAR	u_srch_max;/ *WIN95:move Dicinf* / */
/*UCHAR	m_srch_max;/ *WIN95:move Dicinf* / */
UCHAR	maxjimax;
UCHAR	gakushuu;
short	vje_flag;
short	enb_atr;
#if	USER_DIC
UCHAR	utikesi;
#endif
WBUFF	hira_buf_Q;	//-[NUM_CHAR * 2 + 1];
WBUFF	yomi_buf_Q;	//-[NUM_CHAR * 2 + 1];
WBUFF	cur_yomi_Q;	//-[NUM_CHAR * 2 + 1]; /* 97/4/4 BUNL_MAX3 -> 96 */
WBUFF	PWIN *inbuf;
USHORT	PWIN *atrbuf;
BUFF	PWIN *keybuf;
#if LESS_FZK_CHK_BY_OKF
OKF okflg;	/* check flag, card number */
#endif
/*
 *	VJE henkanb control
 */
short	hb_loopcnt;
/*
 *	Koho block
 */
short	curbunno;
short	koho_bno;
#if MAC							/* MacǤϤʬĥƤ */
UCHAR	kakko_cnt[17];
UCHAR	kakko[17][34];
#else
UCHAR	kakko_cnt[9];
UCHAR	kakko[9][18]; /*  = "ʡ̡ΡСҡԡ֡ء" */
#endif
UCHAR	kansuu[N_KANSUU_TYPE];
UCHAR	kansuu2[N_KANSUU_TYPE];
SCARD   bunmatucard; /* 98/9/1 KCARD->SCARD */
/*KCARD PWINW *bunmatufzkcard; */
KH_LINK koho1[BUN_MAX + 2];
KH_LINK2 koho2[BUN_MAX + 2];
/*
 *	Koho evaluation block
 */
UCHAR	eva_max;
UCHAR	eva_max2;
UCHAR	eva_max3;
UCHAR	eva_cnt;			/* Jiritugo kensaku you */
UCHAR	eva_cnt2;			/* Fuzokugo kensaku you */
EVA_BLK eva[BUNL_MAX3];
BLEN	blen;
PATHWORK	px;
/*
 *	Koho control block
 */
KCB_No	empkcblnk;
KCB	c_kcb[KCB_MAX];
/*
 *	Koho card
 */
KCARD	PWINW *empcardlnk;
SCARD	PWINW *empscardlnk;
KCARD	c_kcard[KCARD_MAX];
SCARD	c_scard[SCARD_MAX];
YCARD	PWINW *empycardlnk;
YCARD	c_ycard[YCARD_MAX];
NEW	new;
#if USER_DIC
short   gdic_no;/*WIN95 */
short   odic_no;/*WIN95 */
short	udic_no;
DIC_INF	PWIND *udicinf;
DIC_INF	PWIND *sdicinf[MAX_SDIC+1];
#if DPMI || unix
OFDOSSTRUCT	OFuserstruct[MAX_SDIC + 1];
#if DPMI2
OFDOSSTRUCT	OFsdicstruct[MAX_SDIC + 1];
#endif
#else
#if WINDOWS
OFSTRUCT	OFuserstruct[MAX_SDIC + 1];
#endif
#endif
#endif
int	fd[MAX_SDIC+1];
short	open_flg[MAX_SDIC+1];/*951117 Update */
#if	PENDIC
	BUFF	yomi_atr_Q;	//-[NUM_CHAR * 2 + 1];
	BUFF	cur_atr_Q;	//-[NUM_CHAR * 2 + 1];
	short	wPenMode;
#endif
/*KIGO-TABLE */
KIGOTBL	wKigo ;
	/*981124 UNIX*/
#if PCUNIX
	BUFF	henkanb_inbuf;	//-[NUM_CHAR * 2 + 3];
	USHORT	henkanb_atrbuf[NUM_CHAR * 2 + 3];
	BUFF	henkanb_keybuf;	//-[NUM_CHAR * 2 + 3];
	BUFF	saihenkan_inbuf;	//-[NUM_CHAR * 2 + 3];
#endif
};
typedef	struct	vjework WORK;

#if OS2|unix
typedef	WORK	* PWORK;
#else
typedef	WORK PWIN	* PWORK;
#endif

#define	CLR_CARD_LNK(p)	((p)->next = (p)->crnt = (p)->prev = END_CARD)
#define	CLR_KCB_LNK(p)		((p)->next = (p)->crnt = (p)->prev = END_MARK)

/*
 *	Control Flag < flg >
 */
#define	EISUU_CNV		0x01
#define	BAD_JI			0x02
#define	BAD_JI2			0x04
#define	BAD_JI3			0x08
#define	FND_MAX_FZK		0x10
#define	FND_MAX_KNJNUM	0x20
#define	FND_MAX_NUM		0x40
#define	FND_MAX_JI		0x80

/*
 *	Mode Flag < mode >
 */
								/* Set	  :  Refer	: Reset  */
#define	ENB_SET		0x0001		/* henkan   : wr_jr_cd  : henkan */
#define	ENB_SEB		0x0002		/* henkan   :  : henkan */
#define	ENB_KNJ		0x0008		/* saihenkan: wt_jr_cd  :		*/
#if	USER_DIC
#define	MODE_UDIC	0x0010		/* srchknj  : wt_jr_cd  :		*/
#define	MODE_DEL	0x0020		/* srchknj  : wt_jr_cd  :		*/
#endif
#define	FULL_MATCH	0x0040		/* toku_henkan: srchknj :		*/
#if	PENDIC
	#define	MODE_RDIC	0x0080		/* FUJI */
#endif
#define MODE_BAD_2ND_1JI	0x0100 /* top char. of 2nd bunsetsu is boin */
#define MODE_BAD_2ND_2JI	0x0200 /* top char. of 2nd bunsetsu is shiin */
#define MODE_BAD_2ND_3JI	0x0400 /* top char. of 2nd bunsetsu is shiin */
#define MODE_BAD_YOMI_EITANGO	0x0800 /* eitango */
#define MODE_BAD_YOMI_EISUU		0x1000 /* eisuu touroku */
#define MODE_BAD_YOMI_HOSEI		0x2000 /* automatic correction */
#define MODE_EIGO			0x4000 /* 1st bunsetsu is changed to alphabet reading */
/*
 *	Kcb Flag < kcb[i].flg >
 */

#define	KCB_DONT_DEL		0x0001	/* arg_eva:   */
#define	KCB_OTHER			0x0002	/* saihenkan */
#define	KCB_HIRAGANA		0x0004	/* saihenkan */
#define	KCB_KATAKANA		0x0008	/* saihenkan */
#define	KCB_BAD_1ST_1JI		0x0010	/* wt_jr_cd  */
#define	KCB_BAD_1ST_2JI		0x0020	/* wt_jr_cd  */
#define	KCB_BAD_1ST_3JI		0x0040	/* wt_jr_cd  */
#define	KCB_BAD_2ND_1JI		0x0080	/* wt_jr_cd  */
#define	KCB_BAD_2ND_2JI		0x0100	/* wt_jr_cd  */
#define	KCB_BAD_2ND_3JI		0x0200	/* wt_jr_cd  */
#define	KCB_BAD_YOMI_EI		0x0400	/* wt_jr_cd  */
#define	KCB_FND_KNJNUM		0x0800	/* bunpou:   */
#define	KCB_FND_NUM			0x1000	/* bunpou:   */
#define	KCB_FND_KAKKO		0x2000	/* bunpou:   */
#define	KCB_FND_MAX_FZK		0x4000	/* bunpou:   */
#define	KCB_NOT_DIC_CARD	0x8000	/* add_vir_card   */

#define	KCB_BAD_MASK	(KCB_BAD_1ST_1JI|KCB_BAD_1ST_2JI|KCB_BAD_1ST_3JI|KCB_BAD_2ND_1JI|KCB_BAD_2ND_2JI|KCB_BAD_2ND_3JI|KCB_BAD_YOMI_EI)

/*
 *	Card Flag < card[i].hinsi2>
 */
#define	CARD_RU_KANOU		0x01 /* MIRERU */
#define	CARD_RERU_UKEMI		0x02
#define	CARD_SERU_SIEKI		0x04
#define	CARD_KD_RENTAI		0x04
#define	CARD_TADOUSHI		0x40
/*
 *	Card Flag < card[i].flg >
 */
#define	CARD_SPECIAL	0x8000
#define	CARD_FND_3JI	0x4000	/* wr_jr_cd: */
#define	CARD_FND_2JI	0x2000	/* wr_jr_cd: */
#define	CARD_FND_1JI	0x1000	/* wr_jr_cd: */
#define	CARD_FND_KATA	0x0800
#define	CARD_FND_TIME	0x0400
#define	CARD_FND_MONO	0x0200
#if	PENDIC
	#define	CARD_RDIC	0x0100 /* CARD_UDIC ƱǤΡ */
#endif
#if	USER_DIC
#define	CARD_UDIC		0x0100
#endif
#define	CARD_MOD_MASK	0x00e0
/*#define	CARD_RENYOU		0x0080 // saem as FZK_RENYOU */
/*#define	CARD_SHUUSHI	0x0040 // saem as FZK_SHUUSHI */
/*#define	CARD_RENTAI		0x0020 // saem as FZK_RENTAI */
#define	CARD_YOUREI_HIT	0x0010
#define	CARD_KYOYOU		0x000f

/*
 *	Card Flag < card[i].flg2 >
 */
#if VJE95
/* Don't change bit assign definition below */
#define	CARD_MOJISHU_MASK		0xfc00
#define	CARD_KATAKANA_ZEN	0x8000
#define	CARD_KATAKANA_HAN	0x4000
#define	CARD_EISUU_ZEN		0x2000
#define	CARD_EISUU_HAN		0x1000
#define CARD_KIGO_ZEN		0x0800
#define CARD_KIGO_HAN		0x0400
/* can be changed bit assign definition below */
#define	CARD_INVALID_KANJI	0x0080
#define	CARD_KYOYO_KUN		0x0040
#define	CARD_YURAGI			0x0020
#define	CARD_KYOYO_KIN		0x0010
#endif

/*
 *	Card Flag < card[i].hindo >
 */
#define	KOUHOU_MASK	0x07			/* kouhou counter mask */
#define	KOUHOU_MAX	0x07			/* kouhou counter max */
#define	HINDO_BIT_FLAG	0x0f			/* internal kouhou counter mask */
#define	DELETE_GAKU	0x40
#define	HIN_WORK	0x80

/*
 *	Card Fuzokugo length < card[i].fzk[] >
 */
/* fzk[].len */
#define	FZK_RENYOU		0x80
#define	FZK_SHUUSHI		0x40
#define	FZK_RENTAI		0x20
#define	FZK_LEN_MASK		0x1f
#define	FZK_SFT			5
/* fzk[].daihyou */
#define	FZK_TYPE_MASK		0x1f

/*
 *	Eva Flag < eva[i].flg >
 */
/*#define	EVA_BAD_1ST_1JI	0x0001 */
/*#define	EVA_BAD_1ST_2JI	0x0002 */
/*#define	EVA_BAD_1ST_3JI	0x0004 */
#define	EVA_BAD_2ND_1JI	0x0010
#define	EVA_BAD_2ND_2JI	0x0020
#define	EVA_BAD_2ND_3JI	0x0040
#define	EVA_BAD_NFZK	0x0100
#define	EVA_BAD_YOMI_EI	0x0200
#define	EVA_ENB_SEB		0x2000
#define	EVA_CHECKED		0x4000
#define	EVA_VALID		0x8000

#define	EVA_BAD_2ND_MASK	(EVA_BAD_2ND_1JI|EVA_BAD_2ND_2JI|EVA_BAD_2ND_3JI)


/*
 *	Jisho Hinshi Jouhou < jitb[i].flg >
 */
#define	NO_FUZOKU	0x80	/* GOBI N, G+FZK N, JIRITUGO Y */
#define	GOKAN_TAIGEN	0x40	/* GOBI ?, G+FZK Y, JIRITUGO Y */
#define	GOKAN_MIZEN	0x20
#define	GOKANKEI	0x08

#define	GOKAN_IIKIRI	0x02	/* GOBI Y, G+FZK N, JIRITUGO IIKIRI */
/*#define	RENYOU_TAIGEN	0x01 */

/*
 *	Komoji Check Parameter < chkomoji() >
 */
#define	SJI_DIC		(SJI_MATUBI|SJI_GF|SJI_G|SJI_F)
#define	SJI_XTU		0x20
#define	SJI_MATUBI	0x10
#define	SJI_PA		0x08
#define	SJI_GF		0x04
#define	SJI_G		0x02
#define	SJI_F		0x01

/*
 *	Katuyoukei Number < Gobi Table Flag >
 */
#define	ILEGAL_END	 0x40


/*
 *	Jisho Hinshi Number
 */
#define	KUGIRI_GAKU		0x00 /* DOUONGO GAKUSHUU */
#define	KEIYOU		0x01
#define	KEIYOU2		0x08
#define	KEIDOU		0x0b
#define	FUKUSHI	0x13
#define	SETUZOKU	0x1c
#define	JHOSUUSHI	0x1d
#define	KANDOU		0x1e
#define	SUU_JHO		0x1f
#define	MEISHI		0x20
#define	MEIKEI		0x21
#define	SJIMEISHI	0x22 /* DELTA */
#define	SMEISHI		0x23
#define	TOKU_KEIDOU	0x26
#define	MEI_BASHO	0x27
#define	MEI_JIN		0x28
#define	MEI_TATE	0x2a
#define	SUUSHI_TOKU	0x2c
#define	SUUSHI		0x2d
#define	KANSUUSHI	0x2e

#define	KYOYOU_HYOUKI			0x48
/* Kyoyou value */
#define	KYOYOU1			0x01
#define	KYOYOU2			0x02
#define	KYOYOU3			0x04
#define	KYOYOU12		0x03
#define	KYOYOU23		0x06
#define	KYOYOU_OKURI	0x08
#define	RENTAISHI		0x1b
#define	SAHEN_MEISHI		0x23
#define	KAKARI_YOUREI_FIELD		0x49
#define	UKE_YOUREI_FIELD		0x4a
#define	KAKARI_IMI_FIELD	0x4b
#define	UKE_IMI_FIELD		0x4c
#define	KAKARI_YOUREI_GAK_FIELD		0x4d
#define	UKE_YOUREI_GAK_FIELD		0x4e

#define	TANKANJI	0x4f
#define	GODAN_K		0x50
#define	GODAN_IKU	0x52
#define	GODAN_YUKU	0x53
#define	GODAN_G		0x54
#define	GODAN_S		0x56
#define	GODAN_T		0x58
#define	GODAN_N		0x5a
#define	GODAN_B		0x5b
#define	GODAN_M		0x5d
#define	GODAN_R		0x5f /* 93/12/20 old = 60 */
#define	GODAN_R_ARU	0x62
#define	GODAN_R_NASARU	0x63
#define	GODAN_W		0x64
/*#define	GODAN_WN	0x65 */
#define	K1DAN  		0x66
/*#define	K1DAN_MEI	0x67 */
#define	KAHEN		0x68
#define	SAHEN		0x69
#define	ZAHEN		0x6b
#define	SAHEN_SURU	0x6d
#define	H_CHOUMEI	0x6f
#define	H_CHIMEI	0x70
#define	H_SEI		0x71
#define	H_MEI		0x72
#define	H_SOSIKI	0x73
#define	H_KIGYOU	0x74
#define	H_SHOUHIN	0x75
#define	H_KOYUU		0x76
#define	DOUON_GAKU	0x77 /* DOUONGO GAKUSHUU GAMMA */
#define	H_GYOUSEI	0x7e
#define	USER_TOUROKU	0x7f /* USER HINSHI */

/*
 *	Jiritugo Setuzoku Bangou
 */
#define	C_OK		255

/*
 *	Kakari Code
 */
#define	C1_RENTAISI	0x00	/* 0 0x80 */
#define	C1_JHOSUU	0x01	/* 0 0x40 */
#define	C1_SUUSHI	0x02	/* 0 0x20 */
#define	C1_SETMEI	0x03	/* 0 0x10 MEISHI NI TUKU SETTOUGO */
#define	C1_SETSA 	0x04	/* 0 0x08 SAHEN MEISHI NI TUKU SETTOUGO */
#define	C1_SETDO 	0x05	/* 0 0x04 DOUSHI NI TUKU */
#define	C1_MEISHI1	0x06	/* 0 0x02 1 MOJI MEISHI NFZK */
#define	C1_SETCHI	0x07	/* 0 0x01 CHIMEI NI TUKU SETTOUGO */
#define	C1_SETJIN	0x08	/* 1 0x80 JINMEI NI TUKU SETTOUGO */
#define	C1_SET_O 	0x09	/* 1 0x40 O */
#define	C1_SET_GO	0x0a	/* 1 0x20 GO */
#define	C1_SETUBI	0x0b	/* 1 0x10 */
#define	C1_MEISHI3	0x0c	/* 1 0x08 3 MOJI MEISHI NFZK */
#define	C1_CHIMEI	0x0d	/* 1 0x04 */
#define	C1_SEI  	0x0e	/* 1 0x02 */
#define	C1_NAMAE	0x0f	/* 1 0x01 */

#define	C1_KANSUU_O	0x10	/* 2 0x80 DAI+nn */
#define	C1_KANSUU_D	0x11	/* 2 0x40 DAI */
#define	C1_KANSUU_S	0x12	/* 2 0x20 YAKU */
#define	C1_MEISHIF	0x13	/* 2 0x10 MEISHI + GA/DE/NI/HA */
#define	C1_MEISHI2	0x14	/* 2 0x08 2 MOJI MEISHI NFZK */
#define	C1_DOU_YOU	0x15	/* 2 0x04 DOUSHI RENYOUKEI */
#define	C1_RENYOU	0x16	/* 2 0x02 */
#define	C1_RENTAI	0x17	/* 2 0x01 */

#define	C1_MEISHI_NFZK	0x18	/* 3 0x80 4 MOJI IJYOU MEISHI NFZK */
#define	C1_SHUUSHI		0x19	/* 3 0x40 */
/*#define	C1_KATAKANA		0x1a	/ * 3 0x20 * / */
#define	C1_MEISHITO		0x1b	/* 3 0x10 MEISHI + TO/YA */
#define	C1_MEISHIWO		0x1c	/* 3 0x08 MEISHI + WO */
#define	C1_FUKUSHI		0x1d	/* 3 0x04 */
#define	C1_MEISHI		0x1e	/* 3 0x02 MEISHI */
#define	C1_GAKU			0x1f	/* 3 0x01 KUGIRI GAKUSHUU */

#define	C1_GYOUSEI		0x20	/* 4 0x80 */
#define	C1_CHOUMEI		0x21	/* 4 0x40 */
#define	C1_MEISHIHA		0x22	/* 4 0x20 */
#define	C1_KUTEN		0x23	/* 4 0x10 */

#define	C1_KEIYOU		0x28	/* */
#define	C1_KEIDOU		0x29	/* */
#define	C1_DOUSHI		0x2a	/* */

#define	C1P_MEISHI1		0x02	 /* hflg[0] */	 
#define	C1P_SET0		0x9d	 /* hflg[0] */	 
#define	C1P_SET1		0xe0	 /* hflg[1] */	 
#define	C1P_MEISHI3		0x08	 /* hflg[1] */	 
#define	C1P_SET2		0x10	 /* hflg[2] */	 
#define	C1P_MEISHI2		0x08	 /* hflg[2] */	 
#define	C1P_DOU_YOU		0x04	 /* hflg[2] */	 
#define	C1P_RENYOU		0x02	 /* hflg[2] */	 
#define	C1P_RENTAI		0x01	 /* hflg[2] */	 
#define	C1P_MEISHI_NFZK	0x80	 /* hflg[3] */	 
#define	C1P_SHUUSHI		0x40	 /* hflg[3] */	 
#define	C1P_FUKUSHI		0x04	 /* hflg[3] */	 
#define	C1P_MEISHI		0x02	 /* hflg[3] */	 
#define	C1P_GAKU		0x01	 /* hflg[3] */	 
#define	C1P_KUTEN		0x01	 /* hflg[4] */	 

/*
 *	Uke Code
 */
#define	C2_JHOSUU	0x80 + 0x00
#define	C2_SUUSHI	0x80 + 0x01
#define	C2_SETTOU	0x80 + 0x02
#define	C2_SEBJIN	0x80 + 0x03
#define	C2_SEBMEI	0x80 + 0x04
#define	C2_SEBSA 	0x80 + 0x05
#define	C2_SEBCHI	0x80 + 0x06
#define	C2_SEBDO 	0x80 + 0x07
#define	C2_SMEISHI 	0x80 + 0x08
#define	C2_CHIMEI 	0x80 + 0x09 
#define	C2_SEI		0x80 + 0x0a
#define	C2_NAMAE 	0x80 + 0x0b
#define	C2_KOYUU  	0x80 + 0x0c
#define	C2_MEISHI	0x80 + 0x0d
#define	C2_KEIYOU	0x80 + 0x0e
#define	C2_GYOUSEI	0x80 + 0x0f
#define	C2_CHOUMEI	0x80 + 0x10
#define	C2_TADOUSHI	0x80 + 0x11
#define	C2_KD		0x80 + 0x12
#define	C2_JIDOUSHI	0x80 + 0x13
#define	C2_MEISHI2	0x80 + 0x14
#define	C2_SUU_JHO	0x80 + 0x15
#define	C2_FUKUSHI	0x80 + 0x16
#define	C2_ARU		0x80 + 0x17
#define	C2_JIDOU_TAI	0x80 + 0x18

/*
 *	Naibu Hinsi Group Number
 */
#define	GRP_SETTOU		1	/* Recerve */
#define	GRP_SETUBI		2
#define	GRP_MEISHI		3

/*
 *	Naibu Hinsi Number
 */
#define	I_MEISHI		1	/* Hinshi_flg Meishi */
#define	I_KEIYOU		2	/* Hinshi_flg Keiyoushi */
#define	I_KEIDOU		3	/* Hinshi_flg Keiyoudoushi */
#define	I_1DAN			4	/* Hinshi_flg Kamiichi,shimoichi */
#define	I_GODAN_K		5	/* Hinshi_flg Godan kagyou */
#define	I_GODAN_G		6	/* Hinshi_flg Godan Gagyou */
#define	I_GODAN_S		7	/* Hinshi_flg Godan Sagyou */
#define	I_GODAN_T		8	/* TA RA WA A gyou */
#define	I_GODAN_N		9	/* NA BA MA gyou */
#define	I_KAHEN			10	/* Hinshi_flg Kahen */
#define	I_SAHEN			11	/* Hinshi_flg Sahen */
#define	I_ZAHEN			12	/* Hinshi_flg Zahen */
#define	I_RA_TOKU		13	/* Hinshi_flg Ragyou Tokushu */
#define	I_MEISHI_HITO	14	/* Hinshi_flg ̾ */
#define	I_NSAHEN  		15	/* Hinshi_flg Meishi + Suru */
#define	I_KD_TARI		16 	/* Hinshi_flg Keiyoudoushi */

/*
 *	Gobi Katuyou Bangou
 */
#define	G_KEIYOU	1
#define	G_KEIYOU2	2
#define	G_KD_TARI	3
#define	G_KEIDOU	4
#define	G_FUKUSHI	5
#define	G_NSAHEN	6
#define	G_GODAN_G	7
#define	G_GODAN_K	8
#define	G_GODAN_S	9
#define	G_GODAN_T	10
#define	G_GODAN_N	11
#define	G_GODAN_M	12
#define	G_GODAN_R	13
#define	G_GODAN_W	14
#define	G_GODAN_B	15
#define	G_1DAN  	16
#define	G_SAHEN 	17
#define	G_ZAHEN 	18
#define	G_KAHEN 	19
#define	G_YODAN_H 	20
#define	G_KANDOU 	21
#define	G_JHOSUU 	22
#define	G_GODAN_W2	23

/*
 *	Katuyou Kata Number (MAX 64)
 */
#define	MIZENKEI	(1  + 0x80)
#define	RENYOUKEI	(2  + 0x80)
#define	SHUUSHIKEI	(3  + 0x80)
#define	RENTAIKEI	(4  + 0x80)
#define	KATEIKEI	(5  + 0x80)
#define	YOU_KATEI	(6 + 0x80)
#define	TAIGEN		(7  + 0x80)
#define	GOKAN		(8  + 0x80)
#define	HENKEI1		(9  + 0x80)
#define	HENKEI2		(10 + 0x80)
#define	HENKEI3		(11 + 0x80)
#define	YOU_SHUU	(12 + 0x80)
#define	SHUU_GO		(13 + 0x80)
#define	MIZENKEI2	(14 + 0x80)
#define	YOU_HEN2	(15 + 0x80)

#define	SELF_GEN	(16 + 0x80)
#define	MI_YOU		(17 + 0x80)
#define	MI_KATEI	(18 + 0x80)
#define	MI_MEI		(19 + 0x80)
/*#define	YOU_KATEI	(20 + 0x80) */
#define	YOU_MEI		(21 + 0x80)
#define	YOU_HEN1	(22 + 0x80)
#define	TAI_HEN2	(23 + 0x80)
#define	YOU_HEN3	(24 + 0x80)
#define	YOU_GEN		(25 + 0x80)
#define	YOU_SHUU_KATEI	(26 + 0x80)
#define	SHUU_KATEI	(27 + 0x80)
#define	SHUU_MEI	(28 + 0x80)
#define	SHUU_TAI	(29 + 0x80)
#define	GOKAN_RENTAI	(30 + 0x80)
#define	KATEI_MEI	(31 + 0x80)
#define	KATEI_HEN1	(32 + 0x80)
#define	KATEI_HEN3	(33 + 0x80)
#define	MEIREIKEI	(34 + 0x80)
#define	KATEI_HEN2	(35 + 0x80)

#define	MI2_KATEI	(37 + 0x80)
#define	RENTAIKEI2	(38 + 0x80)
#define	RENTAI12	(39 + 0x80)
#define	SHUU_TAI2	(40 + 0x80)
#define	SHUU_HEN1	(41 + 0x80)
#define	SHUU_HEN2	(42 + 0x80)
#define	YOU_GO		(43 + 0x80)
#define	MI_SHUU		(44 + 0x80)
#define	O_YOU		(45 + 0x80)
#define	YOU_SHUU_TAI	(46 + 0x80)
#define	YOU_KA_HEN1		(47 + 0x80)
#define	O_YOU_MI		(48 + 0x80)
#define	YOU_HEN2_GO	(49 + 0x80)
#define	YOU_SHUU_GO	(50 + 0x80)
#define	MI_SHUU_KATEI	(51 + 0x80)
#define	YOU_SHUU_HEN2	(52 + 0x80)
#define	YOU_SHUU_MEI	(53 + 0x80)
#define	O_YOU_YOU		(54 + 0x80)
#define	O_YOU_TAI		(55 + 0x80)
