/*
**	VJE Delta
**
**			wtango.c
**
*/
#include	"common.h"
/*#include	"vje.h"
#include	"wvje.h"
#include	"wbebuf.h"*/
#include	"basicedt.h"
#include	"wfncdef.h"

#define	DEBUG_AI	0
#if DEBUG_AI
#include	"windows.h"
#include	"vjelib.h"
#include	"vfncdef.h"
#include	"vyr.h"
#endif

#ifdef	CPM68K
#include	"trename.h"	/* function name rename for CP/M-68K */
#endif

/*
 *	Tango Sentaku
 *	p:
 *	  0         : henkan
 *	  1         : henkan & hyouji sentaku
 *	  2         : bunsetu idou
 *	  3         : UNDO case
 *	Return
 *	
 */
void FTYPE HenkanAndSentaku(pbe,bdata, p)
PBEBUF	pbe;
PBD	bdata;
short	p;
{
	REG1 short	err;
	UCHAR	fnc;
/*	short	len1, len2;*/
	BUFF	work;	//-[NUM_CHAR * 2 + 1 + 2];
	short	sav_yomi_len;

/*8/10*/short	flg;
	short	len;	/*94/10/21 */
	short	key_pos1,key_pos2,key_haba;	/*95/1/13 */

	switch(pbe->wTangoStage) {
/*-------------------------------------------------------------------*/
case 0:	/* INITIAL STAGE */
		pbe->lenSaiYomi = pbe->lenSaiYomiTotal = 0;
		pbe->main_stg = PRC_CNV;
		pbe->CnvKeyCnt = 0;
/*TEST*/	pbe->CnvAaCnt = 0;
/*4/17*/	pbe->KataWXFlag = 0;
		switch(p) {
	case 1:
			pbe->main_stg = PRC_DON;
	case 0:

#if	PENWIN
			if ( pbe->PenInpFlag == 0 ) {
#endif
			if (bdata->wDispListBox == 1)
				pbe->main_stg = PRC_DON;
#if	PENWIN
			}
			if (bdata->wDispListBox != 1)
#endif
			pbe->CnvKeyCnt = 1;
			pbe->KugiriHenkou = 0;
			pbe->edit |= H_CNV;
			break;
	default:
			break;
		};
#if	PENWIN
	if ( pbe->PenInpFlag == 1 )
		goto skip_check ;
#endif
/*1/13	if (pbe->KutenMode == 1) */
		if (SLength(pbe->key_buf_Q) > 1)
			flg = 1;
		else
			flg = 0;
/*1/13	else */
/*1/13		flg = 1; */
/*8/10		if (Length(pbe->key_buf_Q) > 1 && (pbe->key_buf_Q[1] == 0x2e || pbe->key_buf_Q[1] == 0xa1)) { */
/*8/10*/	if (flg == 1 && (pbe->key_buf_Q.str[1] == 0x2e || pbe->key_buf_Q.str[1] == 0xa1)) {
			pbe->toku = 1;
			chg_sdic(pbe->hVjeLib,-1);
			pbe->OptDic = -1;
/* <------ 93/9/16 K.H */
/*			clr_cnv_buf(pbe); */
/*			set_cnv(pbe,0); */
/*			set_pos(pbe,(short)Length(pbe->kihon_buf_Q)); */
/*			if (pbe->kihon_buf_Q[1] == 0x2e || pbe->kihon_buf_Q[1] == 0xa1) */
/*				cnv_code(pbe,bdata, CNV_ZEN); */
			if (p == 2 || p == 3)
				;
			else {
				han_zen(&pbe->kihon_buf_Q, &work); /* 93/9/16 K.H */
				kata_hira(&work, &pbe->in_buf_Q); /* 93/9/16 K.H */
				pbe->kihon_cnvted = 0; /* 93/9/16 K.H */
				clear(pbe->hVjeLib);    /* 93/9/16 K.H */
				pbe->edit |= H_EDIT;   /* 93/9/16 K.H */
				pbe->chg_kihon = 0;    /* 93/9/16 K.H */
			}
/*			pbe->chg_kihon = make_inbuf(pbe,0, bdata); */
/* 93 9/16 K.H ------> */
			if (pbe->edit & H_CNV) {
				err = toku_henkanm(pbe,&pbe->in_buf_Q, bdata);
				pbe->edit &= ~H_CNV;
				if (err == -1) {
					clr_cnv_buf(pbe);
					pbe->main_stg = PRC_INPUT;
					break;
				}
			} /* 93/2/4*/
			koho_all(pbe);
		}
		else {
#if	PENWIN
	skip_check :
#endif
			pbe->toku = 0;
			set_loop_mode(pbe,bdata); /*Option DIC*/
			if (p == 3) /*UNDO case */
				;
			else if (p == 2 && 
/* not use inbuf 97/3/22/ *Length(pbe->kihon_buf_Q) == Length(pbe->in_buf_Q) &&* / */
/*BUGFIX 95/2/14*/		pbe->kihon_cnvted == SLength(pbe->kihon_buf_Q))
				pbe->edit &= ~H_EDIT;
			else {
				pbe->chg_kihon = make_inbuf(pbe,1, bdata);
				sav_yomi_len = SLength(pbe->kihon_buf_Q); /* 97/3/22 */
				err = callvje(pbe,bdata);
				if (err == 0) {
					clr_cnv_buf(pbe);
					pbe->main_stg = PRC_INPUT;
					err = -1;
					break;
				}
/* 97/3/22 */
				if (SLength(pbe->kihon_buf_Q) != sav_yomi_len)
					pbe->kihon_cnvted = SLength(pbe->kihon_buf_Q);
			}  /* 93/2/4*/
			koho_all(pbe);
			if (pbe->k_r.bun_cnt >= pbe->k_r.max_bun) {
				pbe->k_r.bun_cnt = pbe->k_r.max_bun;
				pbe->kihon_cnvted = pbe->k_r.total_yomi;
				set_cnv(pbe,pbe->kihon_cnvted);
				err = -1;
				pbe->main_stg = PRC_INPUT;
				break;
			}
		}
		make_menu( pbe,bdata );
		pbe->wTangoStage = 1;
		err = -2;
		break;
/*-------------------------------------------------------------------*/
case 1: /* HENKAN CHUU */
		fnc = (UCHAR)bdata->wVkey;
		set_cnv(pbe,pbe->k_r.koho[pbe->k_r.bun_cnt].yomi_pnt - 1);
		set_pos(pbe,next_yomi_pnt(pbe,pbe->k_r.bun_cnt) - 1);
		err = TangoSentaku(pbe,bdata);
#if 1/*KOHOSORT*/
		pbe->koho_pos = pbe->donsort.kno[pbe->menu_t[pbe->menu_cnt] + pbe->offset - 1];
#else
		pbe->koho_pos = pbe->menu_t[pbe->menu_cnt] + pbe->offset - 1;
#endif
		set_koho(pbe->hVjeLib, pbe->koho_pos);
ATO_SHORI:
		if (err == -2) {
			koho_all(pbe);
/*94/4/6*/		pbe->kihon_cnvted = pbe->k_r.total_yomi;
/*94/4/6*/		make_menu( pbe,bdata );
			break;
		}
		switch(err) {
	case 0:	/* BUNSETU IDOU */
			if (pbe->cnv_mod == 2 && fnc == F_CHR)
				pbe->fUnget = 1;
			pbe->main_stg = PRC_INPUT;
			break;
	case 1:	/* KAKUTEI */
			pbe->kaku_req = 2;
			pbe->sav_out_cnt = set_kakutei(pbe,bdata);
			goto CMN15;
	case 6 : /* ATOK 1 MOJI KAKUTEI */
			SLength(pbe->out_buf_Q) = 0;
			clr_dsp_buf(bdata);
			bdata->wDataStatus |= VJE_RESULT;
			bdata->wDataUpdate |= VJE_RESULT;
			goto CMN15;
	case 5: /* MOJI NYUURYOKU DE KAKUTEI */
			pbe->sav_out_cnt = set_kakutei(pbe,bdata);
			pbe->kaku_req = 0;
			clear(pbe->hVjeLib);
			clear_buf(pbe,bdata);
	CMN15:
			clr_dsp_buf(bdata);
/*94/10/25 Return ˥꿶Ƥʤꤷ RC_IGNORED ֤ */
			if (fnc == F_CHR || fnc == F_CTRL)
/*			if (fnc == F_CHR ) */
				pbe->fUnget = 1;
			pbe->main_stg = PRC_EMP;
			break;
	case 3:	/* Shift ESC */
			pbe->kaku_req = 2; /* 91/2/7 */
	case 2: /* BS/DEL */
			cansub( pbe,bdata );
			break;
	case 4: /* ESC */
			len = SLength(pbe->kihon_buf_Q);
			key_pos2 = get_pos1(pbe,len);
			key_pos1 = get_pos1(pbe,SLength(pbe->kihon_buf_Q));
			if (key_pos1 > key_pos2)
				key_haba = key_pos1 - key_pos2;
			else
				key_haba = 0;
			set_pos(pbe,SLength(pbe->kihon_buf_Q)); /* 93/9/16 K.H */

			if (pbe->chg_kihon && !(pbe->edit & H_EIGO)) { /* 97/7/25 */
				set_cnv(pbe,0);
				if (pbe->chg_kihon & 0x01)
					cnv_code(pbe,bdata, CNV_ZEN|CNV_KUTEN);
				cnv_code(pbe,bdata, (pbe->chg_kihon & 0xfe)|CNV_KUTEN);
			}
			set_pos(pbe,get_kpos(pbe,-key_haba));
			clr_cnv_buf(pbe);
			if (pbe->KugiriHenkou) {
				clear(pbe->hVjeLib);
				clear_bunmatu_inf(pbe->hVjeLib);
				pbe->ESCFlag = 0;
			}
			else {
				if (chk_gakushuu(pbe->hVjeLib))
					clear(pbe->hVjeLib);
				else
					clear_cnt(pbe->hVjeLib);
				pbe->ESCFlag = 1;
			}
			make_inbuf(pbe,0, bdata);
			pbe->main_stg = PRC_INPUT;
			break;
	case 7: /* VJE OFF */
			scrn_norm( pbe,bdata );
			pbe->main_stg = PRC_EMP;
			break;
	case 8:
	case 9:
	case 10:
			goto SAIHENKAN_CASE;
		};
		pbe->wTangoStage = 0;
		break;
/*---------------------------------------------------------------*/
case 2:
SAIHENKAN_CASE:
		(void)make_inbuf(pbe,0, bdata); /* 97/4/2 for eitango */
		pbe->main_stg = PRC_RCNV;
		err = SaihenkanShori(pbe,bdata, err - 9);
		if ( err == -2)
			break;
		koho_all(pbe);
		pbe->kihon_cnvted = pbe->k_r.total_yomi;
		make_menu( pbe,bdata );
		if (err == 2) { /* BUNSETU GA NAKUNATTA */
			if (pbe->k_r.max_bun == 0 || pbe->k_r.max_bun == pbe->k_r.bun_cnt) {
			/* MIHENKAN MOJIRETU NO SENTOU HE (BUNSETU SUU 0) */
				Keizoku(pbe); 
				err = 0;	/* 89/1/12 */
			}
			else {
				err = -2;
				pbe->main_stg = PRC_CNV;
			}
		}
		else if (err == 5) {
			(void) ji_bunsetu(pbe->hVjeLib);
			pbe->main_stg = PRC_CNV;
			if (pbe->k_r.bun_cnt + 1 >= pbe->k_r.max_bun) {
				koho_all(pbe);
				Keizoku(pbe); /* MIHENKAN MOJI NO SENTOU HE */
				err = 0;
			}
			else {
				koho_all(pbe);
				make_menu( pbe,bdata );
				err = -2;
			}
		}
		else if ( err == 0 ) {
			err = -2;
			pbe->main_stg = PRC_CNV;
		}
		else if ( err == 6 ) {
			err = -2;
			pbe->main_stg = PRC_DON;
		}
		goto ATO_SHORI;
		break;
	}
#if 1/*KOHOSORT*/
	if (!(pbe->main_stg & PRC_DON)) {
		pbe->koho_mode = KOHO_SORT_NORMAL;
	}
#endif
	disp_menu(pbe,bdata);
	if (!((err >= 1 && err <= 3) || err == 5 || err == 7 || err == 6))
		disp_koho(pbe,pbe->lenSaiYomi, pbe->lenSaiYomiTotal, bdata);
}

/*
 *	Select koho
 *	err -2      : continue;
 *      -1      : error
 *	     0      : keizoku (cursor right)
 *	     1      : kakutei (NFER)
 *	     2      : mojiretu nasi (BS/DEL)
 *	     3      : zenbu cancel (Shift ESC)
 *	     4      : yomi ni modosu
 *	     5      : kakutei (BY MOJI NYUURYOKU)
 *	     7      : VJE off
 *       8      : Saihenkan mijikaku
 *       9      : Saihenkan ESC
 *      10      : Saihenkan nagaku
 */
global short FTYPE
TangoSentaku( pbe,bdata )
PBEBUF	pbe;
PBD	bdata;
{
	UCHAR	fnc;
	short	chr, mode, err;
	REG2 short	len;
	short	i;
	short	j;
	BUFF	ResultWork;	//-[NUM_CHAR * 2 + 1];
	short	stg ;

	err = -2;
	switch ( fnc = (UCHAR)bdata->wVkey ) {
	case F_LEFT:
		if (zen_bunsetu(pbe->hVjeLib) == -1)
			break;
		goto BUN_IDOU_CMN;
	case F_RIGHT:
JIBUNSETU:
/*990920 ХåեСեк*/
/*       ѴϤǤƤ뤬ХåեСƤ */
/*	 Ĺ 0 byteˤʤäƤ롣				  */
/*	 ʸ᤬Сեʸλϰưʤ褦ˤ */
		if (pbe->k_r.koho[pbe->k_r.bun_cnt + 1].hyk_len == 0 &&	
		    pbe->k_r.koho[pbe->k_r.bun_cnt + 1].hyk_pnt != 0)
			break;	
/*990920*/
		(void) ji_bunsetu(pbe->hVjeLib);
		if (pbe->k_r.bun_cnt + 1 >= pbe->k_r.max_bun) {
			koho_all(pbe);
			Keizoku(pbe); /* MIHENKAN MOJI NO SENTOU HE */
			err = 0;
			break;
		}
BUN_IDOU_CMN:
		if (pbe->toku == 0 && pbe->OptDic != -1)
			set_loop_mode(pbe,bdata);
		pbe->main_stg = PRC_CNV;
		pbe->CnvKeyCnt = 0;
		pbe->CnvAaCnt = 0;
		pbe->KataWXFlag = 0;
		koho_all(pbe);
		make_menu( pbe,bdata );
		break;
	case F_CNV_BBLK:
	case F_CNV_BBLK1:
	case F_CNV_BBLK_ATK:
		set_loop_mode(pbe,bdata);
FNC_UP:
		if (pbe->menu_cnt == 1) {
				if ((i = zen_block(pbe->hVjeLib)) != 0) {
					koho_all(pbe);
					pbe->kihon_cnvted = pbe->k_r.total_yomi;
#if 1/* always 1Page up */
#if 1/*KOHOSORT*/
					pbe->koho_mode = KOHO_SORT_NORMAL;
					/*991130*/
					get_douon(pbe->hVjeLib,&pbe->don);
					create_douon(pbe);
					i = pbe->donsort.kno[pbe->k_r.koho[pbe->k_r.bun_cnt].max_koho];
#else
					i = pbe->k_r.koho[pbe->k_r.bun_cnt].max_koho;
#endif
					set_koho(pbe->hVjeLib, i);
					pbe->k_r.koho[pbe->k_r.bun_cnt].koho_cnt = i - 1;
#else
					set_koho(pbe->hVjeLib, 1);
					pbe->k_r.koho[pbe->k_r.bun_cnt].koho_cnt = 0;
#endif/**/
#if PCUNIX
					bdata->cLBItemNumMax = /*255*/DOU_MAX;
#endif
					make_menu( pbe,bdata );
					pbe->KugiriHenkou = 1;
				}
				else
					break;
		}
		else
			--pbe->menu_cnt;
		pbe->off_max = pbe->menu_t[pbe->menu_cnt + 1] - pbe->menu_t[pbe->menu_cnt];
#if PCUNIX
		if (fnc == F_CNV_BBLK && bdata->cLBItemNumMax != /*255*/DOU_MAX)
#else
		if (fnc == F_CNV_BBLK)/* Limit mode */
#endif
			pbe->offset = 1;
		else
			pbe->offset = pbe->off_max;
		break;
	case F_CNV_NBLK:
	case F_CNV_NBLK1:
	case F_CNV_NBLK_ATK:
	case F_ATOK_CNV:
		set_loop_mode(pbe,bdata);
		if (pbe->main_stg == PRC_CNV) {
			pbe->main_stg = PRC_DON;
			break;
		}
FNC_DOWN:
		if (pbe->menu_cnt >= pbe->menu_t[0]) {
				if (ji_block(pbe->hVjeLib) != 0) { /* 94/1/17 K.H */
#if 1/*KOHOSORT*/
					pbe->koho_mode = KOHO_SORT_NORMAL;
					/*991130*/
					get_douon(pbe->hVjeLib,&pbe->don);
					create_douon(pbe);
#endif
					koho_all( pbe);
					pbe->kihon_cnvted = pbe->k_r.total_yomi;
#if PCUNIX
					bdata->cLBItemNumMax = /*255*/DOU_MAX;
#endif
					make_menu( pbe,bdata );
					pbe->KugiriHenkou = 1;
				} /* 94/1/17 K.H */
		}
		else {
			++pbe->menu_cnt;
			pbe->offset = 1;
			pbe->off_max = pbe->menu_t[pbe->menu_cnt + 1] - pbe->menu_t[pbe->menu_cnt];
		}
		break;
	case F_CNV_NKOHO:
		goto CNV_NKOHO_CMN;

	case F_FUKUGOU:
		if (set_fukugou(pbe,bdata) == 0) {
			len = pbe->k_r.koho[pbe->k_r.bun_cnt].yomi_len ;
			(void)saihenkan(pbe->hVjeLib, &pbe->in_buf_Q, 1, len, len, S_SRCH_DIC);
			koho_all( pbe);
			make_menu( pbe,bdata );
			pbe->main_stg = PRC_CNV;
			break ;
		} else
			goto F_CNV_CMN ;
	case F_CNV_OPT1:
	case F_CNV_OPT2:
	case F_CNV_OPT3:
	case F_CNV_OPT4:
	case F_CNV_OPT5:
	case F_CNV_OPT6:
	case F_CNV_OPT7:
	case F_CNV_OPT8:
	case F_CNV_OPT9:
	case F_CNV_OPT10:
		if (pbe->toku == 1)
			break;
		set_fukugou(pbe,bdata);
		if (pbe->OptDic == -1 || pbe->OptDic != (SHORT)(bdata->wVkey - F_CNV_OPT1 /*+ 1*/)) {
			set_loop_mode(pbe,bdata);
			len = pbe->k_r.koho[pbe->k_r.bun_cnt].yomi_len ;
			(void)saihenkan(pbe->hVjeLib, &pbe->in_buf_Q, 1, len, len, S_SRCH_DIC);
			koho_all( pbe);
			make_menu( pbe,bdata );
			pbe->main_stg = PRC_CNV;
			break ;
		} else
			goto F_CNV_CMN ;
	case F_CNV:
	case F_CNV1:
	case F_CNV_ATK:
		if (pbe->toku == 1)
			goto F_CNV_CMN;
		if (pbe->OptDic != -1 || set_fukugou(pbe,bdata) == 0) { /* Option Henkan */
			set_loop_mode(pbe,bdata);
			if (fnc == F_CNV_ATK) /*BUG */
				goto F_CNV_CMN;
			len = pbe->k_r.koho[pbe->k_r.bun_cnt].yomi_len ;
			(void)saihenkan(pbe->hVjeLib, &pbe->in_buf_Q, 1, len, len, S_SRCH_DIC);
			koho_all( pbe);
			make_menu( pbe,bdata );
			pbe->main_stg = PRC_CNV;
			break ;
		}
	case F_CNV_NCNV:
	case F_CNV_NCNV1:
	case F_CNV_NCNV_ATK:
F_CNV_CMN:
		pbe->CnvAaCnt = 0;
		if (pbe->main_stg == PRC_CNV) {
			if (++pbe->CnvKeyCnt == bdata->wDispListBox) {
				pbe->CnvKeyCnt = 0;
				pbe->main_stg = PRC_DON;
			}
		}
CNV_NKOHO_CMN:
		if (pbe->k_r.bun_cnt >= pbe->k_r.max_bun)
			break;
		if (pbe->offset >= pbe->off_max)
			goto FNC_DOWN;
		else
			++pbe->offset;
		break;

	case F_KOHOMAX:
		if (pbe->main_stg == PRC_CNV) {
			pbe->main_stg = PRC_DON;
		}
		break;

	case F_CNV_BKOHO:
		goto CNV_BKOHO_CMN;
	case F_CNV_BCNV:
	case F_CNV_BCNV1:
	case F_CNV_BCNV_ATK:
		set_loop_mode(pbe,bdata);
CNV_BKOHO_CMN:
		if (pbe->offset == 1)
			goto FNC_UP;
		--pbe->offset;
		break;
		/* Bunsetu idou */
	case F_RLIM: /* Bunsetu right limit */
	case F_RLIM2: /* WIN95 */
		pbe->main_stg = PRC_CNV;
		pbe->CnvKeyCnt = 0;
		pbe->CnvAaCnt = 0;
		pbe->KataWXFlag = 0;
		if (fnc == F_RLIM) {
			set_koho_bno(pbe->hVjeLib, pbe->k_r.max_bun);
			Keizoku2(pbe); /* BUNMATU HE */
			err = 0;
		} else {
			/*WX,ATOK ʸư */
			set_koho_bno(pbe->hVjeLib, pbe->k_r.max_bun - 1);
			set_cnv(pbe,pbe->kihon_cnvted2 = pbe->kihon_cnvted = pbe->k_r.total_yomi);
			set_pos(pbe,pbe->k_r.koho[i].yomi_pnt - 1);
			pbe->k_r.bun_cnt = pbe->k_r.max_bun - 1 ;
		}
		break;
	case F_LLIM: /* Bunsetu left limit */
		set_koho_bno(pbe->hVjeLib, 0);
		pbe->main_stg = PRC_CNV;
		pbe->CnvKeyCnt = 0;
		pbe->CnvAaCnt = 0;
		pbe->KataWXFlag = 0;
		koho_all(pbe);
		make_menu( pbe,bdata );
		break;
/* BS & DEL */
	case F_BS:
#if DEBUG_AI
{
UCHAR	buf[80];
PWORK	w;
	w = GetWork(pbe->hVjeLib);
	if (w->koho_bno == 0) {
		if (w->koho1[w->koho_bno].yourei_no == 0) {
			MessageBox(NULL,"\x97\x70\x97\xe1\x82\xcd\x82\xa0\x82\xe8\x82\xdc\x82\xb9\x82\xf1","\x97\x70\x97\xe1\x8f\xee\x95\xf1",MB_OK);
			goto CANCEL_ALL;
		}
		if (w->koho1[w->koho_bno].kaku & Y_KAKARI)
			lstrcpy(buf, w->koho1[w->koho_bno].cards.next->ji);
		else
			lstrcpy(buf, w->koho1[w->koho_bno + 1].cards.next->ji);
		if (w->koho1[w->koho_bno].kaku & Y_RENSETU)
			lstrcat(buf, " (");
		else
			lstrcat(buf, " [");
		switch (w->koho1[w->koho_bno].kaku & Y_KAKU_MASK) {
case	0:
			lstrcat(buf, "-");
			break;
case	Y_GA:
			lstrcat(buf, "\x82\xaa");
			break;
case	Y_WO:
			lstrcat(buf, "\x82\xf0");
			break;
case	Y_NI:
			lstrcat(buf, "\x82\xc9");
			break;
case	Y_HE:
			lstrcat(buf, "\x82\xd6");
			break;
case	Y_DE:
			lstrcat(buf, "\x82\xc5");
			break;
case	Y_TO:
			lstrcat(buf, "\x82\xc6");
			break;
case	Y_YORI:
			lstrcat(buf, "\x82\xe6\x82\xe8");
			break;
case	Y_KARA:
			lstrcat(buf, "\x82\xa9\x82\xe7");
			break;
case	Y_MADE:
			lstrcat(buf, "\x82\xdc\x82\xc5");
			break;
case	Y_NO:
			lstrcat(buf, "\x82\xcc");
			break;
case	Y_TARU:
			lstrcat(buf, "\x82\xbd\x82\xe9");
			break;
case	Y_I	:
			lstrcat(buf, "\x82\xa2");
			break;
case	Y_NA:
			lstrcat(buf, "\x82\xc8");
			break;
case	Y_SURU:
			lstrcat(buf, "\x82\xb7\x82\xe9");
			break;
case	Y_GA2:
			lstrcat(buf, "\x82\xaa\x82\x51");
			break;
default:
			lstrcat(buf, "\x81\x48");
			break;
		};
		if (w->koho1[w->koho_bno].kaku & Y_RENSETU)
			lstrcat(buf, ")");
		else
			lstrcat(buf, "]");
		if (w->koho1[w->koho_bno].kaku & Y_HANTAI_FUKA)
			lstrcat(buf, "*/ ");
		else
			lstrcat(buf, "/ ");
		if (w->koho1[w->koho_bno].kaku & Y_KAKARI)
			lstrcat(buf, w->koho1[w->koho_bno + 1].cards.next->ji);
		else
			lstrcat(buf, w->koho1[w->koho_bno].cards.next->ji);
		MessageBox(NULL,buf,"\x97\x70\x97\xe1\x8f\xee\x95\xf1",MB_OK);
		goto CANCEL_ALL;
	}
}
#endif
#if 0	/*#ifndef	UCS/*XKP-UNICODE*/
		if ((i = koho_bs_del(pbe->hVjeLib, (short)pbe->k_r.bun_cnt, 0)) != -1) {
			if (i == 0) {
				del_bunsetu(pbe,pbe->k_r.bun_cnt - 1, bdata);
				pbe->edit |= H_EDIT;
			}
			if (Length(pbe->kihon_buf_Q) == 0)
				err = 2;
		}
#endif
		koho_all( pbe);
		make_menu( pbe,bdata );
		pbe->main_stg = PRC_CNV; /* 91/1/9 */
		pbe->CnvKeyCnt = 0;
		pbe->CnvAaCnt = 0;
		pbe->KataWXFlag = 0;
		break;
	case F_DEL:
		if (pbe->k_r.max_bun != 0) {
#if 0	/*#ifndef	UCS/*XKP-UNICODE*/
			if (koho_bs_del(pbe->hVjeLib, (short)pbe->k_r.bun_cnt, 1) == 0) {
				del_bunsetu(pbe,pbe->k_r.bun_cnt, bdata);
				pbe->edit |= H_EDIT;
				if (Length(pbe->kihon_buf_Q) == 0)
					err = 2;
				else if (pbe->k_r.max_bun == 0 || pbe->k_r.max_bun == pbe->k_r.bun_cnt) {
/* MIHENKAN MOJIRETU NO SENTOU HE (BUNSETU SUU 0) */
					Keizoku(pbe); 
					err = 0;
				}
			}
#endif/*XKP-UNICODE*/
			pbe->main_stg = PRC_CNV;
			pbe->CnvKeyCnt = 0;
			pbe->CnvAaCnt = 0;
			pbe->KataWXFlag = 0;
		}
		koho_all(pbe);
		make_menu( pbe,bdata );
		pbe->main_stg = PRC_CNV; /* 91/1/9 */
		pbe->CnvKeyCnt = 0;
		pbe->CnvAaCnt = 0;
		pbe->KataWXFlag = 0;
		break;
		/* Hiragana katakana zenkaku hankaku */
	case F_HIRA_CNV:
		if (pbe->toku == 1)
			break ;
		i = CNV_HIRA;
		goto	CNV_CMN;
	case F_KATA_CNV:
		if (pbe->toku == 1)
			break ;
		if ((len = KatakanaHenkan(pbe,pbe->kihon_cnv)) == -1) {
			i = CNV_KATA;
			goto CNV_CMN;
		}
		pbe->kihon_cnv = len;
		set_cnv(pbe,pbe->kihon_cnv);
		mode = SLength(pbe->kihon_buf_Q);
		cnv_code(pbe,bdata, CNV_HIRA);
		mode = SLength(pbe->kihon_buf_Q) - mode;
		goto	CNV_CMN2;
	case F_ZEN_CNV:
		if (pbe->toku == 1)
			break ;
		if (pbe->key_pos - pbe->key_cnv > L_YOMI)
			break;
		i = CNV_ZEN;
		goto	CNV_CMN;

	case F_HAN_EISU_CNV:
		if (pbe->toku == 1)
			break ;
		if (pbe->key_pos - pbe->key_cnv > L_YOMI)
			break;
		i = CNV_HAN_EISU;
		goto	CNV_CMN;

	case F_HAN_CNV:
		if (pbe->toku == 1)
			break ;
		i = CNV_HAN;
CNV_CMN:
		mode = SLength(pbe->kihon_buf_Q);
		stg = GetAaStage(pbe,pbe->kihon_cnv);
		cnv_code(pbe,bdata, i);
		SetAaCnvCode(pbe,pbe->kihon_cnv,stg,i,bdata);
		mode = SLength(pbe->kihon_buf_Q) - mode;
CNV_CMN2:
		(void)make_inbuf(pbe,0, bdata);
		pbe->edit |= H_EDIT; /* 89/11/22 */
		len = pbe->k_r.koho[pbe->k_r.bun_cnt].yomi_len + mode;
		if (i == CNV_KATA)
			pbe->KatakanaTouroku = S_KATAKANA;
		else if (i == CNV_HIRA)
			pbe->KatakanaTouroku = S_HIRAGANA;
		else
			pbe->KatakanaTouroku = S_OTHER;
		(void)saihenkan(pbe->hVjeLib, &pbe->in_buf_Q, 1, len, len, pbe->KatakanaTouroku);
		pbe->edit &= ~H_EDIT;
		pbe->KugiriHenkou = 1;
		koho_all( pbe);
		make_menu( pbe,bdata );
		pbe->main_stg = PRC_CNV;
		pbe->CnvKeyCnt = 0;
		break;

	case F_WX_KANA:
		pbe->KataWXFlag = (pbe->KataWXFlag + 1) % 3;
		if (pbe->KataWXFlag == 1)
			i = CNV_KATA;
		else if (pbe->KataWXFlag == 2)
			i = CNV_HAN;
		else
			i = CNV_HIRA;
		goto	CNV_CMN;
		break;

	case F_WX_EISU:
		if ((pbe->KataWXFlag & 0x0100) == 0) {
			i = CNV_ZEN;
			pbe->KataWXFlag |= 0x0100;
		} else {
			i = CNV_HAN;
			pbe->KataWXFlag &= ~0x0100;
		}
		goto	CNV_CMN;
		break;

	case F_LB_SEL2:
		chr	= bdata->wCharCode
			- bdata->cLBItemPageFirst
			+ 1;
		if (bdata->wMainStage & PRC_DON) {
			if (1 <= chr && chr <= pbe->off_max) {
				pbe->offset	= chr;
#if 1/*KOHOSORT*/
				i = (short)pbe->donsort.kno[pbe->menu_t[pbe->menu_cnt] + pbe->offset - 1];
#else
				i  = (short)pbe->menu_t[pbe->menu_cnt]
					+ pbe->offset
					- 1;
#endif
				set_koho (pbe->hVjeLib, i);
			}
		}
		break;

	case F_LB_SEL:
		chr = bdata->wCharCode - bdata->cLBItemPageFirst + 1;
		if ( (bdata->wMainStage == PRC_DON            )
		&&   ( 1 <= chr         && chr <= pbe->off_max) ) {
			pbe->offset = chr;
#if 1/*KOHOSORT*/
			i = (short)pbe->donsort.kno[pbe->menu_t[pbe->menu_cnt] + pbe->offset - 1];
#else
			i  = (short)pbe->menu_t[pbe->menu_cnt]
					+ pbe->offset
					- 1;
#endif
			set_koho(pbe->hVjeLib, i);
			bdata->wVkey = F_RIGHT;
			goto JIBUNSETU;
		}
		break;
	case F_CHR:
		chr = cnv2num(bdata);
		if ( (bdata->wMainStage == PRC_DON            )
		&&   ( 1 <= chr         && chr <= pbe->off_max) ) {
			pbe->offset = chr;
#if 1/*KOHOSORT*/
			i = (short)pbe->donsort.kno[pbe->menu_t[pbe->menu_cnt] + pbe->offset - 1];
#else
			i  = (short)pbe->menu_t[pbe->menu_cnt]
					+ pbe->offset
					- 1;
#endif
			set_koho(pbe->hVjeLib, i);
			bdata->wVkey = F_RIGHT;
			goto JIBUNSETU;
		}
		pbe->main_stg = PRC_CNV;
		pbe->CnvKeyCnt = 0;
		pbe->CnvAaCnt = 0;
		pbe->KataWXFlag = 0;
		if (pbe->cnv_mod == 2) {
			Keizoku2(pbe); /* C = MIHENKAN SENTOU */
			err = 0;
		}
		else
			err = 5;
		break;
		/* Kakutei main he modoru */
	case F_NO_CNV:
		if (pbe->main_stg == PRC_DON) {
			pbe->main_stg = PRC_CNV;
			pbe->CnvKeyCnt = 0;
			pbe->CnvAaCnt = 0;
			pbe->KataWXFlag = 0;
			goto JIBUNSETU;
		}
	case F_NO_CNV2:
		err = 1;
		break;
		/* Change mode */
	case F_ATOK_TOPKAKU:
		if (pbe->k_r.max_bun == 1) {
			pbe->kaku_req = 2;
			ResultWork.len = NUM_CHAR * 2 + 1;
			(void)kakutei1(pbe->hVjeLib, &pbe->kihon_buf_Q, &ResultWork);
			pbe->sav_out_cnt = 1;	/*+mk */
#ifdef	UCS
			i = TopKakuUCS(&ResultWork);
#else
			i = 1;
			if (VjeKanji(ResultWork.str[1]))
				++i;
#endif
			for ( j = 1; j <= i; j++ )
				AddData( ResultWork.str[j], bdata );
			err = 6;
			break ;
		}
		if (pbe->k_r.bun_cnt != 0)
			break;
		ResultWork.len = NUM_CHAR * 2 + 1;
		len = kakutei2(pbe->hVjeLib, &pbe->kihon_buf_Q, &ResultWork);
#ifdef	UCS
		i = TopKakuUCS(&ResultWork);
#else
		i = 1;
		if (VjeKanji(ResultWork.str[1]))
			++i;
#endif
		for ( j = 1; j <= i; j++ )
			AddData( ResultWork.str[j], bdata );
		goto ATOK_KAKU;

	case F_ATOK_ENDKAKU:
		if (pbe->k_r.max_bun == 1) {
			pbe->kaku_req = 2;
			ResultWork.len = NUM_CHAR * 2 + 1;
			(void)kakutei1(pbe->hVjeLib, &pbe->kihon_buf_Q, &ResultWork);
			pbe->sav_out_cnt = 1;	/*+mk */
#ifdef	UCS
			len = EndKakuUCS(&ResultWork);
			if (len > 0) {
				i = j = ResultWork.len;
				i -= len;
			}
			else
#endif
			if (ResultWork.len == 1) {
				i = 1;
				j = 1;
			} else if (VjeKanji(ResultWork.str[ResultWork.len-1])) {
				i = ResultWork.len - 1 ;
				j = i + 1;
			} else {
				i = ResultWork.len ;
				j = ResultWork.len ;
			}
			for ( ; i <= j; i++ )
				AddData( ResultWork.str[i], bdata );
			err = 6;
			break ;
		}
		if (pbe->k_r.bun_cnt != 0)
			break;
		ResultWork.len = NUM_CHAR * 2 + 1;
		len = kakutei2(pbe->hVjeLib, &pbe->kihon_buf_Q, &ResultWork);
#ifdef	UCS
		len = EndKakuUCS(&ResultWork);
		if (len > 0) {
			i = j = ResultWork.len;
			i -= len;
		}
		else
#endif
		if (ResultWork.len == 1) {
			i = 1 ;
			j = 1;
		} else if (VjeKanji(ResultWork.str[ResultWork.len-1])) {
			i = ResultWork.len - 1 ;
			j = i + 1;
		} else {
			i = ResultWork.len ;
			j = ResultWork.len ;
		}
		for ( ; i <= j; i++ )
			AddData( ResultWork.str[i], bdata );
		goto ATOK_KAKU;

	case F_ATOK_KAKU:
		if (pbe->k_r.max_bun == 1 || pbe->k_r.max_bun-1 == pbe->k_r.bun_cnt) {
			err = 1;
			break;
		}
		ResultWork.len = NUM_CHAR * 2 + 1;
		len = kakutei2(pbe->hVjeLib, &pbe->kihon_buf_Q, &ResultWork);
		for ( i = 0; (UCHAR)i < ResultWork.len; i++ )
			AddData( ResultWork.str[i + 1], bdata );
		*(bdata->lpchResult + bdata->cchResult) = 0x00;
ATOK_KAKU:
		cnv_del(pbe, len);
		set_pos(pbe, pbe->kihon_pos > (short) len ? pbe->kihon_pos - (UCHAR)len : 0);
		if (pbe->kihon_cnvted > 0)
			pbe->kihon_cnvted -= len;
		else
			pbe->kihon_cnvted = 0;
		set_cnv(pbe, pbe->kihon_cnvted);
		make_inbuf(pbe, 0, bdata);

		if (bdata->cchResult != 0) {
			bdata->wDataStatus |= VJE_RESULT;
			bdata->wDataUpdate |= VJE_RESULT;
		}
		if (bdata->wMainStage == PRC_DON)
			bdata->wMainStage = PRC_CNV;
		koho_all(pbe);
		make_menu(pbe, bdata );
		break;
	case F_ROM:
	case F_HIRA:
	case F_KATA:
	case F_HAN:
	case F_ZEN:
	case F_EISUU:
	case F_HIRA_KATA:
	case F_KLK_ON: /* kana lock on */
	case F_KLK_OFF: /* kana lock off */

		chg_inp_mode(pbe,fnc, bdata);
		break;
		/* Bunsetu length henkou */
	case F_CNV_BUNL:
		if (pbe->OptDic != -1)
			break;
		i = 1;
		goto LONG_SHORT_CMN;
	case F_CNV_BUNS:
		if (pbe->OptDic != -1)
			break;
		i = -1;
LONG_SHORT_CMN:
		if (pbe->toku == 1)
			break;
		goto RCNV_CMN;
	case F_ATOK_BS:
	case F_ESC2:/*WIN95*/
		err = 4;
		break;
#if 1/*KOHOSORT*/
	case F_KOHO_NORMAL:
		pbe->koho_mode = KOHO_SORT_NORMAL;
		goto KOHO_SORT;
	case F_KOHO_SORT_TOP:
		pbe->koho_mode = KOHO_SORT_TOP;
		goto KOHO_SORT;
	case F_KOHO_SORT_END:
		pbe->koho_mode = KOHO_SORT_END;
		goto KOHO_SORT;
	case F_KOHO_SORT_BUSYU:
		pbe->koho_mode = KOHO_SORT_BUSYU;
		goto KOHO_SORT;
	case F_KOHO_SORT_KAKUSU:
		pbe->koho_mode = KOHO_SORT_KAKUSU;
KOHO_SORT:
		get_current_koho(pbe );
		create_douon(pbe);
		set_koho(pbe->hVjeLib, pbe->donsort.kno[1] - 1);
		pbe->k_r.koho[pbe->k_r.bun_cnt].koho_cnt = pbe->donsort.kno[1] - 1;
		get_menu_inf(pbe,pbe->k_r.bun_cnt);
		break;
#endif/*KOHOSORT*/
	case F_KOHO_DEL:
/*ʸθ */
/*1 ɤߡñκ */
/*2 PRC_INPUTذܹ */
/*3 F_SAKUJYOټ¹ */
		get_koho2(pbe->hVjeLib, &pbe->DelYomiStr, &pbe->DelHyouki);
		pbe->DelYomiStr.str[SLength(pbe->DelYomiStr) + 1] = 0;
		pbe->DelHyouki.str[SLength(pbe->DelHyouki) + 1] = 0;
		bdata->lpchYomi = &pbe->DelYomiStr.str[1];
		bdata->lpchHyouki = &pbe->DelHyouki.str[1];
		bdata->wHinshi = (UCHAR)0xff;

		pbe->edit |= H_EDIT;
		pbe->fUnget = 1 ;	/*loop F_SAKUJYO */
		bdata->wVkey = F_SAKUJYO;
		err = 4;
		break;

	case F_CANCEL:
		if (pbe->k_r.max_bun == 1) {
			pbe->main_stg = PRC_CNV;
			pbe->CnvKeyCnt = 0;
			pbe->CnvAaCnt = 0;
			pbe->KataWXFlag = 0;
			err = 4;
			break;
		}
		i = 0;
RCNV_CMN:
		return(i + 9);
		break;
	case F_CANALL:

#if DEBUG_AI
CANCEL_ALL:
#endif
		err = 3;
		break;
	case F_SCRN:
		err = 7;
		break;
	case F_KNJ:
		err = 5;
		break;
	case F_CTRL:
		if (bdata->wCharCode == 0x0d || bdata->wCharCode == 9 ) {/* or TAB ? */
			err = 5;
		}
		break;
	}
	return (err);
}

/*
 *	Inbuf sakusei shori
 *		cursor position made no hiragana yomi wo
 *		sakusei suru
 *	ret 0: kihon buf ha sonomama
 *	    1: subete hankaku moji deatta node hiraga ni
 *	       henkan sareta
 */
global short FTYPE	make_inbuf(pbe,mode, bdata)
PBEBUF	pbe;
short	mode;
PBD		bdata;
{
	short	ret;
	short	i;
	short	c, c2, cnv;
#if	PENWIN
	short	xflag ;
#endif
	/* Zenbu hankaku moji retu ka douka no check wo suru */
	cnv = ret = 0;
	if (mode == 1) { /* 93/8/11 */
		for (i = pbe->kihon_cnvted+1; (UCHAR)i <= SLength(pbe->kihon_buf_Q); i++) { /* 93/8/11 */
			c = pbe->kihon_buf_Q.str[i];
			if (0x80 < c && c < 0xa0 || 0xe0 <= c && c < 0xfd) {
				i++;
				c2 = pbe->kihon_buf_Q.str[i];
				if (c == 0x82) {
					if (0x9f <= c2 && c2 <= 0xf1)
						break;
					else if (c2 >= 0x60) /* 91/4/23 */
						cnv = CNV_ZEN;
				}
				else if (c == 0x83) {
					if (0x40 <= c2 && c2 <= 0x94)
						cnv = CNV_KATA;
				}
#if	PENWIN
				else
					if (pbe->PenCnvFlag == 1 && pbe->PenInpFlag == 1)
						cnv = ret ;
					else
						break;
#else
#endif
			}
			else {
				if ( (c| 0x20) == 'n' && (UCHAR)i == SLength(pbe->kihon_buf_Q) )
					cnv = ret;
				else if (c >= 0xa6 && c != 0xb0)
					cnv = CNV_HAN;
				else if ( c >= 'A' && c <= 'Z' || c >= 'a' && c <= 'z')
					cnv = CNV_HAN| 0x01;
				else
					cnv = ret;
			}
			if (ret != 0 && cnv != ret)
				break;
			else
				ret = cnv;
		}
#if	PENWIN
		if ( pbe->PenInpFlag == 1 && pbe->PenCnvFlag == 1 )
			xflag = 1 ;
		else
		if ((UCHAR)i > Length(pbe->kihon_buf_Q) && i <= NUM_CHAR+1)
			xflag = 1 ;
		else
			xflag = 0 ;
		if (xflag == 1) {
#else
		if ((UCHAR)i > SLength(pbe->kihon_buf_Q) && i <= NUM_CHAR+1) {
#endif
                        set_cnv(pbe,pbe->kihon_cnvted); 
			set_pos(pbe,(int)SLength(pbe->kihon_buf_Q));
			cnv_code(pbe,bdata, CNV_HIRA|CNV_KUTEN);
			pbe->kihon_cnvted = 0;
			clear(pbe->hVjeLib);
			chg_sdic(pbe->hVjeLib,pbe->OptDic);
			pbe->edit |= H_EDIT;
		}
		else
			ret = 0;
	}
	if (pbe->toku == 0 && (pbe->edit & H_CNV)) {
/*R R λʸѻȾѤξϡѤ˺Ѵ? */
		if (cnv_nn(pbe) == YES)
			pbe->edit |= H_EDIT;
	}
	Copylng(pbe->kihon_buf_Q.str, pbe->in_buf_Q.str, SLength(pbe->kihon_buf_Q) + 1);
	SLength(pbe->in_buf_Q) = SLength(pbe->kihon_buf_Q);
#if PCUNIX
	SetKihonBuff(pbe->hVjeLib, &pbe->kihon_buf_Q,
	     			   pbe->kihon_atr_Q, 
	     			   &pbe->key_buf_Q);
#endif
	return (ret);
}


/*
 *	Call vje liblary
 *		return : 2 end normally recall request
 *             : 1  end normally
 *		         0  error
 *		        -2  bunsetu suu over
 */
global short FTYPE
callvje( pbe,bdata )
PBEBUF	pbe;
PBD	bdata;
{
	REG1 short	err;

	/*991210 WRN*/	
	if ( (err = henkanb(pbe->hVjeLib,&pbe->kihon_buf_Q,pbe->kihon_atr_Q,(BUFF *)&pbe->key_buf_Q,&pbe->edit,pbe->kihon_cnvted))==-1) {
		err = 0;
	}
	pbe->edit &= ~(H_CNV|H_EDIT|H_STR_EDIT);
	return ( err );
}

/*
 *	Menu table sakusei
 */
global void FTYPE
make_menu( pbe,bdata )
PBEBUF	pbe;
PBD	bdata;
{
	BUFF	buf1_Q;	//-[NUM_CHAR * 2 + 1];
	short	w_cnt, kno, lim;
	REG1 short	m_lng;
	REG2 short	k_lng;
	REG3 short	i;

	get_douon(pbe->hVjeLib,&pbe->don);
#if 1/*KOHOSORT*/
	create_douon(pbe);
#endif
	buf1_Q.len = NUM_CHAR * 2 + 1;
	k_lng = w_cnt = m_lng = 0;
	kno = pbe->menu_t[0] = pbe->menu_t[1] = 1;
	lim = bdata->cLBItemLenMax;
	for (i = 0; (USHORT)i < pbe->k_r.koho[pbe->k_r.bun_cnt].max_koho; i++) {
		get_don_koho(pbe, (SHORT *)&kno, &buf1_Q, &pbe->don);
if (!(pbe->wLimitMode & M_NODISP_ILKANJI) && pbe->wLimitRank != 10)
		k_lng = buf1_Q.len + bdata->cLBItemHead + 2;
else
		k_lng = buf1_Q.len + bdata->cLBItemHead;
		buf1_Q.len = NUM_CHAR * 2 + 1;
		if (k_lng >= lim) {
			if (w_cnt != 0)
				Addchar2(pbe->menu_t, kno);
			Addchar2(pbe->menu_t, kno + 1);
			m_lng = w_cnt = 0;
		}
		else if (m_lng + k_lng >= lim || (USHORT)w_cnt >= bdata->cLBItemNumMax) {
			Addchar2(pbe->menu_t, kno);
			w_cnt = 1;
			m_lng = k_lng;
		}
		else {
			w_cnt++;
			m_lng += k_lng;
		}
		++kno;
	}
	if (k_lng >= lim)
		pbe->menu_t[0]--;
	pbe->menu_t[pbe->menu_t[0] + 1] = kno;
	get_menu_inf(pbe,pbe->k_r.bun_cnt);
	pbe->off_max = pbe->menu_t[pbe->menu_cnt + 1] - pbe->menu_t[pbe->menu_cnt];
}

/*
 *	get_don_koho
 */
global void FTYPE get_don_koho(pbe,p, buf, don)
PBEBUF	pbe;
SHORT PWIN	*p;
BUFF PWIN	*buf;
DOUBUFX	*don;
{
KOUHO	*pkr;
UCHAR	*ptr;
short	i;
short	kno;
	pkr = &pbe->k_r.koho[pbe->k_r.bun_cnt];
	kno = (*p);/*Linux NG Segment Halt*/
	if (kno > pkr->max_koho || kno > don->cnt ) {
		return;
	}
#if 1/*KOHOSORT*/
	ptr = pbe->donsort.bufp[kno - 1];
	Copylng(ptr, buf->str, *ptr+1);
	PLength(buf) = *ptr;
#else
	ptr = don->buf;	/* set buffer[] address */
	for ( i = 1 ; i < kno/**p*/ ; i++)
		ptr += *ptr + 1;
#if 0	/*V300*/
	Copylng(ptr, buf->str, don->length + 1);
	PLength(buf) = don->length/**ptr*/;
#else	/*OLD 1999/8/28ԥåǤɽĹ255byteۤʤ*/
	Copylng(ptr, buf->str, *ptr+1);
	PLength(buf) = *ptr;
#endif
#endif
	return;
}
/*
 *	Function  Calculate offset & menu_cnt
 *
 *	Input : current koho No.
 *
 *	Output: nothing
 */
static void FTYPE	get_menu_inf(pbe,cur_koho)
PBEBUF	pbe;
short	cur_koho;			/* Current koho No.	*/
{
	REG1 short	i;
	REG2 short	j;
	
	j = pbe->menu_t[0] + 1;
	for (i = j; i > 0; i--) {
#if 1/*KOHOSORT*/
		pbe->offset = j = get_douon_index(pbe, pbe->k_r.koho[cur_koho].koho_cnt + 1) - (pbe->menu_t[i] - 1);
#else
		pbe->offset = j = (pbe->k_r.koho[cur_koho].koho_cnt + 1) - (pbe->menu_t[i] - 1);
#endif
		if (j > 0)
			break;
	}
	pbe->menu_cnt = i;
}

/*
 *	Saihenkan shori
 *		return :
 *	err  0: sahenkan sareta
 *	     1: kakutei(NFER)
 *	     2: bunsetu ga nakunatta (koho mojiretu nasi)
 *	     3: all cancel
 *	     4: yomi ni modosu
 *	     5: tugi no bunsetu
 *       6: saihenkan sareta (douongo mode)
 *	     7: VJE off
 */
short FTYPE
SaihenkanShori( pbe,bdata, p )
PBEBUF	pbe;
PBD	bdata;
short	p;
{
	UCHAR	fnc;
	short	err, mode;
	UCHAR	key_dat[2];
	REG1 short	i;
	REG2 short	j;
	/*RCNV-ZENKAKU*/
	short	cnt;
	short   k;
	UCHAR	cnv_data[10];
	
	switch (pbe->wTangoStage) {
case 1:
		pbe->upd_nbun = pbe->nbun = 1;
		i = pbe->k_r.bun_cnt;
		pbe->lenSaiYomi = get_next_len(pbe,(short)pbe->k_r.koho[i].yomi_len, p);
		pbe->cursor = pbe->lenSaiYomi;
		get_recnv_len(pbe,&pbe->nbun, pbe->upd_nbun, pbe->lenSaiYomi, &pbe->lenSaiYomiTotal);
		set_pos(pbe,(short)pbe->k_r.koho[i].yomi_pnt - 1 + pbe->cursor);
		pbe->wTangoStage = 2;
		err = -2;
		break;
case 2:
		err = -2;
		switch (fnc = (UCHAR)bdata->wVkey) {
			/* Henkan sousa */
		case F_RIGHT:
			if (pbe->cursor >= pbe->lenSaiYomi)
				break;
			goto SAI_CSR_CMN;
		case F_LEFT:
			if (pbe->cursor <= 0)
				break;
SAI_CSR_CMN:
			move_cur(pbe,bdata->wVkey);
			pbe->cursor = pbe->kihon_pos - pbe->kihon_cnv;
			break;
		case F_BS:
			if (pbe->cursor > 0)
				goto BS_DEL_CMN;
			break;
		case F_DEL:
			if (pbe->cursor < pbe->lenSaiYomi) {
BS_DEL_CMN:
				i = SLength(pbe->kihon_buf_Q);
				edt_char(pbe,bdata->wVkey);
				i -= SLength(pbe->kihon_buf_Q);
				pbe->edit |= H_EDIT;
				pbe->cursor = pbe->kihon_pos - pbe->kihon_cnv;
				pbe->lenSaiYomi -= i;
				pbe->kihon_cnvted -= i;
				CopyKb(&pbe->kihon_buf_Q, &pbe->in_buf_Q);
				if (pbe->nbun > pbe->upd_nbun)
					pbe->upd_nbun = pbe->nbun;
				updkr(pbe,pbe->nbun, &pbe->lenSaiYomiTotal, -i);
				if (pbe->lenSaiYomi == 0) {
					(void)saihenkan(pbe->hVjeLib, &pbe->in_buf_Q, pbe->nbun, pbe->lenSaiYomiTotal, pbe->lenSaiYomi, 0);
					pbe->edit &= ~H_EDIT;
					pbe->KugiriHenkou = 1;
					if (pbe->lenSaiYomiTotal == 0)
						err = 2;
					else
						err = 0;
				}
			}
			break;
		case F_CNV_NBLK:
		case F_CNV_NBLK1:
		case F_CNV_NBLK_ATK:
		case F_ATOK_CNV:
			err = 6;
			set_loop_mode(pbe,bdata);
			goto CNV_CMN0;
		case F_CNV:
		case F_CNV1:
		case F_CNV_ATK:
		case F_CNV_NCNV:
		case F_CNV_NCNV1:
		case F_CNV_NCNV_ATK:
			if (pbe->toku == 1)
				break;
			set_fukugou(pbe,bdata);
			set_loop_mode(pbe,bdata);
			pbe->CnvKeyCnt = 1;
			if (bdata->wDispListBox == 1)
				err = 6;
			else
				err = 0;
			goto CNV_CMN0;

		case F_FUKUGOU:
			err = 0;
			set_fukugou(pbe,bdata);
			goto CNV_CMN0;
			break ;

		case F_CNV_OPT1:
		case F_CNV_OPT2:
		case F_CNV_OPT3:
		case F_CNV_OPT4:
		case F_CNV_OPT5:
		case F_CNV_OPT6:
		case F_CNV_OPT7:
		case F_CNV_OPT8:
		case F_CNV_OPT9:
		case F_CNV_OPT10:
			if (pbe->toku == 1)
				break;
			set_fukugou(pbe,bdata);
			set_loop_mode(pbe,bdata);
			err = 0;
			goto CNV_CMN0;

		case F_CNV_BBLK:
		case F_CNV_BBLK1:
		case F_CNV_BBLK_ATK:

		case F_CNV_BCNV:
		case F_CNV_BCNV1:
		case F_CNV_BCNV_ATK:
			set_loop_mode(pbe,bdata);
			err = 0;
CNV_CMN0:
			set_pos(pbe,pbe->kihon_cnv + pbe->lenSaiYomi);
			i = CNV_HIRA;
			mode = 1;
			goto CNV_CMN2;
			break;
		case F_CNV_BUNL:
			if (pbe->OptDic != -1)
				break;
			i = 1;
			goto BUNLS_CMN;
		case F_CNV_BUNS:
			if (pbe->OptDic != -1)
				break;
			i = -1;
BUNLS_CMN:
			pbe->lenSaiYomi = get_next_len(pbe,pbe->lenSaiYomi, i);
			get_recnv_len(pbe,&pbe->nbun, pbe->upd_nbun, pbe->lenSaiYomi, &pbe->lenSaiYomiTotal);
			pbe->cursor = pbe->lenSaiYomi;
			set_pos(pbe,(short)pbe->k_r.koho[pbe->k_r.bun_cnt].yomi_pnt - 1 + pbe->cursor);
			break;
		case F_RLIM:
		case F_RLIM2:/*WIN95*/
			i = pbe->kihon_cnv + pbe->lenSaiYomi;
			goto BUN_LIM_CMN;
		case F_LLIM:
			i = pbe->kihon_cnv;
BUN_LIM_CMN:
			set_pos(pbe,i);
			pbe->cursor = pbe->kihon_pos - pbe->kihon_cnv;
			break;
			/* Saihenkan */
		case F_WX_KANA:
			pbe->KataWXFlag = (pbe->KataWXFlag + 1) % 3;
			if (pbe->KataWXFlag == 1)
				i = CNV_KATA;
			else if (pbe->KataWXFlag == 2)
				i = CNV_HAN;
			else
				i = CNV_HIRA;
			goto	CNV_CMN;
			break;

		case F_WX_EISU:
			if ((pbe->KataWXFlag & 0x0100) == 0) {
				i = CNV_ZEN;
				pbe->KataWXFlag |= 0x0100;
			} else {
				i = CNV_HAN;
				pbe->KataWXFlag &= ~0x0100;
			}
			goto	CNV_CMN;
			break;

		case F_HIRA_CNV:
			i = CNV_HIRA;
			goto	CNV_CMN;
		case F_KATA_CNV:
			i = CNV_KATA;
			goto	CNV_CMN;
		case F_ZEN_CNV:
			if (pbe->key_pos - pbe->key_cnv > L_YOMI)
				break;
			i = CNV_ZEN;
			goto	CNV_CMN;
		case F_HAN_EISU_CNV:
			if (pbe->key_pos - pbe->key_cnv > L_YOMI)
				break;
			i = CNV_HAN_EISU;
			goto	CNV_CMN;
		case F_HAN_CNV:
			i = CNV_HAN;
CNV_CMN:
			mode = 0;
			err = 0;
CNV_CMN2:

			j = get_chr_cnt(pbe->in_buf_Q.str, pbe->kihon_cnv+1,
					 pbe->kihon_cnv+1 + pbe->lenSaiYomi); /* VJE-LIB */
			if (j > L_YOMI)
				break;
			j = SLength(pbe->kihon_buf_Q);
#if	PENWIN
#else
			if (mode == 0) /*saihenkan dekinai */
#endif
				cnv_code(pbe,bdata, i);
			(void)make_inbuf(pbe,0, bdata);
			j = SLength(pbe->kihon_buf_Q) - j;
			pbe->lenSaiYomi += j;
			pbe->lenSaiYomiTotal += j;
			if (i == CNV_KATA)
				mode |= S_KATAKANA;
			else if (i == CNV_HIRA)
				mode |= S_HIRAGANA;
			else
				mode |= S_OTHER;
			(void)saihenkan(pbe->hVjeLib, &pbe->in_buf_Q, pbe->nbun,
					 pbe->lenSaiYomiTotal, pbe->lenSaiYomi, mode);
			pbe->edit &= ~H_EDIT;
			pbe->KugiriHenkou = 1;
			break;
		case F_CHR:
			i = get_chr_cnt(pbe->in_buf_Q.str, pbe->kihon_cnv+1,
					 pbe->kihon_cnv+1 + pbe->lenSaiYomi); /* VJE-LIB */
			if ( i >= L_YOMI || (short)SLength(pbe->key_buf_Q) >= pbe->key_max ||
			    (short)SLength(pbe->kihon_buf_Q) >= pbe->kihon_max )
				break;
			if ( pbe->cnv_mod == 2 && pbe->k_r.total_yomi != 0 ) {
				if ( (short)SLength(pbe->koho_buf_Q) + 
				    ((short)SLength(pbe->kihon_buf_Q) -
				       pbe->k_r.total_yomi) >= pbe->kihon_max )
					break;
			}
			i = SLength(pbe->kihon_buf_Q);
			if ((cnt = CnvHankaku(pbe, bdata, cnv_data, &mode)) <= 0 )
				break;
			for (k=1;k <= cnt; k++) {
				bdata->wCharCode = (USHORT)cnv_data[k];
				key_dat[0] = 0;
				key_dat[1] = (UCHAR)bdata->wCharCode;
				pbe->wCharSave = ((bdata->wCharCode >>8 ) & 0xff );
				(void)set_buf( pbe, key_dat, bdata );
			}
			if (pbe->SaveFlag == 1) {
				bdata->wVjeModeFlag = pbe->wVjeModeFlagSave;
				pbe->kanamd = pbe->kanamdSave;
			}
			pbe->edit |= H_EDIT;
			j = SLength(pbe->kihon_buf_Q) - i;
			pbe->cursor += j;
			pbe->lenSaiYomi += j;
			if (pbe->nbun > pbe->upd_nbun)
				pbe->upd_nbun = pbe->nbun;
			updkr(pbe,pbe->nbun, &pbe->lenSaiYomiTotal, j);
			CopyKb(&pbe->kihon_buf_Q, &pbe->in_buf_Q);
			break;
		case F_CANALL:
			err = 3;
			break;	
		case F_CANCEL:
			err = 4;
			break;
		case F_CTRL:
			if (!(bdata->wCharCode == 0x0d || bdata->wCharCode == 9 )) /* or TAB ? */
				break;
		case F_NO_CNV:
		case F_ATOK_KAKU:
		case F_ATOK_TOPKAKU:
		case F_ATOK_ENDKAKU:
			err = 5;
    		goto CMN157;
			break;
		case F_NO_CNV2:
			err = 1;
    		goto CMN157;
			break;
		case F_SCRN:
			err = 7;
		CMN157:
			(void)saihenkan(pbe->hVjeLib, &pbe->in_buf_Q, pbe->nbun, pbe->lenSaiYomiTotal, pbe->lenSaiYomi, 0);
			pbe->edit &= ~H_EDIT;
			pbe->KugiriHenkou = 1;
			break;
			/* Change mode */
		case F_ROM:
		case F_HIRA:
		case F_KATA:
		case F_ZEN:
		case F_HAN:
		case F_EISUU:
		case F_HIRA_KATA:
		case F_KLK_ON: /* kana lock on */
		case F_KLK_OFF: /* kana lock off */
			chg_inp_mode(pbe,fnc, bdata);
			break;
		};
		if (err != -2) {
			pbe->lenSaiYomi = pbe->lenSaiYomiTotal = 0;
			pbe->wTangoStage = 1;
		}
		break;
	}
	return (err);
}

/*
 *	Get yomi kaishi poshort of next bunsetu
 *	return : yomi tugi no iti
 */
static short FTYPE	get_next_len(pbe,len, p)
PBEBUF	pbe;
short	len, p;
{
	short	err, yomi_s, yomi_e, yomi_ptr;
	REG1 short	save;
	REG2 short	nchr;
	
	if (p == 0)
		return (len);
	save = len;
	yomi_e = next_yomi_pnt(pbe,(SHORT)pbe->k_r.max_bun);
	yomi_s = pbe->k_r.koho[pbe->k_r.bun_cnt].yomi_pnt;
	yomi_ptr = yomi_s + len;
	nchr = get_chr_cnt(pbe->in_buf_Q.str, yomi_s, yomi_ptr); /* VJE-LIB */
	do {
		nchr += p;
		if (nchr == 0) {
			len = save;
			break;
		}
		yomi_ptr = get_yomi_pos(pbe->in_buf_Q.str, yomi_s, nchr);
		err = 0;
		if (yomi_ptr >= yomi_s && yomi_ptr <= yomi_e) {
			if (yomi_ptr == yomi_e)
				err = 0;
			else {
				if (pbe->in_buf_Q.str[yomi_ptr] == 0x82)
					err = ChKomoji(pbe->in_buf_Q.str[yomi_ptr + 1] - 0x9d, 7);	/* N XYU - */
			}
			len = yomi_ptr - yomi_s;
		}
		else if (yomi_ptr > yomi_e) {
			len = save;
			err = 0;
		}
	} while (err == 1);
	return (len);
}

static short FTYPE	get_yomi_pos(buf, ptr, len)
UCHAR	buf[];
short	ptr, len;
{
	REG1 short	c;
	REG2 short	cnt;
	
	cnt = 0;
	for (;;) {
		c = buf[ptr];
		if (0x80 < c && c < 0xa0 || 0xe0 <= c && c <= 0xfc)
			++ptr;
		++ptr;
		++cnt;
		if (len == cnt)
			break;
	}
	return (ptr);
}

/*
 *	Get yomi kaishi point of next bunsetu
 *		return : yomi tugi no iti
 */
global short FTYPE	next_yomi_pnt(pbe,bno)
PBEBUF	pbe;
REG2 short	bno;
{
	REG1 short	kmax;
	
	if (bno < pbe->k_r.max_bun)
		kmax = pbe->k_r.koho[bno].yomi_pnt + pbe->k_r.koho[bno].yomi_len;
	else if (bno == pbe->k_r.max_bun)
		kmax = pbe->k_r.total_yomi + 1;
	else
		kmax = -1;
	return (kmax);
}

/*
 *	Update koho retu information
 *	yellow underline bubun no nagasaga kawattatokiha
 *	kanarazu call suru koto
 */
static void FTYPE	updkr(pbe,nbun, len_total, dif)
PBEBUF	pbe;
short	nbun, *len_total, dif;
{
	REG1 short	i;
	REG2 short	j;
	
	i = pbe->k_r.bun_cnt;
	for (j = 0; j < nbun; j++) {
		if ((pbe->k_r.koho[i].yomi_len != 0) &&
		    (pbe->k_r.koho[i].yomi_len != 1))
			break;
		else
			++i;
	}
	pbe->k_r.koho[i].yomi_len += /*(UCHAR)*/dif;
	++i;
	for ( ; i < pbe->k_r.max_bun; i++ )
		pbe->k_r.koho[i].yomi_pnt += /*(UCHAR)*/dif;
	pbe->k_r.total_yomi += dif;
	*len_total += dif;
}

/*
 *	Saihenkan suru bunsetu no information wo eru
 *	updkr() ni yori k_r ga update sareteinakereba naranai
 *	     len: yellow underline bubun no length
 *	     j  : len wo fukumu bunsetu no goukei length
 *	    nbun: len wo fukumu bunsetu no kazu
 */
static void FTYPE
get_recnv_len( pbe,j, u, len, total )
PBEBUF	pbe;
REG1 short	*j;
     short	u;
REG4 short	len;
     short	*total;
{
	REG2 short	i;
	REG3 short	bno;
	REG5 short	yomi1;
	     short	yomi2;
	
	i = 1;
	yomi2 = (yomi1 = pbe->k_r.koho[pbe->k_r.bun_cnt].yomi_pnt) + len;
	for (bno = pbe->k_r.bun_cnt; bno < pbe->k_r.max_bun - 1; bno++) {
		if (yomi2 <= next_yomi_pnt(pbe,bno))
			break;
		++i;
	}
	if (i >= u) {
		*j = i;
		*total = next_yomi_pnt(pbe,bno) - yomi1;
	}
}

global void FTYPE	koho_all(pbe)
PBEBUF	pbe;
{
	SLength(pbe->koho_buf_Q) = NUM_CHAR * 2 + 1;
	(void)get_koho_all(pbe->hVjeLib, &pbe->k_r, &pbe->koho_buf_Q);
}

static void FTYPE	Keizoku(pbe)
PBEBUF	pbe;
{
	set_cnv(pbe,pbe->kihon_cnvted2 = pbe->kihon_cnvted = pbe->k_r.total_yomi);
	set_pos(pbe,pbe->kihon_cnvted);
	pbe->k_r.bun_cnt = pbe->k_r.max_bun;
}

static void FTYPE	Keizoku2(pbe)
PBEBUF	pbe;
{
	set_cnv(pbe,pbe->kihon_cnvted2 = pbe->kihon_cnvted = pbe->k_r.total_yomi);
	set_pos(pbe,SLength(pbe->kihon_buf_Q));
	pbe->k_r.bun_cnt = pbe->k_r.max_bun;
}

/*
 *	Eisuji Convert Proc
 *	<exit> =  1:  End Normally
 *	         -1:  Error
 */
global short FTYPE
toku_henkanm( pbe,key, bdata )
PBEBUF	pbe;
BUFF	*key;
PBD	bdata;
{
	short i;
	i = toku_henkan(pbe->hVjeLib, key) ;
	if (i<=0) {
		clear(pbe->hVjeLib);
		i = -1;
	}
	return (i);
}

/*===========================================================================
	cnv2num
===========================================================================*/
static UCHAR cnv2num(bdata)
PBD	bdata;
{
			/*	  123456789 */
	static UCHAR	kana[] = "\xc7\xcc\xb1\xb3\xb4\xb5\xd4\xd5\xd6";
	int		i;
	UCHAR		c = 0;

	if	(bdata->wCharCode >= '1' && bdata->wCharCode <= '9')  {
		c = (UCHAR)(bdata->wCharCode - '0');
	}
	else if ( bdata->wVjeModeFlag & KATA_BIT ) {
		for ( i = (sizeof kana) - 1 ; i >= 0 ; i-- )
			if ( bdata->wCharCode == kana[i] ) break;
		c = (UCHAR)(i + 1);
	}
	return c;
}

/*
 *	Fukugou Convert Proc
 *	<exit> =  1:  End Normally
 *	         -1:  Error
 */
global short FTYPE
set_fukugou( pbe,bdata )
PBEBUF	pbe;
PBD	bdata;
{
	short	mode;
	UCHAR	fnc ;
	MODE	md;

	mode = sense_mode(pbe->hVjeLib,&md);
	mode = md.wCnvMode ;
	md.wKigo = &pbe->wKigoTBL;

	switch (fnc = (UCHAR)bdata->wVkey) {
	case F_CNV :
	case F_CNV1 :
	case F_CNV_ATK :
	case F_CNV_NCNV :
	case F_CNV_NCNV1 :
	case F_CNV_NCNV_ATK :
	case F_CNV_OPT1 :
	case F_CNV_OPT2 :
	case F_CNV_OPT3 :
	case F_CNV_OPT4 :
	case F_CNV_OPT5 :
	case F_CNV_OPT6 :
	case F_CNV_OPT7 :
	case F_CNV_OPT8 :
	case F_CNV_OPT9 :
	case F_CNV_OPT10 :
		if (pbe->fuku_cnv == 1) {
			mode &= ~(M_FUKUGOU );
			md.wCnvMode = mode;
			set_mode(pbe->hVjeLib,&md);
			pbe->fuku_cnv = 0;
			return 0 ;
		}
		break ;
	case F_FUKUGOU :
		if (!(mode & M_FUKUGOU)) {
			mode |= (M_FUKUGOU );
			md.wCnvMode = mode;
			set_mode(pbe->hVjeLib,&md);
			pbe->fuku_cnv = 1;
			return 0 ;
		}
		break ;
	}
	return -1 ;
}
/*
 *	Option Convert Proc
 *	<exit> =  1:  End Normally
 *	         -1:  Error
 */
global short FTYPE
set_loop_mode( pbe,bdata )
PBEBUF	pbe;
PBD	bdata;
{
	short	i, mode;
	UCHAR	fnc ;
	MODE	md;

	mode = sense_mode(pbe->hVjeLib,&md);
	mode = md.wCnvMode ;
	md.wKigo = &pbe->wKigoTBL;

	switch (fnc = (UCHAR)bdata->wVkey) {
/*Current:Loop Mode */
	case F_CNV_ATK:
	case F_CNV_NCNV1:
	case F_CNV_NCNV_ATK:
	case F_CNV_BCNV1:
	case F_CNV_BCNV_ATK:
	case F_CNV_NBLK1:
	case F_CNV_NBLK_ATK:
	case F_CNV_BBLK1:
	case F_CNV_BBLK_ATK:
		mode |= M_LOOP_MODE ;
		md.wCnvMode = mode ;
		set_mode(pbe->hVjeLib,&md);
		break;
/*Current:Not Loop */
	case F_CNV_NCNV:
	case F_CNV_BCNV:
	case F_CNV_NBLK:
	case F_CNV_BBLK:
		if (pbe->OptDic == -1) {
			mode &= ~M_LOOP_MODE ;
			md.wCnvMode = mode ;
			set_mode(pbe->hVjeLib,&md);
		}
		break;

/*Base:not LOOP*/
	case F_CNV :
	case F_LEFT :
	case F_RIGHT :
		mode &= ~M_LOOP_MODE ;
		md.wCnvMode = mode ;
		set_mode(pbe->hVjeLib,&md);
		chg_sdic(pbe->hVjeLib,-1);
		pbe->OptDic = -1;
		break;
/*Base:Loop*/
	case F_CNV1:
		mode |= M_LOOP_MODE ;
		md.wCnvMode = mode ;
		set_mode(pbe->hVjeLib,&md);
		chg_sdic(pbe->hVjeLib,-1);
		pbe->OptDic = -1;
		break;
/*BASE:LOOP*/
	case F_CNV_OPT1 :
	case F_CNV_OPT2 :
	case F_CNV_OPT3 :
	case F_CNV_OPT4 :
	case F_CNV_OPT5 :
	case F_CNV_OPT6 :
	case F_CNV_OPT7 :
	case F_CNV_OPT8 :
	case F_CNV_OPT9 :
	case F_CNV_OPT10 :
		mode |= M_LOOP_MODE ;
		md.wCnvMode = mode ;
		set_mode(pbe->hVjeLib,&md);

		i = bdata->wVkey - F_CNV_OPT1 /*+ 1*/;
		chg_sdic(pbe->hVjeLib,i);
		pbe->OptDic = i;
		break ;
	}
	return 0 ;
}

#ifdef	UCS
/*
 *	Top Kakutei UCS moji? CASE:F_ATOK_TOPKAKU
 */
static	short	TopKakuUCS( BUFF * ResultWork )
{
	USHORT	w;

	if (VjeKanji(ResultWork->str[1])) {
		w = ResultWork->str[1] * 256 + ResultWork->str[2];
		if ( VjeUdcCode(w) )
			return 6;	/*UDC_LEN */
		else if ( VjeUniCode(w) )
			return 4;	/*UCS_LEN */
		else
			return 2;	/*KANJI_LEN */
	}
	return 1;
}

/*
 *	End Kakutei UCS moji? CASE:F_ATOK_ENDKAKU
 */
static	short	EndKakuUCS( BUFF * ResultWork )
{
	USHORT	w;
	short	i;

	i = PLength(ResultWork) ;
	if (i > 3 && ResultWork->str[PLength(ResultWork)-1] >= 0x80) {
		if (i > 5) {
			w = ResultWork->str[i-5] * 256 + ResultWork->str[i-4];
			if ( VjeUdcCode(w) )
				return 5;	/*UDC_LEN-1 */
		}
		w = ResultWork->str[i-3] * 256 + ResultWork->str[i-2];
		if ( VjeUniCode(w) )
			return 3;	/*UCS_LEN-1 */
	}
	return 0;
}
#endif
