#if !USE_XPM
/******************************************************************************
	Xpixmap.H
******************************************************************************/

/*=============================================================================
	Define
=============================================================================*/
#define	MAX_MARK			128

#define	CPIX_QUERY_COLOR_ERROR	 	8
#define	CPIX_COLOR_XPARSE_ERROR 	7
#define	CPIX_COLOR_NAME_ERROR	 	6
#define	CPIX_COLOR_XALLOC_ERROR 	5
#define	CPIX_COLOR_MALLOC_ERROR	 	4
#define	CPIX_XIMAGE_MALLOC_ERROR	3
#define	CPIX_CREATE_XIMAGE_ERROR	2
#define	CPIX_CREATE_PIXMAP_ERROR	1
#define	CPIX_SUCCESS		 	0
#define	CPIX_COLOR_ERROR	 	-1
#define	CPIX_MALLOC_ERROR	 	-2

#define	CPIX_COLOR_KEY			0x0001
#define	CPIX_BACKGROUND			0x0002

#define	CPIX_COLOR			1
#define	CPIX_GRAY			2
#define	CPIX_MONO			3


/*=============================================================================
	Typedef
=============================================================================*/
typedef struct _TagCPIXDATA {
	int		width;
	int		height;
	int		cnum;
	int		cpp;
	XColor		*clr;
	XImage		*image;
} CPIXDATA, *LPCPIXDATA;

typedef struct _TagCPIXATTR {
	ULONG	valuemask;
	USHORT	color_key;
	ULONG	background;
	USHORT	width;
	USHORT	height;
} CPIXATTR, *LPCPIXATTR;

#endif /* !USE_XPM */
